!
!  Software name : CIAO (Code for Investigating Atomic Orbitals)
!  Subroutine(s) : set_atom_label_name, set_cc_param, set_cc_core
!  Author(s)     : Masakuni Okamoto (August 25, 2003)
!
!
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!
!
!  The license of the code and contact address :
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)
!
!=====================================================================
   subroutine set_atom_label_name( &
      NATOM,is_core,zatom,atom_label,atom_name)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   implicit none
   integer,intent(in)        :: NATOM, is_core, zatom
   character(2),intent(out)  :: atom_label(NATOM)
   character(30),intent(out) :: atom_name(NATOM)
 if (is_core == 2) then
   if (zatom < 10) then
      write(atom_label(zatom),'(a1,i1)') 'P',zatom
   else
      write(atom_label(zatom),'(a1,a1)') 'P','X'
   end if
   atom_name(zatom) = 'Pseudo-atom'
 else
   atom_label( 1) = 'H ' ; atom_name( 1) = 'Hydrogen'
   atom_label( 2) = 'He' ; atom_name( 2) = 'Helium'
   atom_label( 3) = 'Li' ; atom_name( 3) = 'Lithium'
   atom_label( 4) = 'Be' ; atom_name( 4) = 'Beryllium'
   atom_label( 5) = 'B ' ; atom_name( 5) = 'Boron'
   atom_label( 6) = 'C ' ; atom_name( 6) = 'Carbon'
   atom_label( 7) = 'N ' ; atom_name( 7) = 'Nitrogen'
   atom_label( 8) = 'O ' ; atom_name( 8) = 'Oxygen'
   atom_label( 9) = 'F ' ; atom_name( 9) = 'Fluorine'
   atom_label(10) = 'Ne' ; atom_name(10) = 'Neon'
   atom_label(11) = 'Na' ; atom_name(11) = 'Sodium'
   atom_label(12) = 'Mg' ; atom_name(12) = 'Magnesium'
   atom_label(13) = 'Al' ; atom_name(13) = 'Aluminum'
   atom_label(14) = 'Si' ; atom_name(14) = 'Silicon'
   atom_label(15) = 'P ' ; atom_name(15) = 'Phosphorus'
   atom_label(16) = 'S ' ; atom_name(16) = 'Sulfur'
   atom_label(17) = 'Cl' ; atom_name(17) = 'Chlorine'
   atom_label(18) = 'Ar' ; atom_name(18) = 'Argon'
   atom_label(19) = 'K ' ; atom_name(19) = 'Potassium'
   atom_label(20) = 'Ca' ; atom_name(20) = 'Calcium'
   atom_label(21) = 'Sc' ; atom_name(21) = 'Scandium'
   atom_label(22) = 'Ti' ; atom_name(22) = 'Titanium'
   atom_label(23) = 'V ' ; atom_name(23) = 'Vanadium'
   atom_label(24) = 'Cr' ; atom_name(24) = 'Chromium'
   atom_label(25) = 'Mn' ; atom_name(25) = 'Manganese'
   atom_label(26) = 'Fe' ; atom_name(26) = 'Iron'
   atom_label(27) = 'Co' ; atom_name(27) = 'Cobalt'
   atom_label(28) = 'Ni' ; atom_name(28) = 'Nickel'
   atom_label(29) = 'Cu' ; atom_name(29) = 'Copper'
   atom_label(30) = 'Zn' ; atom_name(30) = 'Zinc'
   atom_label(31) = 'Ga' ; atom_name(31) = 'Gallium'
   atom_label(32) = 'Ge' ; atom_name(32) = 'Germanium'
   atom_label(33) = 'As' ; atom_name(33) = 'Arsenic'
   atom_label(34) = 'Se' ; atom_name(34) = 'Selenium'
   atom_label(35) = 'Br' ; atom_name(35) = 'Bromine'
   atom_label(36) = 'Kr' ; atom_name(36) = 'Krypton'
   atom_label(37) = 'Rb' ; atom_name(37) = 'Rubidium'
   atom_label(38) = 'Sr' ; atom_name(38) = 'Strontium'
   atom_label(39) = 'Y ' ; atom_name(39) = 'Yttrium'
   atom_label(40) = 'Zr' ; atom_name(40) = 'Zirconium'
   atom_label(41) = 'Nb' ; atom_name(41) = 'Niobium (Colombium)'
   atom_label(42) = 'Mo' ; atom_name(42) = 'Molybdenum'
   atom_label(43) = 'Tc' ; atom_name(43) = 'Technetium'
   atom_label(44) = 'Ru' ; atom_name(44) = 'Ruthenium'
   atom_label(45) = 'Rh' ; atom_name(45) = 'Rhodium'
   atom_label(46) = 'Pd' ; atom_name(46) = 'Palladium'
   atom_label(47) = 'Ag' ; atom_name(47) = 'Silver'
   atom_label(48) = 'Cd' ; atom_name(48) = 'Cadmium'
   atom_label(49) = 'In' ; atom_name(49) = 'Indium'
   atom_label(50) = 'Sn' ; atom_name(50) = 'Tin'
   atom_label(51) = 'Sb' ; atom_name(51) = 'Antimony'
   atom_label(52) = 'Te' ; atom_name(52) = 'Tellurium'
   atom_label(53) = 'I ' ; atom_name(53) = 'Iodine'
   atom_label(54) = 'Xe' ; atom_name(54) = 'Xenon'
   atom_label(55) = 'Cs' ; atom_name(55) = 'Caesium'
   atom_label(56) = 'Ba' ; atom_name(56) = 'Barium'
   atom_label(57) = 'La' ; atom_name(57) = 'Lanthanum'
   atom_label(58) = 'Ce' ; atom_name(58) = 'Cerium'
   atom_label(59) = 'Pr' ; atom_name(59) = 'Praseodymium'
   atom_label(60) = 'Nd' ; atom_name(60) = 'Neodymium'
   atom_label(61) = 'Pm' ; atom_name(61) = 'Promethium'
   atom_label(62) = 'Sm' ; atom_name(62) = 'Samarium'
   atom_label(63) = 'Eu' ; atom_name(63) = 'Europium'
   atom_label(64) = 'Gd' ; atom_name(64) = 'Gadolinium'
   atom_label(65) = 'Tb' ; atom_name(65) = 'Terbium'
   atom_label(66) = 'Dy' ; atom_name(66) = 'Dysprosium'
   atom_label(67) = 'Ho' ; atom_name(67) = 'Holmium'
   atom_label(68) = 'Er' ; atom_name(68) = 'Erbium'
   atom_label(69) = 'Tm' ; atom_name(69) = 'Thullium'
   atom_label(70) = 'Yb' ; atom_name(70) = 'Ytterbium'
   atom_label(71) = 'Lu' ; atom_name(71) = 'Lutetium'
   atom_label(72) = 'Hf' ; atom_name(72) = 'Hafnium'
   atom_label(73) = 'Ta' ; atom_name(73) = 'Tantalum'
   atom_label(74) = 'W ' ; atom_name(74) = 'Tungsten (Wolfram)'
   atom_label(75) = 'Re' ; atom_name(75) = 'Rhenium'
   atom_label(76) = 'Os' ; atom_name(76) = 'Osmium'
   atom_label(77) = 'Ir' ; atom_name(77) = 'Iridium'
   atom_label(78) = 'Pt' ; atom_name(78) = 'Platinum'
   atom_label(79) = 'Au' ; atom_name(79) = 'Gold'
   atom_label(80) = 'Hg' ; atom_name(80) = 'Mercury'
   atom_label(81) = 'Tl' ; atom_name(81) = 'Thallium'
   atom_label(82) = 'Pb' ; atom_name(82) = 'Lead'
   atom_label(83) = 'Bi' ; atom_name(83) = 'Bismuth'
   atom_label(84) = 'Po' ; atom_name(84) = 'Polonium'
   atom_label(85) = 'At' ; atom_name(85) = 'Astatine'
   atom_label(86) = 'Rn' ; atom_name(86) = 'Radon'
   atom_label(87) = 'Fr' ; atom_name(87) = 'Francium'
   atom_label(88) = 'Ra' ; atom_name(88) = 'Radium'
   atom_label(89) = 'Ac' ; atom_name(89) = 'Actinium'
   atom_label(90) = 'Th' ; atom_name(90) = 'Thorium'
   atom_label(91) = 'Pa' ; atom_name(91) = 'Protactinium'
   atom_label(92) = 'U ' ; atom_name(92) = 'Uranium'
   atom_label(93) = 'Np' ; atom_name(93) = 'Neptunium'
   atom_label(94) = 'Pu' ; atom_name(94) = 'Plutonium'
   atom_label(95) = 'Am' ; atom_name(95) = 'Americium'
   atom_label(96) = 'Cm' ; atom_name(96) = 'Curium'
   atom_label(97) = 'Bk' ; atom_name(97) = 'Berkelium'
   atom_label(98) = 'Cf' ; atom_name(98) = 'Californium'
   atom_label(99) = 'Es' ; atom_name(99) = 'Einsteinium'
   atom_label(100)= 'Fm' ; atom_name(100)= 'Fermium'
   atom_label(101)= 'Md' ; atom_name(101)= 'Mendelevium'
   atom_label(102)= 'No' ; atom_name(102)= 'Nobelium'
   atom_label(103)= 'Lr' ; atom_name(103)= 'Lawrencium'
   atom_label(104)= 'Rf' ; atom_name(104)= 'Rutherfordium'
   atom_label(105)= 'Db' ; atom_name(105)= 'Dubnium'
   atom_label(106)= 'Sg' ; atom_name(106)= 'Seaborgium'
   atom_label(107)= 'Bh' ; atom_name(107)= 'Bohrium'
   atom_label(108)= 'Hs' ; atom_name(108)= 'Hassium'
   atom_label(109)= 'Mt' ; atom_name(109)= 'Meitnerium'
   atom_label(110)= 'Ds' ; atom_name(110)= 'Darmstadtium'
   atom_label(111)= 'Rg' ; atom_name(111)= 'Roentgenium'
   atom_label(112)= 'ub' ; atom_name(112)= 'Ununbium'
   atom_label(113)= 'ut' ; atom_name(113)= 'Ununtrium'
   atom_label(114)= 'uq' ; atom_name(114)= 'Ununquadium'
   atom_label(115)= 'up' ; atom_name(115)= 'Ununpentium'
   atom_label(116)= 'uh' ; atom_name(116)= 'Ununhexium'
   atom_label(117)= 'us' ; atom_name(117)= 'Ununseptium'
   atom_label(118)= 'uo' ; atom_name(118)= 'Ununoctium'
   atom_label(119)= '  ' ; atom_name(119)= ''
   atom_label(120)= '  ' ; atom_name(120)= ''
 end if
   end subroutine set_atom_label_name

!=====================================================================
   subroutine set_cc_param(NATOM,cc_param)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   implicit none
   integer,intent(in)  :: NATOM
   real(8),intent(out) :: cc_param(NATOM,0:3)
   integer :: iatom
   cc_param(:,:) = 0.d0
   do iatom=1,2
      cc_param(iatom,0)= 3.0
      cc_param(iatom,1)= 3.6
      cc_param(iatom,2)= 3.6
   end do
   do iatom=3,3
      cc_param(iatom,0)= 2.0
      cc_param(iatom,1)= 3.0
      cc_param(iatom,2)= 3.5
   end do
   do iatom=4,10
      cc_param(iatom,0)= 1.8
      cc_param(iatom,1)= 3.0
      cc_param(iatom,2)= 3.5
   end do
   do iatom=11,11
      cc_param(iatom,0)= 2.0
      cc_param(iatom,1)= 1.8
      cc_param(iatom,2)= 3.5
   end do
   do iatom=12,18
      cc_param(iatom,0)= 1.8
      cc_param(iatom,1)= 1.45
      cc_param(iatom,2)= 2.2
   end do
   do iatom=19,30
      cc_param(iatom,0)= 1.8
      cc_param(iatom,1)= 1.6
      cc_param(iatom,2)= 3.0
   end do
   do iatom=31,36
      cc_param(iatom,0)= 1.8
      cc_param(iatom,1)= 1.7
      cc_param(iatom,2)= 2.0
   end do
   do iatom=37,48
      cc_param(iatom,0)= 1.8
      cc_param(iatom,1)= 1.7
      cc_param(iatom,2)= 1.6
   end do
   do iatom=49,54
      cc_param(iatom,0)= 1.6
      cc_param(iatom,1)= 1.7
      cc_param(iatom,2)= 2.0
   end do
   do iatom=55,55
      cc_param(iatom,0)= 1.8
      cc_param(iatom,1)= 1.7
      cc_param(iatom,2)= 1.45
      cc_param(iatom,3)= 4.5
   end do
   do iatom=56,56
      cc_param(iatom,0)= 1.8
      cc_param(iatom,1)= 1.7
      cc_param(iatom,2)= 1.45
      cc_param(iatom,3)= 3.0
   end do
   do iatom=57,71
      cc_param(iatom,0)= 1.45
      cc_param(iatom,1)= 1.6
      cc_param(iatom,2)= 1.45
      cc_param(iatom,3)= 3.0
   end do
   do iatom=72,80
      cc_param(iatom,0)= 1.6
      cc_param(iatom,1)= 1.6
      cc_param(iatom,2)= 1.45
      cc_param(iatom,3)= 3.0
   end do
!--- Au --- modified
   iatom=79
      cc_param(iatom,0)= 1.6
      cc_param(iatom,1)= 1.6
      cc_param(iatom,2)= 1.45
      cc_param(iatom,3)= 3.0
!---
   do iatom=81,86
      cc_param(iatom,0)= 1.6
      cc_param(iatom,1)= 1.7
      cc_param(iatom,2)= 2.2
      cc_param(iatom,3)= 3.0
   end do
   do iatom=87,87
      cc_param(iatom,0)= 1.6
      cc_param(iatom,1)= 1.6
      cc_param(iatom,2)= 1.45
      cc_param(iatom,3)= 4.5
   end do
   do iatom=88,94
      cc_param(iatom,0)= 1.6
      cc_param(iatom,1)= 1.6
      cc_param(iatom,2)= 1.45
      cc_param(iatom,3)= 2.0
   end do
   end subroutine set_cc_param

!=====================================================================
   subroutine set_cc_core(NATOM,cc_a1,cc_a2,cc_c1)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   implicit none
   integer,intent(in)  :: NATOM
   real(8),intent(out) :: cc_a1(NATOM), cc_a2(NATOM), cc_c1(NATOM)
   integer :: iatom
!--- Default
   do iatom = 1,NATOM
      cc_a1(iatom) = 0.d0
      cc_a2(iatom) = 0.d0
      cc_c1(iatom) = 0.5d0
   end do
!--- H
   iatom = 1
      cc_a1(iatom) = 16.2200d0
      cc_a2(iatom) =  5.5500d0
      cc_c1(iatom) =  1.1924d0
!--- He
   iatom = 2
      cc_a1(iatom) = 56.2300d0
      cc_a2(iatom) = 19.2400d0
      cc_c1(iatom) =  1.1998d0
!--- Li
   iatom = 3
      cc_a1(iatom) =  1.8400d0
      cc_a2(iatom) =  0.7300d0
      cc_c1(iatom) =  2.9081d0
!--- Be
   iatom = 4
      cc_a1(iatom) =  2.6100d0
      cc_a2(iatom) =  1.0000d0
      cc_c1(iatom) =  1.5280d0
!--- B
   iatom = 5
      cc_a1(iatom) =  6.2100d0
      cc_a2(iatom) =  2.4700d0
      cc_c1(iatom) =  1.6546d0
!--- C
   iatom = 6
      cc_a1(iatom) =  9.2800d0
      cc_a2(iatom) =  3.6900d0
      cc_c1(iatom) =  1.5222d0
!--- N
   iatom = 7
      cc_a1(iatom) = 12.8700d0
      cc_a2(iatom) =  5.1200d0
      cc_c1(iatom) =  1.4504d0
!--- O
   iatom = 8
      cc_a1(iatom) = 18.0900d0
      cc_a2(iatom) =  7.1900d0
      cc_c1(iatom) =  1.4224d0
!--- F
   iatom = 9
      cc_a1(iatom) = 23.7800d0
      cc_a2(iatom) =  9.4500d0
      cc_c1(iatom) =  1.3974d0
!--- Ne
   iatom = 10
      cc_a1(iatom) = 29.1300d0
      cc_a2(iatom) = 11.5800d0
      cc_c1(iatom) =  1.3711d0
!--- Na
   iatom = 11
      cc_a1(iatom) =  1.7100d0
      cc_a2(iatom) =  0.5000d0
      cc_c1(iatom) =  5.1815d0
!--- Mg
   iatom = 12
      cc_a1(iatom) =  2.0400d0
      cc_a2(iatom) =  0.8100d0
      cc_c1(iatom) =  3.5602d0
!--- Al
   iatom = 13
      cc_a1(iatom) =  1.7700d0
      cc_a2(iatom) =  0.7000d0
      cc_c1(iatom) =  1.7905d0
!--- Si
   iatom = 14
      cc_a1(iatom) =  2.1600d0
      cc_a2(iatom) =  0.8600d0
      cc_c1(iatom) =  1.6054d0
!--- P
   iatom = 15
      cc_a1(iatom) =  2.5900d0
      cc_a2(iatom) =  1.0300d0
      cc_c1(iatom) =  1.4995d0
!--- S
   iatom = 16
      cc_a1(iatom) =  2.9900d0
      cc_a2(iatom) =  1.1900d0
      cc_c1(iatom) =  1.4261d0
!--- Cl
   iatom = 17
      cc_a1(iatom) =  3.4800d0
      cc_a2(iatom) =  1.3800d0
      cc_c1(iatom) =  1.3860d0
!--- Ar
   iatom = 18
      cc_a1(iatom) =  3.9900d0
      cc_a2(iatom) =  1.5900d0
      cc_c1(iatom) =  1.3622d0
!--- K
   iatom = 19
      cc_a1(iatom) =  3.9900d0
      cc_a2(iatom) =  1.5900d0
      cc_c1(iatom) =  1.3622d0
!--- Ca
   iatom = 20
      cc_a1(iatom) =  1.6100d0
      cc_a2(iatom) =  0.4500d0
      cc_c1(iatom) =  4.8360d0
!--- Sc
   iatom = 21
      cc_a1(iatom) =  3.9600d0
      cc_a2(iatom) =  0.6900d0
      cc_c1(iatom) =  3.7703d0
!--- Ti
   iatom = 22
      cc_a1(iatom) =  4.6800d0
      cc_a2(iatom) =  0.9400d0
      cc_c1(iatom) =  3.3889d0
!--- V
   iatom = 23
      cc_a1(iatom) =  5.1400d0
      cc_a2(iatom) =  1.1100d0
      cc_c1(iatom) =  2.9680d0
!--- Cr
   iatom = 24
      cc_a1(iatom) =  5.1900d0
      cc_a2(iatom) =  1.3700d0
      cc_c1(iatom) =  2.8897d0
!--- Mn
   iatom = 25
      cc_a1(iatom) =  6.0300d0
      cc_a2(iatom) =  1.6300d0
      cc_c1(iatom) =  2.7024d0
!--- Fe
   iatom = 26
      cc_a1(iatom) =  6.5100d0
      cc_a2(iatom) =  1.9100d0
      cc_c1(iatom) =  2.6179d0
!--- Co
   iatom = 27
      cc_a1(iatom) =  6.9500d0
      cc_a2(iatom) =  2.3800d0
      cc_c1(iatom) =  2.7407d0
!--- Ni
   iatom = 28
      cc_a1(iatom) =  7.6000d0
      cc_a2(iatom) =  2.7400d0
      cc_c1(iatom) =  2.6949d0
!--- Cu
   iatom = 29
      cc_a1(iatom) =  7.5900d0
      cc_a2(iatom) =  3.0200d0
      cc_c1(iatom) =  2.6959d0
!--- Zn
   iatom = 30
      cc_a1(iatom) =  8.7800d0
      cc_a2(iatom) =  3.4900d0
      cc_c1(iatom) =  2.6313d0
!--- Ga
   iatom = 31
      cc_a1(iatom) =  2.0100d0
      cc_a2(iatom) =  0.8000d0
      cc_c1(iatom) =  4.0433d0
!--- Ge
   iatom = 32
      cc_a1(iatom) =  2.2800d0
      cc_a2(iatom) =  0.9100d0
      cc_c1(iatom) =  3.1110d0
!--- As
   iatom = 33
      cc_a1(iatom) =  2.6000d0
      cc_a2(iatom) =  1.0300d0
      cc_c1(iatom) =  2.6218d0
!--- Se
   iatom = 34
      cc_a1(iatom) =  2.8800d0
      cc_a2(iatom) =  1.1400d0
      cc_c1(iatom) =  2.2934d0
!--- Br
   iatom = 35
      cc_a1(iatom) =  3.2000d0
      cc_a2(iatom) =  1.2700d0
      cc_c1(iatom) =  2.1007d0
!--- Kr
   iatom = 36
      cc_a1(iatom) =  3.4900d0
      cc_a2(iatom) =  1.3900d0
      cc_c1(iatom) =  1.9478d0
!--- Rb
   iatom = 37
      cc_a1(iatom) =  1.3700d0
      cc_a2(iatom) =  0.2100d0
      cc_c1(iatom) =  6.8301d0
!--- Sr
   iatom = 38
      cc_a1(iatom) =  1.5200d0
      cc_a2(iatom) =  0.3300d0
      cc_c1(iatom) =  4.8514d0
!--- Y
   iatom = 39
      cc_a1(iatom) =  2.0600d0
      cc_a2(iatom) =  0.4900d0
      cc_c1(iatom) =  4.1719d0
!--- Zr
   iatom = 40
      cc_a1(iatom) =  2.2800d0
      cc_a2(iatom) =  0.6600d0
      cc_c1(iatom) =  3.9162d0
!--- Nb
   iatom = 41
      cc_a1(iatom) =  2.4100d0
      cc_a2(iatom) =  0.8200d0
      cc_c1(iatom) =  3.7419d0
!--- Mo
   iatom = 42
      cc_a1(iatom) =  2.5700d0
      cc_a2(iatom) =  1.0200d0
      cc_c1(iatom) =  3.8044d0
!--- Tc
   iatom = 43
      cc_a1(iatom) =  2.8200d0
      cc_a2(iatom) =  1.1200d0
      cc_c1(iatom) =  3.3669d0
!--- Ru
   iatom = 44
      cc_a1(iatom) =  3.0000d0
      cc_a2(iatom) =  1.1900d0
      cc_c1(iatom) =  3.0213d0
!--- Rh
   iatom = 45
      cc_a1(iatom) =  3.2100d0
      cc_a2(iatom) =  1.2800d0
      cc_c1(iatom) =  2.7857d0
!--- Pd
   iatom = 46
      cc_a1(iatom) =  3.3100d0
      cc_a2(iatom) =  1.3200d0
      cc_c1(iatom) =  2.5256d0
!--- Ag
   iatom = 47
      cc_a1(iatom) =  3.5300d0
      cc_a2(iatom) =  1.4100d0
      cc_c1(iatom) =  2.3857d0
!--- Cd
   iatom = 48
      cc_a1(iatom) =  3.9100d0
      cc_a2(iatom) =  1.5600d0
      cc_c1(iatom) =  2.3128d0
!--- In
   iatom = 49
      cc_a1(iatom) =  1.7900d0
      cc_a2(iatom) =  0.7100d0
      cc_c1(iatom) =  6.7251d0
!--- Sn
   iatom = 50
      cc_a1(iatom) =  1.9700d0
      cc_a2(iatom) =  0.7800d0
      cc_c1(iatom) =  5.0086d0
!--- Sb
   iatom = 51
      cc_a1(iatom) =  2.1200d0
      cc_a2(iatom) =  0.8500d0
      cc_c1(iatom) =  4.0534d0
!--- Te
   iatom = 52
      cc_a1(iatom) =  2.3700d0
      cc_a2(iatom) =  0.9500d0
      cc_c1(iatom) =  3.5696d0
!--- I
   iatom = 53
      cc_a1(iatom) =  2.5200d0
      cc_a2(iatom) =  1.0100d0
      cc_c1(iatom) =  3.0856d0
!--- Xe
   iatom = 54
      cc_a1(iatom) =  2.6300d0
      cc_a2(iatom) =  1.0500d0
      cc_c1(iatom) =  2.6837d0
!--- Cs
   iatom = 55
      cc_a1(iatom) =  2.6300d0
      cc_a2(iatom) =  1.0500d0
      cc_c1(iatom) =  2.6837d0
!--- Ba
   iatom = 56
      cc_a1(iatom) =  1.3400d0
      cc_a2(iatom) =  0.2500d0
      cc_c1(iatom) =  5.3338d0
!--- La
   iatom = 57
      cc_a1(iatom) =  5.0000d0
      cc_a2(iatom) =  2.0000d0
      cc_c1(iatom) =  3.2494d0
!--- Ce
   iatom = 58
      cc_a1(iatom) =  5.3200d0
      cc_a2(iatom) =  2.1300d0
      cc_c1(iatom) =  3.0538d0
!--- Pr
   iatom = 59
      cc_a1(iatom) =  5.5300d0
      cc_a2(iatom) =  2.2100d0
      cc_c1(iatom) =  2.8422d0
!--- Nd
   iatom = 60
      cc_a1(iatom) =  5.6900d0
      cc_a2(iatom) =  2.2800d0
      cc_c1(iatom) =  2.8422d0
!--- Pm
   iatom = 61
      cc_a1(iatom) =  5.9100d0
      cc_a2(iatom) =  2.3600d0
      cc_c1(iatom) =  2.5202d0
!--- Sm
   iatom = 62
      cc_a1(iatom) =  6.0700d0
      cc_a2(iatom) =  2.4300d0
      cc_c1(iatom) =  2.3958d0
!--- Eu
   iatom = 63
      cc_a1(iatom) =  6.2400d0
      cc_a2(iatom) =  2.5000d0
      cc_c1(iatom) =  2.2886d0
!--- Gd
   iatom = 64
      cc_a1(iatom) =  6.4700d0
      cc_a2(iatom) =  2.5900d0
      cc_c1(iatom) =  2.2076d0
!--- Tb
   iatom = 65
      cc_a1(iatom) =  7.1500d0
      cc_a2(iatom) =  2.8600d0
      cc_c1(iatom) =  2.2267d0
!--- Dy
   iatom = 66
      cc_a1(iatom) =  7.3400d0
      cc_a2(iatom) =  2.9400d0
      cc_c1(iatom) =  2.1510d0
!--- Ho
   iatom = 67
      cc_a1(iatom) =  7.6100d0
      cc_a2(iatom) =  3.0400d0
      cc_c1(iatom) =  2.0909d0
!--- Er
   iatom = 68
      cc_a1(iatom) =  7.8100d0
      cc_a2(iatom) =  3.1200d0
      cc_c1(iatom) =  2.0304d0
!--- Tm
   iatom = 69
      cc_a1(iatom) =  8.0000d0
      cc_a2(iatom) =  3.2000d0
      cc_c1(iatom) =  1.9772d0
!--- Yb
   iatom = 70
      cc_a1(iatom) =  8.2100d0
      cc_a2(iatom) =  3.2800d0
      cc_c1(iatom) =  1.9271d0
!--- Lu
   iatom = 71
      cc_a1(iatom) =  8.5000d0
      cc_a2(iatom) =  3.4000d0
      cc_c1(iatom) =  1.8919d0
!--- Hf
   iatom = 72
      cc_a1(iatom) =  2.0200d0
      cc_a2(iatom) =  0.8000d0
      cc_c1(iatom) =  5.8921d0
!--- Ta
   iatom = 73
      cc_a1(iatom) =  2.1600d0
      cc_a2(iatom) =  0.8600d0
      cc_c1(iatom) =  4.7264d0
!--- W
   iatom = 74
      cc_a1(iatom) =  2.2600d0
      cc_a2(iatom) =  0.9000d0
      cc_c1(iatom) =  3.9028d0
!--- Re
   iatom = 75
      cc_a1(iatom) =  2.4400d0
      cc_a2(iatom) =  0.9800d0
      cc_c1(iatom) =  3.5075d0
!--- Os
   iatom = 76
      cc_a1(iatom) =  2.4700d0
      cc_a2(iatom) =  0.9900d0
      cc_c1(iatom) =  2.9996d0
!--- Ir
   iatom = 77
      cc_a1(iatom) =  2.6700d0
      cc_a2(iatom) =  1.0700d0
      cc_c1(iatom) =  2.8089d0
!--- Pt
   iatom = 78
      cc_a1(iatom) =  2.7100d0
      cc_a2(iatom) =  1.0800d0
      cc_c1(iatom) =  2.5166d0
!--- Au
   iatom = 79
      cc_a1(iatom) =  2.8500d0
      cc_a2(iatom) =  1.1400d0
      cc_c1(iatom) =  2.3778d0
!--- Hg
   iatom = 80
      cc_a1(iatom) =  2.9900d0
      cc_a2(iatom) =  1.2000d0
      cc_c1(iatom) =  2.2533d0
!--- Tl
   iatom = 81
      cc_a1(iatom) =  1.7700d0
      cc_a2(iatom) =  0.5900d0
      cc_c1(iatom) =  6.7158d0
!--- Pb
   iatom = 82
      cc_a1(iatom) =  1.9200d0
      cc_a2(iatom) =  0.7600d0
      cc_c1(iatom) =  6.5444d0
!--- Bi
   iatom = 83
      cc_a1(iatom) =  2.0300d0
      cc_a2(iatom) =  0.8100d0
      cc_c1(iatom) =  5.2104d0
!--- Po
   iatom = 84
      cc_a1(iatom) =  2.1700d0
      cc_a2(iatom) =  0.8700d0
      cc_c1(iatom) =  4.4190d0
!--- At
   iatom = 85
      cc_a1(iatom) =  2.2900d0
      cc_a2(iatom) =  0.9200d0
      cc_c1(iatom) =  3.8179d0
!--- Rn
   iatom = 86
      cc_a1(iatom) =  2.4500d0
      cc_a2(iatom) =  0.9800d0
      cc_c1(iatom) =  3.4235d0
!--- Fr
   iatom = 87
      cc_a1(iatom) =  1.2300d0
      cc_a2(iatom) =  0.1600d0
      cc_c1(iatom) =  8.4416d0
!--- Ra
   iatom = 88
      cc_a1(iatom) =  0.9900d0
      cc_a2(iatom) =  0.2400d0
      cc_c1(iatom) =  6.1114d0
!--- Ac
   iatom = 89
      cc_a1(iatom) =  1.4900d0
      cc_a2(iatom) =  0.3100d0
      cc_c1(iatom) =  4.7270d0
!--- Th
   iatom = 90
      cc_a1(iatom) =  1.5900d0
      cc_a2(iatom) =  0.4000d0
      cc_c1(iatom) =  4.3902d0
!--- Pa
   iatom = 91
      cc_a1(iatom) =  2.0600d0
      cc_a2(iatom) =  0.4500d0
      cc_c1(iatom) =  3.8349d0
!--- U
   iatom = 92
      cc_a1(iatom) =  2.0800d0
      cc_a2(iatom) =  0.5000d0
      cc_c1(iatom) =  3.5183d0
!--- Np
   iatom = 93
      cc_a1(iatom) =  2.7200d0
      cc_a2(iatom) =  0.6000d0
      cc_c1(iatom) =  3.5099d0
!--- Pu
   iatom = 94
      cc_a1(iatom) =  2.7600d0
      cc_a2(iatom) =  0.6200d0
      cc_c1(iatom) =  3.1671d0
   end subroutine set_cc_core

!=====================================================================
   subroutine set_dist_nn_ang(NATOM,dist_nn_ang)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   implicit none
   integer,intent(in)  :: NATOM
   real(8),intent(out) :: dist_nn_ang(NATOM)
   integer :: iatom
!--- Default
   do iatom = 1,NATOM
      dist_nn_ang(iatom) = 8.d0
   end do
!--- H (H2 --> 0.74085)
   iatom = 1
      dist_nn_ang(iatom) = 0.74085d0
!--- He
   iatom = 2
      dist_nn_ang(iatom) = 0.d0
!--- Li (Li2 --> 2.6723)
   iatom = 3
      dist_nn_ang(iatom) = 3.023d0
!--- Be (Be2 --> 2.4924)
   iatom = 4
      dist_nn_ang(iatom) = 2.22d0
!--- B (B2 --> 1.6087)
   iatom = 5
      dist_nn_ang(iatom) = 1.6087d0
!--- C (C2 --> 1.2436)
   iatom = 6
      dist_nn_ang(iatom) = 1.54d0
!--- N (N2 --> 1.0954)
   iatom = 7
      dist_nn_ang(iatom) = 1.0954d0
!--- O (O2 --> 1.2065)
   iatom = 8
      dist_nn_ang(iatom) = 1.2065d0
!--- F (F2 --> 1.4182)
   iatom = 9
      dist_nn_ang(iatom) = 1.44d0
!--- Ne
   iatom = 10
      dist_nn_ang(iatom) = 3.16d0
!--- Na (Na2 --> 3.0798)
   iatom = 11
      dist_nn_ang(iatom) = 3.659d0
!--- Mg
   iatom = 12
      dist_nn_ang(iatom) = 3.20d0
!--- Al (Al2 --> 2.4660)
   iatom = 13
      dist_nn_ang(iatom) = 2.86d0
!--- Si (Si2 --> 2.2437)
   iatom = 14
      dist_nn_ang(iatom) = 2.35d0
!--- P (P2 --> 1.8945)
   iatom = 15
      dist_nn_ang(iatom) = 1.8945d0
!--- S (S2 --> 1.8892)
   iatom = 16
      dist_nn_ang(iatom) = 1.8892d0
!--- Cl (Cl2 --> 1.9897)
   iatom = 17
      dist_nn_ang(iatom) = 2.02d0
!--- Ar
   iatom = 18
      dist_nn_ang(iatom) = 3.76d0
!--- K
   iatom = 19
      dist_nn_ang(iatom) = 4.525d0
!--- Ca
   iatom = 20
      dist_nn_ang(iatom) = 3.95d0
!--- Sc
   iatom = 21
      dist_nn_ang(iatom) = 3.25d0
!--- Ti
   iatom = 22
      dist_nn_ang(iatom) = 2.89d0
!--- V
   iatom = 23
      dist_nn_ang(iatom) = 2.62d0
!--- Cr (Cr2 --> 1.6775)
   iatom = 24
      dist_nn_ang(iatom) = 2.50d0
!--- Mn
   iatom = 25
      dist_nn_ang(iatom) = 2.24d0
!--- Fe
   iatom = 26
      dist_nn_ang(iatom) = 2.48d0
!--- Co
   iatom = 27
      dist_nn_ang(iatom) = 2.50d0
!--- Ni
   iatom = 28
      dist_nn_ang(iatom) = 2.49d0
!--- Cu (Cu2 --> 2.2225)
   iatom = 29
      dist_nn_ang(iatom) = 2.56d0
!--- Zn
   iatom = 30
      dist_nn_ang(iatom) = 2.66d0
!--- Ga
   iatom = 31
      dist_nn_ang(iatom) = 2.44d0
!--- Ge
   iatom = 32
      dist_nn_ang(iatom) = 2.45d0
!--- As
   iatom = 33
      dist_nn_ang(iatom) = 3.16d0
!--- Se
   iatom = 34
      dist_nn_ang(iatom) = 2.32d0
!--- Br
   iatom = 35
      dist_nn_ang(iatom) = 0.d0
!--- Kr
   iatom = 36
      dist_nn_ang(iatom) = 4.00d0
!--- Rb
   iatom = 37
      dist_nn_ang(iatom) = 4.837d0
!--- Sr
   iatom = 38
      dist_nn_ang(iatom) = 4.30d0
!--- Y
   iatom = 39
      dist_nn_ang(iatom) = 3.55d0
!--- Zr
   iatom = 40
      dist_nn_ang(iatom) = 3.17d0
!--- Nb
   iatom = 41
      dist_nn_ang(iatom) = 2.86d0
!--- Mo (Mo2 --> 1.9315)
   iatom = 42
      dist_nn_ang(iatom) = 2.72d0
!--- Tc
   iatom = 43
      dist_nn_ang(iatom) = 2.71d0
!--- Ru
   iatom = 44
      dist_nn_ang(iatom) = 2.65d0
!--- Rh
   iatom = 45
      dist_nn_ang(iatom) = 2.69d0
!--- Pd
   iatom = 46
      dist_nn_ang(iatom) = 2.75d0
!--- Ag
   iatom = 47
      dist_nn_ang(iatom) = 2.89d0
!--- Cd
   iatom = 48
      dist_nn_ang(iatom) = 2.98d0
!--- In
   iatom = 49
      dist_nn_ang(iatom) = 3.25d0
!--- Sn
   iatom = 50
      dist_nn_ang(iatom) = 2.81d0
!--- Sb
   iatom = 51
      dist_nn_ang(iatom) = 2.91d0
!--- Te
   iatom = 52
      dist_nn_ang(iatom) = 2.86d0
!--- I
   iatom = 53
      dist_nn_ang(iatom) = 3.54d0
!--- Xe
   iatom = 54
      dist_nn_ang(iatom) = 4.34d0
!--- Cs
   iatom = 55
      dist_nn_ang(iatom) = 5.235d0
!--- Ba
   iatom = 56
      dist_nn_ang(iatom) = 4.35d0
!--- La
   iatom = 57
      dist_nn_ang(iatom) = 3.73d0
!--- Ce
   iatom = 58
      dist_nn_ang(iatom) = 3.65d0
!--- Pr
   iatom = 59
      dist_nn_ang(iatom) = 3.63d0
!--- Nd
   iatom = 60
      dist_nn_ang(iatom) = 3.66d0
!--- Pm
   iatom = 61
      dist_nn_ang(iatom) = 0.d0
!--- Sm
   iatom = 62
      dist_nn_ang(iatom) = 3.59d0
!--- Eu
   iatom = 63
      dist_nn_ang(iatom) = 3.96d0
!--- Gd
   iatom = 64
      dist_nn_ang(iatom) = 3.58d0
!--- Tb
   iatom = 65
      dist_nn_ang(iatom) = 3.52d0
!--- Dy
   iatom = 66
      dist_nn_ang(iatom) = 3.51d0
!--- Ho
   iatom = 67
      dist_nn_ang(iatom) = 3.49d0
!--- Er
   iatom = 68
      dist_nn_ang(iatom) = 3.47d0
!--- Tm
   iatom = 69
      dist_nn_ang(iatom) = 3.54d0
!--- Yb
   iatom = 70
      dist_nn_ang(iatom) = 3.88d0
!--- Lu
   iatom = 71
      dist_nn_ang(iatom) = 3.43d0
!--- Hf
   iatom = 72
      dist_nn_ang(iatom) = 3.13d0
!--- Ta
   iatom = 73
      dist_nn_ang(iatom) = 2.86d0
!--- W
   iatom = 74
      dist_nn_ang(iatom) = 2.74d0
!--- Re
   iatom = 75
      dist_nn_ang(iatom) = 2.74d0
!--- Os
   iatom = 76
      dist_nn_ang(iatom) = 2.68d0
!--- Ir
   iatom = 77
      dist_nn_ang(iatom) = 2.71d0
!--- Pt
   iatom = 78
      dist_nn_ang(iatom) = 2.77d0
!--- Au
   iatom = 79
      dist_nn_ang(iatom) = 2.88d0
!--- Hg
   iatom = 80
      dist_nn_ang(iatom) = 3.01d0
!--- Tl
   iatom = 81
      dist_nn_ang(iatom) = 3.46d0
!--- Pb
   iatom = 82
      dist_nn_ang(iatom) = 3.50d0
!--- Bi
   iatom = 83
      dist_nn_ang(iatom) = 3.07d0
!--- Po
   iatom = 84
      dist_nn_ang(iatom) = 3.34d0
!--- At
   iatom = 85
      dist_nn_ang(iatom) = 0.d0
!--- Rn
   iatom = 86
      dist_nn_ang(iatom) = 0.d0
!--- Fr
   iatom = 87
      dist_nn_ang(iatom) = 0.d0
!--- Ra
   iatom = 88
      dist_nn_ang(iatom) = 0.d0
!--- Ac
   iatom = 89
      dist_nn_ang(iatom) = 3.76d0
!--- Th
   iatom = 90
      dist_nn_ang(iatom) = 3.60d0
!--- Pa
   iatom = 91
      dist_nn_ang(iatom) = 3.21d0
!--- U
   iatom = 92
      dist_nn_ang(iatom) = 2.75d0
!--- Np
   iatom = 93
      dist_nn_ang(iatom) = 2.62d0
!--- Pu
   iatom = 94
      dist_nn_ang(iatom) = 3.1d0
!--- Am
   iatom = 95
      dist_nn_ang(iatom) = 3.61d0
!--- Cm
   iatom = 96
      dist_nn_ang(iatom) = 0.d0
!--- Bk
   iatom = 97
      dist_nn_ang(iatom) = 0.d0
!--- Cf
   iatom = 98
      dist_nn_ang(iatom) = 0.d0
!--- Es
   iatom = 99
      dist_nn_ang(iatom) = 0.d0
!--- Fm
   iatom = 100
      dist_nn_ang(iatom) = 0.d0
!--- Md
   iatom = 101
      dist_nn_ang(iatom) = 0.d0
!--- No
   iatom = 102
      dist_nn_ang(iatom) = 0.d0
!--- Lr
   iatom = 103
      dist_nn_ang(iatom) = 0.d0
!--- Rf
   iatom = 104
      dist_nn_ang(iatom) = 0.d0
!--- Db
   iatom = 105
      dist_nn_ang(iatom) = 0.d0
!--- Sg
   iatom = 106
      dist_nn_ang(iatom) = 0.d0
!--- Bh
   iatom = 107
      dist_nn_ang(iatom) = 0.d0
!--- Hs
   iatom = 108
      dist_nn_ang(iatom) = 0.d0
!--- Mt
   iatom = 109
      dist_nn_ang(iatom) = 0.d0
!--- Ds
   iatom = 110
      dist_nn_ang(iatom) = 0.d0
!--- Rg
   iatom = 111
      dist_nn_ang(iatom) = 0.d0
!--- Uub
   iatom = 112
      dist_nn_ang(iatom) = 0.d0
!--- Uut
   iatom = 113
      dist_nn_ang(iatom) = 0.d0
!--- Uuq
   iatom = 114
      dist_nn_ang(iatom) = 0.d0
!--- Uup
   iatom = 115
      dist_nn_ang(iatom) = 0.d0
!--- Uuh
   iatom = 116
      dist_nn_ang(iatom) = 0.d0
!--- Uus
   iatom = 117
      dist_nn_ang(iatom) = 0.d0
!--- Uuo
   iatom = 118
      dist_nn_ang(iatom) = 0.d0
   end subroutine set_dist_nn_ang

!
!  Software name : CIAO (Code for Investigating Atomic Orbitals)
!  Subroutine(s) : det_real_matrix, inv_real_matrix, axb_real_matrix
!                : lu_real_matrix, bk_real_matrix, 
!                : improve_axb_real_matrix
!  Author(s)     : Masakuni Okamoto (August 25, 2003)
!
!
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!
!
!  The license of the code and contact address :
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)
!
!=====================================================================
   subroutine det_real_matrix(ier,n,a,det)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   implicit none
   integer,intent(in)  :: n
   real(8),intent(in)  :: a(n,n)
   integer,intent(out) :: ier
   real(8),intent(out) :: det
   integer :: i, j
   real(8) :: even_odd
   integer,allocatable :: ipiv(:)
   real(8),allocatable :: a_lu(:,:)
  !++++++++++++++++++++++++++++
   allocate(a_lu(n,n),ipiv(n))
  !++++++++++++++++++++++++++++
   ier = 0
   a_lu(:,:) = 0.d0
   do i = 1,n
      do j = 1,n
         a_lu(i,j) = a(i,j)
      end do
   end do
   call lu_real_matrix(ier,n,a_lu,ipiv,even_odd)
   if (ier /= 0) then
      go to 99
   end if
   det = even_odd
   do i = 1,n
      det = det * a_lu(i,i)
   end do
99 continue
  !++++++++++++++++++++++
   deallocate(a_lu,ipiv)
  !++++++++++++++++++++++
   end subroutine det_real_matrix

!=====================================================================
   subroutine inv_real_matrix(ier,n,a,ainv)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   implicit none
   integer,intent(in)  :: n
   real(8),intent(in)  :: a(n,n)
   integer,intent(out) :: ier
   real(8),intent(out) :: ainv(n,n)
   integer :: i, j
   real(8) :: even_odd
   integer,allocatable :: ipiv(:)
   real(8),allocatable :: a_lu(:,:)
  !++++++++++++++++++++++++++++
   allocate(a_lu(n,n),ipiv(n))
  !++++++++++++++++++++++++++++
   ier = 0
   a_lu(:,:) = 0.d0
   ainv(:,:) = 0.d0
   do i = 1,n
      ainv(i,i) = 1.d0
      do j = 1,n
         a_lu(i,j) = a(i,j)
      end do
   end do
   call lu_real_matrix(ier,n,a_lu,ipiv,even_odd)
   if (ier /= 0) then
      go to 99
   end if
   do j = 1,n
      call bk_real_matrix(ier,n,a_lu,ipiv,ainv(1,j))
      if (ier /= 0) then
         go to 99
      end if
   end do
99 continue
  !++++++++++++++++++++++
   deallocate(a_lu,ipiv)
  !++++++++++++++++++++++
   end subroutine inv_real_matrix

!=====================================================================
   subroutine axb_real_matrix(ier,n,m,a,x,b)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   implicit none
   integer,intent(in)  :: n, m
   real(8),intent(in)  :: a(n,n), b(n,m)
   integer,intent(out) :: ier
   real(8),intent(out) :: x(n,m)
   integer :: i
   integer :: j
   real(8) :: even_odd
   real(8) :: rr, rr_old, res
   integer,allocatable :: ipiv(:)
   real(8),allocatable :: a_lu(:,:)
   real(8),allocatable :: z(:)
  !+++++++++++++++++++++++++++++++++
   allocate(a_lu(n,n),ipiv(n),z(n))
  !+++++++++++++++++++++++++++++++++
   ier = 0
   a_lu(:,:) = a(:,:)
   x(:,:) = b(:,:)
   call lu_real_matrix(ier,n,a_lu,ipiv,even_odd)
   if (ier /= 0) then
      go to 99
   end if
   do j = 1,m
      call bk_real_matrix(ier,n,a_lu,ipiv,x(1,j))
      if (ier /= 0) then
         go to 99
      end if
   end do
   rr = 1.d100
   do
      rr_old = rr
      rr = 0.d0
      do j = 1,m
         z(:) = x(:,j)
         call improve_axb_real_matrix(ier,n,a,x(1,j),b(1,j),a_lu,ipiv)
         if (ier /= 0) then
            go to 99
         end if
         do i = 1,n
            rr = rr + (z(i)-x(i,j))**2
         end do
      end do
      if (rr < rr_old) then
         cycle
      else
         exit
      end if
   end do
   res = sqrt(rr)
99 continue
  !++++++++++++++++++++++++
   deallocate(a_lu,ipiv,z)
  !++++++++++++++++++++++++
   end subroutine axb_real_matrix

!=====================================================================
   subroutine lu_real_matrix(ier,n,a,ipiv,even_odd)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   implicit none
   integer,intent(in)    :: n
   real(8),intent(inout) :: a(n,n)
   integer,intent(out)   :: ier, ipiv(n)
   real(8),intent(out)   :: even_odd
   integer :: i_max, i, j, k
   real(8) :: a_max, sum, tmp
   real(8),parameter :: TINY = 1.d-40
   real(8),allocatable :: scaling_row(:)
   ier = 0
  !+++++++++++++++++++++++++
   allocate(scaling_row(n))
  !+++++++++++++++++++++++++
   even_odd = 1.d0
   do i = 1,n
      a_max = 0.d0
      do j = 1,n
         if (abs(a(i,j)) > a_max) then
            a_max = abs(a(i,j))
         end if
      end do
      if (a_max == 0.d0) then
         ier = 1 ; go to 99
      end if
      scaling_row(i) = 1.d0/a_max
   end do
   do j = 1,n
      do i = 1,j-1
         sum = a(i,j)
         do k = 1,i-1
            sum = sum - a(i,k)*a(k,j)
         end do
         a(i,j) = sum
      end do
      a_max = 0.d0
      do i = j,n
         sum = a(i,j)
         do k = 1,j-1
            sum = sum - a(i,k)*a(k,j)
         end do
         a(i,j) = sum
         tmp = scaling_row(i)*abs(sum)
         if (tmp > a_max) then
            i_max = i
            a_max = tmp
         end if
      end do
      if (j /= i_max) then
         do k = 1,n
            tmp = a(i_max,k)
            a(i_max,k) = a(j,k)
            a(j,k) = tmp
         end do
         even_odd = - even_odd
         scaling_row(i_max) = scaling_row(j)
      end if
      ipiv(j) = i_max
      if (a(j,j) == 0.d0) then
         a(j,j) = TINY
      end if
      if (j /= n) then
         tmp = 1.d0/a(j,j)
         do i = j+1,n
            a(i,j) = a(i,j) * tmp
         end do
      end if
   end do
99 continue
  !++++++++++++++++++++++++
   deallocate(scaling_row)
  !++++++++++++++++++++++++
   end subroutine lu_real_matrix

!=====================================================================
   subroutine bk_real_matrix(ier,n,a,ipiv,b)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   implicit none
   integer,intent(in)    :: n, ipiv(n)
   real(8),intent(in)    :: a(n,n)
   real(8),intent(inout) :: b(n)
   integer,intent(out)   :: ier
   integer :: i, j, k, ip
   real(8) :: sum
   ier = 0
   k = 0
   do i = 1,n
      ip = ipiv(i)
      sum = b(ip)
      b(ip) = b(i)
      if (k /= 0) then
         do j = k,i-1
            sum = sum - a(i,j)*b(j)
         end do
      else if (sum /= 0.d0) then
         k = i
      end if
      b(i) = sum
   end do
   do i = n,1,-1
      sum = b(i)
      do j = i+1,n
         sum = sum - a(i,j)*b(j)
      end do
      b(i) = sum/a(i,i)
   end do
99 continue
   end subroutine bk_real_matrix

!=====================================================================
   subroutine improve_axb_real_matrix(ier,n,a,x,b,a_lu,ipiv)
!=====================================================================
!
!  Improves X of a linear equation A*X = B
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   implicit none
   integer,intent(out)   :: ier
   integer,intent(in)    :: n, ipiv(n)
   real(8),intent(in)    :: a(n,n), b(n), a_lu(n,n)
   real(8),intent(inout) :: x(n)
   real(8),allocatable :: r(:)
   ier = 0
  !+++++++++++++++
   allocate(r(n))
  !+++++++++++++++
   r(:) = matmul(a(:,:),x(:)) - b(:)
   call bk_real_matrix(ier,n,a_lu,ipiv,r)
   if (ier /= 0) then
      go to 99
   end if
   x(:) = x(:) - r(:)
  !++++++++++++++
   deallocate(r)
  !++++++++++++++
99 continue
   end subroutine improve_axb_real_matrix

!
!  Software name : CIAO (Code for Investigating Atomic Orbitals)
!  Subroutine(s) : calc_energy_kb, write_energy_kb, calc_local_level_kb
!                : check_ghost_states_kb, write_local_level_kb
!                : write_ghost_exists, write_ghost_none
!  Function(s)   : fn_ghost, fn_pm_sign
!  Author(s)     : Masakuni Okamoto (August 25, 2003)
!
!
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!
!
!  The license of the code and contact address :
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)
!
!=====================================================================
   subroutine calc_energy_kb(ier)
!=====================================================================
!
!  Calculates the Kleinman-Bylander energies
!
!  ### CAUTION ### 2006.08.23 M.O.
!  Temporarily, tt = 1 for veff_ps()
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer :: ir, ips, jps
   real(8) :: sum1, sum2, dv_sl, eps
   real(8),allocatable :: vloc(:)
   ier = 0
   eps = 1.d-12
  !++++++++++++++++++++++++++++++++++++
   allocate(vloc(nmesh)) ; vloc = 0.d0
  !++++++++++++++++++++++++++++++++++++
   engy_kb(:,:) = 0.d0
   do jps = 0,nps
      if (jps == 0) then
! =============================================== modiifed by K. T. ========== 4.0
!         vloc(:) = vloc_scr_us(:)
         vloc(:) = vloc_scr_us(:,1)
! ============================================================================ 4.0
      else
         vloc(:) = veff_ps(:,jps,1)
      end if
      do ips = 1,nps
         sum1 = 0.d0
         sum2 = 0.d0
         do ir = 1,nmesh
            dv_sl = veff_ps(ir,ips,1) - vloc(ir)
            if (abs(dv_sl) < eps) then
               dv_sl = sign(eps,dv_sl)
            end if
            sum1 = sum1 + wr(ir) * chi_ps(ir,ips,1)**2 * dv_sl
            sum2 = sum2 + wr(ir) * chi_ps(ir,ips,1)**2 * dv_sl**2
         end do
         vrms_kb(ips,jps) = sqrt(sum2)
         cos_kb (ips,jps) = sum1 / sqrt(sum2)
         engy_kb(ips,jps) = sum2 / sum1
      end do
   end do
  !+++++++++++++++++
   deallocate(vloc)
  !+++++++++++++++++
99 continue
   end subroutine calc_energy_kb

! ========================================= added by K. T. =================== 4.0
subroutine calc_energy_kb_kt(ier)
  use parameters
  implicit none

  integer,intent(out) :: ier
  integer :: ir, ips, jps
  integer :: ispin, jspin
  
  real(8) :: sum1, sum2, dv_sl, eps
  real(8),allocatable :: vloc(:)

  ier = 0
  eps = 1.d-12

  !++++++++++++++++++++++++++++++++++++
  allocate(vloc(nmesh)) ; vloc = 0.d0
  !++++++++++++++++++++++++++++++++++++

  engy_kb(:,:) = 0.d0
  
  do jps =1, nps+nspin
     
     jspin = 1 + mod(jps-1,nspin)
     if ( jps > nps ) then
        vloc(:) = vloc_scr_us(:,jspin)
     else
        vloc(:) = veff_ps(:,jps,1)
     end if
     
     do ips = 1,nps
        sum1 = 0.d0
        sum2 = 0.d0

        ispin = ( 1 -spin_index_ps(ips) )/2 +1

        if ( ispin /= jspin ) cycle

        do ir = 1,nmesh
           dv_sl = veff_ps(ir,ips,1) - vloc(ir)
           if (abs(dv_sl) < eps) then
              dv_sl = sign(eps,dv_sl)
           end if
           sum1 = sum1 + wr(ir) * chi_ps(ir,ips,1)**2 * dv_sl
           sum2 = sum2 + wr(ir) * chi_ps(ir,ips,1)**2 * dv_sl**2
        end do

        vrms_kb(ips,jps) = sqrt(sum2)
        cos_kb (ips,jps) = sum1 / sqrt(sum2)
        engy_kb(ips,jps) = sum2 / sum1
     end do
  end do

  !+++++++++++++++++
  deallocate(vloc)
  !+++++++++++++++++

99 continue
end subroutine calc_energy_kb_kt
! ============================================================================ 4.0

!=====================================================================
   subroutine write_energy_kb(ifile)
!=====================================================================
!
!  Writes the Kleinman-Bylander energies
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(in) :: ifile
   integer :: ips, jps
   character(1) :: fn_label_orbital
   write(ifile,*)
   write(ifile,*) 'Kleinman-Bylander energies : E[KB](l,loc)'
   write(ifile,10) &
      (fn_label_orbital(l_qnum(ishell_ps(ips,1))),ips=1,nps)
   do jps = 1,nps
      write(ifile,20) &
         fn_label_orbital(l_qnum(ishell_ps(jps,1))), &
         (engy_kb(ips,jps),ips=1,nps)
   end do
   write(ifile,21) 'present',(engy_kb(ips,0),ips=1,nps)
   write(ifile,*)
   write(ifile,*) 'Kleinman-Bylander RMS : Vrms[KB](l,loc)'
   write(ifile,10) &
      (fn_label_orbital(l_qnum(ishell_ps(ips,1))),ips=1,nps)
   do jps = 1,nps
      write(ifile,20) &
         fn_label_orbital(l_qnum(ishell_ps(jps,1))), &
         (vrms_kb(ips,jps),ips=1,nps)
   end do
   write(ifile,21) 'present',(vrms_kb(ips,0),ips=1,nps)
   write(ifile,*)
   write(ifile,*) 'Kleinman-Bylander cosines : C[KB](l,loc)'
   write(ifile,10) &
      (fn_label_orbital(l_qnum(ishell_ps(ips,1))),ips=1,nps)
   do jps = 1,nps
      write(ifile,20) &
         fn_label_orbital(l_qnum(ishell_ps(jps,1))), &
         (cos_kb(ips,jps),ips=1,nps)
   end do
   write(ifile,21) 'present',(cos_kb(ips,0),ips=1,nps)
10 format(1x,7x,4(10x,a1,5x))
20 format(1x,3x,a1,3x,4f16.6)
21 format(1x,a7,4f16.6)
   end subroutine write_energy_kb

!================================== added by K. T ============================= 4.0
subroutine write_energy_kb_kt(ifile)
  use parameters

  implicit none
  integer,intent(in) :: ifile

  integer :: ips, jps, ispin
  character(1) :: fn_label_orbital

  write(ifile,*)
  write(ifile,*) 'Kleinman-Bylander energies : E[KB](l,loc)'

  Do ispin=1, nspin

     if ( nspin == 2 ) then
        write(ifile,*)

        if ( ispin == 1 ) then
           write(ifile,*) 'spin component : up'
        else if ( ispin ==2 ) then
           write(ifile,*) 'spin component : down'
        endif
     endif

     write(ifile,10) &
          (fn_label_orbital(l_qnum(ishell_ps(ips,1))),ips=ispin,nps,nspin )

     do jps =ispin, nps, nspin
        write(ifile,20) &
             fn_label_orbital(l_qnum(ishell_ps(jps,1))), &
             (engy_kb(ips,jps),ips=ispin,nps,nspin)
     end do

     write(ifile,21) 'present',(engy_kb(ips,nps+ispin),ips=ispin,nps,nspin)

  End do

  write(ifile,*)
  write(ifile,*) 'Kleinman-Bylander RMS : Vrms[KB](l,loc)'
  
  Do ispin=1, nspin

     if ( nspin == 2 ) then
        write(ifile,*)

        if ( ispin == 1 ) then
           write(ifile,*) 'spin component : up'
        else if ( ispin ==2 ) then
           write(ifile,*) 'spin component : down'
        endif
     endif

     write(ifile,10) &
          (fn_label_orbital(l_qnum(ishell_ps(ips,1))),ips=ispin,nps,nspin)

     do jps =ispin, nps, nspin
        write(ifile,20) &
             fn_label_orbital(l_qnum(ishell_ps(jps,1))), &
             (vrms_kb(ips,jps),ips=ispin,nps,nspin)
     end do

     write(ifile,21) 'present',(vrms_kb(ips,nps+ispin),ips=ispin,nps,nspin)

  End do

  write(ifile,*)
  write(ifile,*) 'Kleinman-Bylander cosines : C[KB](l,loc)'

  Do ispin=1, nspin

     if ( nspin == 2 ) then
        write(ifile,*)

        if ( ispin == 1 ) then
           write(ifile,*) 'spin component : up'
        else if ( ispin ==2 ) then
           write(ifile,*) 'spin component : down'
        endif

     endif

     write(ifile,10) &
          (fn_label_orbital(l_qnum(ishell_ps(ips,1))),ips=ispin,nps,nspin)

     do jps = ispin, nps, nspin
        write(ifile,20) &
             fn_label_orbital(l_qnum(ishell_ps(jps,1))), &
             (cos_kb(ips,jps),ips=ispin,nps,nspin)
     end do
     write(ifile,21) 'present',(cos_kb(ips,nps+ispin),ips=ispin,nps,nspin)
  End do

10 format(1x,7x,4(10x,a1,5x))
20 format(1x,3x,a1,3x,4f16.6)
21 format(1x,a7,4f16.6)

end subroutine write_energy_kb_kt
! ========================================================================= 4.0

!=====================================================================
   subroutine calc_local_level_kb(ier)
!=====================================================================
!
!  Calculates the Kleinman-Bylander local energy levels
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer :: ips, node, ie, ishell, ll
   ier = 0
   do ips = 1,nps
      ishell = ishell_ps(ips,1)
      ll = l_qnum(ishell)
      do ie = 1,ne_kb
         node = ie - 1
         if (ie > 1) then
            if (is_solved_kb(ie-1,ips) == 0) then
               is_solved_kb(ie,ips) = 0
               ee_local_kb(ie,ips) = 0.d0
               cycle
            end if
         end if
         call calc_bound_state_loc(ier,IFLOG, &
              iord_pc,iord_nec,iord_diff,dx,eps_de, &
              nmesh,rpos,wr,vloc_scr_us,ll,node,ee_local_kb(ie,ips), &
              is_solved_kb(ie,ips))
         if (ier /= 0) then
            write(IFLOG,*) '### ERROR ### in calc_bound_state_loc'
            go to 99
         end if
      end do
   end do
99 continue
   end subroutine calc_local_level_kb

!======================================= added by K. T. ==================== 4.0
subroutine calc_local_level_kb_kt(ier)
  use parameters
  implicit none

  integer,intent(out) :: ier

  integer :: ips, node, ie, ishell, ll
  integer :: ispin
  ier = 0

  do ips = 1,nps
     ishell = ishell_ps(ips,1)
     ll = l_qnum(ishell)

     ispin = ( 1 - spin(ishell) )/2 +1

     do ie = 1,ne_kb
        node = ie - 1
        if (ie > 1) then
           if (is_solved_kb(ie-1,ips) == 0) then
              is_solved_kb(ie,ips) = 0
              ee_local_kb(ie,ips) = 0.d0
              cycle
           end if
        end if

        call calc_bound_state_loc(ier, IFLOG, &
             & iord_pc, iord_nec, iord_diff, dx, eps_de, &
             & nmesh, rpos, wr, vloc_scr_us(:,ispin), ll, node, &
             & ee_local_kb(ie,ips), is_solved_kb(ie,ips) )

        if (ier /= 0) then
           write(IFLOG,*) '### ERROR ### in calc_bound_state_loc'
           go to 99
        end if

     end do
  end do

99 continue

end subroutine calc_local_level_kb_kt
! ======================================================================== 4.0
   
!=====================================================================
   subroutine check_ghost_states_kb(ier)
!=====================================================================
!
!  Checks if ghost states exist or not.
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer :: ips
   real(8) :: e1, e2, ekb, ee, eps = 1.d-4
   ier = 0
   do ips = 1,nps
      ekb = engy_kb(ips,0)
      e1  = ee_local_kb(1,ips)
      e2  = ee_local_kb(2,ips)
      ee  = engy(ishell_ps(ips,1))
      if (ekb > eps) then
         if (e1 > -eps) then
            is_ghost_kb(ips) = -1
         else
            if (ee > e2) then
               is_ghost_kb(ips) = 1
            else
               is_ghost_kb(ips) = 0
            end if
         end if
      else if (ekb < -eps) then
         if (e1 > -eps) then
            is_ghost_kb(ips) = -1
         else
            if (ee > e1) then
               is_ghost_kb(ips) = 1
            else
               is_ghost_kb(ips) = 0
            end if
         end if
      else
         if (abs(ee-e1) > eps) then
            is_ghost_kb(ips) = 1
         else
            is_ghost_kb(ips) = 0
         end if
      end if
   end do
   have_ghost_kb = 0
   do ips = 1,nps
      if (is_ghost_kb(ips) == -1) then
         have_ghost_kb = -1
      end if
   end do
   do ips = 1,nps
      if (is_ghost_kb(ips) == 1) then
         have_ghost_kb = 1
      end if
   end do
99 continue
   end subroutine check_ghost_states_kb

!=============================================== added by K. T. ============= 4.0
subroutine check_ghost_states_kb_kt(ier)
  use parameters
  implicit none

  integer,intent(out) :: ier

  integer :: ips, ispin
  real(8) :: e1, e2, ekb, ee, eps = 1.d-4

  ier = 0

  do ips = 1,nps

     ispin = ( 1 -spin_index_ps(ips) )/2 +1

     ekb = engy_kb(ips,nps+ispin)

     e1  = ee_local_kb(1,ips)
     e2  = ee_local_kb(2,ips)
     ee  = engy(ishell_ps(ips,1))

     if (ekb > eps) then
        if (e1 > -eps) then
           is_ghost_kb(ips) = -1
        else
           if (ee > e2) then
              is_ghost_kb(ips) = 1
           else
              is_ghost_kb(ips) = 0
           end if
        end if

     else if (ekb < -eps) then
        if (e1 > -eps) then
           is_ghost_kb(ips) = -1
        else
           if (ee > e1) then
              is_ghost_kb(ips) = 1
           else
              is_ghost_kb(ips) = 0
           end if
        end if

     else
        if (abs(ee-e1) > eps) then
           is_ghost_kb(ips) = 1
        else
           is_ghost_kb(ips) = 0
        end if
     end if
  end do

  have_ghost_kb = 0

  do ips = 1,nps
     if (is_ghost_kb(ips) == -1) then
        have_ghost_kb = -1
     end if
  end do

  do ips = 1,nps
     if (is_ghost_kb(ips) == 1) then
        have_ghost_kb = 1
     end if
  end do

99 continue

end subroutine check_ghost_states_kb_kt
! ======================================================================== 4.0

!=====================================================================
   subroutine write_local_level_kb(ifile)
!=====================================================================
!
!  Writes the Kleinman-Bylander local energy levels
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(in) :: ifile
   integer :: ips, ie
   character(1) :: fn_label_orbital, fn_pm_sign
   character(7) :: fn_ghost
   write(ifile,*)
   write(ifile,*) &
      'Kleinman-Bylander local energy levels : Eloc[KB](i,l)'
   write(ifile,10) &
      (fn_label_orbital(l_qnum(ishell_ps(ips,1))),ips=1,nps)
   do ie = 1,ne_kb
      write(ifile,20) ie,(ee_local_kb(ie,ips),ips=1,nps)
   end do
   write(ifile,21) (fn_pm_sign(engy_kb(ips,0)),ips=1,nps)
   write(ifile,22) (engy(ishell_ps(ips,1)),ips=1,nps)
   write(ifile,23) (fn_ghost(is_ghost_kb(ips)),ips=1,nps)
10 format(1x,7x,4(10x,a1,5x))
20 format(1x,'local-',i1,4f16.6)
21 format(1x,'E[KB]',2x,4(10x,a1,5x))
22 format(1x,'eigen',2x,4f16.6)
23 format(1x,'ghost',2x,4(9x,a7))
   end subroutine write_local_level_kb

!======================================== added by K. T. ===================== 4.0
subroutine write_local_level_kb_kt(ifile)
  use parameters
  implicit none

  integer,intent(in) :: ifile

  integer :: ips, ie, ispin
  character(1) :: fn_label_orbital, fn_pm_sign
  character(7) :: fn_ghost

  write(ifile,*)
  write(ifile,*) &
       'Kleinman-Bylander local energy levels : Eloc[KB](i,l)'

  Do ispin=1, nspin

     if ( nspin == 2 ) then
        write(ifile,*)
        
        if ( ispin == 1 ) then
           write(ifile,*) 'spin component : up'
        else if ( ispin ==2 ) then
           write(ifile,*) 'spin component : down'
        endif
     endif

     write(ifile,10) &
          (fn_label_orbital(l_qnum(ishell_ps(ips,1))),ips=ispin,nps,nspin)

     do ie = 1,ne_kb
        write(ifile,20) ie,(ee_local_kb(ie,ips),ips=ispin,nps,nspin)
     end do

     write(ifile,21) (fn_pm_sign(engy_kb(ips,nps+ispin)),ips=ispin,nps,nspin)

     write(ifile,22) (engy(ishell_ps(ips,1)),ips=ispin,nps,nspin)
     write(ifile,23) (fn_ghost(is_ghost_kb(ips)),ips=ispin,nps,nspin)

  End do

10 format(1x,7x,4(10x,a1,5x))
20 format(1x,'local-',i1,4f16.6)
21 format(1x,'E[KB]',2x,4(10x,a1,5x))
22 format(1x,'eigen',2x,4f16.6)
23 format(1x,'ghost',2x,4(9x,a7))

end subroutine write_local_level_kb_kt
! ========================================================================== 4.0


!=====================================================================
   function fn_ghost(is_ghost)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   implicit none
   integer,intent(in) :: is_ghost
   character(7) :: fn_ghost
   select case (is_ghost)
   case (1)
      fn_ghost = 'exists '
   case (0)
      fn_ghost = ' none  '
   case (-1)
      fn_ghost = 'unknown'
   end select
   end function fn_ghost

!=====================================================================
   function fn_pm_sign(x)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   implicit none
   real(8),intent(in) :: x
   real(8) :: eps = 1.d-6
   character(1) :: fn_pm_sign
   if (x > eps) then
      fn_pm_sign = '+'
   else if (x < -eps) then
      fn_pm_sign = '-'
   else
      fn_pm_sign = '0'
   end if
   end function fn_pm_sign

!=====================================================================
   subroutine write_ghost_exists(ifile)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   implicit none
   integer,intent(in) :: ifile
   write(ifile,*) '##############################'
   write(ifile,*) '###  A ghost state exists  ###'
   write(ifile,*) '##############################'
   end subroutine write_ghost_exists

!=====================================================================
   subroutine write_ghost_none(ifile)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   implicit none
   integer,intent(in) :: ifile
   write(ifile,*) 'ooooooooooooooooooooooooooooooo'
   write(ifile,*) 'ooo  No ghost states exist  ooo'
   write(ifile,*) 'ooooooooooooooooooooooooooooooo'
   end subroutine write_ghost_none

!=====================================================================
   subroutine write_ghost_unknown(ifile)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   implicit none
   integer,intent(in) :: ifile
   write(ifile,*) '??????????????????????????????????????'
   write(ifile,*) '???  Ghost states analysis failed  ???'
   write(ifile,*) '??????????????????????????????????????'
   end subroutine write_ghost_unknown

!
!  Software name : CIAO (Code for Investigating Atomic Orbitals)
!  Subroutine(s) : generate_rmesh, generate_gmesh
!  Author(s)     : Masakuni Okamoto (August 25, 2003)
!
!
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!
!
!  The license of the code and contact address :
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)
!
!=====================================================================
   subroutine generate_rmesh(ier,mesh,rmin,rmax, &
                             xmin,xmax,dx,xpos,rpos,wr)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   implicit none
   integer,intent(in)  :: mesh
   real(8),intent(in)  :: rmin, rmax
   integer,intent(out) :: ier
   real(8),intent(out) :: xmin, xmax, dx, &
                          xpos(mesh), rpos(mesh), wr(mesh)
   integer :: ir
   real(8) :: rr
   ier = 0
   xmin = log(rmin)
   xmax = log(rmax)
   dx = (xmax - xmin)/dble(mesh-1)
   rr = rmax / rmin
   do ir = 1,mesh
      xpos(ir) = xmin + dble(ir-1) * dx
      rpos(ir) = exp(xpos(ir))
   end do
   call set_weight_exp(ier,1,mesh,rpos,wr)
   end subroutine generate_rmesh

!=====================================================================
   subroutine generate_gmesh(ier,mesh,gmin,gmax,gpos,wg)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   implicit none
   integer,intent(in)  :: mesh
   real(8),intent(in)  :: gmin, gmax
   integer,intent(out) :: ier
   real(8),intent(out) :: gpos(mesh), wg(mesh)
   integer :: ig
   ier = 0
   do ig = 1,mesh
      gpos(ig) = gmin + dble(ig-1)/dble(mesh-1) * (gmax-gmin)
   end do
   call set_weight_unif(ier,1,mesh,gpos,wg)
   end subroutine generate_gmesh

!
!  Software name : CIAO (Code for Investigating Atomic Orbitals)
!  Subroutine(s) : pc_adams_4, pc_adams_5, pc_adams_6, pc_adams_7
!                : pc_adams_8, pc_adams_4ps, pc_adams_5ps
!                : pc_adams_6ps, pc_adams_7ps, pc_adams_8ps
!  Author(s)     : Masakuni Okamoto (August 25, 2003)
!
!
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!
!
!  The license of the code and contact address :
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)
!
!=====================================================================
   subroutine pc_adams_4(ier,ir,id,ll,kk,ee,nec,ispin)
!===================================================================== 
!
!  Predicts & Corrects chi_g(ir+id) & chi_f(ir+id)
!  using values at xpos(ir), xpos(ir-id), xpos(ir-2*id)
!  by the Adams Predictor-Corrector Method (3rd order)
!     
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters   
   implicit none
   integer,intent(in)    :: ir, ll, kk, nec, ispin
   real(8),intent(in)    :: ee
   integer,intent(inout) :: id
   integer,intent(out)   :: ier
   integer :: iec, ll_core
   real(8) :: dx12, &
              g0, g1, g2, dg0, dg1, dg2, g9, dg9, &
              f0, f1, f2, df0, df1, df2, f9, df9
   ier = 0
   if (is_core == PATOM) then
      ll_core = ll
   else
      ll_core = lmax_core
   end if
   id   = sign(1, id)
   dx12 = dx / 12.d0 * dble(id)
   select case (id)
   case(+1)
      g0  =   chi_gl(ir     ) ; f0  =   chi_fl(ir     )
      g1  =   chi_gl(ir-1*id) ; f1  =   chi_fl(ir-1*id)
      g2  =   chi_gl(ir-2*id) ; f2  =   chi_fl(ir-2*id)
      dg0 = dxchi_gl(ir     ) ; df0 = dxchi_fl(ir     )
      dg1 = dxchi_gl(ir-1*id) ; df1 = dxchi_fl(ir-1*id)
      dg2 = dxchi_gl(ir-2*id) ; df2 = dxchi_fl(ir-2*id)
   case(-1)
      g0  =   chi_gr(ir     ) ; f0  =   chi_fr(ir     )
      g1  =   chi_gr(ir-1*id) ; f1  =   chi_fr(ir-1*id)
      g2  =   chi_gr(ir-2*id) ; f2  =   chi_fr(ir-2*id)
      dg0 = dxchi_gr(ir     ) ; df0 = dxchi_fr(ir     )
      dg1 = dxchi_gr(ir-1*id) ; df1 = dxchi_fr(ir-1*id)
      dg2 = dxchi_gr(ir-2*id) ; df2 = dxchi_fr(ir-2*id)
   end select
   g9 = g0 + dx12 * (23.d0*dg0 - 16.d0*dg1 + 5.d0*dg2)
   f9 = f0 + dx12 * (23.d0*df0 - 16.d0*df1 + 5.d0*df2)
   do iec = 1,nec
      select case (is_calc)
      case (NONREL)
         call dgdx_dfdx_nonrel(rpos(ir+id),g9,f9,dg9,df9, &
                               ll,ee,veff(ir+id,ispin,ll_core))
      case (SREL)
         call dgdx_dfdx_srel(rpos(ir+id),g9,f9,dg9,df9, &
                             ll,ee,veff(ir+id,ispin,ll_core))
      case (REL)
         call dgdx_dfdx_rel(rpos(ir+id),g9,f9,dg9,df9, &
                            kk,ee,veff(ir+id,ispin,ll_core))
      end select
      g9 = g0 + dx12 * (5.d0*dg9 + 8.d0*dg0 - dg1)
      f9 = f0 + dx12 * (5.d0*df9 + 8.d0*df0 - df1)
   end do 
   select case (is_calc)
      case (NONREL)
         call dgdx_dfdx_nonrel(rpos(ir+id),g9,f9,dg9,df9, &
                               ll,ee,veff(ir+id,ispin,ll_core))
      case (SREL)
         call dgdx_dfdx_srel(rpos(ir+id),g9,f9,dg9,df9, &
                             ll,ee,veff(ir+id,ispin,ll_core))
      case (REL)
         call dgdx_dfdx_rel(rpos(ir+id),g9,f9,dg9,df9, &
                            kk,ee,veff(ir+id,ispin,ll_core))
   end select
   select case (id)
   case(+1)
        chi_gl(ir+id) =  g9 ;   chi_fl(ir+id) =  f9
      dxchi_gl(ir+id) = dg9 ; dxchi_fl(ir+id) = df9
   case(-1)
        chi_gr(ir+id) =  g9 ;   chi_fr(ir+id) =  f9
      dxchi_gr(ir+id) = dg9 ; dxchi_fr(ir+id) = df9
   end select
   end subroutine pc_adams_4

!=====================================================================
   subroutine pc_adams_5(ier,ir,id,ll,kk,ee,nec,ispin)
!=====================================================================
!
!  Predicts & Corrects chi_g(ir+id) & chi_f(ir+id)
!  using values at xpos(ir), xpos(ir-id), xpos(ir-2*id), xpos(ir-3*id)
!  by the Adams Predictor-Corrector Method
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters   
   implicit none
   integer,intent(in)    :: ir, ll, kk, nec, ispin
   real(8),intent(in)    :: ee
   integer,intent(inout) :: id
   integer,intent(out)   :: ier
   integer :: iec, ll_core
   real(8) :: dx24, &
              g0, g1, g2, g3, dg0, dg1, dg2, dg3, g9, dg9, &
              f0, f1, f2, f3, df0, df1, df2, df3, f9, df9
   ier = 0
   if (is_core == PATOM) then
      ll_core = ll
   else
      ll_core = lmax_core
   end if
   id   = sign(1, id)
   dx24 = dx / 24.d0 * dble(id)
   select case (id)
   case(+1)
      g0  =   chi_gl(ir     ) ; f0  =   chi_fl(ir     )
      g1  =   chi_gl(ir-1*id) ; f1  =   chi_fl(ir-1*id)
      g2  =   chi_gl(ir-2*id) ; f2  =   chi_fl(ir-2*id)
      g3  =   chi_gl(ir-3*id) ; f3  =   chi_fl(ir-3*id)
      dg0 = dxchi_gl(ir     ) ; df0 = dxchi_fl(ir     )
      dg1 = dxchi_gl(ir-1*id) ; df1 = dxchi_fl(ir-1*id)
      dg2 = dxchi_gl(ir-2*id) ; df2 = dxchi_fl(ir-2*id)
      dg3 = dxchi_gl(ir-3*id) ; df3 = dxchi_fl(ir-3*id)
   case(-1)
      g0  =   chi_gr(ir     ) ; f0  =   chi_fr(ir     )
      g1  =   chi_gr(ir-1*id) ; f1  =   chi_fr(ir-1*id)
      g2  =   chi_gr(ir-2*id) ; f2  =   chi_fr(ir-2*id)
      g3  =   chi_gr(ir-3*id) ; f3  =   chi_fr(ir-3*id)
      dg0 = dxchi_gr(ir     ) ; df0 = dxchi_fr(ir     )
      dg1 = dxchi_gr(ir-1*id) ; df1 = dxchi_fr(ir-1*id)
      dg2 = dxchi_gr(ir-2*id) ; df2 = dxchi_fr(ir-2*id)
      dg3 = dxchi_gr(ir-3*id) ; df3 = dxchi_fr(ir-3*id)
   end select
   g9 = g0 + dx24 * (55.d0*dg0 - 59.d0*dg1 + 37.d0*dg2 - 9.d0*dg3)
   f9 = f0 + dx24 * (55.d0*df0 - 59.d0*df1 + 37.d0*df2 - 9.d0*df3)
   do iec = 1,nec 
      select case (is_calc)
      case (NONREL)
         call dgdx_dfdx_nonrel(rpos(ir+id),g9,f9,dg9,df9, &
                               ll,ee,veff(ir+id,ispin,ll_core))
      case (SREL)
         call dgdx_dfdx_srel(rpos(ir+id),g9,f9,dg9,df9, &
                             ll,ee,veff(ir+id,ispin,ll_core))
      case (REL)
         call dgdx_dfdx_rel(rpos(ir+id),g9,f9,dg9,df9, &
                            kk,ee,veff(ir+id,ispin,ll_core))
      end select
      g9 = g0 + dx24 * (9.d0*dg9 + 19.d0*dg0 - 5.d0*dg1 + dg2)
      f9 = f0 + dx24 * (9.d0*df9 + 19.d0*df0 - 5.d0*df1 + df2)
   end do   
   select case (is_calc)
   case (NONREL)
      call dgdx_dfdx_nonrel(rpos(ir+id),g9,f9,dg9,df9, &
                            ll,ee,veff(ir+id,ispin,ll_core))
   case (SREL)
      call dgdx_dfdx_srel(rpos(ir+id),g9,f9,dg9,df9, &
                          ll,ee,veff(ir+id,ispin,ll_core))
   case (REL)
      call dgdx_dfdx_rel(rpos(ir+id),g9,f9,dg9,df9, &
                         kk,ee,veff(ir+id,ispin,ll_core))
   end select
   select case (id)
   case(+1)
        chi_gl(ir+id) =  g9 ;   chi_fl(ir+id) =  f9
      dxchi_gl(ir+id) = dg9 ; dxchi_fl(ir+id) = df9
   case(-1)
        chi_gr(ir+id) =  g9 ;   chi_fr(ir+id) =  f9
      dxchi_gr(ir+id) = dg9 ; dxchi_fr(ir+id) = df9
   end select
   end subroutine pc_adams_5

!=====================================================================
   subroutine pc_adams_6(ier,ir,id,ll,kk,ee,nec,ispin)
!=====================================================================
!
!  Predicts & Corrects chi_g(ir+id) & chi_f(ir+id)
!  using values at xpos(ir), xpos(ir-id), xpos(ir-2*id), xpos(ir-3*id)
!  by the Adams Predictor-Corrector Method
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters   
   implicit none
   integer,intent(in)    :: ir, ll, kk, nec, ispin
   real(8),intent(in)    :: ee
   integer,intent(inout) :: id
   integer,intent(out)   :: ier
   integer :: iec, ll_core
   real(8) :: dx24, dx720, &
              g0, g1, g2, g3, dg0, dg1, dg2, dg3, g9, dg9, &
              f0, f1, f2, f3, df0, df1, df2, df3, f9, df9
   ier = 0
   if (is_core == PATOM) then
      ll_core = ll
   else
      ll_core = lmax_core
   end if
   id    = sign(1, id)
   dx24  = dx /  24.d0 * dble(id)
   dx720 = dx / 720.d0 * dble(id)
   select case (id)
   case(+1)
      g0  =   chi_gl(ir     ) ; f0  =   chi_fl(ir     )
      g1  =   chi_gl(ir-1*id) ; f1  =   chi_fl(ir-1*id)
      g2  =   chi_gl(ir-2*id) ; f2  =   chi_fl(ir-2*id)
      g3  =   chi_gl(ir-3*id) ; f3  =   chi_fl(ir-3*id)
      dg0 = dxchi_gl(ir     ) ; df0 = dxchi_fl(ir     )
      dg1 = dxchi_gl(ir-1*id) ; df1 = dxchi_fl(ir-1*id)
      dg2 = dxchi_gl(ir-2*id) ; df2 = dxchi_fl(ir-2*id)
      dg3 = dxchi_gl(ir-3*id) ; df3 = dxchi_fl(ir-3*id)
   case(-1)
      g0  =   chi_gr(ir     ) ; f0  =   chi_fr(ir     )
      g1  =   chi_gr(ir-1*id) ; f1  =   chi_fr(ir-1*id)
      g2  =   chi_gr(ir-2*id) ; f2  =   chi_fr(ir-2*id)
      g3  =   chi_gr(ir-3*id) ; f3  =   chi_fr(ir-3*id)
      dg0 = dxchi_gr(ir     ) ; df0 = dxchi_fr(ir     )
      dg1 = dxchi_gr(ir-1*id) ; df1 = dxchi_fr(ir-1*id)
      dg2 = dxchi_gr(ir-2*id) ; df2 = dxchi_fr(ir-2*id)
      dg3 = dxchi_gr(ir-3*id) ; df3 = dxchi_fr(ir-3*id)
   end select
   g9 = g0 + dx24 * (55.d0*dg0 - 59.d0*dg1 + 37.d0*dg2 - 9.d0*dg3)
   f9 = f0 + dx24 * (55.d0*df0 - 59.d0*df1 + 37.d0*df2 - 9.d0*df3)
   do iec = 1,nec  
      select case (is_calc)
      case (NONREL)
         call dgdx_dfdx_nonrel(rpos(ir+id),g9,f9,dg9,df9, &
                               ll,ee,veff(ir+id,ispin,ll_core))
      case (SREL)
         call dgdx_dfdx_srel(rpos(ir+id),g9,f9,dg9,df9, &
                             ll,ee,veff(ir+id,ispin,ll_core))
      case (REL)
         call dgdx_dfdx_rel(rpos(ir+id),g9,f9,dg9,df9, &
                            kk,ee,veff(ir+id,ispin,ll_core))
      end select
      g9 = g0 + dx720 * (251.d0*dg9 + 646.d0*dg0 - 264.d0*dg1 &
                      + 106.d0*dg2 - 19.d0*dg3)
      f9 = f0 + dx720 * (251.d0*df9 + 646.d0*df0 - 264.d0*df1 &
                      + 106.d0*df2 - 19.d0*df3)
   end do   
   select case (is_calc)
   case (NONREL)
      call dgdx_dfdx_nonrel(rpos(ir+id),g9,f9,dg9,df9, &
                            ll,ee,veff(ir+id,ispin,ll_core))
   case (SREL)
      call dgdx_dfdx_srel(rpos(ir+id),g9,f9,dg9,df9, &
                          ll,ee,veff(ir+id,ispin,ll_core))
   case (REL)
      call dgdx_dfdx_rel(rpos(ir+id),g9,f9,dg9,df9, &
                         kk,ee,veff(ir+id,ispin,ll_core))
   end select
   select case (id)
   case(+1)
        chi_gl(ir+id) =  g9 ;   chi_fl(ir+id) =  f9
      dxchi_gl(ir+id) = dg9 ; dxchi_fl(ir+id) = df9
   case(-1)
        chi_gr(ir+id) =  g9 ;   chi_fr(ir+id) =  f9
      dxchi_gr(ir+id) = dg9 ; dxchi_fr(ir+id) = df9
   end select
   end subroutine pc_adams_6

!=====================================================================
   subroutine pc_adams_7(ier,ir,id,ll,kk,ee,nec,ispin)
!===================================================================== 
!
!  Predicts & Corrects chi_g(ir+id) & chi_f(ir+id)
!  using values at xpos(ir), xpos(ir-id), xpos(ir-2*id), 
!                  xpos(ir-3*id), xpos(ir-4*id)
!  by the Adams Predictor-Corrector Method
!     
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters   
   implicit none
   integer,intent(in)    :: ir, ll, kk, nec, ispin
   real(8),intent(in)    :: ee
   integer,intent(inout) :: id
   integer,intent(out)   :: ier
   integer :: iec, ll_core
   real(8) :: dx720, dx1440, &
              g0, g1, g2, g3, g4, dg0, dg1, dg2, dg3, dg4, g9, dg9, &
              f0, f1, f2, f3, f4, df0, df1, df2, df3, df4, f9, df9
   ier = 0
   if (is_core == PATOM) then
      ll_core = ll
   else
      ll_core = lmax_core
   end if
   id     = sign(1, id)
   dx720  = dx/ 720.d0*dble(id)
   dx1440 = dx/1440.d0*dble(id)
   select case (id)
   case(+1)
      g0  =   chi_gl(ir     ) ; f0  =   chi_fl(ir     )
      g1  =   chi_gl(ir-1*id) ; f1  =   chi_fl(ir-1*id)
      g2  =   chi_gl(ir-2*id) ; f2  =   chi_fl(ir-2*id)
      g3  =   chi_gl(ir-3*id) ; f3  =   chi_fl(ir-3*id)
      g4  =   chi_gl(ir-4*id) ; f4  =   chi_fl(ir-4*id)
      dg0 = dxchi_gl(ir     ) ; df0 = dxchi_fl(ir     )
      dg1 = dxchi_gl(ir-1*id) ; df1 = dxchi_fl(ir-1*id)
      dg2 = dxchi_gl(ir-2*id) ; df2 = dxchi_fl(ir-2*id)
      dg3 = dxchi_gl(ir-3*id) ; df3 = dxchi_fl(ir-3*id)
      dg4 = dxchi_gl(ir-4*id) ; df4 = dxchi_fl(ir-4*id)
   case(-1)
      g0  =   chi_gr(ir     ) ; f0  =   chi_fr(ir     )
      g1  =   chi_gr(ir-1*id) ; f1  =   chi_fr(ir-1*id)
      g2  =   chi_gr(ir-2*id) ; f2  =   chi_fr(ir-2*id)
      g3  =   chi_gr(ir-3*id) ; f3  =   chi_fr(ir-3*id)
      g4  =   chi_gr(ir-4*id) ; f4  =   chi_fr(ir-4*id)
      dg0 = dxchi_gr(ir     ) ; df0 = dxchi_fr(ir     )
      dg1 = dxchi_gr(ir-1*id) ; df1 = dxchi_fr(ir-1*id)
      dg2 = dxchi_gr(ir-2*id) ; df2 = dxchi_fr(ir-2*id)
      dg3 = dxchi_gr(ir-3*id) ; df3 = dxchi_fr(ir-3*id)
      dg4 = dxchi_gr(ir-4*id) ; df4 = dxchi_fr(ir-4*id)
   end select
   g9 = g0 + dx720 * (1901.d0*dg0-2774.d0*dg1+2616.d0*dg2 &
                     -1274.d0*dg3 +251.d0*dg4)
   f9 = f0 + dx720 * (1901.d0*df0-2774.d0*df1+2616.d0*df2 &
                     -1274.d0*df3 +251.d0*df4)
   do iec = 1,nec  
      select case (is_calc)
      case (NONREL)
         call dgdx_dfdx_nonrel(rpos(ir+id),g9,f9,dg9,df9, &
                               ll,ee,veff(ir+id,ispin,ll_core))
      case (SREL)
         call dgdx_dfdx_srel(rpos(ir+id),g9,f9,dg9,df9, &
                             ll,ee,veff(ir+id,ispin,ll_core))
      case (REL)
         call dgdx_dfdx_rel(rpos(ir+id),g9,f9,dg9,df9, &
                            kk,ee,veff(ir+id,ispin,ll_core))
      end select
      g9 = g0 + dx1440 * (475.d0*dg9+1427.d0*dg0-798.d0*dg1 &
                         +482.d0*dg2 -173.d0*dg3 +27.d0*dg4)
      f9 = f0 + dx1440 * (475.d0*df9+1427.d0*df0-798.d0*df1 &
                         +482.d0*df2 -173.d0*df3 +27.d0*df4)
   end do  
   select case (is_calc)
   case (NONREL)
      call dgdx_dfdx_nonrel(rpos(ir+id),g9,f9,dg9,df9, &
                            ll,ee,veff(ir+id,ispin,ll_core))
   case (SREL)
      call dgdx_dfdx_srel(rpos(ir+id),g9,f9,dg9,df9, &
                          ll,ee,veff(ir+id,ispin,ll_core))
   case (REL)
      call dgdx_dfdx_rel(rpos(ir+id),g9,f9,dg9,df9, &
                         kk,ee,veff(ir+id,ispin,ll_core))
   end select
   select case (id)
   case(+1)
      chi_gl  (ir+id) = g9  ; chi_fl  (ir+id) = f9
      dxchi_gl(ir+id) = dg9 ; dxchi_fl(ir+id) = df9
   case(-1)
      chi_gr  (ir+id) = g9  ; chi_fr  (ir+id) = f9
      dxchi_gr(ir+id) = dg9 ; dxchi_fr(ir+id) = df9
   end select
   end subroutine pc_adams_7

!=====================================================================
   subroutine pc_adams_8(ier,ir,id,ll,kk,ee,nec,ispin)
!===================================================================== 
!
!  Predicts & Corrects chi_g(ir+id) & chi_f(ir+id)
!  using values at xpos(ir), xpos(ir-id), xpos(ir-2*id), 
!                  xpos(ir-3*id), xpos(ir-4*id), xpos(ir-5*id)
!  by Adams Predictor-Corrector Method
!     
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters   
   implicit none
   integer,intent(in)    :: ir, ll, kk, nec, ispin
   real(8),intent(in)    :: ee
   integer,intent(inout) :: id
   integer,intent(out)   :: ier
   integer :: iec, ll_core
   real(8) :: dx1440, dx60480, &
              g0, g1, g2, g3, g4, g5, dg0, dg1, dg2, dg3, dg4, dg5, &
              g9, dg9, &
              f0, f1, f2, f3, f4, f5, df0, df1, df2, df3, df4, df5, &
              f9, df9
   ier = 0
   if (is_core == PATOM) then
      ll_core = ll
   else
      ll_core = lmax_core
   end if
   id      = sign(1, id)
   dx1440  = dx/ 1440.d0 * dble(id)
   dx60480 = dx/60480.d0 * dble(id)
   select case (id)
   case(+1)
      g0  =   chi_gl(ir     ) ; f0  =   chi_fl(ir     )
      g1  =   chi_gl(ir-1*id) ; f1  =   chi_fl(ir-1*id)
      g2  =   chi_gl(ir-2*id) ; f2  =   chi_fl(ir-2*id)
      g3  =   chi_gl(ir-3*id) ; f3  =   chi_fl(ir-3*id)
      g4  =   chi_gl(ir-4*id) ; f4  =   chi_fl(ir-4*id)
      g5  =   chi_gl(ir-5*id) ; f5  =   chi_fl(ir-5*id)
      dg0 = dxchi_gl(ir     ) ; df0 = dxchi_fl(ir     )
      dg1 = dxchi_gl(ir-1*id) ; df1 = dxchi_fl(ir-1*id)
      dg2 = dxchi_gl(ir-2*id) ; df2 = dxchi_fl(ir-2*id)
      dg3 = dxchi_gl(ir-3*id) ; df3 = dxchi_fl(ir-3*id)
      dg4 = dxchi_gl(ir-4*id) ; df4 = dxchi_fl(ir-4*id)
      dg5 = dxchi_gl(ir-5*id) ; df5 = dxchi_fl(ir-5*id)
   case(-1)
      g0  =   chi_gr(ir     ) ; f0  =   chi_fr(ir     )
      g1  =   chi_gr(ir-1*id) ; f1  =   chi_fr(ir-1*id)
      g2  =   chi_gr(ir-2*id) ; f2  =   chi_fr(ir-2*id)
      g3  =   chi_gr(ir-3*id) ; f3  =   chi_fr(ir-3*id)
      g4  =   chi_gr(ir-4*id) ; f4  =   chi_fr(ir-4*id)
      g5  =   chi_gr(ir-5*id) ; f5  =   chi_fr(ir-5*id)
      dg0 = dxchi_gr(ir     ) ; df0 = dxchi_fr(ir     )
      dg1 = dxchi_gr(ir-1*id) ; df1 = dxchi_fr(ir-1*id)
      dg2 = dxchi_gr(ir-2*id) ; df2 = dxchi_fr(ir-2*id)
      dg3 = dxchi_gr(ir-3*id) ; df3 = dxchi_fr(ir-3*id)
      dg4 = dxchi_gr(ir-4*id) ; df4 = dxchi_fr(ir-4*id)
      dg5 = dxchi_gr(ir-5*id) ; df5 = dxchi_fr(ir-5*id)
   end select
   g9 = g0 + dx1440 * (4277.d0*dg0 - 7923.d0*dg1 + 9982.d0*dg2 &
                      -7298.d0*dg3 + 2877.d0*dg4 -  475.d0*dg5)
   f9 = f0 + dx1440 * (4277.d0*df0 - 7923.d0*df1 + 9982.d0*df2 &
                      -7298.d0*df3 + 2877.d0*df4 -  475.d0*df5)
   do iec = 1,nec 
      select case (is_calc)
      case (NONREL)
         call dgdx_dfdx_nonrel(rpos(ir+id),g9,f9,dg9,df9, &
                               ll,ee,veff(ir+id,ispin,ll_core))
      case (SREL)
         call dgdx_dfdx_srel(rpos(ir+id),g9,f9,dg9,df9, &
                             ll,ee,veff(ir+id,ispin,ll_core))
      case (REL)
         call dgdx_dfdx_rel(rpos(ir+id),g9,f9,dg9,df9, &
                            kk,ee,veff(ir+id,ispin,ll_core))
      end select
      g9 = g0 + dx60480 * (19087.d0*dg9+65112.d0*dg0-46461.d0*dg1 &
                          +37504.d0*dg2+20211.d0*dg3 +6312.d0*dg4 &
                          -863.d0*dg5)
      f9 = f0 + dx60480 * (19087.d0*df9+65112.d0*df0-46461.d0*df1 &
                          +37504.d0*df2+20211.d0*df3 +6312.d0*df4 &
                          -863.d0*df5)
   end do   
   select case (is_calc)
   case (NONREL)
      call dgdx_dfdx_nonrel(rpos(ir+id),g9,f9,dg9,df9, &
                            ll,ee,veff(ir+id,ispin,ll_core))
   case (SREL)
      call dgdx_dfdx_srel(rpos(ir+id),g9,f9,dg9,df9, &
                          ll,ee,veff(ir+id,ispin,ll_core))
   case (REL)
      call dgdx_dfdx_rel(rpos(ir+id),g9,f9,dg9,df9, &
                         kk,ee,veff(ir+id,ispin,ll_core))
   end select
   select case (id)
   case(+1)
      chi_gl  (ir+id) = g9  ; chi_fl  (ir+id) = f9
      dxchi_gl(ir+id) = dg9 ; dxchi_fl(ir+id) = df9
   case(-1)
      chi_gr  (ir+id) = g9  ; chi_fr  (ir+id) = f9
      dxchi_gr(ir+id) = dg9 ; dxchi_fr(ir+id) = df9
   end select
   end subroutine pc_adams_8

!=====================================================================
   subroutine pc_adams_4ps(ier,ir,id,ll,tt,kk,ee,nec,ips)
!===================================================================== 
!
!  Predicts & Corrects chi_g(ir+id) & chi_f(ir+id)
!  using values at xpos(ir), xpos(ir-id), xpos(ir-2*id)
!  by the Adams Predictor-Corrector Method (3rd order)
!     
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters   
   implicit none
   integer,intent(in)    :: ir, ll, tt, kk, nec, ips
   real(8),intent(in)    :: ee
   integer,intent(inout) :: id
   integer,intent(out)   :: ier
   integer :: iec
   real(8) :: dx12, &
              g0, g1, g2, dg0, dg1, dg2, g9, dg9, &
              f0, f1, f2, df0, df1, df2, f9, df9
   ier = 0
   id   = sign(1, id)
   dx12 = dx / 12.d0 * dble(id)
   select case (id)
   case(+1)
      g0  =   chi_gl(ir     ) ; f0  =   chi_fl(ir     )
      g1  =   chi_gl(ir-1*id) ; f1  =   chi_fl(ir-1*id)
      g2  =   chi_gl(ir-2*id) ; f2  =   chi_fl(ir-2*id)
      dg0 = dxchi_gl(ir     ) ; df0 = dxchi_fl(ir     )
      dg1 = dxchi_gl(ir-1*id) ; df1 = dxchi_fl(ir-1*id)
      dg2 = dxchi_gl(ir-2*id) ; df2 = dxchi_fl(ir-2*id)
   case(-1)
      g0  =   chi_gr(ir     ) ; f0  =   chi_fr(ir     )
      g1  =   chi_gr(ir-1*id) ; f1  =   chi_fr(ir-1*id)
      g2  =   chi_gr(ir-2*id) ; f2  =   chi_fr(ir-2*id)
      dg0 = dxchi_gr(ir     ) ; df0 = dxchi_fr(ir     )
      dg1 = dxchi_gr(ir-1*id) ; df1 = dxchi_fr(ir-1*id)
      dg2 = dxchi_gr(ir-2*id) ; df2 = dxchi_fr(ir-2*id)
   end select
   g9 = g0 + dx12 * (23.d0*dg0 - 16.d0*dg1 + 5.d0*dg2)
   f9 = f0 + dx12 * (23.d0*df0 - 16.d0*df1 + 5.d0*df2)
   do iec = 1,nec  
      call dgdx_dfdx_nonrel(rpos(ir+id),g9,f9,dg9,df9, &
                               ll,ee,veff_ps(ir+id,ips,1))
      g9 = g0 + dx12 * (5.d0*dg9 + 8.d0*dg0 - dg1)
      f9 = f0 + dx12 * (5.d0*df9 + 8.d0*df0 - df1)
   end do    
      call dgdx_dfdx_nonrel(rpos(ir+id),g9,f9,dg9,df9, &
                               ll,ee,veff_ps(ir+id,ips,1))
   select case (id)
   case(+1)
        chi_gl(ir+id) =  g9 ;   chi_fl(ir+id) =  f9
      dxchi_gl(ir+id) = dg9 ; dxchi_fl(ir+id) = df9
   case(-1)
        chi_gr(ir+id) =  g9 ;   chi_fr(ir+id) =  f9
      dxchi_gr(ir+id) = dg9 ; dxchi_fr(ir+id) = df9
   end select
   end subroutine pc_adams_4ps

!=====================================================================
   subroutine pc_adams_5ps(ier,ir,id,ll,tt,kk,ee,nec,ips)
!=====================================================================
!
!  Predicts & Corrects chi_g(ir+id) & chi_f(ir+id)
!  using values at xpos(ir), xpos(ir-id), xpos(ir-2*id), xpos(ir-3*id)
!  by the Adams Predictor-Corrector Method
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters   
   implicit none
   integer,intent(in)    :: ir, ll, tt, kk, nec, ips
   real(8),intent(in)    :: ee
   integer,intent(inout) :: id
   integer,intent(out)   :: ier
   integer :: iec
   real(8) :: dx24, &
              g0, g1, g2, g3, dg0, dg1, dg2, dg3, g9, dg9, &
              f0, f1, f2, f3, df0, df1, df2, df3, f9, df9
   ier = 0
   id   = sign(1, id)
   dx24 = dx / 24.d0 * dble(id)
   select case (id)
   case(+1)
      g0  =   chi_gl(ir     ) ; f0  =   chi_fl(ir     )
      g1  =   chi_gl(ir-1*id) ; f1  =   chi_fl(ir-1*id)
      g2  =   chi_gl(ir-2*id) ; f2  =   chi_fl(ir-2*id)
      g3  =   chi_gl(ir-3*id) ; f3  =   chi_fl(ir-3*id)
      dg0 = dxchi_gl(ir     ) ; df0 = dxchi_fl(ir     )
      dg1 = dxchi_gl(ir-1*id) ; df1 = dxchi_fl(ir-1*id)
      dg2 = dxchi_gl(ir-2*id) ; df2 = dxchi_fl(ir-2*id)
      dg3 = dxchi_gl(ir-3*id) ; df3 = dxchi_fl(ir-3*id)
   case(-1)
      g0  =   chi_gr(ir     ) ; f0  =   chi_fr(ir     )
      g1  =   chi_gr(ir-1*id) ; f1  =   chi_fr(ir-1*id)
      g2  =   chi_gr(ir-2*id) ; f2  =   chi_fr(ir-2*id)
      g3  =   chi_gr(ir-3*id) ; f3  =   chi_fr(ir-3*id)
      dg0 = dxchi_gr(ir     ) ; df0 = dxchi_fr(ir     )
      dg1 = dxchi_gr(ir-1*id) ; df1 = dxchi_fr(ir-1*id)
      dg2 = dxchi_gr(ir-2*id) ; df2 = dxchi_fr(ir-2*id)
      dg3 = dxchi_gr(ir-3*id) ; df3 = dxchi_fr(ir-3*id)
   end select
   g9 = g0 + dx24 * (55.d0*dg0 - 59.d0*dg1 + 37.d0*dg2 - 9.d0*dg3)
   f9 = f0 + dx24 * (55.d0*df0 - 59.d0*df1 + 37.d0*df2 - 9.d0*df3)
   do iec = 1,nec  
      call dgdx_dfdx_nonrel(rpos(ir+id),g9,f9,dg9,df9, &
                               ll,ee,veff_ps(ir+id,ips,1))
      g9 = g0 + dx24 * (9.d0*dg9 + 19.d0*dg0 - 5.d0*dg1 + dg2)
      f9 = f0 + dx24 * (9.d0*df9 + 19.d0*df0 - 5.d0*df1 + df2)
   end do  
   call dgdx_dfdx_nonrel(rpos(ir+id),g9,f9,dg9,df9, &
                            ll,ee,veff_ps(ir+id,ips,1))
   select case (id)
   case(+1)
        chi_gl(ir+id) =  g9 ;   chi_fl(ir+id) =  f9
      dxchi_gl(ir+id) = dg9 ; dxchi_fl(ir+id) = df9
   case(-1)
        chi_gr(ir+id) =  g9 ;   chi_fr(ir+id) =  f9
      dxchi_gr(ir+id) = dg9 ; dxchi_fr(ir+id) = df9
   end select
   end subroutine pc_adams_5ps

!=====================================================================
   subroutine pc_adams_6ps(ier,ir,id,ll,tt,kk,ee,nec,ips)
!=====================================================================
!
!  Predicts & Corrects chi_g(ir+id) & chi_f(ir+id)
!  using values at xpos(ir), xpos(ir-id), xpos(ir-2*id), xpos(ir-3*id)
!  by the Adams Predictor-Corrector Method
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters   
   implicit none
   integer,intent(in)    :: ir, ll, tt, kk, nec, ips
   real(8),intent(in)    :: ee
   integer,intent(inout) :: id
   integer,intent(out)   :: ier
   integer :: iec
   real(8) :: dx24, dx720, &
              g0, g1, g2, g3, dg0, dg1, dg2, dg3, g9, dg9, &
              f0, f1, f2, f3, df0, df1, df2, df3, f9, df9
   ier = 0
   id    = sign(1, id)
   dx24  = dx /  24.d0 * dble(id)
   dx720 = dx / 720.d0 * dble(id)
   select case (id)
   case(+1)
      g0  =   chi_gl(ir     ) ; f0  =   chi_fl(ir     )
      g1  =   chi_gl(ir-1*id) ; f1  =   chi_fl(ir-1*id)
      g2  =   chi_gl(ir-2*id) ; f2  =   chi_fl(ir-2*id)
      g3  =   chi_gl(ir-3*id) ; f3  =   chi_fl(ir-3*id)
      dg0 = dxchi_gl(ir     ) ; df0 = dxchi_fl(ir     )
      dg1 = dxchi_gl(ir-1*id) ; df1 = dxchi_fl(ir-1*id)
      dg2 = dxchi_gl(ir-2*id) ; df2 = dxchi_fl(ir-2*id)
      dg3 = dxchi_gl(ir-3*id) ; df3 = dxchi_fl(ir-3*id)
   case(-1)
      g0  =   chi_gr(ir     ) ; f0  =   chi_fr(ir     )
      g1  =   chi_gr(ir-1*id) ; f1  =   chi_fr(ir-1*id)
      g2  =   chi_gr(ir-2*id) ; f2  =   chi_fr(ir-2*id)
      g3  =   chi_gr(ir-3*id) ; f3  =   chi_fr(ir-3*id)
      dg0 = dxchi_gr(ir     ) ; df0 = dxchi_fr(ir     )
      dg1 = dxchi_gr(ir-1*id) ; df1 = dxchi_fr(ir-1*id)
      dg2 = dxchi_gr(ir-2*id) ; df2 = dxchi_fr(ir-2*id)
      dg3 = dxchi_gr(ir-3*id) ; df3 = dxchi_fr(ir-3*id)
   end select
   g9 = g0 + dx24 * (55.d0*dg0 - 59.d0*dg1 + 37.d0*dg2 - 9.d0*dg3)
   f9 = f0 + dx24 * (55.d0*df0 - 59.d0*df1 + 37.d0*df2 - 9.d0*df3)
   do iec = 1,nec 
      call dgdx_dfdx_nonrel(rpos(ir+id),g9,f9,dg9,df9, &
                               ll,ee,veff_ps(ir+id,ips,1))
      g9 = g0 + dx720 * (251.d0*dg9 + 646.d0*dg0 - 264.d0*dg1 &
                      + 106.d0*dg2 - 19.d0*dg3)
      f9 = f0 + dx720 * (251.d0*df9 + 646.d0*df0 - 264.d0*df1 &
                      + 106.d0*df2 - 19.d0*df3)
   end do   
   call dgdx_dfdx_nonrel(rpos(ir+id),g9,f9,dg9,df9, &
                            ll,ee,veff_ps(ir+id,ips,1))
   select case (id)
   case(+1)
        chi_gl(ir+id) =  g9 ;   chi_fl(ir+id) =  f9
      dxchi_gl(ir+id) = dg9 ; dxchi_fl(ir+id) = df9
   case(-1)
        chi_gr(ir+id) =  g9 ;   chi_fr(ir+id) =  f9
      dxchi_gr(ir+id) = dg9 ; dxchi_fr(ir+id) = df9
   end select
   end subroutine pc_adams_6ps

!=====================================================================
   subroutine pc_adams_7ps(ier,ir,id,ll,tt,kk,ee,nec,ips)
!===================================================================== 
!
!  Predicts & Corrects chi_g(ir+id) & chi_f(ir+id)
!  using values at xpos(ir), xpos(ir-id), xpos(ir-2*id), 
!                  xpos(ir-3*id), xpos(ir-4*id)
!  by the Adams Predictor-Corrector Method
!     
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters   
   implicit none
   integer,intent(in)    :: ir, ll, tt, kk, nec, ips
   real(8),intent(in)    :: ee
   integer,intent(inout) :: id
   integer,intent(out)   :: ier
   integer :: iec
   real(8) :: dx720, dx1440, &
              g0, g1, g2, g3, g4, dg0, dg1, dg2, dg3, dg4, g9, dg9, &
              f0, f1, f2, f3, f4, df0, df1, df2, df3, df4, f9, df9
   ier = 0
   id     = sign(1, id)
   dx720  = dx/ 720.d0*dble(id)
   dx1440 = dx/1440.d0*dble(id)
   select case (id)
   case(+1)
      g0  =   chi_gl(ir     ) ; f0  =   chi_fl(ir     )
      g1  =   chi_gl(ir-1*id) ; f1  =   chi_fl(ir-1*id)
      g2  =   chi_gl(ir-2*id) ; f2  =   chi_fl(ir-2*id)
      g3  =   chi_gl(ir-3*id) ; f3  =   chi_fl(ir-3*id)
      g4  =   chi_gl(ir-4*id) ; f4  =   chi_fl(ir-4*id)
      dg0 = dxchi_gl(ir     ) ; df0 = dxchi_fl(ir     )
      dg1 = dxchi_gl(ir-1*id) ; df1 = dxchi_fl(ir-1*id)
      dg2 = dxchi_gl(ir-2*id) ; df2 = dxchi_fl(ir-2*id)
      dg3 = dxchi_gl(ir-3*id) ; df3 = dxchi_fl(ir-3*id)
      dg4 = dxchi_gl(ir-4*id) ; df4 = dxchi_fl(ir-4*id)
   case(-1)
      g0  =   chi_gr(ir     ) ; f0  =   chi_fr(ir     )
      g1  =   chi_gr(ir-1*id) ; f1  =   chi_fr(ir-1*id)
      g2  =   chi_gr(ir-2*id) ; f2  =   chi_fr(ir-2*id)
      g3  =   chi_gr(ir-3*id) ; f3  =   chi_fr(ir-3*id)
      g4  =   chi_gr(ir-4*id) ; f4  =   chi_fr(ir-4*id)
      dg0 = dxchi_gr(ir     ) ; df0 = dxchi_fr(ir     )
      dg1 = dxchi_gr(ir-1*id) ; df1 = dxchi_fr(ir-1*id)
      dg2 = dxchi_gr(ir-2*id) ; df2 = dxchi_fr(ir-2*id)
      dg3 = dxchi_gr(ir-3*id) ; df3 = dxchi_fr(ir-3*id)
      dg4 = dxchi_gr(ir-4*id) ; df4 = dxchi_fr(ir-4*id)
   end select
   g9 = g0 + dx720 * (1901.d0*dg0-2774.d0*dg1+2616.d0*dg2 &
                     -1274.d0*dg3 +251.d0*dg4)
   f9 = f0 + dx720 * (1901.d0*df0-2774.d0*df1+2616.d0*df2 &
                     -1274.d0*df3 +251.d0*df4)
   do iec = 1,nec 
      call dgdx_dfdx_nonrel(rpos(ir+id),g9,f9,dg9,df9, &
                               ll,ee,veff_ps(ir+id,ips,1))
      g9 = g0 + dx1440 * (475.d0*dg9+1427.d0*dg0-798.d0*dg1 &
                         +482.d0*dg2 -173.d0*dg3 +27.d0*dg4)
      f9 = f0 + dx1440 * (475.d0*df9+1427.d0*df0-798.d0*df1 &
                         +482.d0*df2 -173.d0*df3 +27.d0*df4)
   end do    
   call dgdx_dfdx_nonrel(rpos(ir+id),g9,f9,dg9,df9, &
                            ll,ee,veff_ps(ir+id,ips,1))
   select case (id)
   case(+1)
      chi_gl  (ir+id) = g9  ; chi_fl  (ir+id) = f9
      dxchi_gl(ir+id) = dg9 ; dxchi_fl(ir+id) = df9
   case(-1)
      chi_gr  (ir+id) = g9  ; chi_fr  (ir+id) = f9
      dxchi_gr(ir+id) = dg9 ; dxchi_fr(ir+id) = df9
   end select
   end subroutine pc_adams_7ps

!=====================================================================
   subroutine pc_adams_8ps(ier,ir,id,ll,tt,kk,ee,nec,ips)
!===================================================================== 
!
!  Predicts & Corrects chi_g(ir+id) & chi_f(ir+id)
!  using values at xpos(ir), xpos(ir-id), xpos(ir-2*id), 
!                  xpos(ir-3*id), xpos(ir-4*id), xpos(ir-5*id)
!  by Adams Predictor-Corrector Method
!     
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters   
   implicit none
   integer,intent(in)    :: ir, ll, tt, kk, nec, ips
   real(8),intent(in)    :: ee
   integer,intent(inout) :: id
   integer,intent(out)   :: ier
   integer :: iec
   real(8) :: dx1440, dx60480, &
              g0, g1, g2, g3, g4, g5, dg0, dg1, dg2, dg3, dg4, dg5, &
              g9, dg9, &
              f0, f1, f2, f3, f4, f5, df0, df1, df2, df3, df4, df5, &
              f9, df9
   ier = 0
   id      = sign(1, id)
   dx1440  = dx/ 1440.d0 * dble(id)
   dx60480 = dx/60480.d0 * dble(id)
   select case (id)
   case(+1)
      g0  =   chi_gl(ir     ) ; f0  =   chi_fl(ir     )
      g1  =   chi_gl(ir-1*id) ; f1  =   chi_fl(ir-1*id)
      g2  =   chi_gl(ir-2*id) ; f2  =   chi_fl(ir-2*id)
      g3  =   chi_gl(ir-3*id) ; f3  =   chi_fl(ir-3*id)
      g4  =   chi_gl(ir-4*id) ; f4  =   chi_fl(ir-4*id)
      g5  =   chi_gl(ir-5*id) ; f5  =   chi_fl(ir-5*id)
      dg0 = dxchi_gl(ir     ) ; df0 = dxchi_fl(ir     )
      dg1 = dxchi_gl(ir-1*id) ; df1 = dxchi_fl(ir-1*id)
      dg2 = dxchi_gl(ir-2*id) ; df2 = dxchi_fl(ir-2*id)
      dg3 = dxchi_gl(ir-3*id) ; df3 = dxchi_fl(ir-3*id)
      dg4 = dxchi_gl(ir-4*id) ; df4 = dxchi_fl(ir-4*id)
      dg5 = dxchi_gl(ir-5*id) ; df5 = dxchi_fl(ir-5*id)
   case(-1)
      g0  =   chi_gr(ir     ) ; f0  =   chi_fr(ir     )
      g1  =   chi_gr(ir-1*id) ; f1  =   chi_fr(ir-1*id)
      g2  =   chi_gr(ir-2*id) ; f2  =   chi_fr(ir-2*id)
      g3  =   chi_gr(ir-3*id) ; f3  =   chi_fr(ir-3*id)
      g4  =   chi_gr(ir-4*id) ; f4  =   chi_fr(ir-4*id)
      g5  =   chi_gr(ir-5*id) ; f5  =   chi_fr(ir-5*id)
      dg0 = dxchi_gr(ir     ) ; df0 = dxchi_fr(ir     )
      dg1 = dxchi_gr(ir-1*id) ; df1 = dxchi_fr(ir-1*id)
      dg2 = dxchi_gr(ir-2*id) ; df2 = dxchi_fr(ir-2*id)
      dg3 = dxchi_gr(ir-3*id) ; df3 = dxchi_fr(ir-3*id)
      dg4 = dxchi_gr(ir-4*id) ; df4 = dxchi_fr(ir-4*id)
      dg5 = dxchi_gr(ir-5*id) ; df5 = dxchi_fr(ir-5*id)
   end select
   g9 = g0 + dx1440 * (4277.d0*dg0 - 7923.d0*dg1 + 9982.d0*dg2 &
                      -7298.d0*dg3 + 2877.d0*dg4 -  475.d0*dg5)
   f9 = f0 + dx1440 * (4277.d0*df0 - 7923.d0*df1 + 9982.d0*df2 &
                      -7298.d0*df3 + 2877.d0*df4 -  475.d0*df5)
   do iec = 1,nec 
      call dgdx_dfdx_nonrel(rpos(ir+id),g9,f9,dg9,df9, &
                               ll,ee,veff_ps(ir+id,ips,1))
      g9 = g0 + dx60480 * (19087.d0*dg9+65112.d0*dg0-46461.d0*dg1 &
                          +37504.d0*dg2+20211.d0*dg3 +6312.d0*dg4 &
                          -863.d0*dg5)
      f9 = f0 + dx60480 * (19087.d0*df9+65112.d0*df0-46461.d0*df1 &
                          +37504.d0*df2+20211.d0*df3 +6312.d0*df4 &
                          -863.d0*df5)
   end do   
   call dgdx_dfdx_nonrel(rpos(ir+id),g9,f9,dg9,df9, &
                            ll,ee,veff_ps(ir+id,ips,1))
   select case (id)
   case(+1)
      chi_gl  (ir+id) = g9  ; chi_fl  (ir+id) = f9
      dxchi_gl(ir+id) = dg9 ; dxchi_fl(ir+id) = df9
   case(-1)
      chi_gr  (ir+id) = g9  ; chi_fr  (ir+id) = f9
      dxchi_gr(ir+id) = dg9 ; dxchi_fr(ir+id) = df9
   end select
   end subroutine pc_adams_8ps

!
!  Software name : CIAO (Code for Investigating Atomic Orbitals)
!  Subroutine(s) : calc_pp, calc_rcore_rmaxps, write_rcore_rmaxps
!                : sort_ips_ps, calc_felec_val_us, set_ips_loc
!                : write_pp, write_gncpp, write_gncpp2, write_ciaopp
!  Author(s)     : Masakuni Okamoto (August 25, 2003)
!
!
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!
!
!  The license of the code and contact address :
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)
!
!=====================================================================
   subroutine calc_pp(ier)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   call find_ishell_core_hole(ier)
   if (ier /= 0) then
      write(IFLOG,*) '### ERROR ### in find_ishell_core_hole'
      go to 99
   end if
   call calc_rho_core(ier)
   if (ier /= 0) then
      write(IFLOG,*) '### ERROR ### in calc_rho_core' ; go to 99
   end if
   call calc_rcore_rmaxps(ier)
   if (ier /= 0) then
      write(IFLOG,*) '### ERROR ### in calc_rcore_rmaxps' ; go to 99
   end if
   call set_ips_loc(ier)
   if (ier /= 0) then
      write(IFLOG,*) '### ERROR ### in set_ips_loc' ; go to 99
   end if
   select case (is_pp)
   case (GENERAL_PP, TM91)
      select case (is_calc)
      case (NONREL,SREL)
         call calc_general_pp_srel(ier)
         if (ier /= 0) then
            write(IFLOG,*) '### ERROR ### in calc_general_pp_srel' ; go to 99
         end if
         is_pp_generated = YES
         select case (is_pp_calc_class)
         case (NC)
            write(IFLOG,*)
            write(IFLOG,*) &
               'Troullier-Martins pseudopotentials have been calculated.'
            write(IFSUM,*)
            write(IFSUM,*) &
               'Troullier-Martins pseudopotentials have been calculated.'
         case (US)
            write(IFLOG,*)
            write(IFLOG,*) &
               'General pseudopotentials have been calculated.'
            write(IFSUM,*)
            write(IFSUM,*) &
            'General pseudopotentials have been calculated.'
         end select
      case (REL)
         write(IFLOG,*)
         write(IFLOG,*) 'General pseudopotential is not supported for REL.'
         write(IFSUM,*)
         write(IFSUM,*) 'General pseudopotential is not supported for REL.'
      end select
   case (TM91SO)
      select case (is_calc)
      case (NONREL,SREL)
         write(IFLOG,*)
         write(IFLOG,*) 'TMSO pseudopotential is not generated from NONREL/SREL.'
         write(IFSUM,*)
         write(IFSUM,*) 'TMSO pseudopotential is not generated from NONREL/SREL.'
      case (REL)
         call calc_tmso_pp_rel(ier)
         if (ier /= 0) then
            write(IFLOG,*) '### ERROR ### in calc_tmso_pp_rel' ; go to 99
         end if
         is_pp_generated = YES
         select case (is_pp_calc_class)
         case (NC)
            write(IFLOG,*)
            write(IFLOG,*) 'TMSO pseudopotentials have been calculated.'
            write(IFSUM,*)
            write(IFSUM,*) 'TMSO pseudopotentials have been calculated.'
         end select
         call write_tmsopp(ier)
      end select
   case (BHS82)
      select case (is_calc)
      case (NONREL,SREL)
         write(IFLOG,*)
         write(IFLOG,*) 'BHS pseudopotential is not generated from NONREL/SREL.'
         write(IFSUM,*)
         write(IFSUM,*) 'BHS pseudopotential is not generated from NONREL/SREL.'
      case (REL)
         call calc_bhs_pp_rel(ier)
         if (ier /= 0) then
            write(IFLOG,*) '### ERROR ### in calc_bhs_pp_rel' ; go to 99
         end if
         is_pp_generated = YES
         select case (is_pp_calc_class)
         case (NC)
            write(IFLOG,*)
            write(IFLOG,*) 'BHS pseudopotentials have been calculated.'
            write(IFSUM,*)
            write(IFSUM,*) 'BHS pseudopotentials have been calculated.'
         end select
         call write_bhspp(ier)
      end select
   end select
99 continue
   end subroutine calc_pp

!=====================================================================
   subroutine calc_rcore_rmaxps(ier)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer :: ir, ishell, ll
   real(8) :: rcut_tmp
   ier = 0
   if (felec_core > 1.d-5) then
   do ir = nmesh,2,-1
      if (rho_core(ir) > 1.d-10) then
         r_core = rpos(ir) ; exit
      end if
   end do
   else
      r_core = 0.d0
   end if
   rmax_ps = 0.d0
   do ishell = 1,nshell
      if (is_valence(ishell) /= 0) then
         rcut_tmp = rcut_tm(l_qnum(ishell))
         ll       = l_qnum(ishell)
         if (rmax_ps < rcut_tmp) then
            rmax_ps = rcut_tmp
         end if
      end if
   end do
   call write_rcore_rmaxps(IFLOG)
   call write_rcore_rmaxps(IFSUM)
   if (dist_nn(zatom)*0.5d0 < 1.d-6) then
   else if (rmax_ps > dist_nn(zatom)*0.5d0) then
      call write_caution_dist_nn(IFLOG)
      call write_caution_dist_nn(IFSUM)
   end if
99 continue
   end subroutine calc_rcore_rmaxps

!=====================================================================
   subroutine write_caution_dist_nn(ifile)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(in) :: ifile
   write(ifile,*)
   write(ifile,*) '#################### CAUTION #####################'
   write(ifile,*) '##  One of cutoff radii is longer than half of  ##'
   write(ifile,*) '##  the nearest neighbour distance.             ##'
   write(ifile,*) '##################################################'
   write(ifile,10) 'Maximum ps radius  (Bohr),(A):', &
      rmax_ps, rmax_ps*BOHR
   write(ifile,10) '1/2 of n.n. distance  (B),(A):', &
      dist_nn(zatom)*0.5d0, dist_nn(zatom)*0.5d0*BOHR
10 format(1x,a30,2(f20.10))
   end subroutine write_caution_dist_nn

!=====================================================================
   subroutine write_rcore_rmaxps(ifile)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(in) :: ifile
   write(ifile,*)
   write(ifile,10) 'Core charge radius (Bohr),(A):', &
      r_core, r_core*BOHR
   write(ifile,10) 'Maximum ps radius  (Bohr),(A):', &
      rmax_ps, rmax_ps*BOHR
   write(ifile,10) '1/2 of n.n. distance  (B),(A):', &
      dist_nn(zatom)*0.5d0, dist_nn(zatom)*0.5d0*BOHR
10 format(1x,a30,2(f20.10))
   end subroutine write_rcore_rmaxps

!=====================================================================
   subroutine sort_ips_ps(ier,nps,nref, &
      n_val_label_ps,l_val_label_ps,is_val_type_ps,nref_ps, &
      rcut_phi_ps,deref_ps,rin_qps_ps,is_gen_ps)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   implicit none
   integer,intent(in)    :: nps, nref
   integer,intent(inout) :: n_val_label_ps(nps), &
                            l_val_label_ps(nps), &
                            is_val_type_ps(nps), &
                            nref_ps(nps),        &
                            is_gen_ps(nps,2)
   real(8),intent(inout) :: rcut_phi_ps(nps,nref), &
                            deref_ps(nps,nref), &
                            rin_qps_ps(nps,nref)
   integer,intent(out)   :: ier
   integer :: ips, jps, l1, l2, tt
   ier = 0
   if (nps > 1) then
      do ips = 1,nps-1
         l1 = l_val_label_ps(ips)
         do jps = ips+1,nps
            l2 = l_val_label_ps(jps)
            if (l1 > l2) then
               call iswap(n_val_label_ps(ips),n_val_label_ps(jps))
               call iswap(l_val_label_ps(ips),l_val_label_ps(jps))
               call iswap(is_val_type_ps(ips),is_val_type_ps(jps))
               call iswap(nref_ps(ips),nref_ps(jps))
               do tt = 1,nref
                  call swap(rcut_phi_ps(ips,tt),rcut_phi_ps(jps,tt))
                  call swap(deref_ps(ips,tt),deref_ps(jps,tt))
                  call swap(rin_qps_ps(ips,tt),rin_qps_ps(jps,tt))
               end do
               do tt = 1,2
                  call iswap(is_gen_ps(ips,tt),is_gen_ps(jps,tt))
               end do
               l1 = l2
            end if
         end do
      end do
   end if
99 continue
   end subroutine sort_ips_ps

!=====================================================================
   subroutine calc_ishell_ps_felec_val(ier)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer :: ishell, n1, l1, n2, l2, k2, ips, &
              is_found, ishell_found, iso
   ier = 0
   felec_val = 0.d0
   is_valence(:) = 0
   num_so_ps(:) = 0
   do ips = 1,nps
      n1 = n_val_label_ps(ips)
      l1 = l_val_label_ps(ips)
      iso = 0
      is_found = 0
      do ishell = 1,nshell
         n2 = n_qnum(ishell)
         l2 = l_qnum(ishell)
         k2 = k_qnum(ishell)
         if ((n1 == n2).and.(l1 == l2)) then
            iso = iso + 1
            ishell_found = ishell
            is_valence(ishell_found) = 1
            ishell_ps(ips,iso) = ishell_found
            is_found = is_found + 1
            felec_val = felec_val + focc(ishell_found)
         end if
      end do
      num_so_ps(ips) = iso
      if (is_found == 0) then
         write(IFLOG,*) '### ERROR ### ishell was not found'
         write(IFLOG,*) &
            'Valence state specified by PP input was not found.'
         write(IFLOG,*) '   (n,l) ...',n1,l1
         ier = 1 ; go to 99
      end if
   end do
99 continue
   end subroutine calc_ishell_ps_felec_val

!=====================================================================
   subroutine set_ips_loc(ier)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer :: ishell, ll, ips
   ier = 0
   if (nps == 0) then
      write(IFLOG,*) '### ERROR ### nps == 0'
      ier = 1 ; go to 99
   end if
   ips_loc = 0
   do ips = 1,nps
      ishell = ishell_ps(ips,1)
      ll = l_qnum(ishell)
      if (ll == lloc) then
         ips_loc = ips
      end if
   end do
99 continue
   end subroutine set_ips_loc

!=====================================================================
   subroutine write_pp(ier)
!=====================================================================
!
!  ### CAUTION ### 2006.08.23 M.O.
!  Temporarily, tt = 1 for veff_ps()
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer :: ips, ishell, ir, nn, ll, kk, jj2, ispin, ll_core, lt
   character(1) :: fn_label_orbital
   character(2) :: ch_del, ch2
   ier = 0
   ch_del = ','//' '
   open(IFPP,file=trim(ppfile),status='unknown')
   write(IFPP,*) 'All-electron potential and pseudopotential'
   call write_file_header(IFPP)
   write(IFPP,*)
   select case (nspin)
   case (1)
      write(IFPP,*) 'rpos, rho, rho_ps, vh, vh_ps, vxc_ps, vloc_ion'
      do ir = 1,nmesh
         write(IFPP,10) rpos(ir),rho(ir,1),rho_ps(ir), &
                        vh(ir),vh_ps(ir),vx_ps(ir)+vc_ps(ir), &
                        vloc_ion_us(ir)
      end do
   case (2)
      write(IFPP,*) &
         'rpos, rho1, rho2, rho_ps, vh, vh_ps, vxc_ps, vloc_ion'
      do ir = 1,nmesh
         write(IFPP,10) rpos(ir),rho(ir,1),rho(ir,2),rho_ps(ir), &
                        vh(ir),vh_ps(ir),vx_ps(ir)+vc_ps(ir), &
                        vloc_ion_us(ir)
      end do
   end select
   do ips = 1,nps
      ishell = ishell_ps(ips,1)
      nn = n_qnum(ishell)
      ll = l_qnum(ishell)
      lt = lt_n_us(ll,1)
      if (is_core == PATOM) then
         ll_core = ll
      else
         ll_core = lmax_core
      end if
      kk = k_qnum(ishell)
      jj2 = j2_qnum(ishell)
      ispin = (1-spin(ishell))/2 + 1
      ch2(1:2) = '_'//fn_label_orbital(ll)
      write(IFPP,*)
      write(IFPP,30) nn,ll,jj2,ispin,'(n, l, 2*j, s)'
      write(IFPP,31) eref_us(lt),           'elevel'
      write(IFPP,31) rpos(nrcut_phi_us(lt)),'rcut  '
      write(IFPP,*)
      write(IFPP,*) &
         'rpos'//ch2//ch_del//'chi'//ch2//ch_del//'chi_ps'//ch2 &
         //ch_del//'veff'//ch2//ch_del//'veff_ps'//ch2 &
         //ch_del//'vion'//ch2//ch_del//'vion_ps'//ch2
      do ir = 1,nmesh
         write(IFPP,10) rpos(ir),rpsi_us(ir,lt),rphi_us(ir,lt), &
                        veff(ir,ispin,ll_core),veff_ps(ir,ips,1), &
                        vion(ir,ll_core),vion_ps(ir,ips,1)
      end do
   end do
10 format(10(1pe20.10))
30 format(1x,4i5,   5x,':',1x,a14)
31 format(1x,f20.10,5x,':',1x,a6)
   close(IFPP)
   end subroutine write_pp

!=====================================================================
   subroutine write_gncpp(ier)
!=====================================================================
!
!  ### CAUTION ### 2006.08.23 M.O.
!  Temporarily, tt = 1 for veff_ps()
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   
   character(7) :: xcname
   integer :: ival, iloc, itpcc, ir, ips, ishell, ll, lt, &
              icoeff, ln, tn, lm, tm, l3, tmin, ltlt, ispin, &
              mm, mmmax, mopsw, mopsc, il1, tau1, il2, tau2, il3
   real(8) :: cca1, cca2, ccc1, chgpc
   integer,allocatable :: &
      nrcl(:,:), nrcml(:,:), ivanl(:), itau(:)
   real(8),allocatable :: &
      vscr(:,:), rhvr(:), co1(:,:,:), phiv(:,:,:), eps(:,:), &
      qrsps(:,:,:), copsc(:,:,:), rhpcr(:), coc(:)
  !+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   mmmax = max(ncoeff_phi_us,ncoeff_qps_us)
   allocate(nrcl(lmax+1,nref_max_us),nrcml(num_ltltx_us,l3_max_us+1),&
      ivanl(lmax+1),itau(lmax+1),vscr(nmesh,lmax+1),rhvr(nmesh),&
      co1(0:mmmax,lmax+1,l3_max_us+1),phiv(nmesh,lmax+1,nref_max_us),&
      eps(lmax+1,nref_max_us),qrsps(nmesh,num_ltltx_us,l3_max_us+1),&
      copsc(0:mmmax,num_ltltx_us,l3_max_us+1),rhpcr(nmesh),&
      coc(0:ncoeff_pcc))
      nrcl    = 0 ; nrcml    = 0 ; ivanl    = 0 ; itau     = 0
      vscr = 0.d0 ; rhvr  = 0.d0 ; co1   = 0.d0 ; phiv  = 0.d0
      eps  = 0.d0 ; qrsps = 0.d0 ; copsc = 0.d0 ; rhpcr = 0.d0
      coc  = 0.d0
  !+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   
   open(IFGNCPP,file=trim(gncppfile),status='unknown')
   rewind(IFGNCPP)
   
   write(IFLOG,*) '   Writing GNCPP1 -->',IFGNCPP
   fval = fatom - felec_core
   zval = int(fval + 1.d-6)
   ival   = zval
   iloc   = lloc+1 
   select case (is_pcc)
   case (NONE)
      itpcc = 0
   case (PCC)
      itpcc = 1
   case (FCC)
      itpcc = 2
   end select

   if (abs(fatom-dble(zatom)) < 1.d-6) then
      if (abs(fval-dble(ival)) < 1.d-5) then
         write(IFGNCPP,60) zatom, ival, iloc, itpcc  !!!  GNCPP1
      else
         write(IFGNCPP,61) zatom, fval, iloc, itpcc  !!!  GNCPP1
      end if
   else
      if (abs(fval-dble(ival)) < 1.d-5) then
         write(IFGNCPP,62) fatom, ival, iloc, itpcc  !!!  GNCPP1
      else
         write(IFGNCPP,63) fatom, fval, iloc, itpcc  !!!  GNCPP1
      end if
   end if
60 format(' ',5i4,         '  : zatom, ival, iloc, itpcc ')
61 format(' ',i4,f10.5,3i4,'  : zatom, fval, iloc, itpcc ')
62 format(' ',f10.5,4i4,   '  : fatom, ival, iloc, itpcc ')
63 format(' ',2f10.5,3i4,  '  : fatom, fval, iloc, itpcc ')

   select case (is_xc)
   case (LDAPZ81)
      xcname = 'ldapz81'
   case (LDAPW92_MOMO, LDAPW92_MOMO2, LDAPW92_GNCPP)
      xcname = 'ldapw91'
   case (GGAPW91_MOMO, GGAPW91_MOMO2, GGAPW91_F90, GGAPW91_F77)
      xcname = 'ggapw91'
   case (GGAPBE96_MOMO, GGAPBE96_MOMO2, GGAPBE96_GNCPP, GGAPBE96_KATO)
      xcname = 'ggapbe'
   case default
      write(IFLOG,*) '### ERROR ### xc-type'
      write(IFLOG,*) '   is_xc ...', is_xc
      ier = 1 ; go to 99
   end select
   write(IFGNCPP,11) xcname
11 format(a7,'  : name ')

   cca1 = cc_a1(zatom)
   cca2 = cc_a2(zatom)
   ccc1 = cc_c1(zatom)
   write(IFGNCPP,12) cca1,cca2,ccc1,1.d0-ccc1
12 format(' ',4f12.6,'  :   alp,cc')

   write(IFGNCPP,13)           nmesh,  xh, rmax
13 format(' ',i6,2f12.6,'  :   nmesh,  xh, rmax')

   write(IFGNCPP,14)
14 format('VALL')

   ispin = 1
   write(IFGNCPP,15) (veff(ir,ispin,lmax_core),ir=1,nmesh)
15 format(3e25.17)

   vscr(:,:) = 0.d0
   select case (is_pp_calc_class)
   case (NC)
      do ips = 1,nps
         ishell = ishell_ps(ips,1)
         ll = l_qnum(ishell)
         do ir = 1,nmesh                      
            vscr(ir,ll+1) = veff_ps(ir,ips,1) 
         end do                               
      end do
   case (US)
      do lt = 1,num_ltx_us
         ips = ips_lt_us(lt)
         ln = ln_lt_us(lt)
         tn = tn_lt_us(lt)
         select case (is_val_type_us(ln))
         case (TM91)
            do ir = 1,nmesh
               vscr(ir,ln+1) = veff_ps(ir,ips,1)
            end do
         case (US90)
            do ir = 1,nmesh
               vscr(ir,ln+1) = 0.d0
            end do
         end select
      end do
   end select
   if(iloc >= 5) then
      write(IFGNCPP,15) (vloc_scr_sol(ir),ir=1,nmesh)
   else
      write(IFGNCPP,15) (vscr(ir,iloc),ir=1,nmesh)
   endif

   do ir = 1,nmesh
      rhvr(ir) = rho_sol(ir) * 4.d0*PI*rpos(ir)**2
   end do                                        
   write(IFGNCPP,15) (rhvr(ir),ir=1,nmesh)

   if(lmax == 3) then
      write(IFGNCPP,16)
   end if
16 format('F-STATE')

   co1 (:,:,:) = 0.d0
   phiv(:,:,:) = 0.d0
   select case (is_pp_calc_class)
   case (NC)
      mopsw = 0
      do lt = 1,num_ltx_us
         ln = ln_lt_us(lt)
         tn = tn_lt_us(lt)
         do ir=1,nmesh
            phiv(ir,ln+1,tn) = rphi_us(ir,lt)
         end do
      end do
   case (US)
      mopsw = ncoeff_phi_us
      do lt = 1,num_ltx_us
         ln = ln_lt_us(lt)
         tn = tn_lt_us(lt)
         ips = ips_lt_us(lt)
         select case (is_val_type_us(ln))
         case (TM91)
            do ir=1,nmesh
               phiv(ir,ln+1,tn) = rphi_us(ir,lt)
            end do            
         case (US90)                                
            do icoeff = 0,mopsw
               co1(icoeff,ln+1,tn) = coeff_phi_us(icoeff,lt)
            end do
            do ir=1,nmesh
               phiv(ir,ln+1,tn) = rphi_us(ir,lt)
            end do
         end select
      end do
   end select
   nrcl (:,:) = 0
   nrcml(:,:) = 0
   select case (is_pp_calc_class)
   case (NC)
   case (US)
      do ln = 0,lmax
         do tn = 1,nref_us(ln)
            lt = lt_n_us(ln,tn)
            nrcl(ln+1,tn) = nrcut_phi_us(lt)
         end do
      end do
      mm = 0
      do ln = 0,lmax
         if (ln == lloc) then
            cycle
         end if
         do tn = 1,nref_us(ln)
            do lm = ln,lmax
               if (lm == lloc) then
                  cycle
               end if
               if ((is_val_type_us(ln) == TM91).and. &
                   (is_val_type_us(lm) == TM91)) then
                  cycle
               end if
               tmin = 1
               if (ln == lm) then
                  tmin = tn
               end if
               do tm = tmin,nref_us(lm)
                  mm = mm+1
                  ltlt = ltlt_nm_us(ln,tn,lm,tm)
                  do l3 = abs(ln-lm),ln+lm,2
                     nrcml(mm,l3+1) = nrcut_qps_us(ltlt,l3)
                     write(IFLOG,*) &
                        'ln,tn,lm,tm,l3,mm,ltlt,nrcml ...', &
                         ln,tn,lm,tm,l3,mm,ltlt,nrcml(mm,l3+1)
                  end do
               end do
            end do
         end do
      end do
   end select
   do ln = 0,lmax
      itau (ln+1) = nref_us(ln)
   end do
   do ln = 0,lmax
      select case (is_val_type_us(ln))
      case (US90)
         ivanl(ln+1) = 1
      case (TM91)
         ivanl(ln+1) = 0
      end select
   end do
   eps(:,:) = 0.d0
   do lt = 1,num_ltx_us
      ln = ln_lt_us(lt)
      tn = tn_lt_us(lt)
      eps(ln+1,tn) = eref_us(lt)
   end do
   do il1 = 1,lmax+1
      write(IFGNCPP,20) il1,itau(il1),ivanl(il1)
      do tau1 = 1,itau(il1)
         if(ivanl(il1) >= 1) then
            write(IFGNCPP,21) il1,tau1,eps(il1,tau1),nrcl(il1,tau1),mopsw
            write(IFGNCPP,15) (co1(icoeff,il1,tau1),icoeff=0,mopsw)
            write(IFGNCPP,15) (phiv(ir,il1,tau1),ir=nrcl(il1,tau1)+1,nmesh)
         else
            write(IFGNCPP,21) il1,tau1,eps(il1,tau1),0,0
            write(IFGNCPP,15) (phiv(ir,il1,tau1),ir=1,nmesh)
            write(IFGNCPP,15) (vscr(ir,il1),ir=1,nmesh)
         end if
      end do
   end do
20 format(' ',3i4,'  :   il1, itau(il1),ivanl(il1) ')
21 format(' ',2i6,f24.16,2i6,' : il,tau,eps,nrcl,mopsw')

   qrsps(:,:,:) = 0.d0
   copsc(:,:,:) = 0.d0
   select case (is_pp_calc_class)
   case (NC)
      mopsc = 0
   case (US)
      mopsc = ncoeff_qps_us
      mm = 0
      do ln = 0,lmax
         if (ln == lloc) then
            cycle
         end if
         do tn = 1,nref_us(ln)
            do lm = ln,lmax
               if (lm == lloc) then
                  cycle
               end if
               if ((is_val_type_us(ln) == TM91).and. &
                   (is_val_type_us(lm) == TM91)) then
                  cycle
               end if
               tmin = 1
               if (ln == lm) then
                  tmin = tn
               end if
               do tm = tmin,nref_us(lm)
                  mm = mm+1
                  ltlt = ltlt_nm_us(ln,tn,lm,tm)
                  do l3 = abs(ln-lm),ln+lm,2
                     do icoeff = 0,mopsc
                        copsc(icoeff,mm,l3+1) = &
                           coeff_qps_us(icoeff,ltlt,l3)
                     end do
                     do ir = nrcut_qps_us(ltlt,l3)+1,nmesh
!                        qrsps(ir,mm,l3+1) = qps_us(ir,ltlt,l3) &   !AAS 2009
!                                          * rpos(ir)**(l3+2)
                        qrsps(ir,mm,l3+1) = qps_us(ir,ltlt,l3) &    !AAS 2009
                                          * rpos(ir)**(2)
                     end do
                     write(IFLOG,*) 'ln,tn,lm,tm,l3,mm,ltlt ...', &
                                     ln,tn,lm,tm,l3,mm,ltlt
                  end do
               end do
            end do
         end do
      end do
   end select
   mm = 0
   do il1 = 1,lmax+1
      if (iloc == il1) cycle
      do tau1 = 1,itau(il1)
      do il2 = il1,lmax+1
         if ((iloc == il2) .or. &
            ((ivanl(il1) == 0).and.(ivanl(il2) == 0))) cycle
            tmin = 1
         if (il1 == il2) tmin = tau1
         do tau2 = tmin,itau(il2)
            mm = mm+1
            do il3 = abs(il1-il2)+1,il1+il2-1,2
               !if (il3-1 > 4) cycle          !!! <---------- M.Okamoto 2003.04.23
               if (il3-1 > 4) cycle           !!! <---------- M.Okamoto 2005.01.31
               write(IFGNCPP,30) il1,tau1,il2,tau2,il3,nrcml(mm,il3),mopsc
               write(IFGNCPP,15) (copsc(icoeff,mm,il3),icoeff=0,mopsc)
               write(IFGNCPP,15) (qrsps(ir,mm,il3),ir=nrcml(mm,il3)+1,nmesh)
            end do
         end do
      end do
      end do
   end do
30 format(' ',5i3,i6,i4,' il1,tau1,il2,tau2,il3,nrcml,mopsc')

   rhpcr(:) = 0.d0
   coc  (:) = 0.d0
   select case (is_pcc)
   case (PCC)
      chgpc = 0.d0
      do ir = 1,nmesh
         if (rho_pcore(ir) * 4.d0*PI*rpos(ir)**2 < 1.d-99) then
            rhpcr(ir) = 0.d0
         else
            rhpcr(ir) = rho_pcore(ir) * 4.d0*PI*rpos(ir)**2
         end if
         chgpc = chgpc + rhpcr(ir) * wr(ir)
      end do
      do icoeff = 0,ncoeff_pcc
         coc(icoeff) = coeff_pcc(icoeff) * 4.d0*PI
      end do
   end select
   if (itpcc == 1) then
      write(IFGNCPP,40) chgpc, nr0_pcc, ncoeff_pcc
      write(IFGNCPP,15) (coc(icoeff),icoeff=0,ncoeff_pcc)
      write(IFGNCPP,15) (rhpcr(ir),ir=nr0_pcc+1,nmesh)
   end if
40 format(' ',f24.16,2i6,' : chgpc, nrc0, mopcc  ')

   close(IFGNCPP)
  !+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   deallocate(nrcl,nrcml,ivanl,itau,vscr,rhvr,co1,phiv,eps,qrsps,&
      copsc,rhpcr,coc)
  !+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
99 continue
   end subroutine write_gncpp

!=====================================================================
   subroutine write_gncpp2(ier)
!=====================================================================
!
!  ### CAUTION ### 2006.08.23 M.O.
!  Temporarily, tt = 1 for veff_ps()
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   
   character(7) :: xcname
   integer :: ival, iloc, itpcc, ir, ips, ishell, ll, lt, itpp, &
              icoeff, ln, tn, lm, tm, l3, tmin, ltlt, ispin, &
              mm, mmmax, mopsw, mopsc, il1, tau1, il2, tau2, il3
   integer :: n1, l1, t1, m1, n2, l2, t2, m2, ltmltm
   real(8) :: cca1, cca2, ccc1, chgpc
   integer,allocatable :: &
      nrcl(:,:), nrcml(:,:), ivanl(:), itau(:)
   real(8),allocatable :: &
      vscr(:,:), rhvr(:), co1(:,:,:), phiv(:,:,:), eps(:,:), &
      qrsps(:,:,:), copsc(:,:,:), rhpcr(:), coc(:), vscr2(:,:), &
      phia(:,:,:)
  !+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   mmmax = max(ncoeff_phi_us,ncoeff_qps_us)
   allocate(nrcl(lmax+1,nref_max_us),nrcml(num_ltltx_us,l3_max_us+1),&
      ivanl(lmax+1),itau(lmax+1),vscr(nmesh,lmax+1),rhvr(nmesh),&
      co1(0:mmmax,lmax+1,l3_max_us+1),phiv(nmesh,lmax+1,nref_max_us),&
      eps(lmax+1,nref_max_us),qrsps(nmesh,num_ltltx_us,l3_max_us+1),&
      copsc(0:mmmax,num_ltltx_us,l3_max_us+1),rhpcr(nmesh),&
      coc(0:ncoeff_pcc),vscr2(nmesh,lmax+1),&
      phia(nmesh,lmax+1,nref_max_us))
      nrcl    = 0 ; nrcml    = 0 ; ivanl    = 0 ; itau     = 0
      vscr = 0.d0 ; rhvr  = 0.d0 ; co1   = 0.d0 ; phiv  = 0.d0
      eps  = 0.d0 ; qrsps = 0.d0 ; copsc = 0.d0 ; rhpcr = 0.d0
      coc  = 0.d0 ; vscr2 = 0.d0 ; phia  = 0.d0
  !+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   
   open(IFGNCPP2,file=trim(gncpp2file),status='unknown')
   rewind(IFGNCPP2)
   
   write(IFLOG,*) '   Writing GNCPP2 -->',IFGNCPP2
   fval = fatom - felec_core
   zval = int(fval + 1.d-6)
   ival   = zval
   iloc   = lloc+1 
   select case (is_pcc)
   case (NONE)
      itpcc = 0
   case (PCC)
      itpcc = 1
   case (FCC)
      itpcc = 2
   end select
   if (is_with_ae /= 0) then
      itpp = -2
   else
      itpp = 2
   end if

   if (abs(fatom-dble(zatom)) < 1.d-6) then
      if (abs(fval-dble(ival)) < 1.d-5) then
         write(IFGNCPP2,60) zatom, ival, iloc, itpcc, itpp  !!!  GNCPP2
      else
         write(IFGNCPP2,61) zatom, fval, iloc, itpcc, itpp  !!!  GNCPP2
      end if
   else
      if (abs(fval-dble(ival)) < 1.d-5) then
         write(IFGNCPP2,62) fatom, ival, iloc, itpcc, itpp  !!!  GNCPP2
      else
         write(IFGNCPP2,63) fatom, fval, iloc, itpcc, itpp  !!!  GNCPP2
      end if
   end if
60 format(' ',5i4,         '  : zatom, ival, iloc, itpcc ')
61 format(' ',i4,f10.5,3i4,'  : zatom, fval, iloc, itpcc ')
62 format(' ',f10.5,4i4,   '  : fatom, ival, iloc, itpcc ')
63 format(' ',2f10.5,3i4,  '  : fatom, fval, iloc, itpcc ')

   select case (is_xc)
   case (LDAPZ81)
      xcname = 'ldapz81'
   case (LDAPW92_MOMO, LDAPW92_MOMO2, LDAPW92_GNCPP)
      xcname = 'ldapw91'
   case (GGAPW91_MOMO, GGAPW91_MOMO2, GGAPW91_F90, GGAPW91_F77)
      xcname = 'ggapw91'
   case (GGAPBE96_MOMO, GGAPBE96_MOMO2, GGAPBE96_GNCPP, GGAPBE96_KATO)
      xcname = 'ggapbe'
   case default
      write(IFLOG,*) '### ERROR ### xc-type'
      write(IFLOG,*) '   is_xc ...', is_xc
      ier = 1 ; go to 99
   end select
   write(IFGNCPP2,11) xcname
11 format(a7,'  : name ')

   cca1 = cc_a1(zatom)
   cca2 = cc_a2(zatom)
   ccc1 = cc_c1(zatom)
   write(IFGNCPP2,12) cca1,cca2,ccc1,1.d0-ccc1
12 format(' ',4f12.6,'  :   alp,cc')

   write(IFGNCPP2,13)           nmesh,  xh, rmax
13 format(' ',i6,2f12.6,'  :   nmesh,  xh, rmax')

   write(IFGNCPP2,14)
14 format('VALL')

   ispin = 1
   write(IFGNCPP2,15) (veff(ir,ispin,lmax_core),ir=1,nmesh)
15 format(3e25.17)

   vscr(:,:) = 0.d0
   vscr2(:,:) = 0.d0
   select case (is_pp_calc_class)
   case (NC)
      do ips = 1,nps
         ishell = ishell_ps(ips,1)
         ll = l_qnum(ishell)
         do ir = 1,nmesh                      
            vscr(ir,ll+1) = veff_ps(ir,ips,1) 
            vscr2(ir,ll+1) = vion_ps(ir,ips,1) 
         end do                               
      end do
   case (US)
      do lt = 1,num_ltx_us
         ips = ips_lt_us(lt)
         ln = ln_lt_us(lt)
         tn = tn_lt_us(lt)
         select case (is_val_type_us(ln))
         case (TM91)
            do ir = 1,nmesh
               vscr(ir,ln+1) = veff_ps(ir,ips,1)
               vscr2(ir,ln+1) = vion_ps(ir,ips,1)
            end do
         case (US90)
            do ir = 1,nmesh
               vscr(ir,ln+1) = 0.d0
               vscr2(ir,ln+1) = 0.d0
            end do
         end select
      end do
   end select
   if(iloc >= 5) then
      write(IFGNCPP2,15) (vloc_scr_sol(ir),ir=1,nmesh)
      write(IFGNCPP2,15) (vloc_ion_sol(ir),ir=1,nmesh)
   else
      write(IFGNCPP2,15) (vscr(ir,iloc),ir=1,nmesh)
      write(IFGNCPP2,15) (vscr2(ir,iloc),ir=1,nmesh)
   endif

   do ir = 1,nmesh
      rhvr(ir) = rho_sol(ir) * 4.d0*PI*rpos(ir)**2
   end do                                        
   write(IFGNCPP2,15) (rhvr(ir),ir=1,nmesh)

   if(lmax == 3) then
      write(IFGNCPP2,16)
   end if
16 format('F-STATE')

   co1 (:,:,:) = 0.d0
   phiv(:,:,:) = 0.d0
   select case (is_pp_calc_class)
   case (NC)
      mopsw = 0
      do lt = 1,num_ltx_us
         ln = ln_lt_us(lt)
         tn = tn_lt_us(lt)
         do ir=1,nmesh
            phia(ir,ln+1,tn) = rpsi_us(ir,lt)
            phiv(ir,ln+1,tn) = rphi_us(ir,lt)
         end do
      end do
   case (US)
      mopsw = ncoeff_phi_us
      do lt = 1,num_ltx_us
         ln = ln_lt_us(lt)
         tn = tn_lt_us(lt)
         ips = ips_lt_us(lt)
         select case (is_val_type_us(ln))
         case (TM91)
            do ir=1,nmesh
               phia(ir,ln+1,tn) = rpsi_us(ir,lt)
               phiv(ir,ln+1,tn) = rphi_us(ir,lt)
            end do            
         case (US90)                                
            do icoeff = 0,mopsw
               co1(icoeff,ln+1,tn) = coeff_phi_us(icoeff,lt)
            end do
            do ir=1,nmesh
               phia(ir,ln+1,tn) = rpsi_us(ir,lt)
               phiv(ir,ln+1,tn) = rphi_us(ir,lt)
            end do
         end select
      end do
   end select
   nrcl (:,:) = 0
   nrcml(:,:) = 0
   select case (is_pp_calc_class)
   case (NC)
   case (US)
      do ln = 0,lmax
         do tn = 1,nref_us(ln)
            lt = lt_n_us(ln,tn)
            nrcl(ln+1,tn) = nrcut_phi_us(lt)
         end do
      end do
      mm = 0
      do ln = 0,lmax
         if (ln == lloc) then
            cycle
         end if
         do tn = 1,nref_us(ln)
            do lm = ln,lmax
               if (lm == lloc) then
                  cycle
               end if
               if ((is_val_type_us(ln) == TM91).and. &
                   (is_val_type_us(lm) == TM91)) then
                  cycle
               end if
               tmin = 1
               if (ln == lm) then
                  tmin = tn
               end if
               do tm = tmin,nref_us(lm)
                  mm = mm+1
                  ltlt = ltlt_nm_us(ln,tn,lm,tm)
                  do l3 = abs(ln-lm),ln+lm,2
                     nrcml(mm,l3+1) = nrcut_qps_us(ltlt,l3)
                     write(IFLOG,*) &
                        'ln,tn,lm,tm,l3,mm,ltlt,nrcml ...', &
                         ln,tn,lm,tm,l3,mm,ltlt,nrcml(mm,l3+1)
                  end do
               end do
            end do
         end do
      end do
   end select
   do ln = 0,lmax
      itau (ln+1) = nref_us(ln)
   end do
   do ln = 0,lmax
      select case (is_val_type_us(ln))
      case (US90)
         ivanl(ln+1) = 1
      case (TM91)
         ivanl(ln+1) = 0
      end select
   end do
   eps(:,:) = 0.d0
   do lt = 1,num_ltx_us
      ln = ln_lt_us(lt)
      tn = tn_lt_us(lt)
      eps(ln+1,tn) = eref_us(lt)
   end do
   do il1 = 1,lmax+1
      write(IFGNCPP2,20) il1,itau(il1),ivanl(il1)
      do tau1 = 1,itau(il1)
         if(ivanl(il1) >= 1) then
            write(IFGNCPP2,21) il1,tau1,eps(il1,tau1),nrcl(il1,tau1),mopsw
            if (is_with_ae /= 0) then
            write(IFGNCPP2,15) (phia(ir,il1,tau1),ir=1,nmesh)
            end if
            write(IFGNCPP2,15) (co1(icoeff,il1,tau1),icoeff=0,mopsw)
            write(IFGNCPP2,15) (phiv(ir,il1,tau1),ir=nrcl(il1,tau1)+1,nmesh)
         else
            write(IFGNCPP2,21) il1,tau1,eps(il1,tau1),0,0
            if (is_with_ae /= 0) then
            write(IFGNCPP2,15) (phia(ir,il1,tau1),ir=1,nmesh)
            end if
            write(IFGNCPP2,15) (phiv(ir,il1,tau1),ir=1,nmesh)
            write(IFGNCPP2,15) (vscr2(ir,il1),ir=1,nmesh)
         end if
      end do
   end do
20 format(' ',3i4,'  :   il1, itau(il1),ivanl(il1) ')
21 format(' ',2i6,f24.16,2i6,' : il,tau,eps,nrcl,mopsw')

   qrsps(:,:,:) = 0.d0
   copsc(:,:,:) = 0.d0
   select case (is_pp_calc_class)
   case (NC)
      mopsc = 0
   case (US)
      mopsc = ncoeff_qps_us
      mm = 0
      do ln = 0,lmax
         if (ln == lloc) then
            cycle
         end if
         do tn = 1,nref_us(ln)
            do lm = ln,lmax
               if (lm == lloc) then
                  cycle
               end if
               if ((is_val_type_us(ln) == TM91).and. &
                   (is_val_type_us(lm) == TM91)) then
                  cycle
               end if
               tmin = 1
               if (ln == lm) then
                  tmin = tn
               end if
               do tm = tmin,nref_us(lm)
                  mm = mm+1
                  ltlt = ltlt_nm_us(ln,tn,lm,tm)
                  do l3 = abs(ln-lm),ln+lm,2
                     do icoeff = 0,mopsc
                        copsc(icoeff,mm,l3+1) = &
                           coeff_qps_us(icoeff,ltlt,l3)
                     end do
                     do ir = nrcut_qps_us(ltlt,l3)+1,nmesh
!                        qrsps(ir,mm,l3+1) = qps_us(ir,ltlt,l3) &   !AAS 2009
!                                          * rpos(ir)**(l3+2)
                        qrsps(ir,mm,l3+1) = qps_us(ir,ltlt,l3) &    !AAS 2009
                                          * rpos(ir)**(2)
                     end do
                     write(IFLOG,*) 'ln,tn,lm,tm,l3,mm,ltlt ...', &
                                     ln,tn,lm,tm,l3,mm,ltlt
                  end do
               end do
            end do
         end do
      end do
   end select
   mm = 0
   do il1 = 1,lmax+1
      if (iloc == il1) cycle
      do tau1 = 1,itau(il1)
      do il2 = il1,lmax+1
         if ((iloc == il2) .or. &
            ((ivanl(il1) == 0).and.(ivanl(il2) == 0))) cycle
            tmin = 1
         if (il1 == il2) tmin = tau1
         do tau2 = tmin,itau(il2)
            mm = mm+1
            do il3 = abs(il1-il2)+1,il1+il2-1,2
               !if (il3-1 > 4) cycle          !!! <---------- M.Okamoto 2003.04.23
               if (il3-1 > 4) cycle           !!! <---------- M.Okamoto 2005.01.31
               write(IFGNCPP2,30) il1,tau1,il2,tau2,il3,nrcml(mm,il3),mopsc
               write(IFGNCPP2,15) (copsc(icoeff,mm,il3),icoeff=0,mopsc)
               write(IFGNCPP2,15) (qrsps(ir,mm,il3),ir=nrcml(mm,il3)+1,nmesh)
            end do
         end do
      end do
      end do
   end do
30 format(' ',5i3,i6,i4,' il1,tau1,il2,tau2,il3,nrcml,mopsc')

   rhpcr(:) = 0.d0
   coc  (:) = 0.d0
   select case (is_pcc)
   case (PCC)
      chgpc = 0.d0
      do ir = 1,nmesh
         if (rho_pcore(ir) * 4.d0*PI*rpos(ir)**2 < 1.d-99) then
            rhpcr(ir) = 0.d0
         else
            rhpcr(ir) = rho_pcore(ir) * 4.d0*PI*rpos(ir)**2
         end if
         chgpc = chgpc + rhpcr(ir) * wr(ir)
      end do
      do icoeff = 0,ncoeff_pcc
         coc(icoeff) = coeff_pcc(icoeff) * 4.d0*PI
      end do
   end select
   if (itpcc == 1) then
      write(IFGNCPP2,40) chgpc, nr0_pcc, ncoeff_pcc
      write(IFGNCPP2,15) (coc(icoeff),icoeff=0,ncoeff_pcc)
      write(IFGNCPP2,15) (rhpcr(ir),ir=nr0_pcc+1,nmesh)
   end if
40 format(' ',f24.16,2i6,' : chgpc, nrc0, mopcc  ')

if(is_with_core /= 0) then
   write(IFGNCPP2,50)
50 format('CORE-CHARGE')
   rhpcr(:) = 0.d0
   chgpc = 0.d0
   do ir = 1,nmesh
      if (rho_core(ir) * 4.d0*PI*rpos(ir)**2 < 1.d-99) then
         rhpcr(ir) = 0.d0
      else
         rhpcr(ir) = rho_core(ir) * 4.d0*PI*rpos(ir)**2
      end if
      chgpc = chgpc + rhpcr(ir) * wr(ir)
   end do
51 format(' ',f24.16,' : chg_core')
   write(IFGNCPP2,51) chgpc
   write(IFGNCPP2,15) (rhpcr(ir),ir=1,nmesh)
end if

if(is_with_dipole /= 0) then
   write(IFGNCPP2,52)
52 format('DIPOLE')
   write(IFGNCPP2,*) num_dipole_lm_us/2
   do ltmltm = 1,num_dipole_lm_us
      n1 = n1_dipole_lm_us(ltmltm) ; n2 = n2_dipole_lm_us(ltmltm)
      l1 = l1_dipole_lm_us(ltmltm) ; l2 = l2_dipole_lm_us(ltmltm)
      t1 = t1_dipole_lm_us(ltmltm) ; t2 = t2_dipole_lm_us(ltmltm)
      m1 = m1_dipole_lm_us(ltmltm) ; m2 = m2_dipole_lm_us(ltmltm)
      if (l1 > l2) then
         cycle
      end if
      write(IFGNCPP2,53) n1,l1,t1,m1,n2,l2,t2,m2, &
      dipole_dx_us(ltmltm),dipole_dy_us(ltmltm),dipole_dz_us(ltmltm), &
      phase_ylm(l1,m1),phase_ylm(l2,m2)
   end do
53 format(8i3,3e18.10,2i3)
end if

   close(IFGNCPP2)
  !+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   deallocate(nrcl,nrcml,ivanl,itau,vscr,rhvr,co1,phiv,eps,qrsps,&
      copsc,rhpcr,coc,vscr2,phia)
  !+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
99 continue
   end subroutine write_gncpp2

!=====================================================================
   subroutine write_ciaopp(ier)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   character(10) :: xc_name
   character(1)  :: ch_ln, ch_tn, ch_lm, ch_tm, ch_l3, &
                    fn_label_orbital, fn_label_orbital_capital
   character(2)  :: val_type_tmp, ch2
   character(3)  :: ch3
   character(5)  :: ch5
   character(6)  :: ch6
   integer :: ir, nn, ll, tt, lt, ln, tn, lm, tm, l3, nrc, icoeff, &
              n1, l1, t1, m1, n2, l2, t2, m2, ltmltm, ltlt, ltt, &
              ips, nsum, ishell, lshell, ie, nref, lps, iss, lss, ig
   real(8) :: rcut, eref, rho_pcore_sum
   real(8),allocatable :: array_tmp(:)
  !++++++++++++++++++++++++++++++++++++++++++++++
   allocate(array_tmp(nmesh)) ; array_tmp = 0.d0
  !++++++++++++++++++++++++++++++++++++++++++++++
   open(IFCIAOPP,file=trim(ciaoppfile),status='unknown')
   rewind(IFCIAOPP)
   write(IFLOG,*) '   Writing CIAOPP -->',IFCIAOPP
   call date_time(day_now)
   call write_title(IFCIAOPP,day_now)
   write(IFCIAOPP,*)
   write(IFCIAOPP,'(a16)') '### Atomic label'
   write(IFCIAOPP,'((a12,8x),a2,7x,a20)') &
      'atomic_label', atom_label(zatom), atom_name(zatom)
   write(IFCIAOPP,*)
   write(IFCIAOPP,'(a47)') '### Atomic charge : Z, Za, Zc, Zv, (Ne, Nc, Nv)'
   write(IFCIAOPP,'((a13,6x),(i3,4x),3f11.5)') &
      'atomic_charge', zatom, fatom, fcore, fval
   write(IFCIAOPP,'((13x,6x),(3x,4x),3f11.5)') &
      felec, felec_core, felec_val
   write(IFCIAOPP,*)
   write(IFCIAOPP,'(a34)') '### Exchange-correlation potential'
   select case (is_xc)
   case (LDAPZ81)
      xc_name = 'ldapz81'
   case (LDAPW92_MOMO, LDAPW92_MOMO2, LDAPW92_GNCPP)
      xc_name = 'ldapw92'
   case (GGAPW91_MOMO, GGAPW91_MOMO2, GGAPW91_F90, GGAPW91_F77)
      xc_name = 'ggapw91'
   case (GGAPBE96_MOMO, GGAPBE96_MOMO2, GGAPBE96_GNCPP, GGAPBE96_KATO)
      xc_name = 'ggapbe'
   case default
      write(IFLOG,*) '### ERROR ### xc_type'
      write(IFLOG,*) '   is_xc ...', is_xc
      ier = 1 ; go to 99
   end select
   write(IFCIAOPP,'((a12,8x),a7,5x,a5)') &
      'xc_potential', xc_name, xc_approx
   write(IFCIAOPP,*)
   write(IFCIAOPP,'(a30)') '### r-Mesh : Nmesh, rmin, rmax'
   write(IFCIAOPP,'(a5,5x,a11)') 'rmesh','logarithmic'
   write(IFCIAOPP,'(i10,2(1pe25.15))') nmesh, rmin, rmax
   write(IFCIAOPP,*)
   write(IFCIAOPP,'(a30)') '### g-Mesh : Nmesh, gmin, gmax'
   write(IFCIAOPP,'(a5,5x,a6)') 'gmesh','linear'
   write(IFCIAOPP,'(i10,2(1pe25.15))') ng_mesh, gmin, gmax
   write(IFCIAOPP,*)
   write(IFCIAOPP,'(a34)') '### All-electron SCF energy levels'
   select case (is_calc)
   case (NONREL)
      write(IFCIAOPP,'(a3,5x,a16)') '#AE','non_relativistic'
   case (SREL)
      write(IFCIAOPP,'(a3,5x,a19)') '#AE','scalar_relativistic'
   end select
   write(IFCIAOPP,21) &
      'symm','Energy (Ha)','Energy (eV)','nocc','focc'
   do ishell = 1,nshell
      lshell = list_shell(ishell)
      if (is_solve(lshell) == NO) then
         cycle
      end if
      nn = n_qnum(lshell) ; ll = l_qnum(lshell)
      write(IFCIAOPP,22) &
         state(lshell)(1:2),engy(lshell),engy(lshell)*HARTREE, &
         nocc(lshell),focc(lshell)
   end do
   write(IFCIAOPP,23) 'Total number of electrons',felec
21 format('#AE',(3x,a4),2(9x,a11),(2x,a4),(6x,a4))
22 format('#AE',(4x,a2,1x),2(f20.10),i6,f10.5)
23 format('#AE',2x,a25,26x,f10.5)
   write(IFCIAOPP,*)
   write(IFCIAOPP,'(a29)') '### All-electron total energy'
   write(IFCIAOPP,24) 'Energy (Ha)','Energy (eV)'
   if (is_calc == NONREL) then
   write(IFCIAOPP,25) 'Ekin  ',ekin_sum1,ekin_sum1*HARTREE
   else
   write(IFCIAOPP,25) 'Ekin  ',ekin_sum ,ekin_sum*HARTREE
   end if
   write(IFCIAOPP,25) 'Eion  ',eion_sum ,eion_sum *HARTREE
   write(IFCIAOPP,25) 'Eh    ',eh_sum   ,eh_sum   *HARTREE
   write(IFCIAOPP,25) 'Exc   ',exc_sum  ,exc_sum  *HARTREE
   if (is_calc == NONREL) then
   write(IFCIAOPP,25) 'Etot  ',etot_sum1,etot_sum1*HARTREE
   else
   write(IFCIAOPP,25) 'Etot  ',etot_sum ,etot_sum *HARTREE
   end if
24 format('#AE',2x,6x,2(9x,a11))
25 format('#AE',2x,a6,2(f20.10))
   write(IFCIAOPP,*)
   write(IFCIAOPP,'(a32)') '### Cutoff WF : rc[n] & dEref[n]'
   write(IFCIAOPP,'(a9)') 'cutoff_wf'
   write(IFCIAOPP,'(16i5)') nps, (nref_ps(ips),ips=1,nps)
   do ips = 1,nps
      nn = n_val_label_ps(ips) ; ll = l_val_label_ps(ips)
      select case (is_val_type_ps(ips))
      case (TM91)
         val_type_tmp = 'NC'
      case (US90)
         val_type_tmp = 'US'
      end select
      write(ch2,'(i1,a1)') nn, fn_label_orbital(ll)
      write(IFCIAOPP,'(5x,a2,(10x,a2),i12)') ch2,val_type_tmp,nref_ps(ips)
      do tt = 1,nref_ps(ips)
         write(IFCIAOPP,'(5x,2f12.5)') &
            rcut_phi_ps(ips,tt),deref_ps(ips,tt)
      end do
   end do
if (is_pp_calc_class == US) then
   write(IFCIAOPP,*)
   write(IFCIAOPP,'(a22)') '### Cutoff energy [US]'
   write(IFCIAOPP,36) 'Gcut (au)', 'Ecut (Ha)', 'Ecut (eV)'
   write(IFCIAOPP,37) 'WaveFn',gmin_phi_us, &
      0.5d0*gmin_phi_us**2,0.5d0*gmin_phi_us**2*HARTREE
   write(IFCIAOPP,37) 'Charge',gmin_qps_us, &
      0.5d0*gmin_qps_us**2,0.5d0*gmin_qps_us**2*HARTREE
36 format('#PP',2x,6x,3(11x,a9))
37 format('#PP',2x,a6,3(f20.10))
end if
   write(IFCIAOPP,*)
   write(IFCIAOPP,'(a33)') '### Pseudopotential energy levels'
   write(IFCIAOPP,31) 'symm', &
                   'Energy (Ha)','Energy (eV)','nocc','focc'
   do ips = 1,nps
      lps = list_sol(ips)
      lshell = ishell_ps(lps,1)
      if (is_solve(lshell) == 0) then
         cycle
      end if
      nn = n_qnum(lshell)
      ll = l_qnum(lshell)
      write(IFCIAOPP,32) state(lshell)(1:2), &
         engy_sol(lps),engy_sol(lps)*HARTREE,nocc(lshell),focc_sol(lps)
   end do
   write(IFCIAOPP,33) 'Total number of electrons',felec_sol
31 format('#PP',(3x,a4),2(9x,a11),(2x,a4),(6x,a4))
32 format('#PP',(4x,a2,1x),2(f20.10),i6,f10.5)
33 format('#PP',2x,a25,26x,f10.5)
   write(IFCIAOPP,*)
   write(IFCIAOPP,'(a31)') '### Psedopotential total energy'
   write(IFCIAOPP,34) 'Energy (Ha)','Energy (eV)'
   write(IFCIAOPP,35) 'Ekin     ',ekin_sum1_sol   ,ekin_sum1_sol   *HARTREE
   write(IFCIAOPP,35) 'Eion[NL] ',enl_ion_sum_sol ,enl_ion_sum_sol *HARTREE
   write(IFCIAOPP,35) 'Eion[LOC]',eloc_ion_sum_sol,eloc_ion_sum_sol*HARTREE
   write(IFCIAOPP,35) 'Eh       ',eh_sum_sol      ,eh_sum_sol      *HARTREE
   write(IFCIAOPP,35) 'Exc      ',exc_sum_sol     ,exc_sum_sol     *HARTREE
   write(IFCIAOPP,35) 'Epcc     ',excpc_sum_sol   ,excpc_sum_sol   *HARTREE
   write(IFCIAOPP,35) 'Etot     ',etot_sum1_sol   ,etot_sum1_sol   *HARTREE
34 format('#PP',2x,9x,2(9x,a11))
35 format('#PP',2x,a9,2(f20.10))
if (is_solve_pp_spin /= NO) then
   write(IFCIAOPP,*)
   write(IFCIAOPP,'(a50)') &
      '### Pseudopotential energy levels [Spin polarized]'
   write(IFCIAOPP,41) 'symm','s', &
                   'Energy (Ha)','Energy (eV)','nocc','focc'
   do iss = 1,nss
      lss = list_ss(iss)
      lshell = ishell_ss(lss)
      if (is_solve_ss(lss) == 0) then
         cycle
      end if
      nn = n_qnum(lshell)
      ll = l_qnum(lshell)
      write(IFCIAOPP,42) state(lshell)(1:2),spin_label_ss(lss)(1:1), &
         engy_ss(lss),engy_ss(lss)*HARTREE,nocc_ss(lss),focc_ss(lss)
   end do
   write(IFCIAOPP,43) 'Number of electrons (+)',felec1_ss
   write(IFCIAOPP,43) '                    (-)',felec2_ss
41 format('#SS',(3x,a4),(4x,a1),2(9x,a11),(2x,a4),(6x,a4))
42 format('#SS',(4x,a2,1x),(4x,a1),2(f20.10),i6,f10.5)
43 format('#SS',2x,a23,33x,f10.5)
end if
if (is_solve_pp_spin /= NO) then
   write(IFCIAOPP,*)
   write(IFCIAOPP,'(a48)') '### Psedopotential total energy [Spin polarized]'
   write(IFCIAOPP,44) 'Energy (Ha)','Energy (eV)'
   write(IFCIAOPP,45) 'Ekin     ',ekin_sum1_ss   ,ekin_sum1_ss   *HARTREE
   write(IFCIAOPP,45) 'Eion[NL] ',enl_ion_sum_ss ,enl_ion_sum_ss *HARTREE
   write(IFCIAOPP,45) 'Eion[LOC]',eloc_ion_sum_ss,eloc_ion_sum_ss*HARTREE
   write(IFCIAOPP,45) 'Eh       ',eh_sum_ss      ,eh_sum_ss      *HARTREE
   write(IFCIAOPP,45) 'Exc      ',exc_sum_ss     ,exc_sum_ss     *HARTREE
   write(IFCIAOPP,45) 'Epcc     ',excpc_sum_ss   ,excpc_sum_ss   *HARTREE
   write(IFCIAOPP,45) 'Etot     ',etot_sum1_ss   ,etot_sum1_ss   *HARTREE
44 format('#SS',2x,9x,2(9x,a11))
45 format('#SS',2x,a9,2(f20.10))
end if
   write(IFCIAOPP,*)
   write(IFCIAOPP,'(a49)') '### All-electron screened potential : Vae[scr](r)'
   write(IFCIAOPP,'(a16)') 'ae_scr_potential'
   write(IFCIAOPP,10) (veff(ir,1,lmax_core),ir=1,nmesh)
   write(IFCIAOPP,*)
   write(IFCIAOPP,'(a41)') '### BHS potential parameters : a1, a2, c1'
   write(IFCIAOPP,'(a63)') '#  Vbhs(r) := -Zv/r * [c1*erf{sqrt(a1*r)} + c2*erf{sqrt(a2*r)}]'
   write(IFCIAOPP,'(a15)') '#  c2 := 1 - c1'
   write(IFCIAOPP,'(a13)') 'bhs_potential'
   write(IFCIAOPP,'(3f20.10)') cc_a1(zatom), cc_a2(zatom), cc_c1(zatom)
   write(IFCIAOPP,*)
   write(IFCIAOPP,'(a43)') '### Screened local potential : Vloc[scr](r)'
   write(IFCIAOPP,'(a19)') 'scr_local_potential'
   write(IFCIAOPP,'(i10)') nrcut_max_us
   write(IFCIAOPP,10) (vloc_scr_sol(ir),ir=1,nrcut_max_us)
   write(IFCIAOPP,*)
   write(IFCIAOPP,'(a40)') '### Ionic local potential : Vloc[ion](r)'
   select case (lloc)
   case (0)
      write(IFCIAOPP,'(a19,6x,a7,2x,a1)') 'ion_local_potential','orbital','s'
   case (1)
      write(IFCIAOPP,'(a19,6x,a7,2x,a1)') 'ion_local_potential','orbital','p'
   case (2)
      write(IFCIAOPP,'(a19,6x,a7,2x,a1)') 'ion_local_potential','orbital','d'
   case (3)
      write(IFCIAOPP,'(a19,6x,a7,2x,a1)') 'ion_local_potential','orbital','f'
   case (5)
      write(IFCIAOPP,'(a19,6x,a7,2x,a3)') 'ion_local_potential','special','bhs'
   case (6)
      write(IFCIAOPP,'(a19,6x,a7,2x,a10)') 'ion_local_potential','special','polynomial'
   end select
   write(IFCIAOPP,10) (vloc_ion_sol(ir),ir=1,nmesh)
   write(IFCIAOPP,*)
   write(IFCIAOPP,'(a30)') '### Valence charge : r*r*nv(r)'
   write(IFCIAOPP,'(a19)') 'valence_charge_rrnv'
   do ir = 1,nmesh
      if (abs(rpos(ir)**2*rho_sol(ir)) < 1.d-99) then
         array_tmp(ir) = 0.d0
      else
         array_tmp(ir) = rpos(ir)**2*rho_sol(ir)
      end if
   end do
   write(IFCIAOPP,10) (array_tmp(ir),ir=1,nmesh)
   write(IFCIAOPP,*)
   write(IFCIAOPP,'(a27)') '### Core charge : r*r*nc(r)'
   write(IFCIAOPP,'(a16)') 'core_charge_rrnc'
   do ir = 1,nmesh
      if (abs(rpos(ir)**2*rho_core(ir)) < 1.d-99) then
         array_tmp(ir) = 0.d0
      else
         array_tmp(ir) = rpos(ir)**2*rho_core(ir)
      end if
   end do
   write(IFCIAOPP,10) (array_tmp(ir),ir=1,nmesh)
   write(IFCIAOPP,*)
   write(IFCIAOPP,'(a48)') '### All-electron SCF wavefunctions : r*psi[n](r)'
   write(IFCIAOPP,'(a21)') 'ae_wave_function_rpsi'
   write(IFCIAOPP,'(i10)') num_ltx_us
   write(IFCIAOPP,'(1x,3(2x,a1),2(1x,a2),2x,(4x,3x),(10x,a7,3x))') &
      'n','l','t','ln','tn','Eref[n]'
   do lt = 1,num_ltx_us
      nn  = n_lt_us(lt)  ; ll  = l_lt_us(lt)  ; tt   = t_lt_us(lt)
      ln  = ln_lt_us(lt) ; tn  = tn_lt_us(lt) ; eref = eref_us(lt)
      ch_ln = fn_label_orbital(ll)
      write(ch_tn,'(i1)') tn
      ch3(1:3) = '_'//ch_ln(1:1)//ch_tn(1:1)
      write(IFCIAOPP,'(1x,5i3,2x,(a4,a3),f20.10)') &
         nn,ll,tt,ln,tn,'rpsi',ch3,eref
   end do
   do lt = 1,num_ltx_us
      nn  = n_lt_us(lt)  ; ll  = l_lt_us(lt)  ; tt   = t_lt_us(lt)
      ln  = ln_lt_us(lt) ; tn  = tn_lt_us(lt) ; eref = eref_us(lt)
      ch_ln = fn_label_orbital(ll)
      write(ch_tn,'(i1)') tn
      ch3(1:3) = '_'//ch_ln(1:1)//ch_tn(1:1)
      write(IFCIAOPP,'(1x,a34,5i3,2x,a4,a3)') &
         'r*psi[n](r): n = (n,l,t,ln,tn) -->',nn,ll,tt,ln,tn,'rpsi',ch3
      write(IFCIAOPP,20) nn,ll,tt,ln,tn,eref
      do ir = 1,nmesh
         if (abs(rpsi_us(ir,lt)) < 1.d-99) then
            array_tmp(ir) = 0.d0
         else
            array_tmp(ir) = rpsi_us(ir,lt)
         end if
      end do
      write(IFCIAOPP,10) (array_tmp(ir),ir=1,nmesh)
   end do
   write(IFCIAOPP,*)
   write(IFCIAOPP,'(a38)') '### Pseudo-wavefunctions : r*phi[n](r)'
   write(IFCIAOPP,'(a41)') '#  For r < rc[n], phi[n](r) is explicitly'
   write(IFCIAOPP,'(a57)') '#    NC ... phi[n](r) = r^ln * exp(c0+c1*r^2+...+cN*r^2N)'
   write(IFCIAOPP,'(a54)') '#    US ... phi[n](r) = r^ln * (c0+c1*r^2+...+cN*r^2N)'
   write(IFCIAOPP,'(a39)') '#  For r > rc[n], phi[n](r) = psi[n](r)'
   write(IFCIAOPP,'(a21)') 'pp_wave_function_rphi'
   write(IFCIAOPP,'(i10)') num_ltx_us
   write(IFCIAOPP,'(1x,3(2x,a1),2(1x,a2),2x,(4x,3x),(2x,2x),(8x,a7,3x),(8x,a2,8x),(7x,a3))') &
      'n','l','t','ln','tn','Eref[n]','rc','nrc'
   do lt = 1,num_ltx_us
      nn  = n_lt_us(lt)  ; ll  = l_lt_us(lt)  ; tt   = t_lt_us(lt)
      ln  = ln_lt_us(lt) ; tn  = tn_lt_us(lt) ; eref = eref_us(lt)
      nrc = nrcut_phi_us(lt)
      rcut = rpos(nrc)
      ips = ips_lt_us(lt)
      ch_ln = fn_label_orbital(ll)
      select case (is_val_type_ps(ips))
      case (TM91)
         val_type_tmp = 'NC'
      case (US90)
         val_type_tmp = 'US'
      end select
      write(ch_tn,'(i1)') tn
      ch3(1:3) = '_'//ch_ln(1:1)//ch_tn(1:1)
      write(IFCIAOPP,'(1x,5i3,2x,(a4,a3),2x,a2,2f18.10,i10)') &
         nn,ll,tt,ln,tn,'rphi',ch3,val_type_tmp,eref,rcut,nrc
   end do
   do lt = 1,num_ltx_us
      nn  = n_lt_us(lt)  ; ll  = l_lt_us(lt)  ; tt   = t_lt_us(lt)
      ln  = ln_lt_us(lt) ; tn  = tn_lt_us(lt) ; eref = eref_us(lt)
      nrc = nrcut_phi_us(lt)
      rcut = rpos(nrc)
      ips = ips_lt_us(lt)
      ch_ln = fn_label_orbital(ll)
      write(ch_tn,'(i1)') tn
      ch3(1:3) = '_'//ch_ln(1:1)//ch_tn(1:1)
      write(IFCIAOPP,'(1x,a34,5i3,2x,a4,a3)') &
         'r*phi[n](r): n = (n,l,t,ln,tn) -->',nn,ll,tt,ln,tn,'rphi',ch3
      select case (is_val_type_ps(ips))
      case (TM91)
         write(IFCIAOPP,19) nn,ll,tt,ln,tn,'NC',nrc,ncoeff_phi_tm
         write(IFCIAOPP,10) (coeff_phi_tm(icoeff,ips,1),icoeff=0,ncoeff_phi_tm)
      case (US90)
         write(IFCIAOPP,19) nn,ll,tt,ln,tn,'US',nrc,ncoeff_phi_us
         write(IFCIAOPP,10) (coeff_phi_us(icoeff,lt),icoeff=0,ncoeff_phi_us)
      end select
   end do
   write(IFCIAOPP,*)
   write(IFCIAOPP,'(a42)') '### Separable potential : q[nm] & Dion[nm]'
   write(IFCIAOPP,'(a64)') '#  q[nm]    := <psi[n]|psi[m]> - <phi[n]|phi[m]> = q[l,tn,tm]   '
   write(IFCIAOPP,'(a64)') '#  Dion[nm] := D[nm] - <Vloc|Q[nm]>              = Dion[l,tn,tm]'
   write(IFCIAOPP,'(a64)') '#  D[nm]    := B[nm] + E[m]*q[nm]                = D[l,tn,tm]   '
   write(IFCIAOPP,'(a64)') '#  B[nm]    := <phi[n]|chi[m]>                   = B[l,tn,tm]   '
   write(IFCIAOPP,'(a19)') 'separable_potential'
   write(IFCIAOPP,'(i10)') num_lttx_us
   write(IFCIAOPP,'(1x,(1x,a1,2x,a2,2x,a2),(8x,a5,12x),(8x,a8,9x))') &
      'l','tn','tm','q[nm]','Dion[nm]'
   do ltt = 1,num_lttx_us
      ll = l_ltt_us(ltt) ; tn = tn_ltt_us(ltt) ; tm = tm_ltt_us(ltt)
      write(IFCIAOPP,'(1x,(i2,2x,i2,2x,i2),2(1pe25.15))') &
         ll,tn,tm,q_sum_us(ltt),dion_us(ltt)
   end do
   write(IFCIAOPP,'(1x,(1x,a1,2x,a2,2x,a2),(8x,a5,12x),(8x,a5,12x))') &
      'l','tn','tm','B[nm]','D[nm]'
   do ltt = 1,num_lttx_us
      ll = l_ltt_us(ltt) ; tn = tn_ltt_us(ltt) ; tm = tm_ltt_us(ltt)
      write(IFCIAOPP,'(1x,(i2,2x,i2,2x,i2),2(1pe25.15))') &
         ll,tn,tm,bmat_us(ltt),dmat_us(ltt)
   end do
   write(IFCIAOPP,'(1x,(1x,a1,2x,a2,2x,a2),(8x,a14,3x))') &
      'l','tn','tm','<Vloc|Qps[nm]>'
   do ltt = 1,num_lttx_us
      ll = l_ltt_us(ltt) ; tn = tn_ltt_us(ltt) ; tm = tm_ltt_us(ltt)
      write(IFCIAOPP,'(1x,(i2,2x,i2,2x,i2),2(1pe25.15))') &
         ll,tn,tm,vlocqps_us(ltt)
   end do
   write(IFCIAOPP,*)
   write(IFCIAOPP,'(a29)') '### Projectors : r*beta[n](r)'
   write(IFCIAOPP,'(a15)') 'projector_rbeta'
   write(IFCIAOPP,'(i10)') num_ltx_us
   write(IFCIAOPP,'(1x,3(2x,a1),2(1x,a2),2x,(5x,3x),2x,2x,(8x,a7,3x))') &
      'n','l','t','ln','tn','Eref[n]'
   do lt = 1,num_ltx_us
      nn  = n_lt_us(lt)  ; ll  = l_lt_us(lt)  ; tt   = t_lt_us(lt)
      ln  = ln_lt_us(lt) ; tn  = tn_lt_us(lt) ; eref = eref_us(lt)
      nrc = nmesh
      ips = ips_lt_us(lt)
      select case (is_val_type_ps(ips))
      case (TM91)
         val_type_tmp = 'NC'
      case (US90)
         val_type_tmp = 'US'
      end select
      ch_ln = fn_label_orbital(ll)
      write(ch_tn,'(i1)') tn
      ch3(1:3) = '_'//ch_ln(1:1)//ch_tn(1:1)
      write(IFCIAOPP,'(1x,5i3,2x,(a5,a3),2x,a2,f18.10)') &
         nn,ll,tt,ln,tn,'rbeta',ch3,val_type_tmp,eref
   end do
   do lt = 1,num_ltx_us
      nn  = n_lt_us(lt)  ; ll  = l_lt_us(lt)  ; tt   = t_lt_us(lt)
      ln  = ln_lt_us(lt) ; tn  = tn_lt_us(lt) ; eref = eref_us(lt)
      nrc = nmesh
      ips = ips_lt_us(lt)
      select case (is_val_type_ps(ips))
      case (TM91)
         val_type_tmp = 'NC'
      case (US90)
         val_type_tmp = 'US'
      end select
      ch_ln = fn_label_orbital(ll)
      write(ch_tn,'(i1)') tn
      ch3(1:3) = '_'//ch_ln(1:1)//ch_tn(1:1)
      write(IFCIAOPP,'(1x,a35,5i3,2x,a5,a3)') &
         'r*beta[n](r): n = (n,l,t,ln,tn) -->',nn,ll,tt,ln,tn,'rbeta',ch3
      write(IFCIAOPP,19) nn,ll,tt,ln,tn,val_type_tmp,nrc
      write(IFCIAOPP,10) (rbeta_us(ir,lt),ir=1,nrc)
   end do
if (is_pp_calc_class == US) then
   write(IFCIAOPP,*)
   write(IFCIAOPP,'(a36)') '### Deficit charge : r*r*Qps[nmL](r)'
   write(IFCIAOPP,'(a53)') '#  Qps[nm](rvec) = sum_{LM} c[LMnm] Y[LM] Qps[nmL](r)'
   write(IFCIAOPP,'(a50)') '#  Q[nm](rvec)   = sum_{LM} c[LMnm] Y[LM] Q[nm](r)'
   write(IFCIAOPP,'(a41)') '#  Y[n] Y[m]     = sum_{LM} c[LMnm] Y[LM]'
   write(IFCIAOPP,'(a28)') '#  Qps[nmL](r) is explicitly'
   write(IFCIAOPP,'(a61)') '#    for r < rin, Qps[nmL](r) = r^L * (c0+c1*r^2+...+cN*r^2N)'
   write(IFCIAOPP,'(a40)') '#    for r > rin, Qps[nmL](r) = Q[nm](r)'
   select case (is_deficit_type)
   case (POLYNOMIAL)
      write(IFCIAOPP,'((a20,5x),(a10))') 'deficit_charge_rrqps','polynomial'
      nsum = 0
      do ltlt = 1,num_ltlt_us
         ln = ln_ltlt_us(ltlt) ; lm = lm_ltlt_us(ltlt)
         do l3 = abs(ln-lm),ln+lm,2
            nsum = nsum + 1
         end do
      end do
      write(IFCIAOPP,'(2i10)') nsum, num_ltlt_us
      write(IFCIAOPP,'(1x,4(1x,a2),(2x,a1),2x,(6x,6x),(10x,a2,8x),(7x,a3))') &
         'ln','tn','lm','tm','L','rc','nrc'
      do ltlt = 1,num_ltlt_us
         ln = ln_ltlt_us(ltlt) ; tn = tn_ltlt_us(ltlt)
         lm = lm_ltlt_us(ltlt) ; tm = tm_ltlt_us(ltlt)
         ch_ln = fn_label_orbital(ln) ; ch_lm = fn_label_orbital(lm)
         write(ch_tn,'(i1)') tn
         write(ch_tm,'(i1)') tm
         ch5(1:5) = '_'//ch_ln(1:1)//ch_tn(1:1) &
                       //ch_lm(1:1)//ch_tm(1:1)
         do l3 = abs(ln-lm),ln+lm,2
            nrc = nrcut_qps_us(ltlt,l3)
            ch_l3 = fn_label_orbital_capital(l3)
            ch6(1:6) = ch5(1:5)//ch_l3(1:1)
            write(IFCIAOPP,'(1x,5i3,2x,(a6,a6),f20.10,i10)') &
               ln,tn,lm,tm,l3,'rr_qps',ch6, &
               rcut_qps_us(ltlt,l3),nrcut_qps_us(ltlt,l3)
         end do
      end do
      do ltlt = 1,num_ltlt_us
         ln = ln_ltlt_us(ltlt) ; tn = tn_ltlt_us(ltlt)
         lm = lm_ltlt_us(ltlt) ; tm = tm_ltlt_us(ltlt)
         ch_ln = fn_label_orbital(ln) ; ch_lm = fn_label_orbital(lm)
         write(ch_tn,'(i1)') tn
         write(ch_tm,'(i1)') tm
         ch5(1:5) = '_'//ch_ln(1:1)//ch_tn(1:1) &
                       //ch_lm(1:1)//ch_tm(1:1)
         do l3 = abs(ln-lm),ln+lm,2
            nrc = nrcut_qps_us(ltlt,l3)
            ch_l3 = fn_label_orbital_capital(l3)
            ch6(1:6) = ch5(1:5)//ch_l3(1:1)
            write(IFCIAOPP,'(1x,a42,5i3,2x,a6,a6)') &
               'r*r*Qps[nmL](r): nmL = (ln,tn,lm,tm,L) -->', &
               ln,tn,lm,tm,l3,'rr_qps',ch6
            write(IFCIAOPP,'(5i3,i6,i4)') &
               ln,tn,lm,tm,l3,nrc,ncoeff_qps_us
            write(IFCIAOPP,10) &
               (coeff_qps_us(icoeff,ltlt,l3),icoeff=0,ncoeff_qps_us)
            write(IFCIAOPP,10) &
               (rpos(ir)**2*qps_us(ir,ltlt,l3),ir=nrc+1,nmesh)
         end do
      end do
   case (SBESSEL)
      write(IFCIAOPP,'((a20,5x),a16)') 'deficit_charge_rrqps','spherical_bessel'
      nsum = 0
      do ltlt = 1,num_ltlt_us
         ln = ln_ltlt_us(ltlt)
         lm = lm_ltlt_us(ltlt)
         do l3 = abs(ln-lm),ln+lm,2
            nsum = nsum + 1
         end do
      end do
      write(IFCIAOPP,'(2i10)') nsum, num_ltlt_us
      write(IFCIAOPP,'(1x,4(1x,a2),(2x,a1),2x,(6x,6x),(10x,a2,8x),(7x,a3))') &
         'ln','tn','lm','tm','L','rc','nrc'
      do ltlt = 1,num_ltlt_us
         ln = ln_ltlt_us(ltlt) ; tn = tn_ltlt_us(ltlt)
         lm = lm_ltlt_us(ltlt) ; tm = tm_ltlt_us(ltlt)
         ch_ln = fn_label_orbital(ln) ; ch_lm = fn_label_orbital(lm)
         write(ch_tn,'(i1)') tn
         write(ch_tm,'(i1)') tm
         ch5(1:5) = '_'//ch_ln(1:1)//ch_tn(1:1) &
                       //ch_lm(1:1)//ch_tm(1:1)
         do l3 = abs(ln-lm),ln+lm,2
            nrc = nrcut_qps_us(ltlt,l3)
            ch_l3 = fn_label_orbital_capital(l3)
            ch6(1:6) = ch5(1:5)//ch_l3(1:1)
            write(IFCIAOPP,'(1x,5i3,2x,(a6,a6),f20.10,i10)') &
               ln,tn,lm,tm,l3,'rr_qps',ch6, &
               rcut_qps_us(ltlt,l3),nrcut_qps_us(ltlt,l3)
         end do
      end do
      do ltlt = 1,num_ltlt_us
         ln = ln_ltlt_us(ltlt) ; tn = tn_ltlt_us(ltlt)
         lm = lm_ltlt_us(ltlt) ; tm = tm_ltlt_us(ltlt)
         ch_ln = fn_label_orbital(ln) ; ch_lm = fn_label_orbital(lm)
         write(ch_tn,'(i1)') tn
         write(ch_tm,'(i1)') tm
         ch5(1:5) = '_'//ch_ln(1:1)//ch_tn(1:1) &
                       //ch_lm(1:1)//ch_tm(1:1)
         do l3 = abs(ln-lm),ln+lm,2
            nrc = nrcut_qps_us(ltlt,l3)
            ch_l3 = fn_label_orbital_capital(l3)
            ch6(1:6) = ch5(1:5)//ch_l3(1:1)
            write(IFCIAOPP,'(1x,a42,5i3,2x,a6,a6)') &
               'r*r*Qps[nmL](r): nmL = (ln,tn,lm,tm,L) -->', &
               ln,tn,lm,tm,l3,'rr_qps',ch6
            write(IFCIAOPP,'(5i3,i6,i4)') ln,tn,lm,tm,l3,nrc
            write(IFCIAOPP,10) &
               (rpos(ir)**2*qps_us(ir,ltlt,l3),ir=1,nmesh)
         end do
      end do
   end select
end if
if (is_pcc == PCC) then
   write(IFCIAOPP,*)
   write(IFCIAOPP,'(a36)') '### Partial core charge : r*r*npc(r)'
   write(IFCIAOPP,'(a23)') '#  npc(r) is explicitly'
   write(IFCIAOPP,'(a47)') '#    for r < rc, npc(r) = c0+c1*r^2+...+cN*r^2N'
   write(IFCIAOPP,'(a31)') '#    for r > rc, npc(r) = nc(r)'
   rho_pcore_sum = 0.d0
   do ir = 1,nmesh
      rho_pcore_sum = rho_pcore_sum &
         + 4.d0*PI*rpos(ir)**2*rho_pcore(ir) * wr(ir)
   end do
   select case (is_pcc_method)
   case (POLYNOMIAL)
      write(IFCIAOPP,'((a15,5x),a10)') 'pc_charge_rrnpc','polynomial'
      write(IFCIAOPP,'(f24.16,2i6)') rho_pcore_sum, nr0_pcc, ncoeff_pcc
      write(IFCIAOPP,10) &
         (coeff_pcc(icoeff),icoeff=0,ncoeff_pcc)
   case (SBESSEL)
      write(IFCIAOPP,'((a15,5x),a16)') 'pc_charge_rrnpc','spherical_bessel'
      write(IFCIAOPP,'(f24.16,2i6)') rho_pcore_sum, nr0_pcc
      write(IFCIAOPP,10) a_pcc, b_pcc
   end select
end if
if (is_with_dipole /= NO) then
   write(IFCIAOPP,*)
   write(IFCIAOPP,'(a54)') &
      '### Dipole moment : [n|d/dx|m], [n|d/dy|m], [n|d/dz|m]'
   write(IFCIAOPP,'(a73)') &
      '#  [n|d/dx|m] = <psi[n]|d/dx|psi[m]> - <phi[n]|d/dx|phi[m]> = -[m|d/dx|n]'
   write(IFCIAOPP,'(a73)') &
      '#  [n|d/dy|m] = <psi[n]|d/dy|psi[m]> - <phi[n]|d/dy|phi[m]> = -[m|d/dy|n]'
   write(IFCIAOPP,'(a73)') &
      '#  [n|d/dz|m] = <psi[n]|d/dz|psi[m]> - <phi[n]|d/dz|phi[m]> = -[m|d/dz|n]'
   write(IFCIAOPP,'(a42)') &
      '#     n = (n1,l1,t1,m1), m = (n2,l2,t2,m2)'
   write(IFCIAOPP,'(a6)') 'dipole'
   write(IFCIAOPP,'(i10)') num_dipole_lm_us/2
   write(IFCIAOPP,'(8(1x,a2),3(4x,a10,4x),2(1x,a2))') &
      'n1','l1','t1','m1','n2','l2','t2','m2', &
      '[n|d/dx|m]','[n|d/dy|m]','[n|d/dz|m]','y1','y2'
   do ltmltm = 1,num_dipole_lm_us
      n1 = n1_dipole_lm_us(ltmltm) ; n2 = n2_dipole_lm_us(ltmltm)
      l1 = l1_dipole_lm_us(ltmltm) ; l2 = l2_dipole_lm_us(ltmltm)
      t1 = t1_dipole_lm_us(ltmltm) ; t2 = t2_dipole_lm_us(ltmltm)
      m1 = m1_dipole_lm_us(ltmltm) ; m2 = m2_dipole_lm_us(ltmltm)
      if (l1 > l2) then
         cycle
      end if
      write(IFCIAOPP,'(8i3,3(1pe18.10),2i3)') &
      n1,l1,t1,m1,n2,l2,t2,m2, &
      dipole_dx_us(ltmltm),dipole_dy_us(ltmltm),dipole_dz_us(ltmltm), &
      phase_ylm(l1,m1),phase_ylm(l2,m2)
   end do
end if
if ((is_write_logderi /= NO).and.(is_logderi /= NO)) then
   write(IFCIAOPP,*)
   write(IFCIAOPP,'(a39)') '### Logarithmic derivatives [separable]'
   write(IFCIAOPP,'(a38)') '#  AE --> dlog{psi[l](r,E)}/dr at r=rc'
   write(IFCIAOPP,'(a38)') '#  PP --> dlog{phi[l](r,E)}/dr at r=rc'
   write(IFCIAOPP,'(a7,5x,a6)') 'logderi','linear'
   write(IFCIAOPP,'(i10,2(1pe25.15))') &
      ne_logderi, emin_logderi, emax_logderi
   if (nrcut_logderi == 0) then
      nrc = nrcut_max_us
   else
      nrc = max(nrcut_logderi,nrcut_max_us)
   end if
   nsum = 0
   do ll = 0,lmax
      nref = nref_us(ll)
      if (nref == 0) then
         cycle
      end if
      nsum = nsum + 1
   end do
   write(IFCIAOPP,'(i10)') nsum
   write(IFCIAOPP,'((9x,a1),(10x,a2,8x),(7x,a3))') 'l','rc','nrc'
   do ll = 0,lmax
      ch_ln = fn_label_orbital(ll)
      ch2(1:2) = '_'//ch_ln(1:1)
      nref = nref_us(ll)
      if (nref == 0) then
         cycle
      end if
      write(IFCIAOPP,'(i10,f20.10,i10,5x,a6,a2)') ll,rpos(nrc),nrc,'ldr_ae',ch2
      write(IFCIAOPP,'(i10,f20.10,i10,5x,a6,a2)') ll,rpos(nrc),nrc,'ldr_pp',ch2
   end do
   do ll = 0,lmax
      ch_ln = fn_label_orbital(ll)
      ch2(1:2) = '_'//ch_ln(1:1)
      nref = nref_us(ll)
      if (nref == 0) then
         cycle
      end if
      write(IFCIAOPP,'(1x,a32,i5,f20.10,5x,a6,a2)') &
         'dlog{psi[l](r,E)}/dr: (l,rc) -->',ll,rpos(nrc),'ldr_ae',ch2
      write(IFCIAOPP,11) (logderi_ae(ie,ll),ie=1,ne_logderi)
      write(IFCIAOPP,'(1x,a32,i5,f20.10,5x,a6,a2)') &
         'dlog{phi[l](r,E)}/dr: (l,rc) -->',ll,rpos(nrc),'ldr_pp',ch2
      write(IFCIAOPP,11) (logderi_us(ie,ll),ie=1,ne_logderi)
   end do
end if
   write(IFCIAOPP,*)
   write(IFCIAOPP,'(a48)') '### All-electron SCF wavefunctions : g*psi[n](g)'
   write(IFCIAOPP,'(a21)') 'ae_wave_function_gpsi'
   write(IFCIAOPP,'(i10)') num_ltx_us
   write(IFCIAOPP,'(1x,3(2x,a1),2(1x,a2),2x,(4x,3x),(10x,a7,3x))') &
      'n','l','t','ln','tn','Eref[n]'
   do lt = 1,num_ltx_us
      nn  = n_lt_us(lt)  ; ll  = l_lt_us(lt)  ; tt   = t_lt_us(lt)
      ln  = ln_lt_us(lt) ; tn  = tn_lt_us(lt) ; eref = eref_us(lt)
      ch_ln = fn_label_orbital(ll)
      write(ch_tn,'(i1)') tn
      ch3(1:3) = '_'//ch_ln(1:1)//ch_tn(1:1)
      write(IFCIAOPP,'(1x,5i3,2x,(a4,a3),f20.10)') &
         nn,ll,tt,ln,tn,'gpsi',ch3,eref
   end do
   do lt = 1,num_ltx_us
      nn  = n_lt_us(lt)  ; ll  = l_lt_us(lt)  ; tt   = t_lt_us(lt)
      ln  = ln_lt_us(lt) ; tn  = tn_lt_us(lt) ; eref = eref_us(lt)
      ch_ln = fn_label_orbital(ll)
      write(ch_tn,'(i1)') tn
      ch3(1:3) = '_'//ch_ln(1:1)//ch_tn(1:1)
      write(IFCIAOPP,'(1x,a34,5i3,2x,a4,a3)') &
         'g*psi[n](g): n = (n,l,t,ln,tn) -->',nn,ll,tt,ln,tn,'gpsi',ch3
      write(IFCIAOPP,20) nn,ll,tt,ln,tn,eref
      write(IFCIAOPP,11) (gpos(ig)*psi_g_us(ig,lt),ig=1,ng_mesh)
   end do
   write(IFCIAOPP,*)
   write(IFCIAOPP,'(a38)') '### Pseudo-wavefunctions : g*phi[n](g)'
   write(IFCIAOPP,'(a21)') 'pp_wave_function_gphi'
   write(IFCIAOPP,'(i10)') num_ltx_us
   write(IFCIAOPP,'(1x,3(2x,a1),2(1x,a2),2x,(5x,3x),2x,2x,(8x,a7,3x))') &
      'n','l','t','ln','tn','Eref[n]'
   do lt = 1,num_ltx_us
      nn  = n_lt_us(lt)  ; ll  = l_lt_us(lt)  ; tt   = t_lt_us(lt)
      ln  = ln_lt_us(lt) ; tn  = tn_lt_us(lt) ; eref = eref_us(lt)
      ips = ips_lt_us(lt)
      select case (is_val_type_ps(ips))
      case (TM91)
         val_type_tmp = 'NC'
      case (US90)
         val_type_tmp = 'US'
      end select
      ch_ln = fn_label_orbital(ll)
      write(ch_tn,'(i1)') tn
      ch3(1:3) = '_'//ch_ln(1:1)//ch_tn(1:1)
      write(IFCIAOPP,'(1x,5i3,2x,(a4,a3),2x,a2,f18.10)') &
         nn,ll,tt,ln,tn,'gphi',ch3,val_type_tmp,eref
   end do
   do lt = 1,num_ltx_us
      nn  = n_lt_us(lt)  ; ll  = l_lt_us(lt)  ; tt   = t_lt_us(lt)
      ln  = ln_lt_us(lt) ; tn  = tn_lt_us(lt) ; eref = eref_us(lt)
      ips = ips_lt_us(lt)
      select case (is_val_type_ps(ips))
      case (TM91)
         val_type_tmp = 'NC'
      case (US90)
         val_type_tmp = 'US'
      end select
      ch_ln = fn_label_orbital(ll)
      write(ch_tn,'(i1)') tn
      ch3(1:3) = '_'//ch_ln(1:1)//ch_tn(1:1)
      write(IFCIAOPP,'(1x,a34,5i3,2x,a4,a3)') &
         'g*phi[n](g): n = (n,l,t,ln,tn) -->',nn,ll,tt,ln,tn,'gphi',ch3
      write(IFCIAOPP,19) nn,ll,tt,ln,tn,val_type_tmp
      write(IFCIAOPP,11) (gpos(ig)*phi_g_us(ig,lt),ig=1,ng_mesh)
   end do
   write(IFCIAOPP,*)
   write(IFCIAOPP,'(a29)') '### Projectors : g*beta[n](g)'
   write(IFCIAOPP,'(a15)') 'projector_gbeta'
   write(IFCIAOPP,'(i10)') num_ltx_us
   write(IFCIAOPP,'(1x,3(2x,a1),2(1x,a2),2x,(5x,3x),2x,2x,(8x,a7,3x))') &
      'n','l','t','ln','tn','Eref[n]'
   do lt = 1,num_ltx_us
      nn  = n_lt_us(lt)  ; ll  = l_lt_us(lt)  ; tt   = t_lt_us(lt)
      ln  = ln_lt_us(lt) ; tn  = tn_lt_us(lt) ; eref = eref_us(lt)
      ips = ips_lt_us(lt)
      select case (is_val_type_ps(ips))
      case (TM91)
         val_type_tmp = 'NC'
      case (US90)
         val_type_tmp = 'US'
      end select
      ch_ln = fn_label_orbital(ll)
      write(ch_tn,'(i1)') tn
      ch3(1:3) = '_'//ch_ln(1:1)//ch_tn(1:1)
      write(IFCIAOPP,'(1x,5i3,2x,(a5,a3),2x,a2,f18.10)') &
         nn,ll,tt,ln,tn,'gbeta',ch3,val_type_tmp,eref
   end do
   do lt = 1,num_ltx_us
      nn  = n_lt_us(lt)  ; ll  = l_lt_us(lt)  ; tt   = t_lt_us(lt)
      ln  = ln_lt_us(lt) ; tn  = tn_lt_us(lt) ; eref = eref_us(lt)
      ips = ips_lt_us(lt)
      select case (is_val_type_ps(ips))
      case (TM91)
         val_type_tmp = 'NC'
      case (US90)
         val_type_tmp = 'US'
      end select
      ch_ln = fn_label_orbital(ll)
      write(ch_tn,'(i1)') tn
      ch3(1:3) = '_'//ch_ln(1:1)//ch_tn(1:1)
      write(IFCIAOPP,'(1x,a35,5i3,2x,a5,a3)') &
         'g*beta[n](g): n = (n,l,t,ln,tn) -->',nn,ll,tt,ln,tn,'gbeta',ch3
      write(IFCIAOPP,19) nn,ll,tt,ln,tn,val_type_tmp
      write(IFCIAOPP,11) (gpos(ig)*beta_g_us(ig,lt),ig=1,ng_mesh)
   end do
if (is_pp_calc_class == US) then
   write(IFCIAOPP,*)
   write(IFCIAOPP,'(a36)') '### Deficit charge : g*g*Qps[nmL](g)'
   write(IFCIAOPP,'(a18,5x)') 'deficit_charge_ggqps'
   write(IFCIAOPP,'(i10)') num_ltlt_us
   write(IFCIAOPP,'(1x,4(1x,a2),(2x,a1))') &
      'ln','tn','lm','tm','L'
   do ltlt = 1,num_ltlt_us
      ln = ln_ltlt_us(ltlt) ; tn = tn_ltlt_us(ltlt)
      lm = lm_ltlt_us(ltlt) ; tm = tm_ltlt_us(ltlt)
      ch_ln = fn_label_orbital(ln) ; ch_lm = fn_label_orbital(lm)
      write(ch_tn,'(i1)') tn
      write(ch_tm,'(i1)') tm
      ch5(1:5) = '_'//ch_ln(1:1)//ch_tn(1:1) &
                    //ch_lm(1:1)//ch_tm(1:1)
      write(IFCIAOPP,'(1x,4i3,5x,(a6,a5))') &
         ln,tn,lm,tm,'gg_qps',ch5
      do l3 = abs(ln-lm),ln+lm,2
         ch_l3 = fn_label_orbital_capital(l3)
         ch6(1:6) = ch5(1:5)//ch_l3(1:1)
         write(IFCIAOPP,'(1x,5i3,2x,(a6,a6))') &
            ln,tn,lm,tm,l3,'gg_qps',ch6
      end do
   end do
   do ltlt = 1,num_ltlt_us
      ln = ln_ltlt_us(ltlt) ; tn = tn_ltlt_us(ltlt)
      lm = lm_ltlt_us(ltlt) ; tm = tm_ltlt_us(ltlt)
      ch_ln = fn_label_orbital(ln) ; ch_lm = fn_label_orbital(lm)
      write(ch_tn,'(i1)') tn
      write(ch_tm,'(i1)') tm
      ch5(1:5) = '_'//ch_ln(1:1)//ch_tn(1:1) &
                    //ch_lm(1:1)//ch_tm(1:1)
      write(IFCIAOPP,'(1x,a36,4i3,2x,a4,a5)') &
         'g*g*Q[nm](g): nm = (ln,tn,lm,tm) -->', &
         ln,tn,lm,tm,'gg_q',ch5
      write(IFCIAOPP,'(4i3)') ln,tn,lm,tm
      write(IFCIAOPP,11) &
         (gpos(ig)**2*q_g_us(ig,ltlt),ig=1,ng_mesh)
      do l3 = abs(ln-lm),ln+lm,2
         ch_l3 = fn_label_orbital_capital(l3)
         ch6(1:6) = ch5(1:5)//ch_l3(1:1)
         write(IFCIAOPP,'(1x,a42,5i3,2x,a6,a6)') &
            'g*g*Qps[nmL](g): nmL = (ln,tn,lm,tm,L) -->', &
            ln,tn,lm,tm,l3,'gg_qps',ch6
         write(IFCIAOPP,'(5i3)') ln,tn,lm,tm,l3
         write(IFCIAOPP,11) &
            (gpos(ig)**2*qps_g_us(ig,ltlt,l3),ig=1,ng_mesh)
      end do
   end do
end if
   write(IFCIAOPP,*)
   write(IFCIAOPP,'(a17)') '### End of CIAOPP'
   write(IFCIAOPP,'(a3)') 'end'
   close(IFCIAOPP)
10 format(3(1pe25.17))
11 format(6(1pe11.3))
19 format(1x,3(i2,2x),2(i2,2x),2x,a2,2i10)
20 format(1x,3(i2,2x),2(i2,2x),2f20.10,i10)
99 continue
  !++++++++++++++++++++++
   deallocate(array_tmp)
  !++++++++++++++++++++++
   end subroutine write_ciaopp

!
!  Software name : CIAO (Code for Investigating Atomic Orbitals)
!  Subroutine(s) : calc_tmso_pp_rel, write_param_tmso, find_nrc_tmso,
!                  calc_vh_tmso, calc_vxc_exc_tmso,
!                  write_tmsopp, write_rcut_tmso
!  Author(s)     : Masakuni Okamoto (May 22, 2007)
!
!
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!
!
!  The license of the code and contact address :
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)
!
!=====================================================================
   subroutine calc_tmso_pp_rel(ier)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer :: ips, iso, ishell, ll, kk, i, ir, is_solved, node, nrm, &
              loop, ntries, is_converged
   integer :: nn, tt, tn, nrc, ll_core, &
              is_bound_state, nk_tm, n1, n2, isdiff, icoeff, lt, nodes
   real(8) :: eref, deref, gcut0, gcut1, gcut2, gcut3, gcut4, rcut, &
              sumpsi_exact, sumphi_num, arg
   integer,allocatable :: nrcut_tmp(:)
   real(8),allocatable :: drpsi_tmp(:), rphi_tmp(:), chi_g_tmp(:)

! ============================================== modiifed by K. T. ========= 4.0
!   rho_ps(:) = 0.d0
   rho_ps = 0.d0
! ========================================================================== 4.0

   chi_ps(:,:,:) = 0.d0
   veff_ps(:,:,:) = 0.d0

   nk_tm = 4
   ncoeff_phi_tm = 6
  !++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   allocate(nrcut_tmp(nps)) ; nrcut_tmp = 0
   allocate(chi_g_tmp(nmesh)) ; chi_g_tmp = 0.d0
   allocate(coeff_tm(0:12,nps,2))
   allocate(coeff_phi_tm(0:ncoeff_phi_tm,nps,2))
   allocate(drpsi_tmp(0:nk_tm),rphi_tmp(nmesh))
      coeff_tm  = 0.d0 ; coeff_phi_tm = 0.d0
      drpsi_tmp = 0.d0 ; rphi_tmp     = 0.d0
  !++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   do ips = 1,nps
      rcut = rcut_phi_ps(ips,1)
      nrc = 0
      do i = nmesh,1,-1
         if (rpos(i) < rcut) then
            nrc = i ; exit
         end if
      end do
      if (nrc > 0) then
         nrcut_tmp(ips) = nrc
      else
         write(IFLOG,*) '### ERROR ### nrc was not found.'
         write(IFLOG,*) '   ips ...',ips
         stop
      end if
   end do
   coeff_phi_tm(:,:,:) = 0.d0
   !chi_g_tmp(:,:) = chi_g(:,:)
   do ips = 1,nps
   do iso = 1,num_so_ps(ips)
      ishell = ishell_ps(ips,iso)
      nn = n_qnum(ishell)
      ll = l_qnum(ishell)
      write(IFLOG,*)
      write(IFLOG,'(1x,a23,6i5)') &
            '??? lt,ips,nn,ll,iso ...',lt,ips,nn,ll,iso
      nrc = nrcut_tmp(ips)
      rcut = rpos(nrc)
      if (is_solve(ishell) /= 0) then
         if (abs(engy(ishell)) > 1.d-6) then
            is_bound_state = 1
         else
            is_bound_state = 0
         end if
      else
         is_bound_state = 0
      end if
      chi_g_tmp(:) = chi_g(:,ishell)
      select case (is_bound_state)
      case (0)
         call set_weight_exp(ier,1,nrc,rpos,wt)
         arg = 0.d0
         do ir = 1,nrc
            arg = arg + chi_g_tmp(ir)**2*wt(ir)
         end do
         eref = 0.d0
      case (1)
         arg = 0.d0 
         do ir = 1,nmesh 
            arg = arg + chi_g_tmp(ir)**2*wr(ir)
         end do
         eref = engy(ishell)
      end select
      chi_g_tmp(:) = chi_g_tmp(:) / sqrt(arg)
      n1 = nrc - 10 ; n2 = nrc + 10
      if (n1 < 1) then
         n1 = 1 ; n2 = 1 + 10*2
      else if (n2 > nmesh) then
         n1 = nmesh - 10*2 ; n2 = nmesh
      end if
      isdiff = 4
      call diff4_exp(ier,isdiff,n1,n2,rpos,chi_g_tmp(1),rcut, &
                     gcut0,gcut1,gcut2,gcut3,gcut4)
      if (gcut0 < 0.d0) then
         write(IFLOG,*) '### ERROR ### gcut0 < 0'
         write(IFLOG,*) '   gcut0 ...',gcut0
         write(IFLOG,*) '   gcut1 ...',gcut1
         write(IFLOG,*) '   gcut2 ...',gcut2
         write(IFLOG,*) '   gcut3 ...',gcut3
         write(IFLOG,*) '   gcut4 ...',gcut4
         ier = 1 ; go to 99
      end if
      call calc_tmpp_us(ier,IFLOG,is_bound_state, &
           nmesh,rpos,wr,wt, &
           chi_g_tmp(1),veff(1,1,ll_core), &
           chi_ps(1,ips,iso),veff_ps(1,ips,iso), &
           ll,eref,nrc,gcut0,gcut1,gcut2,gcut3,gcut4, &
           coeff_tm(0,ips,iso))
      if (ier /= 0) then
         write(IFLOG,*) '### ERROR ### in calc_tmpp_us'
         go to 99
      end if
      if (is_bound_state == 0) then
         do ir = nrc+1,nmesh
            veff_ps(ir,ips,iso) = veff(ir,1,ll_core)
         end do
      end if
      call set_weight_exp(ier,1,nrc,rpos,wt)
      sumpsi_exact = 0.d0
      sumphi_num   = 0.d0
      do ir = 1,nrc
         sumpsi_exact = sumpsi_exact + chi_g_tmp(ir)**2      * wt(ir)
         sumphi_num   = sumphi_num   + chi_ps(ir,ips,iso)**2 * wt(ir)
      end do
      drpsi_tmp(0) = gcut0 ; drpsi_tmp(1) = gcut1
      drpsi_tmp(2) = gcut2 ; drpsi_tmp(3) = gcut3
      drpsi_tmp(4) = gcut4
      rphi_tmp(:) = chi_ps(:,ips,iso) 
      do icoeff = 0,ncoeff_phi_tm
         coeff_phi_tm(icoeff,ips,iso) = coeff_tm(2*icoeff,ips,iso)
      end do
      call check_rphi_tm(ier,ips,nn,ll,tt,eref,deref,nrc,nk_tm, &
                         drpsi_tmp,rphi_tmp, &
                         sumpsi_exact,sumphi_num)

! ======================================= modified by K. T. =========== 4.0
!      rho_ps(:) = rho_ps(:) + focc(ishell)*chi_ps(:,ips,iso)**2
      rho_ps(:,1) = rho_ps(:,1) + focc(ishell)*chi_ps(:,ips,iso)**2
! ===================================================================== 4.0

   end do
   end do

! ======================================== modified by K. T. =========== 4.0
!   rho_ps(:) = rho_ps(:) / (4.d0*PI*rpos(:)**2)
!   write(IFLOG,*) 'TMSO: sum of rho_ps(:) ...',sum(4.d0*PI*rpos(:)**2*rho_ps(:)*wr(:))
!
   rho_ps(:,1) = rho_ps(:,1) / (4.d0*PI*rpos(:)**2)
   write(IFLOG,*) 'TMSO: sum of rho_ps(:) ...',sum(4.d0*PI*rpos(:)**2*rho_ps(:,1)*wr(:))
! ====================================================================== 4.0

   if (is_pcc == PCC) then
      select case (is_pcc_method)
      case (BHSPCC)
         write(IFLOG,*) 'PCC: using special PCC of the BHS type'
         write(IFSUM,*) 'PCC: using special PCC of the BHS type'
         do ir = 1,nmesh
            arg = a_bhspcc * rpos(ir) * rpos(ir)
            arg = min(arg,99.d0)
            rho_pcore(ir) = b_bhspcc * exp(-arg) / (4.d0*PI)
         end do
      case (POLYNOMIAL, SBESSEL)
         call calc_rho_pcore_sol(ier)
      end select
      if (ier /= 0) then
         write(IFLOG,*) '### ERROR ### in calc_rho_pcore_sol' ; go to 99
      end if
      !!!call check_rho_pcore_sol(ier)
      !!!call calc_pcc_fourier_sol(ier)
      !if (ier /= 0) then
      !   write(IFLOG,*) '### ERROR ### in calc_pcc_fourier_sol' ; go to 99
      !end if
   end if
  !++++++++++++++++++++++++++++++++++++++++++++++++++++++
   if (is_xc_class == GGA) then

! ============================================= modified by K. T. ========= 4.0
!      allocate(drho_ps(nmesh),ddrho_ps(nmesh))
      allocate(drho_ps(nmesh,1),ddrho_ps(nmesh,1))
! ========================================================================= 4.0

      drho_ps = 0.d0 ; ddrho_ps = 0.d0
      
      allocate(drho_core(nmesh),ddrho_core(nmesh))
         drho_core = 0.d0 ; ddrho_core = 0.d0
      if (is_pcc == PCC) then
         allocate(drho_pcore(nmesh),ddrho_pcore(nmesh))
            drho_pcore = 0.d0 ; ddrho_pcore = 0.d0
      end if
   end if
  !++++++++++++++++++++++++++++++++++++++++++++++++++++++
   if (is_xc_class == GGA) then
      call calc_drho_ddrho_ps(ier)
   end if
   call calc_vh_tmso(ier,nmesh,rpos,rho_ps,vh_ps)
   if (ier /= 0) then
      write(IFLOG,*) '### ERROR ### in calc_vh_tmso' ; go to 99
   end if

! =============================================== modified by K. T. =========== 4.0
!   vx_ps(:) = 0.d0 ; vxpc_ps(:) = 0.d0
!   vc_ps(:) = 0.d0 ; vcpc_ps(:) = 0.d0
!
   vx_ps(:,:) = 0.d0 ; vxpc_ps(:) = 0.d0
   vc_ps(:,:) = 0.d0 ; vcpc_ps(:) = 0.d0
! ============================================================================== 4.0

   ex_ps(:) = 0.d0 ; expc_ps(:) = 0.d0
   ec_ps(:) = 0.d0 ; ecpc_ps(:) = 0.d0

   call calc_vxc_exc_tmso(ier)
   if (ier /= 0) then
      write(IFLOG,*) '### ERROR ### in calc_vxc_exc_tmso' ; go to 99
   end if
   vion_ps(:,:,:) = 0.d0
   do ips = 1,nps
   do iso = 1,num_so_ps(ips)
      vion_ps(:,ips,iso) = veff_ps(:,ips,iso) &
! ========================================== modified by K. T. ================ 4.0
!         - vh_ps(:) - vx_ps(:) - vc_ps(:)
         - vh_ps(:) - vx_ps(:,1) - vc_ps(:,1)
! ============================================================================= 4.0
   end do
   end do
   vscr_tmso(:,:) = 0.d0
   vion_tmso(:,:) = 0.d0
   vso_tmso(:,:)  = 0.d0
   do ips = 1,nps
      do iso = 1,num_so_ps(ips)
         ishell = ishell_ps(ips,iso)
         ll = l_qnum(ishell)
         kk = k_qnum(ishell)
         if (ll == 0) then
            vscr_tmso(:,ips) = veff_ps(:,ips,iso)
            vion_tmso(:,ips) = vion_ps(:,ips,iso)
            vso_tmso (:,ips) = 0.d0
         else if (kk < 0) then
            vscr_tmso(:,ips) = vscr_tmso(:,ips) + veff_ps(:,ips,iso)*dble(ll+1)
            vion_tmso(:,ips) = vion_tmso(:,ips) + vion_ps(:,ips,iso)*dble(ll+1)
            vso_tmso (:,ips) = vso_tmso (:,ips) + vion_ps(:,ips,iso)*2.d0
         else
            vscr_tmso(:,ips) = vscr_tmso(:,ips) + veff_ps(:,ips,iso)*dble(ll)
            vion_tmso(:,ips) = vion_tmso(:,ips) + vion_ps(:,ips,iso)*dble(ll)
            vso_tmso (:,ips) = vso_tmso (:,ips) - vion_ps(:,ips,iso)*2.d0
         end if
      end do
      vscr_tmso(:,ips) = vscr_tmso(:,ips) / dble(2*ll+1)
      vion_tmso(:,ips) = vion_tmso(:,ips) / dble(2*ll+1)
      vso_tmso (:,ips) = vso_tmso (:,ips) / dble(2*ll+1)
   end do

  !+++++++++++++++++++++++++++++++++++++++++
   if (is_xc_class == GGA) then
      deallocate(drho_core,ddrho_core)
      if (is_pcc == PCC) then
         deallocate(drho_pcore,ddrho_pcore)
      end if
   end if
  !+++++++++++++++++++++++++++++++++++++++++
99 continue
   end subroutine calc_tmso_pp_rel
   
!=====================================================================
   subroutine write_param_tmso(ier,ifile,ips,iso)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(in)  :: ifile, ips, iso
   integer,intent(out) :: ier
   integer :: n1, l1, ishell, n2, l2, k2, jj
   real(8) :: psi2_sum, g2_sum, f2_sum, vmax, vmin
   ier = 0
   n1 = n_val_label_ps(ips)
   l1 = l_val_label_ps(ips)
   ishell = ishell_ps(ips,iso)
   n2 = n_qnum(ishell)
   l2 = l_qnum(ishell)
   k2 = k_qnum(ishell)
   jj = j2_qnum(ishell)
   write(ifile,*)
   write(ifile,*) 'ips,iso   ...',ips,iso
   write(ifile,*) 'n1,l1     ...',n1,l1
   write(ifile,*) 'n2,l2,k2  ...',n2,l2,k2
   write(ifile,*) '2*j       ...',jj
   write(ifile,*) 'ishell    ...',ishell
   write(ifile,*) 'focc      ...',focc(ishell)
   write(ifile,*) 'Rcut      ...',rcut_phi_ps(ips,1)
   write(ifile,*) 'Rcut (A)  ...',rcut_phi_ps(ips,1)*BOHR
   write(ifile,*) 'is_gen_ps ...',is_gen_ps(ips,iso)
   write(ifile,*) 'is_solve  ...',is_solve(ishell)
   write(ifile,*) 'E         ...',engy(ishell)
   write(ifile,*) 'E (eV)    ...',engy(ishell)*HARTREE
   g2_sum = sum(chi_g(:,ishell)**2*wr(:))
   f2_sum = sum(chi_f(:,ishell)**2*wr(:))
   psi2_sum = g2_sum + f2_sum
   !write(ifile,*) 'g2_sum    ...',g2_sum
   !write(ifile,*) 'f2_sum    ...',f2_sum
   write(ifile,*) 'psi2_sum  ...',psi2_sum
   write(ifile,*) 'nrm       ...',nrm_pos(ishell)
   write(ifile,*) 'Rm        ...',rpos(nrm_pos(ishell))
   write(ifile,*) 'Rm (A)    ...',rpos(nrm_pos(ishell))*BOHR
   vmax = maxval(veff(:,nspin,lmax_core))
   vmin = minval(veff(:,nspin,lmax_core))
   write(ifile,*) 'Vmax      ...',vmax
   write(ifile,*) 'Vmin      ...',vmin
   end subroutine write_param_tmso

!=====================================================================
   subroutine find_nrc_tmso(ier,nmesh,rpos,rcut,nrc)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   implicit none
   integer,intent(in)  :: nmesh
   real(8),intent(in)  :: rpos(nmesh), rcut
   integer,intent(out) :: ier, nrc
   integer :: ir
   ier = 0
   do ir = nmesh,10,-1
      if (rpos(ir) < rcut) then
         nrc = ir+1 ; exit
      end if
      if (ir == 10) then
         write(*,*) '### ERROR ### nrc was not found.'
         ier = 1 ; go to 99
      end if
   end do
99 continue
   end subroutine find_nrc_tmso

!=====================================================================
   subroutine calc_vh_tmso(ier,nmesh,rpos,rho,vh)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   implicit none
   integer,intent(in)  :: nmesh
   real(8),intent(in)  :: rpos(nmesh), rho(nmesh)
   integer,intent(out) :: ier
   real(8),intent(out) :: vh(nmesh)
   integer :: ir, ii, i0, is, j, jr
   real(8) :: sum1, sum2
   real(8),allocatable :: wt(:)
   real(8),parameter :: &
      PI = 3.1415926535897932384626433832795028d0
   ier = 0
  !++++++++++++++++++++++++++++++++
   allocate(wt(nmesh)) ; wt = 0.d0
  !++++++++++++++++++++++++++++++++
   do ir = 1,nmesh
      sum1 = 0.d0
      sum2 = 0.d0
      if (ir == 1) then
         sum1 = 0.d0
      else if ((ir >= 2).and.(ir <= 5)) then
         do ii = 2,ir
            i0 = ii-1
            is = 1
            call set_open_weight_exp(ier,i0,is,rpos,wt)
            do j = 1,4
               sum1 = sum1 &
                  + rpos(i0+j*is)**2*rho(i0+j*is)*wt(i0+j*is)
            end do
         end do
      else
         call set_weight_exp(ier,1,ir,rpos,wt)
         do jr = 1,ir
            sum1 = sum1 + rpos(jr)**2*rho(jr)*wt(jr)
         end do
      end if
      sum1 = sum1*(4.d0*PI/rpos(ir))
      if (ir == nmesh) then
            sum2 = 0.d0
      else if ((ir <= nmesh-1).and.(ir >= nmesh-4)) then
         do ii = ir,nmesh-1
            i0 = ii+1
            is = -1
            call set_open_weight_exp(ier,i0,is,rpos,wt)
            do j = 1,4
               sum2 = sum2 &
                    - rpos(i0+j*is)**2*rho(i0+j*is)*wt(i0+j*is)
            end do
         end do
      else
         call set_weight_exp(ier,ir,nmesh,rpos,wt)
         do jr = ir,nmesh
            sum2 = sum2 + rpos(jr)*rho(jr)*wt(jr)
         end do
      end if
      sum2 = sum2*(4.d0*PI)
      vh(ir) = sum1 + sum2
   end do
  !+++++++++++++++
   deallocate(wt)
  !+++++++++++++++
99 continue
   end subroutine calc_vh_tmso

!=====================================================================
   subroutine calc_vxc_exc_tmso(ier)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
  !++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

! ========================================== modifed by K. T. ========== 4.0
!   allocate(rho_sol(nmesh)) ; rho_sol = 0.d0
!   allocate(ex_sol(nmesh),ec_sol(nmesh),vx_sol(nmesh),vc_sol(nmesh))
   allocate(rho_sol(nmesh,1)) ; rho_sol = 0.d0
   allocate(ex_sol(nmesh),ec_sol(nmesh),vx_sol(nmesh,1),vc_sol(nmesh,1))
! ====================================================================== 4.0

   ex_sol = 0.d0 ; ec_sol = 0.d0
   vx_sol = 0.d0 ; vc_sol = 0.d0
   allocate( &
      expc_sol(nmesh),ecpc_sol(nmesh),vxpc_sol(nmesh),vcpc_sol(nmesh))
      expc_sol = 0.d0 ; ecpc_sol = 0.d0
      vxpc_sol = 0.d0 ; vcpc_sol = 0.d0
   if (is_xc_class == GGA) then
! ============================================ modifed by K. T. ============ 4.0
!      allocate(drho_sol(nmesh),ddrho_sol(nmesh))
      allocate(drho_sol(nmesh,1),ddrho_sol(nmesh,1))
! ========================================================================== 4.0
         drho_sol = 0.d0 ; ddrho_sol = 0.d0
   end if
  !++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

! ====================================== modiifed by K. T. ============= 4.0
!   rho_sol(:) = rho_ps(:)
!   if (is_xc_class == GGA) then
!      drho_sol (:) = drho_ps (:)
!      ddrho_sol(:) = ddrho_ps(:)
!   end if
!
   rho_sol(:,:) = rho_ps(:,:)
   if (is_xc_class == GGA) then
      drho_sol (:,:) = drho_ps (:,:)
      ddrho_sol(:,:) = ddrho_ps(:,:)
   end if
! ========================================================================= 4.0

   call calc_vxc_exc_sol(ier)
   if (ier /= 0) then
      write(IFLOG,*) '### ERROR ### in calc_vxc_exc_sol' ; go to 99
   end if

! ========================================= modified by K. T. ============= 4.0
!   vx_ps(:) = vx_sol(:)
!   vc_ps(:) = vc_sol(:)
!
   vx_ps(:,:) = vx_sol(:,:)
   vc_ps(:,:) = vc_sol(:,:)
! ========================================================================== 4.0

   ex_ps(:) = ex_sol(:)
   ec_ps(:) = ec_sol(:)

   vxpc_ps(:) = vxpc_sol(:)
   vcpc_ps(:) = vcpc_sol(:)
   expc_ps(:) = expc_sol(:)
   ecpc_ps(:) = ecpc_sol(:)
  !++++++++++++++++++++++++++++++++++++++++++++++++
   if (allocated(drho_sol)) then
      deallocate(drho_sol,ddrho_sol)
   end if
   deallocate(expc_sol,ecpc_sol,vxpc_sol,vcpc_sol)
   deallocate(ex_sol,ec_sol,vx_sol,vc_sol)
   deallocate(rho_sol)
  !++++++++++++++++++++++++++++++++++++++++++++++++
99 continue
   end subroutine calc_vxc_exc_tmso

!=====================================================================
   subroutine write_tmsopp(ier)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer :: ips, ishell, ll, ir
   character(1) :: fn_label_orbital
   ier = 0
   do ips = 1,nps
      !if (is_gen_ps(ips,1) == 0) then
      !   cycle
      !end if
      ishell = ishell_ps(ips,1)
      ll = l_qnum(ishell)
      tmsoppfile = trim(jobname)//'_'//fn_label_orbital(ll)//'.tmsopp'
      open(IFTMSOPP,file=trim(tmsoppfile),status='unknown')
      rewind(IFTMSOPP)
      write(IFLOG,*) '   Writing TMSOPP for l -->',ll
      write(IFTMSOPP,10) 'TMSO pseudopotential for valence-orbital ll =',ll
      write(IFTMSOPP,20) 'r', 'r*psi', 'r*phi', 'rho_core', 'rho_pc', 'rho_pp', &
                        'vae_scr', 'vpp_scr', 'vpp_ion', 'vpp_so'
      do ir = 1,nmesh
         write(IFTMSOPP,21) &
            rpos(ir), &
            chi_g(ir,ishell), &
            !chi_f(ir,ishell), &
            chi_ps(ir,ips,1), &
            !chi_ps(ir,ips,2), &
            rho_core(ir), &
            rho_pcore(ir), &

! ================================================= modified by K. T. ========== 4.0
!            rho_ps(ir), &
            rho_ps(ir,1), &
! ============================================================================= 4.0

            veff(ir,nspin,lmax_core), &
            vscr_tmso(ir,ips), &
            vion_tmso(ir,ips), &
            vso_tmso(ir,ips)
      end do
      write(IFLOG,*) 'TMSOPP data have been saved into ... ',trim(tmsoppfile)
      write(IFSUM,*) 'TMSOPP data have been saved into ... ',trim(tmsoppfile)
      close(IFTMSOPP)
   end do
10 format('#',1x,a45,i5)
20 format(('#',18x,a1),2(15x,a5),(12x,a8),2(14x,a6),3(13x,a7),(14x,a6))
21 format(12(1pe20.10))
   end subroutine write_tmsopp

!=====================================================================
   subroutine write_rcut_tmso(ifile)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(in) :: ifile
   integer        :: i, ishell, ips, iso, tt
   real(8)        :: rcut
   character(100) :: line
   do i = 1,100
      line(i:i)='-'
   end do
   write(ifile,*)
   write(ifile,*) 'rcut  Cutoff radii for TMSO-PP'
   write(ifile,10) line(1:100)
   write(ifile,11) 'symm','j', &
                   'rcut (Bohr)','   rcut (A)'
   write(ifile,10) line(1:100)
   do ips = 1,nps
      tt = 1
      !if (is_gen_ps(ips,1) == 0) then
      !   cycle
      !end if
      do iso = 1,num_so_ps(ips)
         ishell = ishell_ps(ips,iso)
         rcut = rcut_phi_ps(ips,tt)
         write(ifile,12) state(ishell)(1:2),j2_qnum(ishell), &
            rcut,rcut*BOHR
      end do
   end do
   write(ifile,10) line(1:100)
10 format(1x,'rcut',a55)
11 format(1x,'rcut',(3x,a4),(4x,a1,1x),2(9x,a11))
12 format(1x,'rcut',(4x,a2,1x),(3x,i1,'/2'),2(f20.10))
   end subroutine write_rcut_tmso

!
!  Software name : CIAO (Code for Investigating Atomic Orbitals)
!  Subroutine(s) : write_title_pao, calc_bound_state_pao
!                : calc_nodes_range, calc_beta_phi_pao
!                : write_energy_level_pao, write_pao
!  Author(s)     : Masakuni Okamoto (August 25, 2003)
!
!
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!
!
!  The license of the code and contact address :
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)
!
!=====================================================================
   subroutine write_title_pao(ifile)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   implicit none
   integer,intent(in) :: ifile
   integer :: i
   character(100) :: line1, line2
   do i=1,100
      line1(i:i) = '/'
      line2(i:i) = '/'
   end do
   line2(38:42) = ' PAO '
   write(ifile,*)
   write(ifile,50) line1
   write(ifile,*) 'PAO'
50 format(a80)
   end subroutine write_title_pao

!=====================================================================
   subroutine set_vloc_pao(ier)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer :: n1_tmp, n2_tmp, ir
   real(8) :: vl_tmp, dvl_tmp, dummy, b_ok(0:3), r
   ier = 0
  !++++++++++++++++++++++++++++++++++++++++++++
   allocate(vloc_pao(nmesh)) ; vloc_pao = 0.d0
  !++++++++++++++++++++++++++++++++++++++++++++
   select case (is_pao_type)
   case (CORE_POTENTIAL_CONFINEMENT)

! ========================================== modiifed by K. T. =============== 4.0
!      vloc_pao(:) = vloc_scr_sol(:)
      vloc_pao(:) = vloc_scr_sol(:,1)
! =========================================================================== 4.0

   case (OZAKI_KINO_CONFINEMENT)
      do ir = nmesh,1,-1
         r = rpos(ir)
         if (r < rcut_ok) then
            nrcut_ok = ir+1 ; exit
         end if
      end do
      n1_tmp = nrcut_ok - 6
      n2_tmp = nrcut_ok + 6
      call diff_exp(ier,1,n1_tmp,n2_tmp,rpos,vloc_scr_sol,rcut_ok-drcl_ok, &
           vl_tmp,dvl_tmp,dummy)
      call calc_coeff_ok_pao(vl_tmp,dvl_tmp,rcut_ok,drcl_ok,h_ok,b_ok)
      do ir = 1,nmesh
         r = rpos(ir)
         if (r < rcut_ok - drcl_ok) then
! ================================================= modified by K. T. ========= 4.0
!            vloc_pao(ir) = vloc_scr_sol(ir)
            vloc_pao(ir) = vloc_scr_sol(ir,1)
! ============================================================================= 4.0
         else if (r < rcut_ok) then
            vloc_pao(ir) = &
               b_ok(0) + r*(b_ok(1) + r*(b_ok(2) + r*b_ok(3)))
         else
            vloc_pao(ir) = h_ok
         end if
      end do
   end select
99 continue
   end subroutine set_vloc_pao

!=====================================================================
   subroutine calc_coeff_ok_pao(vl,dvl,rc,dr,h,b)
!=====================================================================
   implicit none
   real(8),intent(in)  :: vl, dvl, rc, dr, h
   real(8),intent(out) :: b(0:3)
   real(8) :: amat(4,4), bvec(4), xvec(4), rl
   integer :: ier
   rl = rc - dr
   amat(1,1) = 1.d0 ; amat(1,2) = rl ; amat(1,3) = rl*rl ; amat(1,4) = rl*rl*rl
   amat(2,1) = 0.d0 ; amat(2,2) = 1.d0 ; amat(2,3) = 2.d0*rl ; amat(2,4) = 3.d0*rl*rl
   amat(3,1) = 1.d0 ; amat(3,2) = rc ; amat(3,3) = rc*rc ; amat(3,4) = rc*rc*rc
   amat(4,1) = 0.d0 ; amat(4,2) = 1.d0 ; amat(4,3) = 2.d0*rc ; amat(4,4) = 3.d0*rc*rc
   bvec(1) = vl ; bvec(2) = dvl ; bvec(3) = h ; bvec(4) = 0.d0
   call axb_real_matrix(ier,4,1,amat,xvec,bvec)
   if (ier /= 0) then
      write(*,*) '### ERROR ### ier != 0 in axb_real_matrix'
      write(*,*) '   ier ...',ier
      stop
   end if
   b(0:3) = xvec(1:4)
   end subroutine calc_coeff_ok_pao

!=====================================================================
   subroutine calc_bound_state_pao(ier)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   real(8),allocatable :: &
      bsum(:), amat(:,:), bvec(:), coeff(:), fmat(:,:), hmat(:,:), &
      h0vec(:), rphi_gl(:,:), dxrphi_gl(:,:)
   integer :: ir, nn, ll, tt, lt, t1, t2, lt1, lt2, &
              ltt, nref, nrm, nrt, node_sum, node, nmesh_max, &
              loop, max_loop, ipao, node_sum_left, node_sum_right, &
              lguess, max_loop_in
   real(8) :: ee, de, r, vv, ss, rr, &
              sign_gr, ee_upper_limit, ee_lower_limit,         &
              ee_upper_limit_in, sum, etest, fguess, gg_norm,  &
              eps_de_tmp = 1.d-9
   ier = 0
   max_loop_in  =  50
  !++++++++++++++++++++++++++++++++++++
   allocate(bsum(nmesh)) ; bsum = 0.d0
  !++++++++++++++++++++++++++++++++++++
   engy_pao(:)       = 1.d0
   rphi_pao(:,:)     = 0.d0
   beta_phi_pao(:,:) = 0.d0
   write(IFLOG,*) 'PAO: num_l_pao ...',num_l_pao
   LOOP_PAO:do ipao = 1,num_pao
      ll = l_pao(ipao)
      nn = n_pao(ipao)
      nref = nref_us(ll)
     !++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      allocate(amat(nref,nref),bvec(nref),coeff(nref), &
               fmat(nref,nref),hmat(nref,nref),h0vec(nref), &
               rphi_gl(nmesh,0:nref),dxrphi_gl(nmesh,0:nref))
         amat = 0.d0 ; bvec = 0.d0 ; coeff = 0.d0
         fmat = 0.d0 ; hmat = 0.d0 ; h0vec = 0.d0
         rphi_gl = 0.d0 ; dxrphi_gl = 0.d0
     !++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      fguess = 0.5d0
      lguess = 1
      node = nn - 1
      node_sum = node
      if (mod(node,2) == 0) then
         sign_gr = +1.d0
      else
         sign_gr = -1.d0
      end if
         write(IFLOG,'(1x,a29,5i5)') &
            'PAO: ipao,ll,nn,node ...',ipao,ll,nn,node
      ee = engy_pao(ipao)
      nmesh_max = nrcut_ok + 20
      ee_upper_limit = 20.d0
      ee_upper_limit_in = ee_upper_limit
      ee_lower_limit = minval(engy_sol(:)) - 1.d0
      if ((ee > ee_upper_limit).or.(ee < ee_lower_limit)) then
         ee = 0.5d0*(ee_upper_limit + ee_lower_limit)
      end if
      de = ee_upper_limit - ee_lower_limit
      nrm = max(nrcut_ok &
         - int(dble(nmesh-1)*log(2.d0)/log(dble(rmax)/dble(rmin))), &
           nrcut_ok/2)
      max_loop = max_loop_in
      loop = 0
   SRCH_EE:do while (abs(de) > eps_de_tmp)
      loop = loop + 1
      if (loop > max_loop) then
         if (lguess < 2) then
            lguess = lguess + 1
            fguess = fguess * 0.5d0
            max_loop = max_loop * 2
            loop = 0
            node_sum = node
            cycle SRCH_EE
         end if
         write(IFLOG,*) '### ERROR ### loop > max_loop'
         write(IFLOG,*) '   loop, max_loop    ...',loop,max_loop
         write(IFLOG,*) '   ipao,ll,nn        ...',ipao,ll,nn
         write(IFLOG,*) '   node_sum,node     ...',node_sum,node
         write(IFLOG,*) '   ee_upper_limit    ...',ee_upper_limit
         write(IFLOG,*) '   ee_lower_limit    ...',ee_lower_limit
         write(IFLOG,*) '   ee                ...',ee
         write(IFLOG,*) '   de                ...',de
         ier=1 ; go to 99
      end if
      nrt = nrm + 1 + max(iord_pc,iord_diff)
      bsum(:) = 0.d0
      call set_initpoints_left_sol(ier,nmesh,ll,ee,rpos, &
              chi_gl,chi_fl,dxchi_gl,dxchi_fl,vloc_pao,bsum)
      call int_from_left_sol(ier,nmesh,node_sum,nrt, &
              ll,ee,iord_nec,dx,rpos, &
              chi_gl,chi_fl,dxchi_gl,dxchi_fl,vloc_pao,bsum)
      if (ier /= 0) then
         write(IFLOG,*) '### ERROR ### in int_from_left_sol [0]'
         go to 99
      end if
      rphi_gl(:,0)   = chi_gl(:)
      dxrphi_gl(:,0) = dxchi_gl(:)
      do tt = 1,nref
         lt = lt_n_us(ll,tt)
         bsum(:) = -rbeta_us(:,lt)
         call set_initpoints_left_sol(ier,nmesh,ll,ee,rpos, &
                 chi_gl,chi_fl,dxchi_gl,dxchi_fl,vloc_pao,bsum)
         call int_from_left_sol(ier,nmesh,node_sum,nrt, &
                 ll,ee,iord_nec,dx,rpos, &
                 chi_gl,chi_fl,dxchi_gl,dxchi_fl,vloc_pao,bsum)
         if (ier /= 0) then
            write(IFLOG,*) '### ERROR ### in int_from_left_sol [1]'
            go to 99
         end if
         rphi_gl(:,tt)   = chi_gl(:)
         dxrphi_gl(:,tt) = dxchi_gl(:)
      end do
      fmat(:,:) = 0.d0
      do t1 = 1,nref
         lt1 = lt_n_us(ll,t1)
         do t2 = 1,nref
            ltt = ltt_nm_us(ll,t1,t2)
            fmat(t1,t2) = dmat_us(ltt) - ee*q_sum_us(ltt)
            sum = 0.d0
            do ir = 1,nmesh
               sum = sum + rbeta_us(ir,lt1)*rphi_gl(ir,t2)*wr(ir)
            end do
            hmat(t1,t2) = sum
         end do
      end do
      amat(:,:) = matmul(fmat(:,:),hmat(:,:))
      do tt = 1,nref
         amat(tt,tt) = amat(tt,tt) + 1.d0
         lt = lt_n_us(ll,tt)
         sum = 0.d0
         do ir = 1,nmesh
            sum = sum + rbeta_us(ir,lt)*rphi_gl(ir,0)*wr(ir)
         end do
         h0vec(tt) = sum
      end do
      bvec = -matmul(fmat,h0vec)
      call axb_real_matrix(ier,nref,1,amat,coeff,bvec)
      chi_gl(:)   = rphi_gl(:,0)
      dxchi_gl(:) = dxrphi_gl(:,0)
      do tt = 1,nref
         chi_gl(:) = chi_gl(:) + coeff(tt)*rphi_gl(:,tt)
         dxchi_gl(:) = dxchi_gl(:) + coeff(tt)*dxrphi_gl(:,tt)
      end do
      do ir = 1,nrt
         r = rpos(ir)
         chi_fl(ir) = dxchi_gl(ir)/r - dble(ll+1)/r*chi_gl(ir)
      end do
      call calc_nodes_range(nmesh,chi_gl,2,nrm,node_sum_left)
      nmesh_max = nrcut_ok + 20
      if (nmesh_max < nmesh) then
         r  = rpos(nmesh_max)
         vv = vloc_pao(nmesh_max)
         ss = sqrt(2.d0*abs(ee-vv))
         do ir = nmesh_max+1,nmesh
            r  = rpos(ir)
            vv = vloc_pao(ir)
            ss = sqrt(2.d0*abs(ee-vv))
            chi_gr(ir) = exp(-ss*r) * sign_gr
            chi_fr(ir) = -ss * chi_gr(ir) 
            dxchi_gr(ir) = 0.d0
            dxchi_fr(ir) = 0.d0
         end do
      end if
      call set_initpoints_right_sol(ier, &
              nmesh,nmesh_max,ll,ee,rpos, &
              chi_gr,chi_fr,dxchi_gr,dxchi_fr, &
              vloc_pao,bsum,sign_gr)
      if (ier /= 0) then
         write(IFLOG,*) '### ERROR ### in set_initpoints_right_sol'
         go to 99
      end if
      nrt = nrm - 1 - max(iord_pc,iord_diff)
      call int_from_right_sol(ier,nmesh,nmesh_max,nrt, &
              ll,ee,iord_nec,dx,rpos, &
              chi_gr,chi_fr,dxchi_gr,dxchi_fr, &
              vloc_pao,bsum)
      if (ier /= 0) then
         write(IFLOG,*) '### ERROR ### in int_from_right_sol'
         go to 99
      end if
      call calc_nodes_range(nmesh,chi_gr,nrm,nmesh_max,node_sum_right)
      node_sum = node_sum_left + node_sum_right
      if (node_sum > node) then
         ee_upper_limit = min(ee,ee_upper_limit)
         ee_upper_limit = min(ee_upper_limit_in,ee_upper_limit)
         ee = 0.5d0*(ee + ee_lower_limit)
         cycle SRCH_EE
      else if (node_sum < node) then
         ee_lower_limit = max(ee,ee_lower_limit)
         ee = 0.5d0*(ee_upper_limit + ee)
         cycle SRCH_EE
      end if
      rr = chi_gl(nrm) / chi_gr(nrm)
      do ir = nmesh,nrt,-1
           chi_gr(ir) =   chi_gr(ir) * rr
           chi_fr(ir) =   chi_fr(ir) * rr
         dxchi_gr(ir) = dxchi_gr(ir) * rr
         dxchi_fr(ir) = dxchi_fr(ir) * rr
      end do
      call guess_de_sol(ier,IFLOG,nmesh,nrm,rpos,wt, &
              chi_gl,chi_fl,chi_gr,chi_fr,de,fguess,gg_norm)
      if (ier /= 0) then
         write(IFLOG,*) '### ERROR ### in guess_de' ; go to 99
      end if
      etest = ee + de
      if (etest > ee_upper_limit) then
         ee_upper_limit = etest + 0.5d0*de
      else if (etest < ee_lower_limit) then
         ee_lower_limit = etest + 0.5d0*de
      end if
      ee = etest
         write(IFLOG,'(1x,a30,4i5,f25.15,1pe20.10)') &
           'PAO: ipao,ll,nn,node,ee,de ...',ipao,ll,nn,node_sum,ee,de
   end do SRCH_EE
      engy_pao(ipao) = ee
      do ir = 1,nrm
         rphi_pao(ir,ipao) = chi_gl(ir)
         drphi_pao(ir,ipao) = dxchi_gl(ir)
      end do
      do ir = nrm,nmesh
         rphi_pao(ir,ipao) = chi_gr(ir)
         drphi_pao(ir,ipao) = dxchi_gr(ir)
      end do
      call calc_beta_phi_pao(ier,ipao)
      sum = 0.d0
      do ir = 1,nmesh
         sum = sum + rphi_pao(ir,ipao)**2*wr(ir)
      end do
      do t1 = 1,nref
      do t2 = 1,nref
         lt1 = lt_n_us(ll,t1)
         lt2 = lt_n_us(ll,t2)
         ltt = ltt_nm_us(ll,t1,t2)
         sum = sum + q_sum_us(ltt) &
                   * beta_phi_pao(lt1,ipao) &
                   * beta_phi_pao(lt2,ipao)
      end do
      end do
      rphi_pao(:,ipao) = rphi_pao(:,ipao)/sqrt(sum)*sign_gr
      drphi_pao(:,ipao) = drphi_pao(:,ipao)/sqrt(sum)*sign_gr
      call calc_beta_phi_pao(ier,ipao)
      do ir = 1,nmesh
         if (abs(rphi_pao(ir,ipao)) < 1.d-99) then
            rphi_pao(ir,ipao) = 0.d0
         end if
         if (abs(drphi_pao(ir,ipao)) < 1.d-99) then
            drphi_pao(ir,ipao) = 0.d0
         end if
      end do
     !++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      deallocate(amat,bvec,coeff,fmat,hmat,h0vec,rphi_gl,dxrphi_gl)
     !++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   end do LOOP_PAO
99 continue
  !+++++++++++++++++
   deallocate(bsum)
  !+++++++++++++++++
   end subroutine calc_bound_state_pao

!=====================================================================
   subroutine calc_nodes_range(nmesh,func,nr1,nr2,nodes)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   implicit none
   integer,intent(in)  :: nmesh, nr1, nr2
   real(8),intent(in)  :: func(nmesh)
   integer,intent(out) :: nodes
   integer :: ir
   nodes = 0
   do ir = nr1,nr2
      if (func(ir-1)*func(ir) < 0.d0) then
         nodes = nodes + 1
      end if
   end do
   end subroutine calc_nodes_range

!=====================================================================
   subroutine calc_beta_phi_pao(ier,ipao)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(in)  :: ipao
   integer,intent(out) :: ier
   integer :: ir, ll, nref, tt, lt
   real(8) :: sum
   ier = 0
   beta_phi_pao(:,ipao) = 0.d0
   ll = l_pao(ipao)
   nref = nref_us(ll)
   do tt = 1,nref
      lt = lt_n_us(ll,tt)
      if (ll == lloc) then
         sum = 1.d0
      else
         sum = 0.d0
         do ir = 1,nmesh
            sum = sum &
                + wr(ir) * rbeta_us(ir,lt) * rphi_pao(ir,ipao)
         end do
      end if
      beta_phi_pao(lt,ipao) = sum
   end do
99 continue
   end subroutine calc_beta_phi_pao

!=====================================================================
   subroutine write_energy_level_pao(ifile)
!=====================================================================  
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(in) :: ifile
   integer        :: i, nn, ll, ipao, nodes, lpao
   character(100) :: line
   character(1)   :: fn_label_orbital
   integer,allocatable :: idx_tmp(:)
  !+++++++++++++++++++++++++++
   allocate(idx_tmp(num_pao))
  !+++++++++++++++++++++++++++
   call sort_simple(num_pao,engy_pao,idx_tmp)
   do i = 1,100
      line(i:i)='-'
   end do
   write(ifile,*)
   write(ifile,*) 'eng  Energy levels of PAO [Solved]'
   write(ifile,*) 'eng  PAO type ---> ',adjustl(pao_formula)
   write(ifile,10) line(1:100)
   write(ifile,11) 'symm', 'number', 'nodes', &
                   'Energy (Ha)','Energy (eV)'
   write(ifile,10) line(1:100)
   do ipao = 1,num_pao
      lpao = idx_tmp(ipao)
      ll = l_pao(lpao)
      nn = n_pao(lpao)
      nodes = nn - 1
      write(ifile,12) fn_label_orbital(ll),nn,nodes, &
         engy_pao(lpao),engy_pao(lpao)*HARTREE
   end do
   write(ifile,10) line(1:100)
10 format(1x,'eng',a72)
11 format(1x,'eng',(6x,a4),(4x,a6),(5x,a5),2(9x,a11))
12 format(1x,'eng',(8x,a1,1x),2i10,2f20.10)
  !++++++++++++++++++++
   deallocate(idx_tmp)
  !++++++++++++++++++++
   end subroutine write_energy_level_pao

!=====================================================================
   subroutine write_pao(ier)
!=====================================================================
!
!  M. Okamoto
!     
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer :: ir, nn, ll, ipao
   character(1) :: ch_ln, ch_nn, fn_label_orbital
   character(2) :: ch_del
   character(3) :: ch3
   ier = 0
   ch_del = ','//' '
   open(IFPAO,file=trim(paofile),status='unknown')
   write(IFPAO,*) 'PAO primitive orbitals'
   call write_file_header(IFPAO)
   do ipao = 1,num_pao
      nn  = n_pao(ipao)
      ll  = l_pao(ipao)
      ch_ln = fn_label_orbital(ll)
      write(ch_nn,'(i1)') nn
      ch3(1:3) = '_'//ch_ln(1:1)//ch_nn(1:1)
      write(IFPAO,*)
      write(IFPAO,*)  'PAO type ---> ',adjustl(pao_formula)
      write(IFPAO,*)  '(l,n)    --->',ll,nn
      write(IFPAO,20) 'energy   --->',engy_pao(ipao)
      write(IFPAO,20) 'rcut     --->',rcut_ok
      write(IFPAO,20) 'rl       --->',rcut_ok - drcl_ok
      write(IFPAO,20) 'height   --->',h_ok
      write(IFPAO,*)  'nrcut    --->',nrcut_ok
      write(IFPAO,*)  'nmesh    --->',nmesh
      write(IFPAO,*) &
         'rpos'//ch3//ch_del//'rphi'//ch3//ch_del//'drphi'//ch3
      do ir = 1,nmesh
         write(IFPAO,10) rpos(ir), &
            rphi_pao(ir,ipao),drphi_pao(ir,ipao)
      end do
   end do
10 format(10(1pe20.10))
20 format(1x,a13,f20.10)
   close(IFPAO)
   end subroutine write_pao

!=====================================================================
   subroutine set_pao_formula
!=====================================================================
!
!  M. Okamoto
!     
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer :: ipos, il, ll, nn
   character(1) :: fn_label_orbital
   read(atom_label(zatom),*) pao_formula
   ipos = len_trim(pao_formula) + 1
   pao_formula(ipos:ipos) = '-' ; ipos = ipos + 1
   do il = 1,num_l_pao
      ll = lnum_pao(il)
      nn = nnum_pao(il)
      write(pao_formula(ipos:ipos),'(a1)') fn_label_orbital(ll) ; ipos = ipos + 1
      write(pao_formula(ipos:ipos),'(i1)') nn ; ipos = ipos + 1
   end do
   end subroutine set_pao_formula

!
!  Software name : CIAO (Code for Investigating Atomic Orbitals)
!  Subroutine(s) : calc_xc_lda_pz81_sol, calc_xc_lda_pz81_ss
!                : calc_xc_lda_pw92_sol, calc_xc_lda_pw92_ss
!                : calc_xc_gga_pbe96_sol, calc_xc_gga_pbe96_ss
!                : calc_xc_gga_pw91_sol, calc_xc_gga_pw91_ss
!                : calc_x_lda_sol, calc_x_lda_ss, calc_x_gga_sol
!                : calc_x_gga_ss, calc_xc_none_sol, calc_xc_none_ss
!  Author(s)     : Masakuni Okamoto (August 25, 2003)
!
!
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!
!
!  The license of the code and contact address :
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)
!
!=====================================================================
   subroutine calc_xc_lda_pz81_sol(ier)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer :: ir
   real(8) :: rho1, rho2, rho1_tmp, &
              ex_tmp, ec_tmp, vx_tmp(2), vc_tmp(2), &
              rhomin = 1.d-35
   ier = 0
   do ir = 1,nmesh
      select case (is_pcc)
! ======================================- modified by K. T. ============= 4.0
!      case (NONE)
!         rho1_tmp = rho_sol(ir)
!      case (PCC)
!         rho1_tmp = rho_sol(ir) + rho_pcore(ir)
!      case (FCC)
!         rho1_tmp = rho_sol(ir) + rho_core(ir)
!      end select
!
      case (NONE)
         rho1_tmp = rho_sol(ir,1)
      case (PCC)
         rho1_tmp = rho_sol(ir,1) + rho_pcore(ir)
      case (FCC)
         rho1_tmp = rho_sol(ir,1) + rho_core(ir)
      end select
! ========================================================================= 4.0

      rho1 = rho1_tmp*0.5d0 ; rho2 = rho1
      call lda_pz81(rho1,rho2,ex_tmp,ec_tmp,vx_tmp,vc_tmp)
      ex_sol(ir) = ex_tmp
      ec_sol(ir) = ec_tmp

! ====================================== modified by K. T. =============== 4.0
!      vx_sol(ir) = vx_tmp(1)
!      vc_sol(ir) = vc_tmp(1)
      vx_sol(ir,1) = vx_tmp(1)
      vc_sol(ir,1) = vc_tmp(1)
! ======================================================================== 4.0
   end do
   do ir = 1,nmesh
      select case (is_pcc)
      case (NONE)
         rho1_tmp = 0.d0
      case (PCC)
         rho1_tmp = rho_pcore(ir)
      case (FCC)
         rho1_tmp = rho_core(ir)
      end select
      rho1 = rho1_tmp*0.5d0 ; rho2 = rho1
      select case (is_pcc)
      case (PCC,FCC)
         call lda_pz81(rho1,rho2,ex_tmp,ec_tmp,vx_tmp,vc_tmp)
      case (NONE)
         ex_tmp    = 0.d0
         ec_tmp    = 0.d0
         vx_tmp(:) = 0.d0
         vc_tmp(:) = 0.d0
      end select
      expc_sol(ir) = ex_tmp
      ecpc_sol(ir) = ec_tmp
      vxpc_sol(ir) = vx_tmp(1)
      vcpc_sol(ir) = vc_tmp(1)
   end do
   end subroutine calc_xc_lda_pz81_sol

! ========================================= added by K. T. =================== 4.0
subroutine calc_xc_lda_pz81_sol_kt(ier)
  use parameters
  implicit none

  integer,intent(out) :: ier
  integer :: ir, ispin
  real(8) :: rho1, rho2, &
       ex_tmp, ec_tmp, vx_tmp(2), vc_tmp(2), &
       rhomin = 1.d-35
  real(8) :: rho_tmp(2)

  ier = 0

  do ir = 1,nmesh

     Do ispin=1, nspin

        select case (is_pcc)
        case (NONE)
           rho_tmp(ispin) = rho_sol(ir,ispin)
        case (PCC)
           rho_tmp(ispin) = rho_sol(ir,ispin) + rho_pcore(ir)/dble(nspin)
        case (FCC)
           rho_tmp(ispin) = rho_sol(ir,ispin) + rho_core(ir)/dble(nspin)
        end select

     End do

     if ( nspin == 1 ) then
        rho1 = rho_tmp(1) *0.5d0 ; rho2 = rho1
     else if ( nspin == 2 ) then
        rho1 = rho_tmp(1); rho2 = rho_tmp(2)
     endif

     call lda_pz81(rho1,rho2,ex_tmp,ec_tmp,vx_tmp,vc_tmp)

     ex_sol(ir) = ex_tmp
     ec_sol(ir) = ec_tmp

     Do ispin=1, nspin
        vx_sol(ir,ispin) = vx_tmp(ispin)
        vc_sol(ir,ispin) = vc_tmp(ispin)
     End do

  end do

  do ir = 1,nmesh

     select case (is_pcc)
     case (NONE)
        rho_tmp(1) = 0.d0
     case (PCC)
        rho_tmp(1) = rho_pcore(ir)
     case (FCC)
        rho_tmp(1) = rho_core(ir)
     end select
     
     rho1 = rho_tmp(1)*0.5d0 ; rho2 = rho1
     
     select case (is_pcc)
        
     case (PCC,FCC)
        call lda_pz81(rho1,rho2,ex_tmp,ec_tmp,vx_tmp,vc_tmp)
     case (NONE)
        ex_tmp    = 0.d0
        ec_tmp    = 0.d0
        vx_tmp(:) = 0.d0
        vc_tmp(:) = 0.d0
     end select

     expc_sol(ir) = ex_tmp
     ecpc_sol(ir) = ec_tmp
     vxpc_sol(ir) = vx_tmp(1)
     vcpc_sol(ir) = vc_tmp(1)
     
  end do
  
end subroutine calc_xc_lda_pz81_sol_kt
! ============================================================================ 4.0

!=====================================================================
   subroutine calc_xc_lda_pz81_ss(ier)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer :: ir, ispin
   real(8) :: rho1, rho2, rho1_tmp, &
              ex_tmp, ec_tmp, vx_tmp(2), vc_tmp(2), &
              rhomin = 1.d-35
   ier = 0
   do ir = 1,nmesh
      select case (is_spin_ss)
      case (RESTRICTED)
         select case (is_pcc)
         case (NONE)
            rho1_tmp = rho_ss(ir,1)
         case (PCC)
            rho1_tmp = rho_ss(ir,1) + rho_pcore(ir)
         case (FCC)
            rho1_tmp = rho_ss(ir,1) + rho_core(ir)
         end select
         rho1 = rho1_tmp*0.5d0 ; rho2 = rho1
      case (POLARIZED)
         select case (is_pcc)
         case (NONE)
            rho1 = rho_ss(ir,1)
            rho2 = rho_ss(ir,2)
         case (PCC)
            rho1 = rho_ss(ir,1) + rho_pcore(ir)*0.5d0
            rho2 = rho_ss(ir,2) + rho_pcore(ir)*0.5d0
         case (FCC)
            rho1 = rho_ss(ir,1) + rho_core(ir)*0.5d0
            rho2 = rho_ss(ir,2) + rho_core(ir)*0.5d0
         end select
       end select
      call lda_pz81(rho1,rho2,ex_tmp,ec_tmp,vx_tmp,vc_tmp)
      ex_ss(ir) = ex_tmp
      ec_ss(ir) = ec_tmp
      do ispin = 1,nspin_ss
         vx_ss(ir,ispin) = vx_tmp(ispin)
         vc_ss(ir,ispin) = vc_tmp(ispin)
      end do
   end do
   do ir = 1,nmesh
      select case (is_pcc)
      case (NONE)
         rho1_tmp = 0.d0
      case (PCC)
         rho1_tmp = rho_pcore(ir)
      case (FCC)
         rho1_tmp = rho_core(ir)
      end select
      rho1 = rho1_tmp*0.5d0 ; rho2 = rho1
      select case (is_pcc)
      case (PCC,FCC)
         call lda_pz81(rho1,rho2,ex_tmp,ec_tmp,vx_tmp,vc_tmp)
      case (NONE)
         ex_tmp    = 0.d0
         ec_tmp    = 0.d0
         vx_tmp(:) = 0.d0
         vc_tmp(:) = 0.d0
      end select
      expc_ss(ir) = ex_tmp
      ecpc_ss(ir) = ec_tmp
      do ispin = 1,nspin_ss
         vxpc_ss(ir,ispin) = vx_tmp(ispin)
         vcpc_ss(ir,ispin) = vc_tmp(ispin)
      end do
   end do
   end subroutine calc_xc_lda_pz81_ss

!=====================================================================
   subroutine calc_xc_lda_pw92_sol(ier)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer :: ir
   real(8) :: rho1, rho2, rho1_tmp, &
              ex_tmp, ec_tmp, vx_tmp(2), vc_tmp(2), &
              decdrs, decdzeta, &
              rhomin = 1.d-35
   ier = 0
   do ir = 1,nmesh
      select case (is_pcc)

! =================================== modified by K. T. ================== 4.0
!      case (NONE)
!         rho1_tmp = rho_sol(ir)
!      case (PCC)
!         rho1_tmp = rho_sol(ir) + rho_pcore(ir)
!      case (FCC)
!         rho1_tmp = rho_sol(ir) + rho_core(ir)
!      end select
!
      case (NONE)
         rho1_tmp = rho_sol(ir,1)
      case (PCC)
         rho1_tmp = rho_sol(ir,1) + rho_pcore(ir)
      case (FCC)
         rho1_tmp = rho_sol(ir,1) + rho_core(ir)
      end select
! ========================================================================= 4.0

      rho1 = rho1_tmp*0.5d0 ; rho2 = rho1
      call lda_pw92(rho1,rho2,ex_tmp,ec_tmp,vx_tmp,vc_tmp, &
                    decdrs,decdzeta)
      ex_sol(ir) = ex_tmp
      ec_sol(ir) = ec_tmp

! ==================================== modified by K. T. =================== 4.0
!      vx_sol(ir) = vx_tmp(1)
!      vc_sol(ir) = vc_tmp(1)
      vx_sol(ir,1) = vx_tmp(1)
      vc_sol(ir,1) = vc_tmp(1)
! ============================================================================ 4.0

   end do
   do ir = 1,nmesh
      select case (is_pcc)
      case (NONE)
         rho1_tmp = 0.d0
      case (PCC)
         rho1_tmp = rho_pcore(ir)
      case (FCC)
         rho1_tmp = rho_core(ir)
      end select
      rho1 = rho1_tmp*0.5d0 ; rho2 = rho1
      select case (is_pcc)
      case (PCC,FCC)
         call lda_pw92(rho1,rho2,ex_tmp,ec_tmp,vx_tmp,vc_tmp, &
                       decdrs,decdzeta)
      case (NONE)
         ex_tmp    = 0.d0
         ec_tmp    = 0.d0
         vx_tmp(:) = 0.d0
         vc_tmp(:) = 0.d0
      end select
      expc_sol(ir) = ex_tmp
      ecpc_sol(ir) = ec_tmp
      vxpc_sol(ir) = vx_tmp(1)
      vcpc_sol(ir) = vc_tmp(1)
   end do
   end subroutine calc_xc_lda_pw92_sol

! ======================================== added by K. T. ====================== 4.0
subroutine calc_xc_lda_pw92_sol_kt(ier)
  use parameters
  implicit none

  integer,intent(out) :: ier
  integer :: ir, ispin
  real(8) :: rho1, rho2, &
       ex_tmp, ec_tmp, vx_tmp(2), vc_tmp(2), &
       decdrs, decdzeta, &
       rhomin = 1.d-35
  real(8) :: rho_tmp(2)

  ier = 0

  do ir = 1,nmesh

     Do ispin=1, nspin

        select case (is_pcc)
        case (NONE)
           rho_tmp(ispin) = rho_sol(ir,ispin)
        case (PCC)
           rho_tmp(ispin) = rho_sol(ir,ispin) + rho_pcore(ir) /dble(nspin)
        case (FCC)
           rho_tmp(ispin) = rho_sol(ir,ispin) + rho_core(ir) /dble(nspin)
        end select

     End do

     if ( nspin == 1 ) then
        rho1 = rho_tmp(1) *0.5d0 ; rho2 = rho1
     else if ( nspin == 2 ) then
        rho1 = rho_tmp(1);  rho2 = rho_tmp(2)
     endif

     call lda_pw92(rho1,rho2,ex_tmp,ec_tmp,vx_tmp,vc_tmp, &
          decdrs,decdzeta)

     ex_sol(ir) = ex_tmp
     ec_sol(ir) = ec_tmp

     Do ispin=1, nspin
        vx_sol(ir,ispin) = vx_tmp(ispin)
        vc_sol(ir,ispin) = vc_tmp(ispin)
     End do

  end do

  do ir = 1,nmesh

     select case (is_pcc)
     case (NONE)
        rho_tmp(1) = 0.d0
     case (PCC)
        rho_tmp(1) = rho_pcore(ir)
     case (FCC)
        rho_tmp(1) = rho_core(ir)
     end select

     rho1 = rho_tmp(1) *0.5d0 ; rho2 = rho1

     select case (is_pcc)
     case (PCC,FCC)
        call lda_pw92(rho1,rho2,ex_tmp,ec_tmp,vx_tmp,vc_tmp, &
             decdrs,decdzeta)

     case (NONE)
        ex_tmp    = 0.d0
        ec_tmp    = 0.d0
        vx_tmp(:) = 0.d0
        vc_tmp(:) = 0.d0
     end select

     expc_sol(ir) = ex_tmp
     ecpc_sol(ir) = ec_tmp
     vxpc_sol(ir) = vx_tmp(1)
     vcpc_sol(ir) = vc_tmp(1)

  end do

end subroutine calc_xc_lda_pw92_sol_kt
! ============================================================================= 4.0

!=====================================================================
   subroutine calc_xc_lda_pw92_ss(ier)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer :: ir, ispin
   real(8) :: rho1, rho2, rho1_tmp, &
              ex_tmp, ec_tmp, vx_tmp(2), vc_tmp(2), &
              decdrs, decdzeta, &
              rhomin = 1.d-35
   ier = 0
   do ir = 1,nmesh
      select case (is_spin_ss)
      case (RESTRICTED)
         select case (is_pcc)
         case (NONE)
            rho1_tmp = rho_ss(ir,1)
         case (PCC)
            rho1_tmp = rho_ss(ir,1) + rho_pcore(ir)
         case (FCC)
            rho1_tmp = rho_ss(ir,1) + rho_core(ir)
         end select
         rho1 = rho1_tmp*0.5d0 ; rho2 = rho1
      case (POLARIZED)
         select case (is_pcc)
         case (NONE)
            rho1 = rho_ss(ir,1) ; rho2 = rho_ss(ir,2)
         case (PCC)
            rho1 = rho_ss(ir,1) + rho_pcore(ir)*0.5d0
            rho2 = rho_ss(ir,2) + rho_pcore(ir)*0.5d0
         case (FCC)
            rho1 = rho_ss(ir,1) + rho_core(ir)*0.5d0
            rho2 = rho_ss(ir,2) + rho_core(ir)*0.5d0
         end select
      end select
      call lda_pw92(rho1,rho2,ex_tmp,ec_tmp,vx_tmp,vc_tmp, &
                    decdrs,decdzeta)
      ex_ss(ir) = ex_tmp
      ec_ss(ir) = ec_tmp
      do ispin = 1,nspin_ss
         vx_ss(ir,ispin) = vx_tmp(ispin)
         vc_ss(ir,ispin) = vc_tmp(ispin)
      end do
   end do
   do ir = 1,nmesh
      select case (is_pcc)
      case (NONE)
         rho1_tmp = 0.d0
      case (PCC)
         rho1_tmp = rho_pcore(ir)
      case (FCC)
         rho1_tmp = rho_core(ir)
      end select
      rho1 = rho1_tmp*0.5d0 ; rho2 = rho1
      select case (is_pcc)
      case (PCC,FCC)
         call lda_pw92(rho1,rho2,ex_tmp,ec_tmp,vx_tmp,vc_tmp, &
                       decdrs,decdzeta)
      case (NONE)
         ex_tmp    = 0.d0
         ec_tmp    = 0.d0
         vx_tmp(:) = 0.d0
         vc_tmp(:) = 0.d0
      end select
      expc_ss(ir) = ex_tmp
      ecpc_ss(ir) = ec_tmp
      do ispin = 1,nspin_ss
         vxpc_ss(ir,ispin) = vx_tmp(ispin)
         vcpc_ss(ir,ispin) = vc_tmp(ispin)
      end do
   end do
   end subroutine calc_xc_lda_pw92_ss

!=====================================================================
   subroutine calc_xc_gga_pbe96_sol(ier,imode)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(in)  :: imode
   integer,intent(out) :: ier
   integer :: ir
   real(8) :: r, rho1, rho2, drho1, drho2, ddrho1, ddrho2, &
              rho1_tmp, drho1_tmp, ddrho1_tmp, &
              ex_tmp, ec_tmp, vx_tmp(2), vc_tmp(2), &
              rhomin = 1.d-35, eps_chg = 1.d-25
   ier = 0
   do ir = 1,nmesh
      select case (is_pcc)

! ====================================== modified by K. T. ============== 4.0
!      case (NONE)
!           rho1_tmp =   rho_sol(ir)
!          drho1_tmp =  drho_sol(ir)
!         ddrho1_tmp = ddrho_sol(ir)
!      case (PCC)
!           rho1_tmp =   rho_sol(ir) +   rho_pcore(ir)
!          drho1_tmp =  drho_sol(ir) +  drho_pcore(ir)
!         ddrho1_tmp = ddrho_sol(ir) + ddrho_pcore(ir)
!      case (FCC)
!           rho1_tmp =   rho_sol(ir) +   rho_core(ir)
!          drho1_tmp =  drho_sol(ir) +  drho_core(ir)
!         ddrho1_tmp = ddrho_sol(ir) + ddrho_core(ir)
!      end select
!
      case (NONE)
           rho1_tmp =   rho_sol(ir,1)
          drho1_tmp =  drho_sol(ir,1)
         ddrho1_tmp = ddrho_sol(ir,1)
      case (PCC)
           rho1_tmp =   rho_sol(ir,1) +   rho_pcore(ir)
          drho1_tmp =  drho_sol(ir,1) +  drho_pcore(ir)
         ddrho1_tmp = ddrho_sol(ir,1) + ddrho_pcore(ir)
      case (FCC)
           rho1_tmp =   rho_sol(ir,1) +   rho_core(ir)
          drho1_tmp =  drho_sol(ir,1) +  drho_core(ir)
         ddrho1_tmp = ddrho_sol(ir,1) + ddrho_core(ir)
      end select
! ======================================================================= 4.0

        rho1 =    rho1_tmp*0.5d0 ;    rho2 =    rho1
       drho1 =   drho1_tmp*0.5d0 ;   drho2 =   drho1
      ddrho1 =  ddrho1_tmp*0.5d0 ;  ddrho2 =  ddrho1
      if (rho1 < rhomin) then
           rho1 = rhomin ;   rho2 = rho1
          drho1 =   0.d0 ;  drho2 = 0.d0
         ddrho1 =   0.d0 ; ddrho2 = 0.d0
      end if
      r = rpos(ir)
      call gga_pbe96_spherical(imode, &
                 r,rho1,rho2,drho1,drho2,ddrho1,ddrho2, &
                 ex_tmp,ec_tmp,vx_tmp,vc_tmp)
      ex_sol(ir) = ex_tmp
      ec_sol(ir) = ec_tmp
      if (rho1 < eps_chg) then
         ec_sol(ir) = 0.d0    
      end if

! =================================== modified by K. T. ============ 4.0
!      vx_sol(ir) = vx_tmp(1)
!      vc_sol(ir) = vc_tmp(1)
!      if (rho1 < eps_chg) then
!         vc_sol(ir) = 0.d0
!      end if
!
      vx_sol(ir,1) = vx_tmp(1)
      vc_sol(ir,1) = vc_tmp(1)
      if (rho1 < eps_chg) then
         vc_sol(ir,1) = 0.d0
      end if
! =================================================================== 4.0

   end do
   do ir = 1,nmesh
      select case (is_pcc)
      case (NONE)
           rho1_tmp = 0.d0
          drho1_tmp = 0.d0
         ddrho1_tmp = 0.d0
      case (PCC)
           rho1_tmp =   rho_pcore(ir)
          drho1_tmp =  drho_pcore(ir)
         ddrho1_tmp = ddrho_pcore(ir)
      case (FCC)
           rho1_tmp =   rho_core(ir)
          drho1_tmp =  drho_core(ir)
         ddrho1_tmp = ddrho_core(ir)
      end select
        rho1 =    rho1_tmp*0.5d0 ;    rho2 =    rho1
       drho1 =   drho1_tmp*0.5d0 ;   drho2 =   drho1
      ddrho1 =  ddrho1_tmp*0.5d0 ;  ddrho2 =  ddrho1
      if (rho1 < rhomin) then
           rho1 = rhomin ;   rho2 = rho1
          drho1 =   0.d0 ;  drho2 = 0.d0
         ddrho1 =   0.d0 ; ddrho2 = 0.d0
      end if
      r = rpos(ir)
      select case (is_pcc)
      case (PCC,FCC)
         call gga_pbe96_spherical(imode, &
                 r,rho1,rho2,drho1,drho2,ddrho1,ddrho2, &
                 ex_tmp,ec_tmp,vx_tmp,vc_tmp)
      case (NONE)
         ex_tmp = 0.d0
         ec_tmp = 0.d0
         vx_tmp(:) = 0.d0
         vc_tmp(:) = 0.d0
      end select
      expc_sol(ir) = ex_tmp
      ecpc_sol(ir) = ec_tmp
      if (rho1 < eps_chg) then
         ecpc_sol(ir) = 0.d0    
      end if
      vxpc_sol(ir) = vx_tmp(1)
      vcpc_sol(ir) = vc_tmp(1)
      if (rho1 < eps_chg) then
         vcpc_sol(ir) = 0.d0
      end if
   end do
   end subroutine calc_xc_gga_pbe96_sol

!================================== added by K. T. ======================= 4.0
subroutine calc_xc_gga_pbe96_sol_kt(ier,imode)
  use parameters
  implicit none

  integer,intent(in)  :: imode
  integer,intent(out) :: ier
  integer :: ir, ispin

  real(8) :: r, rho1, rho2, drho1, drho2, ddrho1, ddrho2, &
       rho_tmp(2), drho_tmp(2), ddrho_tmp(2), &
       ex_tmp, ec_tmp, vx_tmp(2), vc_tmp(2), &
       rhomin = 1.d-35, eps_chg = 1.d-25

  ier = 0

  do ir = 1,nmesh

     Do ispin=1, nspin
        
        select case (is_pcc)
        case (NONE)
             rho_tmp(ispin) =   rho_sol(ir,ispin)
            drho_tmp(ispin) =  drho_sol(ir,ispin)
           ddrho_tmp(ispin) = ddrho_sol(ir,ispin)
        case (PCC)
             rho_tmp(ispin) =   rho_sol(ir,ispin) +   rho_pcore(ir)/dble(nspin)
            drho_tmp(ispin) =  drho_sol(ir,ispin) +  drho_pcore(ir)/dble(nspin)
           ddrho_tmp(ispin) = ddrho_sol(ir,ispin) + ddrho_pcore(ir)/dble(nspin)
        case (FCC)
             rho_tmp(ispin) =   rho_sol(ir,ispin) +   rho_core(ir)/dble(nspin)
            drho_tmp(ispin) =  drho_sol(ir,ispin) +  drho_core(ir)/dble(nspin)
           ddrho_tmp(ispin) = ddrho_sol(ir,ispin) + ddrho_core(ir)/dble(nspin)
        end select
     End do

     if ( nspin == 1 ) then
          rho1 =    rho_tmp(1)*0.5d0 ;    rho2 =    rho1
         drho1 =   drho_tmp(1)*0.5d0 ;   drho2 =   drho1
        ddrho1 =  ddrho_tmp(1)*0.5d0 ;  ddrho2 =  ddrho1

        if (rho1 < rhomin) then
             rho1 = rhomin ;   rho2 = rho1
            drho1 =   0.d0 ;  drho2 = 0.d0
           ddrho1 =   0.d0 ; ddrho2 = 0.d0
        endif

     else if ( nspin == 2 ) then
          rho1 =    rho_tmp(1);    rho2 =    rho_tmp(2)
         drho1 =   drho_tmp(1);   drho2 =   drho_tmp(2)
        ddrho1 =  ddrho_tmp(1);  ddrho2 =  ddrho_tmp(2)

        if (rho1 < rhomin) then
             rho1 = rhomin;      drho1 = 0.d0;     ddrho1 = 0.d0
        endif
        if (rho2 < rhomin) then
             rho2 = rhomin;      drho2 = 0.d0;     ddrho2 = 0.d0
        endif

     end if

     r = rpos(ir)
     call gga_pbe96_spherical(imode, &
          r,rho1,rho2,drho1,drho2,ddrho1,ddrho2, &
          ex_tmp,ec_tmp,vx_tmp,vc_tmp)
     ex_sol(ir) = ex_tmp
     ec_sol(ir) = ec_tmp

     if ( nspin == 1 ) then
        if (rho1 < eps_chg) then
           ec_sol(ir) = 0.d0    
        end if
     else if ( nspin ==2 ) then
        if (rho1 +rho2 < eps_chg) then
           ec_sol(ir) = 0.d0    
        end if
     endif

     Do ispin=1, nspin
        vx_sol(ir,ispin) = vx_tmp(ispin)
        vc_sol(ir,ispin) = vc_tmp(ispin)
     End do

     if ( nspin == 1 ) then
        if (rho1 < eps_chg) then
           vc_sol(ir,1) = 0.d0
        end if
     else if ( nspin == 2 ) then
        if (rho1 < eps_chg) then
           vc_sol(ir,1) = 0.d0
        end if
        if (rho2 < eps_chg) then
           vc_sol(ir,2) = 0.d0
        end if
     endif

  end do

  do ir = 1,nmesh

     select case (is_pcc)
     case (NONE)
          rho_tmp(1) = 0.d0
         drho_tmp(1) = 0.d0
        ddrho_tmp(1) = 0.d0
     case (PCC)
          rho_tmp(1) =   rho_pcore(ir)
         drho_tmp(1) =  drho_pcore(ir)
        ddrho_tmp(1) = ddrho_pcore(ir)
     case (FCC)
          rho_tmp(1) =   rho_core(ir)
         drho_tmp(1) =  drho_core(ir)
        ddrho_tmp(1) = ddrho_core(ir)
     end select

       rho1 =    rho_tmp(1)*0.5d0 ;    rho2 =    rho1
      drho1 =   drho_tmp(1)*0.5d0 ;   drho2 =   drho1
     ddrho1 =  ddrho_tmp(1)*0.5d0 ;  ddrho2 =  ddrho1

     
     if (rho1 < rhomin) then
          rho1 = rhomin ;   rho2 = rho1
         drho1 =   0.d0 ;  drho2 = 0.d0
        ddrho1 =   0.d0 ; ddrho2 = 0.d0
     end if

     r = rpos(ir)

     select case (is_pcc)

     case (PCC,FCC)
        call gga_pbe96_spherical(imode, &
             r,rho1,rho2,drho1,drho2,ddrho1,ddrho2, &
             ex_tmp,ec_tmp,vx_tmp,vc_tmp)

     case (NONE)
        ex_tmp = 0.d0
        ec_tmp = 0.d0
        vx_tmp(:) = 0.d0
        vc_tmp(:) = 0.d0
     end select

     expc_sol(ir) = ex_tmp
     ecpc_sol(ir) = ec_tmp

     if (rho1 < eps_chg) then
        ecpc_sol(ir) = 0.d0    
     end if

     vxpc_sol(ir) = vx_tmp(1)
     vcpc_sol(ir) = vc_tmp(1)
     if (rho1 < eps_chg) then
        vcpc_sol(ir) = 0.d0
     end if

  end do

end subroutine calc_xc_gga_pbe96_sol_kt
! ========================================================================= 4.0

!=====================================================================
   subroutine calc_xc_gga_pbe96_ss(ier,imode)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(in)  :: imode
   integer,intent(out) :: ier
   integer :: ir, ispin
   real(8) :: r, rho1, rho2, drho1, drho2, ddrho1, ddrho2, &
              rho1_tmp, drho1_tmp, ddrho1_tmp, &
              ex_tmp, ec_tmp, vx_tmp(2), vc_tmp(2), &
              rhomin = 1.d-35, eps_chg = 1.d-25
   ier = 0
   do ir = 1,nmesh
      select case (is_spin_ss)
      case (RESTRICTED)
         select case (is_pcc)
         case (NONE)
              rho1_tmp =   rho_ss(ir,1)
             drho1_tmp =  drho_ss(ir,1)
            ddrho1_tmp = ddrho_ss(ir,1)
         case (PCC)
              rho1_tmp =   rho_ss(ir,1) +   rho_pcore(ir)
             drho1_tmp =  drho_ss(ir,1) +  drho_pcore(ir)
            ddrho1_tmp = ddrho_ss(ir,1) + ddrho_pcore(ir)
         case (FCC)
              rho1_tmp =   rho_ss(ir,1) +   rho_core(ir)
             drho1_tmp =  drho_ss(ir,1) +  drho_core(ir)
            ddrho1_tmp = ddrho_ss(ir,1) + ddrho_core(ir)
         end select
           rho1 =    rho1_tmp*0.5d0 ;    rho2 =    rho1
          drho1 =   drho1_tmp*0.5d0 ;   drho2 =   drho1
         ddrho1 =  ddrho1_tmp*0.5d0 ;  ddrho2 =  ddrho1
         if (rho1 < rhomin) then
              rho1 = rhomin ;   rho2 = rho1
             drho1 =   0.d0 ;  drho2 = 0.d0
            ddrho1 =   0.d0 ; ddrho2 = 0.d0
         end if
      case (POLARIZED)
         select case (is_pcc)
         case (NONE)
              rho1 =   rho_ss(ir,1) ;   rho2 =   rho_ss(ir,2)
             drho1 =  drho_ss(ir,1) ;  drho2 =  drho_ss(ir,2)
            ddrho1 = ddrho_ss(ir,1) ; ddrho2 = ddrho_ss(ir,2)
         case (PCC)
              rho1 =   rho_ss(ir,1) +   rho_pcore(ir)*0.5d0
             drho1 =  drho_ss(ir,1) +  drho_pcore(ir)*0.5d0
            ddrho1 = ddrho_ss(ir,1) + ddrho_pcore(ir)*0.5d0
              rho2 =   rho_ss(ir,2) +   rho_pcore(ir)*0.5d0
             drho2 =  drho_ss(ir,2) +  drho_pcore(ir)*0.5d0
            ddrho2 = ddrho_ss(ir,2) + ddrho_pcore(ir)*0.5d0
         case (FCC)
              rho1 =   rho_ss(ir,1) +   rho_core(ir)*0.5d0
             drho1 =  drho_ss(ir,1) +  drho_core(ir)*0.5d0
            ddrho1 = ddrho_ss(ir,1) + ddrho_core(ir)*0.5d0
              rho2 =   rho_ss(ir,2) +   rho_core(ir)*0.5d0
             drho2 =  drho_ss(ir,2) +  drho_core(ir)*0.5d0
            ddrho2 = ddrho_ss(ir,2) + ddrho_core(ir)*0.5d0
         end select
         if (rho1 < rhomin) then
              rho1 = rhomin
             drho1 =   0.d0
            ddrho1 =   0.d0
         end if
         if (rho2 < rhomin) then
              rho2 = rhomin
             drho2 =   0.d0
            ddrho2 =   0.d0
         end if
      end select
      r = rpos(ir)
      call gga_pbe96_spherical(imode, &
                 r,rho1,rho2,drho1,drho2,ddrho1,ddrho2, &
                 ex_tmp,ec_tmp,vx_tmp,vc_tmp)
      ex_ss(ir) = ex_tmp
      ec_ss(ir) = ec_tmp
      if (max(rho1,rho2) < eps_chg) then
         ec_ss(ir) = 0.d0    
      end if
      do ispin = 1,nspin_ss
         vx_ss(ir,ispin) = vx_tmp(ispin)
         vc_ss(ir,ispin) = vc_tmp(ispin)
      end do
      if (rho1 < eps_chg) then
         vc_ss(ir,1) = 0.d0
      end if
      if ((rho2 < eps_chg).and.(nspin_ss == 2)) then
         vc_ss(ir,2) = 0.d0
      end if
   end do
   do ir = 1,nmesh
      select case (is_pcc)
      case (NONE)
           rho1_tmp = 0.d0
          drho1_tmp = 0.d0
         ddrho1_tmp = 0.d0
      case (PCC)
           rho1_tmp =   rho_pcore(ir)
          drho1_tmp =  drho_pcore(ir)
         ddrho1_tmp = ddrho_pcore(ir)
      case (FCC)
           rho1_tmp =   rho_core(ir)
          drho1_tmp =  drho_core(ir)
         ddrho1_tmp = ddrho_core(ir)
      end select
        rho1 =    rho1_tmp*0.5d0 ;    rho2 =    rho1
       drho1 =   drho1_tmp*0.5d0 ;   drho2 =   drho1
      ddrho1 =  ddrho1_tmp*0.5d0 ;  ddrho2 =  ddrho1
      if (rho1 < rhomin) then
           rho1 = rhomin ;   rho2 = rho1
          drho1 =   0.d0 ;  drho2 = 0.d0
         ddrho1 =   0.d0 ; ddrho2 = 0.d0
      end if
      r = rpos(ir)
      select case (is_pcc)
      case (PCC,FCC)
         call gga_pbe96_spherical(imode, &
                 r,rho1,rho2,drho1,drho2,ddrho1,ddrho2, &
                 ex_tmp,ec_tmp,vx_tmp,vc_tmp)
      case (NONE)
         ex_tmp = 0.d0
         ec_tmp = 0.d0
         vx_tmp(:) = 0.d0
         vc_tmp(:) = 0.d0
      end select
      expc_ss(ir) = ex_tmp
      ecpc_ss(ir) = ec_tmp
      if (max(rho1,rho2) < eps_chg) then
         ecpc_ss(ir) = 0.d0
      end if
      do ispin = 1,nspin_ss
         vxpc_ss(ir,ispin) = vx_tmp(ispin)
         vcpc_ss(ir,ispin) = vc_tmp(ispin)
      end do
      if (rho1 < eps_chg) then
         vcpc_ss(ir,1) = 0.d0
      end if
      if ((rho2 < eps_chg).and.(nspin_ss == 2)) then
         vcpc_ss(ir,2) = 0.d0
      end if
   end do
   end subroutine calc_xc_gga_pbe96_ss

!=====================================================================
   subroutine calc_xc_gga_pbe96_rad_sol(ier,imode)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(in)  :: imode
   integer,intent(out) :: ier
   ier = 0
   select case (is_pcc)

! ====================================== modified by K. T. ============= 4.0
!   case (NONE)
!       rho1_rad(:) =  rho_sol(:) * 0.5d0
!      drho1_rad(:) = drho_sol(:) * 0.5d0
!   case (PCC)
!       rho1_rad(:) = ( rho_sol(:) +  rho_pcore(:)) * 0.5d0
!      drho1_rad(:) = (drho_sol(:) + drho_pcore(:)) * 0.5d0
!   case (FCC)
!       rho1_rad(:) = ( rho_sol(:) +  rho_core(:)) * 0.5d0
!      drho1_rad(:) = (drho_sol(:) + drho_core(:)) * 0.5d0
!   end select
!
   case (NONE)
       rho1_rad(:) =  rho_sol(:,1) * 0.5d0
      drho1_rad(:) = drho_sol(:,1) * 0.5d0
   case (PCC)
       rho1_rad(:) = ( rho_sol(:,1) +  rho_pcore(:)) * 0.5d0
      drho1_rad(:) = (drho_sol(:,1) + drho_pcore(:)) * 0.5d0
   case (FCC)
       rho1_rad(:) = ( rho_sol(:,1) +  rho_core(:)) * 0.5d0
      drho1_rad(:) = (drho_sol(:,1) + drho_core(:)) * 0.5d0
   end select
! ================================================================== 4.0

    rho2_rad(:) =  rho1_rad(:)
   drho2_rad(:) = drho1_rad(:)
   call gga_fxc_rmesh( &
      ier,IFLOG,imode+1,iord_diff,nmesh,1,               &
      rpos,wr,rho1_rad,rho2_rad,drho1_rad,drho2_rad,     &
      fx_rad,fc_rad,dfx_rad,dfc_rad,dfxda_rad,dfcda_rad, &
      vx_sol,vc_sol,ex_sol,ec_sol,ex_sum_sol,ec_sum_sol)
   if (ier /= 0) then
      write(IFLOG,*) '### ERROR ### in gga_fxc_rmesh' ; go to 99
   end if
   select case (is_pcc)
   case (NONE)
       rho1_rad(:) = 0.d0
      drho1_rad(:) = 0.d0
   case (PCC)
       rho1_rad(:) =  rho_pcore(:) * 0.5d0
      drho1_rad(:) = drho_pcore(:) * 0.5d0
   case (FCC)
       rho1_rad(:) =  rho_core(:) * 0.5d0
      drho1_rad(:) = drho_core(:) * 0.5d0
   end select
    rho2_rad(:) =  rho1_rad(:)
   drho2_rad(:) = drho1_rad(:)
   if (is_pcc == NONE) then
      vxpc_sol(:)  = 0.d0 ; vcpc_sol(:)  = 0.d0
      expc_sol(:)  = 0.d0 ; ecpc_sol(:)  = 0.d0
      expc_sum_sol = 0.d0 ; ecpc_sum_sol = 0.d0
   else
      call gga_fxc_rmesh( &
         ier,IFLOG,imode+1,iord_diff,nmesh,1,               &
         rpos,wr,rho1_rad,rho2_rad,drho1_rad,drho2_rad,     &
         fx_rad,fc_rad,dfx_rad,dfc_rad,dfxda_rad,dfcda_rad, &
         vxpc_sol,vcpc_sol,expc_sol,ecpc_sol,               &
         expc_sum_sol,ecpc_sum_sol)
      expc_sum_sol = - expc_sum_sol
      ecpc_sum_sol = - ecpc_sum_sol
      if (ier /= 0) then
         write(IFLOG,*) '### ERROR ### in gga_fxc_rmesh' ; go to 99
      end if
   end if
99 continue
   end subroutine calc_xc_gga_pbe96_rad_sol

!======================================= added by K. T. ================== 4.0
subroutine calc_xc_gga_pbe96_rad_sol_kt(ier,imode)
  use parameters
  implicit none
  integer,intent(in)  :: imode
  integer,intent(out) :: ier

  ier = 0

  if ( nspin == 1 ) then

     select case (is_pcc)
     case (NONE)
         rho1_rad(:) =  rho_sol(:,1) * 0.5d0
        drho1_rad(:) = drho_sol(:,1) * 0.5d0
     case (PCC)
         rho1_rad(:) = ( rho_sol(:,1) +  rho_pcore(:)) * 0.5d0
        drho1_rad(:) = (drho_sol(:,1) + drho_pcore(:)) * 0.5d0
     case (FCC)
         rho1_rad(:) = ( rho_sol(:,1) +  rho_core(:)) * 0.5d0
        drho1_rad(:) = (drho_sol(:,1) + drho_core(:)) * 0.5d0
     end select

      rho2_rad(:) =  rho1_rad(:)
     drho2_rad(:) = drho1_rad(:)

  else if ( nspin == 2 ) then

     select case (is_pcc)
     case (NONE)
         rho1_rad(:) =  rho_sol(:,1)
        drho1_rad(:) = drho_sol(:,1)
         rho2_rad(:) =  rho_sol(:,2)
        drho2_rad(:) = drho_sol(:,2)
     case (PCC)
         rho1_rad(:) =  rho_sol(:,1) +  rho_pcore(:)*0.5d0
        drho1_rad(:) = drho_sol(:,1) + drho_pcore(:)*0.5d0
         rho2_rad(:) =  rho_sol(:,2) +  rho_pcore(:)*0.5d0
        drho2_rad(:) = drho_sol(:,2) + drho_pcore(:)*0.5d0
     case (FCC)
         rho1_rad(:) =  rho_sol(:,1) +  rho_core(:)*0.5d0 
        drho1_rad(:) = drho_sol(:,1) + drho_core(:)*0.5d0
         rho2_rad(:) =  rho_sol(:,2) +  rho_core(:)*0.5d0 
        drho2_rad(:) = drho_sol(:,2) + drho_core(:)*0.5d0
     end select

  endif

  call gga_fxc_rmesh( &
       ier,IFLOG,imode+1,iord_diff,nmesh, nspin,               &
       rpos,wr,rho1_rad,rho2_rad,drho1_rad,drho2_rad,     &
       fx_rad,fc_rad,dfx_rad,dfc_rad,dfxda_rad,dfcda_rad, &
       vx_sol,vc_sol,ex_sol,ec_sol,ex_sum_sol,ec_sum_sol)

  if (ier /= 0) then
     write(IFLOG,*) '### ERROR ### in gga_fxc_rmesh' ; go to 99
  end if

  select case (is_pcc)
  case (NONE)
      rho1_rad(:) = 0.d0
     drho1_rad(:) = 0.d0
  case (PCC)
      rho1_rad(:) =  rho_pcore(:) * 0.5d0
     drho1_rad(:) = drho_pcore(:) * 0.5d0
  case (FCC)
      rho1_rad(:) =  rho_core(:) * 0.5d0
     drho1_rad(:) = drho_core(:) * 0.5d0
  end select
  rho2_rad(:) =  rho1_rad(:)
  drho2_rad(:) = drho1_rad(:)

  if (is_pcc == NONE) then
     vxpc_sol(:)  = 0.d0 ; vcpc_sol(:)  = 0.d0
     expc_sol(:)  = 0.d0 ; ecpc_sol(:)  = 0.d0
     expc_sum_sol = 0.d0 ; ecpc_sum_sol = 0.d0

  else
     call gga_fxc_rmesh( &
          ier,IFLOG,imode+1,iord_diff,nmesh,1,               &
          rpos,wr,rho1_rad,rho2_rad,drho1_rad,drho2_rad,     &
          fx_rad,fc_rad,dfx_rad,dfc_rad,dfxda_rad,dfcda_rad, &
          vxpc_sol,vcpc_sol,expc_sol,ecpc_sol,               &
          expc_sum_sol,ecpc_sum_sol)
     expc_sum_sol = - expc_sum_sol
     ecpc_sum_sol = - ecpc_sum_sol
     
     if (ier /= 0) then
        write(IFLOG,*) '### ERROR ### in gga_fxc_rmesh' ; go to 99
     end if
  end if

99 continue

end subroutine calc_xc_gga_pbe96_rad_sol_kt
! =========================================================================== 4.0

!=====================================================================
   subroutine calc_xc_gga_pbe96_rad_ss(ier,imode)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(in)  :: imode
   integer,intent(out) :: ier
   ier = 0
   if (is_spin_ss == POLARIZED) then
      select case (is_pcc)
      case (NONE)
          rho1_rad(:) =  rho_ss(:,1)
         drho1_rad(:) = drho_ss(:,1)
          rho2_rad(:) =  rho_ss(:,2)
         drho2_rad(:) = drho_ss(:,2)
      case (PCC)
          rho1_rad(:) =  rho_ss(:,1) +  rho_pcore(:) * 0.5d0
         drho1_rad(:) = drho_ss(:,1) + drho_pcore(:) * 0.5d0
          rho2_rad(:) =  rho_ss(:,2) +  rho_pcore(:) * 0.5d0
         drho2_rad(:) = drho_ss(:,2) + drho_pcore(:) * 0.5d0
      case (FCC)
          rho1_rad(:) =  rho_ss(:,1) +  rho_core(:) * 0.5d0
         drho1_rad(:) = drho_ss(:,1) + drho_core(:) * 0.5d0
          rho2_rad(:) =  rho_ss(:,2) +  rho_core(:) * 0.5d0
         drho2_rad(:) = drho_ss(:,2) + drho_core(:) * 0.5d0
      end select
   else
      select case (is_pcc)
      case (NONE)
          rho1_rad(:) =  rho_ss(:,1) * 0.5d0
         drho1_rad(:) = drho_ss(:,1) * 0.5d0
      case (PCC)
          rho1_rad(:) = ( rho_ss(:,1) +  rho_pcore(:)) * 0.5d0
         drho1_rad(:) = (drho_ss(:,1) + drho_pcore(:)) * 0.5d0
      case (FCC)
          rho1_rad(:) = ( rho_ss(:,1) +  rho_core(:)) * 0.5d0
         drho1_rad(:) = (drho_ss(:,1) + drho_core(:)) * 0.5d0
      end select
       rho2_rad(:) =  rho1_rad(:)
      drho2_rad(:) = drho1_rad(:)
   end if
   call gga_fxc_rmesh( &
      ier,IFLOG,imode+1,iord_diff,nmesh,nspin_ss,        &
      rpos,wr,rho1_rad,rho2_rad,drho1_rad,drho2_rad,     &
      fx_rad,fc_rad,dfx_rad,dfc_rad,dfxda_rad,dfcda_rad, &
      vx_ss,vc_ss,ex_ss,ec_ss,ex_sum_ss,ec_sum_ss)
   if (ier /= 0) then
      write(IFLOG,*) '### ERROR ### in gga_fxc_rmesh' ; go to 99
   end if
   select case (is_pcc)
   case (NONE)
       rho1_rad(:) = 0.d0
      drho1_rad(:) = 0.d0
   case (PCC)
       rho1_rad(:) =  rho_pcore(:) * 0.5d0
      drho1_rad(:) = drho_pcore(:) * 0.5d0
   case (FCC)
       rho1_rad(:) =  rho_core(:) * 0.5d0
      drho1_rad(:) = drho_core(:) * 0.5d0
   end select
    rho2_rad(:) =  rho1_rad(:)
   drho2_rad(:) = drho1_rad(:)
   if (is_pcc == NONE) then
      vxpc_ss(:,:) = 0.d0 ; vcpc_ss(:,:) = 0.d0
      expc_ss(:)   = 0.d0 ; ecpc_ss(:)   = 0.d0
      expc_sum_ss  = 0.d0 ; ecpc_sum_ss  = 0.d0      
   else
      call gga_fxc_rmesh( &
         ier,IFLOG,imode+1,iord_diff,nmesh,nspin_ss,        &
         rpos,wr,rho1_rad,rho2_rad,drho1_rad,drho2_rad,     &
         fx_rad,fc_rad,dfx_rad,dfc_rad,dfxda_rad,dfcda_rad, &
         vxpc_ss,vcpc_ss,expc_ss,ecpc_ss,                   &
         expc_sum_ss,ecpc_sum_ss)
      expc_sum_ss = - expc_sum_ss
      ecpc_sum_ss = - ecpc_sum_ss
      if (ier /= 0) then
         write(IFLOG,*) '### ERROR ### in gga_fxc_rmesh' ; go to 99
      end if
   end if
99 continue
   end subroutine calc_xc_gga_pbe96_rad_ss

!=====================================================================
   subroutine calc_xc_gga_pw91_rad_sol(ier)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   ier = 0
   select case (is_pcc)

! ===================================== modified by K. T. ================ 4.0
!   case (NONE)
!       rho1_rad(:) =  rho_sol(:) * 0.5d0
!      drho1_rad(:) = drho_sol(:) * 0.5d0
!   case (PCC)
!       rho1_rad(:) = ( rho_sol(:) +  rho_pcore(:)) * 0.5d0
!      drho1_rad(:) = (drho_sol(:) + drho_pcore(:)) * 0.5d0
!   case (FCC)
!       rho1_rad(:) = ( rho_sol(:) +  rho_core(:)) * 0.5d0
!      drho1_rad(:) = (drho_sol(:) + drho_core(:)) * 0.5d0
!   end select
!
   case (NONE)
       rho1_rad(:) =  rho_sol(:,1) * 0.5d0
      drho1_rad(:) = drho_sol(:,1) * 0.5d0
   case (PCC)
       rho1_rad(:) = ( rho_sol(:,1) +  rho_pcore(:)) * 0.5d0
      drho1_rad(:) = (drho_sol(:,1) + drho_pcore(:)) * 0.5d0
   case (FCC)
       rho1_rad(:) = ( rho_sol(:,1) +  rho_core(:)) * 0.5d0
      drho1_rad(:) = (drho_sol(:,1) + drho_core(:)) * 0.5d0
   end select
! ===================================================================== 4.0


    rho2_rad(:) =  rho1_rad(:)
   drho2_rad(:) = drho1_rad(:)
   call gga_fxc_rmesh( &
      ier,IFLOG,3,iord_diff,nmesh,1,                     &
      rpos,wr,rho1_rad,rho2_rad,drho1_rad,drho2_rad,     &
      fx_rad,fc_rad,dfx_rad,dfc_rad,dfxda_rad,dfcda_rad, &
      vx_sol,vc_sol,ex_sol,ec_sol,ex_sum_sol,ec_sum_sol)
   if (ier /= 0) then
      write(IFLOG,*) '### ERROR ### in gga_fxc_rmesh' ; go to 99
   end if
   select case (is_pcc)
   case (NONE)
       rho1_rad(:) = 0.d0
      drho1_rad(:) = 0.d0
   case (PCC)
       rho1_rad(:) =  rho_pcore(:) * 0.5d0
      drho1_rad(:) = drho_pcore(:) * 0.5d0
   case (FCC)
       rho1_rad(:) =  rho_core(:) * 0.5d0
      drho1_rad(:) = drho_core(:) * 0.5d0
   end select
    rho2_rad(:) =  rho1_rad(:)
   drho2_rad(:) = drho1_rad(:)
   if (is_pcc == NONE) then
      vxpc_sol(:)  = 0.d0 ; vcpc_sol(:)  = 0.d0
      expc_sol(:)  = 0.d0 ; ecpc_sol(:)  = 0.d0
      expc_sum_sol = 0.d0 ; ecpc_sum_sol = 0.d0
   else
      call gga_fxc_rmesh( &
         ier,IFLOG,3,iord_diff,nmesh,1,                     &
         rpos,wr,rho1_rad,rho2_rad,drho1_rad,drho2_rad,     &
         fx_rad,fc_rad,dfx_rad,dfc_rad,dfxda_rad,dfcda_rad, &
         vxpc_sol,vcpc_sol,expc_sol,ecpc_sol,               &
         expc_sum_sol,ecpc_sum_sol)
         expc_sum_sol = - expc_sum_sol
         ecpc_sum_sol = - ecpc_sum_sol
      if (ier /= 0) then
         write(IFLOG,*) '### ERROR ### in gga_fxc_rmesh' ; go to 99
      end if
   end if
99 continue
   end subroutine calc_xc_gga_pw91_rad_sol

! ================================================== added by K. T. ============= 4.0
subroutine calc_xc_gga_pw91_rad_sol_kt(ier)
  use parameters
  implicit none

  integer,intent(out) :: ier
  integer :: ispin

  ier = 0

  if ( nspin == 1 ) then

     select case (is_pcc)

     case (NONE)
         rho1_rad(:) =  rho_sol(:,1) * 0.5d0
        drho1_rad(:) = drho_sol(:,1) * 0.5d0
     case (PCC)
         rho1_rad(:) = ( rho_sol(:,1) +  rho_pcore(:)) * 0.5d0
        drho1_rad(:) = (drho_sol(:,1) + drho_pcore(:)) * 0.5d0
     case (FCC)
         rho1_rad(:) = ( rho_sol(:,1) +  rho_core(:)) * 0.5d0
        drho1_rad(:) = (drho_sol(:,1) + drho_core(:)) * 0.5d0
     end select

      rho2_rad(:) =  rho1_rad(:)
     drho2_rad(:) = drho1_rad(:)
 
  else if ( nspin == 2 ) then

     select case (is_pcc)

     case (NONE)
         rho1_rad(:) =  rho_sol(:,1)
        drho1_rad(:) = drho_sol(:,1)
         rho2_rad(:) =  rho_sol(:,2)
        drho2_rad(:) = drho_sol(:,2)
     case (PCC)
         rho1_rad(:) =   rho_sol(:,1) +  rho_pcore(:)*0.5d0
        drho1_rad(:) =  drho_sol(:,1) + drho_pcore(:)*0.5d0
         rho2_rad(:) =   rho_sol(:,2) +  rho_pcore(:)*0.5d0
        drho2_rad(:) =  drho_sol(:,2) + drho_pcore(:)*0.5d0
     case (FCC)
         rho1_rad(:) =   rho_sol(:,1) +  rho_core(:)*0.5d0
        drho1_rad(:) =  drho_sol(:,1) + drho_core(:)*0.5d0
         rho2_rad(:) =   rho_sol(:,2) +  rho_core(:)*0.5d0
        drho2_rad(:) =  drho_sol(:,2) + drho_core(:)*0.5d0
     end select

  endif

  call gga_fxc_rmesh( &
       ier,IFLOG,3,iord_diff,nmesh, nspin,                     &
       rpos,wr,rho1_rad,rho2_rad,drho1_rad,drho2_rad,     &
       fx_rad,fc_rad,dfx_rad,dfc_rad,dfxda_rad,dfcda_rad, &
       vx_sol,vc_sol,ex_sol,ec_sol,ex_sum_sol,ec_sum_sol)

  if (ier /= 0) then
     write(IFLOG,*) '### ERROR ### in gga_fxc_rmesh' ; go to 99
  end if

  select case (is_pcc)
  case (NONE)
      rho1_rad(:) = 0.d0
     drho1_rad(:) = 0.d0
  case (PCC)
      rho1_rad(:) =  rho_pcore(:) * 0.5d0
     drho1_rad(:) = drho_pcore(:) * 0.5d0
  case (FCC)
      rho1_rad(:) =  rho_core(:) * 0.5d0
     drho1_rad(:) = drho_core(:) * 0.5d0
  end select

   rho2_rad(:) =  rho1_rad(:)
  drho2_rad(:) = drho1_rad(:)

  if (is_pcc == NONE) then
     vxpc_sol(:)  = 0.d0 ; vcpc_sol(:)  = 0.d0
     expc_sol(:)  = 0.d0 ; ecpc_sol(:)  = 0.d0
     expc_sum_sol = 0.d0 ; ecpc_sum_sol = 0.d0
  else
     call gga_fxc_rmesh( &
          ier,IFLOG,3,iord_diff,nmesh,1,                     &
          rpos,wr,rho1_rad,rho2_rad,drho1_rad,drho2_rad,     &
          fx_rad,fc_rad,dfx_rad,dfc_rad,dfxda_rad,dfcda_rad, &
          vxpc_sol,vcpc_sol,expc_sol,ecpc_sol,               &
          expc_sum_sol,ecpc_sum_sol)
     expc_sum_sol = - expc_sum_sol
     ecpc_sum_sol = - ecpc_sum_sol

     if (ier /= 0) then
        write(IFLOG,*) '### ERROR ### in gga_fxc_rmesh' ; go to 99
     end if
  end if

99 continue

end subroutine calc_xc_gga_pw91_rad_sol_kt
! ========================================================================== 4.0

!=====================================================================
   subroutine calc_xc_gga_pw91_rad_ss(ier)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   ier = 0
   if (is_spin_ss == POLARIZED) then
      select case (is_pcc)
      case (NONE)
          rho1_rad(:) =  rho_ss(:,1)
         drho1_rad(:) = drho_ss(:,1)
          rho2_rad(:) =  rho_ss(:,2)
         drho2_rad(:) = drho_ss(:,2)
      case (PCC)
          rho1_rad(:) =  rho_ss(:,1) +  rho_pcore(:) * 0.5d0
         drho1_rad(:) = drho_ss(:,1) + drho_pcore(:) * 0.5d0
          rho2_rad(:) =  rho_ss(:,2) +  rho_pcore(:) * 0.5d0
         drho2_rad(:) = drho_ss(:,2) + drho_pcore(:) * 0.5d0
      case (FCC)
          rho1_rad(:) =  rho_ss(:,1) +  rho_core(:) * 0.5d0
         drho1_rad(:) = drho_ss(:,1) + drho_core(:) * 0.5d0
          rho2_rad(:) =  rho_ss(:,2) +  rho_core(:) * 0.5d0
         drho2_rad(:) = drho_ss(:,2) + drho_core(:) * 0.5d0
      end select
   else
      select case (is_pcc)
      case (NONE)
          rho1_rad(:) =  rho_ss(:,1) * 0.5d0
         drho1_rad(:) = drho_ss(:,1) * 0.5d0
      case (PCC)
          rho1_rad(:) = ( rho_ss(:,1) +  rho_pcore(:)) * 0.5d0
         drho1_rad(:) = (drho_ss(:,1) + drho_pcore(:)) * 0.5d0
      case (FCC)
          rho1_rad(:) = ( rho_ss(:,1) +  rho_core(:)) * 0.5d0
         drho1_rad(:) = (drho_ss(:,1) + drho_core(:)) * 0.5d0
      end select
       rho2_rad(:) =  rho1_rad(:)
      drho2_rad(:) = drho1_rad(:)
   end if
   call gga_fxc_rmesh( &
      ier,IFLOG,3,iord_diff,nmesh,nspin_ss,              &
      rpos,wr,rho1_rad,rho2_rad,drho1_rad,drho2_rad,     &
      fx_rad,fc_rad,dfx_rad,dfc_rad,dfxda_rad,dfcda_rad, &
      vx_ss,vc_ss,ex_ss,ec_ss,ex_sum_ss,ec_sum_ss)
   if (ier /= 0) then
      write(IFLOG,*) '### ERROR ### in gga_fxc_rmesh' ; go to 99
   end if
   select case (is_pcc)
   case (NONE)
       rho1_rad(:) = 0.d0
      drho1_rad(:) = 0.d0
   case (PCC)
       rho1_rad(:) =  rho_pcore(:) * 0.5d0
      drho1_rad(:) = drho_pcore(:) * 0.5d0
   case (FCC)
       rho1_rad(:) =  rho_core(:) * 0.5d0
      drho1_rad(:) = drho_core(:) * 0.5d0
   end select
    rho2_rad(:) =  rho1_rad(:)
   drho2_rad(:) = drho1_rad(:)
   if (is_pcc == NONE) then
      vxpc_ss(:,:) = 0.d0 ; vcpc_ss(:,:) = 0.d0
      expc_ss(:)   = 0.d0 ; ecpc_ss(:)   = 0.d0
      expc_sum_ss  = 0.d0 ; ecpc_sum_ss  = 0.d0      
   else
      call gga_fxc_rmesh( &
         ier,IFLOG,3,iord_diff,nmesh,nspin_ss,              &
         rpos,wr,rho1_rad,rho2_rad,drho1_rad,drho2_rad,     &
         fx_rad,fc_rad,dfx_rad,dfc_rad,dfxda_rad,dfcda_rad, &
         vxpc_ss,vcpc_ss,expc_ss,ecpc_ss,                   &
         expc_sum_ss,ecpc_sum_ss)
      expc_sum_ss = - expc_sum_ss
      ecpc_sum_ss = - ecpc_sum_ss
      if (ier /= 0) then
         write(IFLOG,*) '### ERROR ### in gga_fxc_rmesh' ; go to 99
      end if
   end if
99 continue
   end subroutine calc_xc_gga_pw91_rad_ss

!=====================================================================
   subroutine calc_x_lda_sol(ier)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer :: ir
   real(8) :: rho1, rho2, rho1_tmp, &
              ex_tmp, ec_tmp, vx_tmp(2), vc_tmp(2)
   ier = 0
   do ir = 1,nmesh
      select case (is_pcc)

! ========================================== modified by K. T. ============ 4.0
!      case (NONE)
!         rho1_tmp = rho_sol(ir)
!      case (PCC)
!         rho1_tmp = rho_sol(ir) + rho_pcore(ir)
!      case (FCC)
!         rho1_tmp = rho_sol(ir) + rho_core(ir)
!      end select
!
      case (NONE)
         rho1_tmp = rho_sol(ir,1)
      case (PCC)
         rho1_tmp = rho_sol(ir,1) + rho_pcore(ir)
      case (FCC)
         rho1_tmp = rho_sol(ir,1) + rho_core(ir)
      end select
! ======================================================================== 4.0

      rho1 = rho1_tmp*0.5d0 ; rho2 = rho1
      call lda_x(rho1,rho2,ex_tmp,ec_tmp,vx_tmp,vc_tmp)
      ex_sol(ir) = ex_tmp
      ec_sol(ir) = ec_tmp

! ========================================== modified by K. T. ============= 4.0
!      vx_sol(ir) = vx_tmp(1)
!      vc_sol(ir) = vc_tmp(1)
      vx_sol(ir,1) = vx_tmp(1)
      vc_sol(ir,1) = vc_tmp(1)
! =========================================================================== 4.0
   end do
   end subroutine calc_x_lda_sol

!=============================================== added by K. T. ============== 4.0
subroutine calc_x_lda_sol_kt(ier)
  use parameters
  implicit none

  integer,intent(out) :: ier
  integer :: ir, ispin
  real(8) :: rho1, rho2, rho_tmp(2), &
       ex_tmp, ec_tmp, vx_tmp(2), vc_tmp(2)

  ier = 0

  do ir = 1,nmesh

     Do ispin=1, nspin

        select case (is_pcc)

        case (NONE)
           rho_tmp(ispin) = rho_sol(ir,ispin)
        case (PCC)
           rho_tmp(ispin) = rho_sol(ir,ispin) + rho_pcore(ir)/dble(nspin)
        case (FCC)
           rho_tmp(ispin) = rho_sol(ir,ispin) + rho_core(ir)/dble(nspin)
        end select
     End do

     if ( nspin == 1 ) then
        rho1 = rho_tmp(1)*0.5d0 ;   rho2 = rho1
     else if ( nspin == 2 ) then
        rho1 = rho_tmp(1);    rho2 = rho_tmp(2)
     endif

     call lda_x(rho1,rho2,ex_tmp,ec_tmp,vx_tmp,vc_tmp)

     ex_sol(ir) = ex_tmp
     ec_sol(ir) = ec_tmp

     Do ispin=1, nspin
        vx_sol(ir,ispin) = vx_tmp(ispin)
        vc_sol(ir,ispin) = vc_tmp(ispin)
     End do
     
  end do

end subroutine calc_x_lda_sol_kt
! =========================================================================== 4.0

!=====================================================================
   subroutine calc_x_lda_ss(ier)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer :: ir, ispin
   real(8) :: rho1, rho2, rho1_tmp, &
              ex_tmp, ec_tmp, vx_tmp(2), vc_tmp(2)
   ier = 0
   do ir = 1,nmesh
      select case (is_spin_ss)
      case (RESTRICTED)
         select case (is_pcc)
         case (NONE)
            rho1_tmp = rho_ss(ir,1)
         case (PCC)
            rho1_tmp = rho_ss(ir,1) + rho_pcore(ir)
         case (FCC)
            rho1_tmp = rho_ss(ir,1) + rho_core(ir)
         end select
         rho1 = rho1_tmp*0.5d0 ; rho2 = rho1
      case (POLARIZED)
         select case (is_pcc)
         case (NONE)
            rho1 = rho_ss(ir,1) ; rho2 = rho_ss(ir,2)
         case (PCC)
            rho1 = rho_ss(ir,1) + rho_pcore(ir)*0.5d0
            rho2 = rho_ss(ir,2) + rho_pcore(ir)*0.5d0
         case (FCC)
            rho1 = rho_ss(ir,1) + rho_core(ir)*0.5d0
            rho2 = rho_ss(ir,2) + rho_core(ir)*0.5d0
         end select
      end select
      call lda_x(rho1,rho2,ex_tmp,ec_tmp,vx_tmp,vc_tmp)
      ex_ss(ir) = ex_tmp
      ec_ss(ir) = ec_tmp
      do ispin = 1,nspin_ss
         vx_ss(ir,ispin) = vx_tmp(ispin)
         vc_ss(ir,ispin) = vc_tmp(ispin)
      end do
   end do
   end subroutine calc_x_lda_ss

!=====================================================================
   subroutine calc_x_gga_sol(ier)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer :: ir
   real(8) :: r, rho1, rho2, &
              drho1, drho2, ddrho1, ddrho2, &
              rho1_tmp, &
              drho1_tmp, ddrho1_tmp, &
              ex_tmp, ec_tmp, vx_tmp(2), vc_tmp(2), &
              rhomin = 1.d-25
   ier = 0
   do ir = 1,nmesh
      select case (is_pcc)

! ======================================= modified by K. T. ============== 4.0
!      case (NONE)
!           rho1_tmp =   rho_sol(ir)
!          drho1_tmp =  drho_sol(ir)
!         ddrho1_tmp = ddrho_sol(ir)
!      case (PCC)
!           rho1_tmp =   rho_sol(ir) +   rho_pcore(ir)
!          drho1_tmp =  drho_sol(ir) +  drho_pcore(ir)
!         ddrho1_tmp = ddrho_sol(ir) + ddrho_pcore(ir)
!      case (FCC)
!           rho1_tmp =   rho_sol(ir) +   rho_core(ir)
!          drho1_tmp =  drho_sol(ir) +  drho_core(ir)
!         ddrho1_tmp = ddrho_sol(ir) + ddrho_core(ir)
!      end select
!
      case (NONE)
           rho1_tmp =   rho_sol(ir,1)
          drho1_tmp =  drho_sol(ir,1)
         ddrho1_tmp = ddrho_sol(ir,1)
      case (PCC)
           rho1_tmp =   rho_sol(ir,1) +   rho_pcore(ir)
          drho1_tmp =  drho_sol(ir,1) +  drho_pcore(ir)
         ddrho1_tmp = ddrho_sol(ir,1) + ddrho_pcore(ir)
      case (FCC)
           rho1_tmp =   rho_sol(ir,1) +   rho_core(ir)
          drho1_tmp =  drho_sol(ir,1) +  drho_core(ir)
         ddrho1_tmp = ddrho_sol(ir,1) + ddrho_core(ir)
      end select
! ===================================================================== 4.0

        rho1 =    rho1_tmp*0.5d0 ;    rho2 =    rho1
       drho1 =   drho1_tmp*0.5d0 ;   drho2 =   drho1
      ddrho1 =  ddrho1_tmp*0.5d0 ;  ddrho2 =  ddrho1
      if (rho1 < rhomin) then
           rho1 = rhomin ;   rho2 = rho1
          drho1 =   0.d0 ;  drho2 = 0.d0
         ddrho1 =   0.d0 ; ddrho2 = 0.d0
      end if
      r = rpos(ir)
      call gga_x(r,rho1,rho2,drho1,drho2,ddrho1,ddrho2, &
                 ex_tmp,ec_tmp,vx_tmp,vc_tmp)
      ex_sol(ir) = ex_tmp
      ec_sol(ir) = ec_tmp

! =============================================== modified by K. T. ========= 4.0
!      vx_sol(ir) = vx_tmp(1)
!      vc_sol(ir) = vc_tmp(1)
      vx_sol(ir,1) = vx_tmp(1)
      vc_sol(ir,1) = vc_tmp(1)
! =========================================================================== 4.0
   end do
   end subroutine calc_x_gga_sol

!==================================================== added by K. T. ============ 4.0
subroutine calc_x_gga_sol_kt(ier)
  use parameters
  implicit none

  integer,intent(out) :: ier
  integer :: ir, ispin
  real(8) :: r, rho1, rho2, &
       drho1, drho2, ddrho1, ddrho2, &
       rho_tmp(2), &
       drho_tmp(2), ddrho_tmp(2), &
       ex_tmp, ec_tmp, vx_tmp(2), vc_tmp(2), &
       rhomin = 1.d-25
  ier = 0

  do ir = 1,nmesh

     Do ispin=1, nspin

        select case (is_pcc)

        case (NONE)
             rho_tmp(ispin) =   rho_sol(ir,ispin)
            drho_tmp(ispin) =  drho_sol(ir,ispin)
           ddrho_tmp(ispin) = ddrho_sol(ir,ispin)
        case (PCC)
             rho_tmp(ispin) =   rho_sol(ir,ispin) +   rho_pcore(ir)/dble(nspin)
            drho_tmp(ispin) =  drho_sol(ir,ispin) +  drho_pcore(ir)/dble(nspin)
           ddrho_tmp(ispin) = ddrho_sol(ir,ispin) + ddrho_pcore(ir)/dble(nspin)
        case (FCC)
             rho_tmp(ispin) =   rho_sol(ir,ispin) +   rho_core(ir)/dble(nspin)
            drho_tmp(ispin) =  drho_sol(ir,ispin) +  drho_core(ir)/dble(nspin)
           ddrho_tmp(ispin) = ddrho_sol(ir,ispin) + ddrho_core(ir)/dble(nspin)
        end select
        
     End do

     if ( nspin == 1 ) then
          rho1 =    rho_tmp(1)*0.5d0 ;    rho2 =    rho1
         drho1 =   drho_tmp(1)*0.5d0 ;   drho2 =   drho1
        ddrho1 =  ddrho_tmp(1)*0.5d0 ;  ddrho2 =  ddrho1

        if (rho1 < rhomin) then
             rho1 = rhomin ;   rho2 = rho1
            drho1 =   0.d0 ;  drho2 = 0.d0
           ddrho1 =   0.d0 ; ddrho2 = 0.d0
        endif
        
     else if ( nspin == 2 ) then
          rho1 =    rho_tmp(1);    rho2 =    rho_tmp(2)
         drho1 =   drho_tmp(1);   drho2 =   drho_tmp(2)
        ddrho1 =  ddrho_tmp(1);  ddrho2 =  ddrho_tmp(2)

        if (rho1 < rhomin) then
           rho1 = rhomin ;    drho1 =   0.d0 ;     ddrho1 =   0.d0
        endif
        if (rho2 < rhomin) then
           rho2 = rhomin ;    drho2 =   0.d0 ;     ddrho2 =   0.d0
        endif

     end if
     
     r = rpos(ir)
     call gga_x(r,rho1,rho2,drho1,drho2,ddrho1,ddrho2, &
          ex_tmp,ec_tmp,vx_tmp,vc_tmp)

     ex_sol(ir) = ex_tmp
     ec_sol(ir) = ec_tmp

     Do ispin=1, nspin
        vx_sol(ir,ispin) = vx_tmp(ispin)
        vc_sol(ir,ispin) = vc_tmp(ispin)
     End do

  end do

end subroutine calc_x_gga_sol_kt
! =========================================================================== 4.0

!=====================================================================
   subroutine calc_x_gga_ss(ier)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer :: ir, ispin
   real(8) :: r, rho1, rho2, &
              drho1, drho2, ddrho1, ddrho2, &
              rho1_tmp, &
              drho1_tmp, ddrho1_tmp, &
              ex_tmp, ec_tmp, vx_tmp(2), vc_tmp(2), &
              rhomin = 1.d-25
   ier = 0
   do ir = 1,nmesh
      select case (is_spin_ss)
      case (RESTRICTED)
         select case (is_pcc)
         case (NONE)
              rho1_tmp =   rho_ss(ir,1)
             drho1_tmp =  drho_ss(ir,1)
            ddrho1_tmp = ddrho_ss(ir,1)
         case (PCC)
              rho1_tmp =   rho_ss(ir,1) +   rho_pcore(ir)
             drho1_tmp =  drho_ss(ir,1) +  drho_pcore(ir)
            ddrho1_tmp = ddrho_ss(ir,1) + ddrho_pcore(ir)
         case (FCC)
              rho1_tmp =   rho_ss(ir,1) +   rho_core(ir)
             drho1_tmp =  drho_ss(ir,1) +  drho_core(ir)
            ddrho1_tmp = ddrho_ss(ir,1) + ddrho_core(ir)
         end select
           rho1 =    rho1_tmp*0.5d0 ;    rho2 =    rho1
          drho1 =   drho1_tmp*0.5d0 ;   drho2 =   drho1
         ddrho1 =  ddrho1_tmp*0.5d0 ;  ddrho2 =  ddrho1
         if (rho1 < rhomin) then
              rho1 = rhomin ;   rho2 = rho1
             drho1 =   0.d0 ;  drho2 = 0.d0
            ddrho1 =   0.d0 ; ddrho2 = 0.d0
         end if
      case (POLARIZED)
         select case (is_pcc)
         case (NONE)
              rho1 =   rho_ss(ir,1) ;   rho2 =   rho_ss(ir,2)
             drho1 =  drho_ss(ir,1) ;  drho2 =  drho_ss(ir,2)
            ddrho1 = ddrho_ss(ir,1) ; ddrho2 = ddrho_ss(ir,2)
         case (PCC)
              rho1 =   rho_ss(ir,1) +   rho_pcore(ir)*0.5d0
             drho1 =  drho_ss(ir,1) +  drho_pcore(ir)*0.5d0
            ddrho1 = ddrho_ss(ir,1) + ddrho_pcore(ir)*0.5d0
              rho2 =   rho_ss(ir,2) +   rho_pcore(ir)*0.5d0
             drho2 =  drho_ss(ir,2) +  drho_pcore(ir)*0.5d0
            ddrho2 = ddrho_ss(ir,2) + ddrho_pcore(ir)*0.5d0
         case (FCC)
              rho1 =   rho_ss(ir,1) +   rho_core(ir)*0.5d0
             drho1 =  drho_ss(ir,1) +  drho_core(ir)*0.5d0
            ddrho1 = ddrho_ss(ir,1) + ddrho_core(ir)*0.5d0
              rho2 =   rho_ss(ir,2) +   rho_core(ir)*0.5d0
             drho2 =  drho_ss(ir,2) +  drho_core(ir)*0.5d0
            ddrho2 = ddrho_ss(ir,2) + ddrho_core(ir)*0.5d0
         end select
      end select
      r = rpos(ir)
      call gga_x(r,rho1,rho2,drho1,drho2,ddrho1,ddrho2, &
                 ex_tmp,ec_tmp,vx_tmp,vc_tmp)
      ex_ss(ir) = ex_tmp
      ec_ss(ir) = ec_tmp
      do ispin = 1,nspin_ss
         vx_ss(ir,ispin) = vx_tmp(ispin)
         vc_ss(ir,ispin) = vc_tmp(ispin)
      end do
   end do
   end subroutine calc_x_gga_ss

!=====================================================================
   subroutine calc_xc_none_sol(ier)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   ier = 0
   ex_sol(:) = 0.d0
   ec_sol(:) = 0.d0

! ================================ modified by K. T. ================ 4.0
!   vx_sol(:) = 0.d0
!   vc_sol(:) = 0.d0
   vx_sol(:,:) = 0.d0
   vc_sol(:,:) = 0.d0
! =================================================================== 4.0

   end subroutine calc_xc_none_sol

!=====================================================================
   subroutine calc_xc_none_ss(ier)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   ier = 0
   ex_ss(:)   = 0.d0
   ec_ss(:)   = 0.d0
   vx_ss(:,:) = 0.d0
   vc_ss(:,:) = 0.d0
   end subroutine calc_xc_none_ss

!
!  Software name : CIAO (Code for Investigating Atomic Orbitals)
!  Subroutine(s) : calc_vh_sol, calc_vh_ss, calc_vxc_exc_sol
!                : calc_vxc_exc_ss, calc_dmat_ss,calc_vloc_ion_sol
!                : calc_vloc_scr_ss, write_sol, write_ss
!  Author(s)     : Masakuni Okamoto (August 25, 2003)
!
!
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!
!
!  The license of the code and contact address :
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)
!
!=====================================================================
   subroutine calc_vh_sol(ier)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer :: ir, ii, i0, is, j, jr
   real(8) :: sum1, sum2
   ier = 0
   do ir = 1,nmesh
      sum1 = 0.d0
      sum2 = 0.d0
      if (ir == 1) then
         sum1 = 0.d0
      else if ((ir >= 2).and.(ir <= 5)) then
         do ii = 2,ir
            i0 = ii-1
            is = 1
            call set_open_weight_exp(ier,i0,is,rpos,wt)
            do j = 1,4
               sum1 = sum1 &
! ================================================= modified by K. T. =========== 4.0
!                  + rpos(i0+j*is)**2*rho_sol(i0+j*is)*wt(i0+j*is)
                  + rpos(i0+j*is)**2*rho_sol(i0+j*is,1)*wt(i0+j*is)
! ============================================================================== 4.0
            end do
            
         end do
      else
         call set_weight_exp(ier,1,ir,rpos,wt)
         do jr = 1,ir
! ================================================== modified by K. T. ======== 4.0
!            sum1 = sum1 + rpos(jr)**2*rho_sol(jr)*wt(jr)
            sum1 = sum1 + rpos(jr)**2*rho_sol(jr,1)*wt(jr)
! ============================================================================== 4.0
         end do
      end if
      sum1 = sum1*(4.d0*PI/rpos(ir))
      if (ir == nmesh) then
            sum2 = 0.d0
      else if ((ir <= nmesh-1).and.(ir >= nmesh-4)) then
         do ii = ir,nmesh-1
            i0 = ii+1
            is = -1
            call set_open_weight_exp(ier,i0,is,rpos,wt)
            do j = 1,4
               sum2 = sum2 &
! ======================================================== modified by K. T. ======= 4.0
!                    - rpos(i0+j*is)**2*rho_sol(i0+j*is)*wt(i0+j*is)
                    - rpos(i0+j*is)**2*rho_sol(i0+j*is,1)*wt(i0+j*is)
! ============================================================================== 4.0
            end do
         end do
      else
         call set_weight_exp(ier,ir,nmesh,rpos,wt)
         do jr = ir,nmesh
! ==================================================== modified by K. T. ======= 4.0
!            sum2 = sum2 + rpos(jr)*rho_sol(jr)*wt(jr)
            sum2 = sum2 + rpos(jr)*rho_sol(jr,1)*wt(jr)
! ============================================================================== 4.0
         end do
      end if
      sum2 = sum2*(4.d0*PI)
      vh_sol(ir) = sum1 + sum2
   end do
99 continue
   end subroutine calc_vh_sol

! ==================================== added by K. T. ======================== 4.0
subroutine calc_vh_sol_kt(ier)
  use parameters
  implicit none

  integer,intent(out) :: ier
  integer :: ir, ii, i0, is, j, jr
  integer :: ispin

  real(8) :: sum1, sum2

  ier = 0
  do ir = 1,nmesh
     sum1 = 0.d0
     sum2 = 0.d0

     if (ir == 1) then
        sum1 = 0.d0
     else if ((ir >= 2).and.(ir <= 5)) then
        do ii = 2,ir
           i0 = ii-1
           is = 1
           
           call set_open_weight_exp(ier,i0,is,rpos,wt)
           
           do ispin = 1,nspin
              do j = 1,4
                 sum1 = sum1 &
                      & + rpos(i0+j*is)**2*rho_sol(i0+j*is,ispin)*wt(i0+j*is)
              end do
           end do
           
        end do

     else
        call set_weight_exp(ier,1,ir,rpos,wt)
        do jr = 1,ir

           do ispin = 1,nspin
              sum1 = sum1 + rpos(jr)**2*rho_sol(jr,ispin)*wt(jr)
           end do
        end do

     end if

     sum1 = sum1*(4.d0*PI/rpos(ir))

     if (ir == nmesh) then
        sum2 = 0.d0
     else if ((ir <= nmesh-1).and.(ir >= nmesh-4)) then
        do ii = ir,nmesh-1
           i0 = ii+1
           is = -1
           call set_open_weight_exp(ier,i0,is,rpos,wt)
           
           do ispin = 1,nspin
              do j = 1,4
                 sum2 = sum2 &
                      & - rpos(i0+j*is)**2*rho_sol(i0+j*is,ispin)*wt(i0+j*is)
              end do
           end do
        end do

     else
        call set_weight_exp(ier,ir,nmesh,rpos,wt)
        do jr = ir,nmesh

           do ispin=1, nspin
              sum2 = sum2 + rpos(jr)*rho_sol(jr,ispin)*wt(jr)
           end do
        end do
     end if

     sum2 = sum2*(4.d0*PI)
     vh_sol(ir) = sum1 + sum2

  end do

99 continue

end subroutine calc_vh_sol_kt
! ======================================================================= 4.0

!=====================================================================
   subroutine calc_vh_ss(ier)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer :: ir, ii, i0, is, j, jr, ispin
   real(8) :: sum1, sum2
   ier = 0
   do ir = 1,nmesh
      sum1 = 0.d0
      sum2 = 0.d0
      if (ir == 1) then
         sum1 = 0.d0
      else if ((ir >= 2).and.(ir <= 5)) then
         do ii = 2,ir
            i0 = ii-1
            is = 1
            call set_open_weight_exp(ier,i0,is,rpos,wt)
            do ispin = 1,nspin_ss
            do j = 1,4
               sum1 = sum1 &
                  + rpos(i0+j*is)**2*rho_ss(i0+j*is,ispin)*wt(i0+j*is)
            end do
            end do
         end do
      else
         call set_weight_exp(ier,1,ir,rpos,wt)
         do ispin = 1,nspin_ss
         do jr = 1,ir
            sum1 = sum1 + rpos(jr)**2*rho_ss(jr,ispin)*wt(jr)
         end do
         end do
      end if
      sum1 = sum1*(4.d0*PI/rpos(ir))
      if (ir == nmesh) then
            sum2 = 0.d0
      else if ((ir <= nmesh-1).and.(ir >= nmesh-4)) then
         do ii = ir,nmesh-1
            i0 = ii+1
            is = -1
            call set_open_weight_exp(ier,i0,is,rpos,wt)
            do ispin = 1,nspin_ss
            do j = 1,4
               sum2 = sum2 &
                    - rpos(i0+j*is)**2*rho_ss(i0+j*is,ispin)*wt(i0+j*is)
            end do
            end do
         end do
      else
         call set_weight_exp(ier,ir,nmesh,rpos,wt)
         do ispin = 1,nspin_ss
         do jr = ir,nmesh
            sum2 = sum2 + rpos(jr)*rho_ss(jr,ispin)*wt(jr)
         end do
         end do
      end if
      sum2 = sum2*(4.d0*PI)
      vh_ss(ir) = sum1 + sum2
   end do
99 continue
   end subroutine calc_vh_ss

!=====================================================================
   subroutine calc_vxc_exc_sol(ier)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer :: imode
   ier = 0
   select case (is_xc)
   case(LDAPZ81)
      call calc_xc_lda_pz81_sol(ier)
      if (ier /= 0) then
         write(IFLOG,*) '### ERROR ### in calc_xc_lda_pz81_sol'
         write(IFLOG,*) '   ier ...',ier ; go to 99
      end if
   case(LDAPW92_MOMO)
      call calc_xc_lda_pw92_sol(ier)
      if (ier /= 0) then
         write(IFLOG,*) '### ERROR ### in calc_xc_lda_pw92_sol'
         write(IFLOG,*) '   ier ...',ier ; go to 99
      end if
   case(LDAPW92_GNCPP, GGAPBE96_GNCPP, GGAPBE96_KATO, &
        GGAPW91_F90, GGAPW91_F77)
      ier = 1 ! call calc_xc_gga_gncpp_sol(ier)
      if (ier /= 0) then
         write(IFLOG,*) '### ERROR ### in calc_xc_gga_gncpp_sol'
         write(IFLOG,*) '   ier ...',ier ; go to 99
      end if
   case(GGAPBE96_MOMO)
      imode = 0
      call calc_xc_gga_pbe96_sol(ier,imode)
      if (ier /= 0) then
         write(IFLOG,*) '### ERROR ### in calc_xc_gga_pbe96_sol'
         write(IFLOG,*) '   ier   ...',ier
         write(IFLOG,*) '   imode ...',imode
         go to 99
      end if
   case(GGAPBE96_MOMO2)
      imode = 0
      call calc_xc_gga_pbe96_rad_sol(ier,imode)
      if (ier /= 0) then
         write(IFLOG,*) '### ERROR ### in calc_xc_gga_pbe96_rad_sol'
         write(IFLOG,*) '   ier   ...',ier
         write(IFLOG,*) '   imode ...',imode
         go to 99
      end if
   case(REVPBE)
      imode = 1
      call calc_xc_gga_pbe96_sol(ier,imode)
      if (ier /= 0) then
         write(IFLOG,*) '### ERROR ### in calc_xc_gga_pbe96_sol'
         write(IFLOG,*) '   ier   ...',ier
         write(IFLOG,*) '   imode ...',imode
         go to 99
      end if
   case(GGAPW91_MOMO, GGAPW91_MOMO2)
      call calc_xc_gga_pw91_rad_sol(ier)
      if (ier /= 0) then
         write(IFLOG,*) '### ERROR ### in calc_xc_gga_pw91_rad_sol'
         write(IFLOG,*) '   ier   ...',ier
         go to 99
      end if
   case(XLDA)
      call calc_x_lda_sol(ier)
      if (ier /= 0) then
         write(IFLOG,*) '### ERROR ### in calc_x_lda_sol'
         write(IFLOG,*) '   ier ...',ier ; go to 99
      end if
   case(XGGA)
      call calc_x_gga_sol(ier)
      if (ier /= 0) then
         write(IFLOG,*) '### ERROR ### in calc_x_gga_sol'
         write(IFLOG,*) '   ier ...',ier ; go to 99
      end if
   case(NONE)
      call calc_xc_none_sol(ier)
      if (ier /= 0) then
         write(IFLOG,*) '### ERROR ### in calc_xc_none_sol'
         write(IFLOG,*) '   ier ...',ier ; go to 99
      end if
   end select
99 continue
   end subroutine calc_vxc_exc_sol

!=========================================== adde by K. T. ============== 4.0
subroutine calc_vxc_exc_sol_kt(ier)
  use parameters
  implicit none

  integer,intent(out) :: ier
  integer :: imode

  ier = 0

  select case (is_xc)
     
  case(LDAPZ81)
     call calc_xc_lda_pz81_sol_kt(ier)
     if (ier /= 0) then
        write(IFLOG,*) '### ERROR ### in calc_xc_lda_pz81_sol_kt'
        write(IFLOG,*) '   ier ...',ier ; go to 99
     end if

  case(LDAPW92_MOMO)
     call calc_xc_lda_pw92_sol_kt(ier)
     if (ier /= 0) then
        write(IFLOG,*) '### ERROR ### in calc_xc_lda_pw92_sol_kt'
        write(IFLOG,*) '   ier ...',ier ; go to 99
     end if

  case(LDAPW92_GNCPP, GGAPBE96_GNCPP, GGAPBE96_KATO, &
       GGAPW91_F90, GGAPW91_F77)
     ier = 1 ! call calc_xc_gga_gncpp_sol(ier)
     if (ier /= 0) then
        write(IFLOG,*) '### ERROR ### in calc_xc_gga_gncpp_sol'
        write(IFLOG,*) '   ier ...',ier ; go to 99
     end if

  case(GGAPBE96_MOMO)
     imode = 0
     call calc_xc_gga_pbe96_sol_kt(ier,imode)
     if (ier /= 0) then
        write(IFLOG,*) '### ERROR ### in calc_xc_gga_pbe96_sol_kt'
        write(IFLOG,*) '   ier   ...',ier
        write(IFLOG,*) '   imode ...',imode
        go to 99
     end if

  case(GGAPBE96_MOMO2)
     imode = 0
     call calc_xc_gga_pbe96_rad_sol_kt(ier,imode)
     if (ier /= 0) then
        write(IFLOG,*) '### ERROR ### in calc_xc_gga_pbe96_rad_sol_kt'
        write(IFLOG,*) '   ier   ...',ier
        write(IFLOG,*) '   imode ...',imode
        go to 99
     end if

  case(REVPBE)
     imode = 1
     call calc_xc_gga_pbe96_sol_kt(ier,imode)
     if (ier /= 0) then
        write(IFLOG,*) '### ERROR ### in calc_xc_gga_pbe96_sol_kt'
        write(IFLOG,*) '   ier   ...',ier
        write(IFLOG,*) '   imode ...',imode
        go to 99
     end if

  case(GGAPW91_MOMO, GGAPW91_MOMO2)
     call calc_xc_gga_pw91_rad_sol_kt(ier)
     if (ier /= 0) then
        write(IFLOG,*) '### ERROR ### in calc_xc_gga_pw91_rad_sol_kt'
        write(IFLOG,*) '   ier   ...',ier
        go to 99
     end if
     
  case(XLDA)
     call calc_x_lda_sol_kt(ier)
     if (ier /= 0) then
        write(IFLOG,*) '### ERROR ### in calc_x_lda_sol_kt'
        write(IFLOG,*) '   ier ...',ier ; go to 99
     end if

  case(XGGA)
     call calc_x_gga_sol_kt(ier)
     if (ier /= 0) then
        write(IFLOG,*) '### ERROR ### in calc_x_gga_sol_kt'
        write(IFLOG,*) '   ier ...',ier ; go to 99
     end if

  case(NONE)
     call calc_xc_none_sol(ier)
     if (ier /= 0) then
        write(IFLOG,*) '### ERROR ### in calc_xc_none_sol'
        write(IFLOG,*) '   ier ...',ier ; go to 99
     end if
  end select

99 continue

end subroutine calc_vxc_exc_sol_kt
! =============================================================================== 4.0

!=====================================================================
   subroutine calc_vxc_exc_ss(ier)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer :: imode
   ier = 0
   select case (is_xc)
   case(LDAPZ81)
      call calc_xc_lda_pz81_ss(ier)
      if (ier /= 0) then
         write(IFLOG,*) '### ERROR ### in calc_xc_lda_pz81_ss'
         write(IFLOG,*) '   ier ...',ier ; go to 99
      end if
   case(LDAPW92_MOMO)
      call calc_xc_lda_pw92_ss(ier)
      if (ier /= 0) then
         write(IFLOG,*) '### ERROR ### in calc_xc_lda_pw92_ss'
         write(IFLOG,*) '   ier ...',ier ; go to 99
      end if
   case(LDAPW92_GNCPP, GGAPBE96_GNCPP, GGAPBE96_KATO, &
        GGAPW91_F90, GGAPW91_F77)
      ier = 1 ! call calc_xc_gga_gncpp_ss(ier)
      if (ier /= 0) then
         write(IFLOG,*) '### ERROR ### in calc_xc_gga_gncpp_ss'
         write(IFLOG,*) '   ier ...',ier ; go to 99
      end if
   case(GGAPBE96_MOMO)
      imode = 0
      call calc_xc_gga_pbe96_ss(ier,imode)
      if (ier /= 0) then
         write(IFLOG,*) '### ERROR ### in calc_xc_gga_pbe96_ss'
         write(IFLOG,*) '   ier   ...',ier
         write(IFLOG,*) '   imode ...',imode
         go to 99
      end if
   case(GGAPBE96_MOMO2)
      imode = 0
      call calc_xc_gga_pbe96_rad_ss(ier,imode)
      if (ier /= 0) then
         write(IFLOG,*) '### ERROR ### in calc_xc_gga_pbe96_rad_ss'
         write(IFLOG,*) '   ier   ...',ier
         write(IFLOG,*) '   imode ...',imode
         go to 99
      end if
   case(REVPBE)
      imode = 1
      call calc_xc_gga_pbe96_ss(ier,imode)
      if (ier /= 0) then
         write(IFLOG,*) '### ERROR ### in calc_xc_gga_pbe96_ss'
         write(IFLOG,*) '   ier   ...',ier
         write(IFLOG,*) '   imode ...',imode
         go to 99
      end if
   case(GGAPW91_MOMO, GGAPW91_MOMO2)
      call calc_xc_gga_pw91_rad_ss(ier)
      if (ier /= 0) then
         write(IFLOG,*) '### ERROR ### in calc_xc_gga_pw91_rad_ss'
         write(IFLOG,*) '   ier   ...',ier
         go to 99
      end if
   case(XLDA)
      call calc_x_lda_ss(ier)
      if (ier /= 0) then
         write(IFLOG,*) '### ERROR ### in calc_x_lda_ss'
         write(IFLOG,*) '   ier ...',ier ; go to 99
      end if
   case(XGGA)
      call calc_x_gga_ss(ier)
      if (ier /= 0) then
         write(IFLOG,*) '### ERROR ### in calc_x_gga_ss'
         write(IFLOG,*) '   ier ...',ier ; go to 99
      end if
   case(NONE)
      call calc_xc_none_ss(ier)
      if (ier /= 0) then
         write(IFLOG,*) '### ERROR ### in calc_xc_none_ss'
         write(IFLOG,*) '   ier ...',ier ; go to 99
      end if
   end select
99 continue
   end subroutine calc_vxc_exc_ss

!=====================================================================
   subroutine calc_dmat_ss(ier)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer :: ir, ltlt, ltt, ll, tn, tm, ispin
   real(8) :: r, sum
   ier = 0
   do ispin = 1,nspin_ss
   do ltt = 1,num_lttx_us
      ll   = l_ltt_us(ltt)
      tn   = tn_ltt_us(ltt)
      tm   = tm_ltt_us(ltt)
      ltlt = ltlt_nm_us(ll,tn,ll,tm)
      if (ltlt /= 0) then
         sum = 0.d0
         do ir = 1,nmesh
            r = rpos(ir)
            sum = sum &
            + r*r*wr(ir) * vloc_scr_ss(ir,ispin) * qps_us(ir,ltlt,0)
         end do
      else
         sum = 0.d0
      end if
      vlocqps_ss(ltt,ispin) = sum
      dmat_ss(ltt,ispin) = dion_us(ltt) + vlocqps_ss(ltt,ispin)
   end do
   end do
99 continue
   end subroutine calc_dmat_ss

!=============================================== added by K. T. ========= 4.0
subroutine calc_dmat_ss_kt(ier)
  use parameters
  implicit none

  integer,intent(out) :: ier
  integer :: ir, ltlt, ltt, ll, tn, tm, ispin

  integer :: myspin1, myspin2, itmp1, itmp2
  real(8) :: r, sum

  ier = 0
  dmat_ss = 0.0d0

  do ispin = 1,nspin_ss

     do ltt = 1,num_lttx_us
        ll   = l_ltt_us(ltt)
        tn   = tn_ltt_us(ltt)
        tm   = tm_ltt_us(ltt)
!
        myspin1 = spin1_index_ltt_us(ltt)
        myspin2 = spin2_index_ltt_us(ltt)

        if ( nspin == 2 ) then
           if ( myspin1 /= myspin2 ) cycle
           if ( myspin1 /= ispin ) cycle
        endif
!
        itmp1 = tn + nref_max_us *(myspin1 -1)
        itmp2 = tm + nref_max_us *(myspin2 -1)

        ltlt = ltlt_nm_us(ll,itmp1,ll,itmp2)

        if (ltlt /= 0) then
           sum = 0.d0
           do ir = 1,nmesh
              r = rpos(ir)
              sum = sum &
                   + r*r*wr(ir) * vloc_scr_ss(ir,ispin) * qps_us(ir,ltlt,0)
           end do
        else
           sum = 0.d0
        end if
        vlocqps_ss(ltt,ispin) = sum
        dmat_ss(ltt,ispin) = dion_us(ltt) + vlocqps_ss(ltt,ispin)

     end do
  end do

99 continue

end subroutine calc_dmat_ss_kt
! ======================================================================= 4.0

!=====================================================================
   subroutine calc_vloc_ion_sol(ier)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer :: ips, ir
   ier = 0
   call calc_vh_sol(ier)
   if (ier /= 0) then
      write(IFLOG,*) '### ERROR ### in calc_vh_sol'
      write(IFLOG,*) '   ier ...',ier ; go to 99
   end if
   call calc_vxc_exc_sol(ier)
   if (ier /= 0) then
      write(IFLOG,*) '### ERROR ### in calc_vxc_exc_sol'
      write(IFLOG,*) '   ier ...',ier ; go to 99
   end if

! ======================================= modified by K. T. ========= 4.0
!   vloc_ion_sol(:) = vloc_scr_sol(:) - vh_sol(:) &
!                        - vx_sol(:) - vc_sol(:)
   vloc_ion_sol(:,1) = vloc_scr_sol(:,1) - vh_sol(:) &
                        - vx_sol(:,1) - vc_sol(:,1)
! =================================================================== 4.0

   do ips = 1,nps
   do ir = 1,nmesh
! ======================================= modified by K. T. =========== 4.0
!      vion_ps(ir,ips,:) = veff_ps(ir,ips,:) - vh_sol(ir) &
!                     - vx_sol(ir) - vc_sol(ir)
      vion_ps(ir,ips,:) = veff_ps(ir,ips,:) - vh_sol(ir) &
                     - vx_sol(ir,1) - vc_sol(ir,1)
! ==================================================================== 4.0
   end do
   end do
99 continue
   end subroutine calc_vloc_ion_sol

!================================== added by K. T. ========================== 4.0
subroutine calc_vloc_ion_sol_kt(ier)
  use parameters
  implicit none

  integer,intent(out) :: ier
  integer :: ips, ir
  integer :: ispin, ishell

  ier = 0

  call calc_vh_sol_kt(ier)
  if (ier /= 0) then
     write(IFLOG,*) '### ERROR ### in calc_vh_sol'
     write(IFLOG,*) '   ier ...',ier ; go to 99
  end if

  call calc_vxc_exc_sol_kt(ier)
  if (ier /= 0) then
     write(IFLOG,*) '### ERROR ### in calc_vxc_exc_sol'
     write(IFLOG,*) '   ier ...',ier ; go to 99
  end if

  Do ispin=1, nspin
     vloc_ion_sol(:,ispin) = vloc_scr_sol(:,ispin) - vh_sol(:) &
          &            - vx_sol(:,ispin) - vc_sol(:,ispin)
  End do

  do ips = 1,nps
     ishell = ishell_ps(ips,1)

     ispin = (1-spin(ishell))/2 + 1

     do ir = 1,nmesh
        vion_ps(ir,ips,:) = veff_ps(ir,ips,:) - vh_sol(ir) &
             - vx_sol(ir,ispin) - vc_sol(ir,ispin)
     end do
  end do

99 continue

end subroutine calc_vloc_ion_sol_kt
! ================================================================================ 4.0

!=====================================================================
   subroutine calc_vloc_scr_ss(ier)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer :: ispin, ir
   ier = 0
   call calc_vh_ss(ier)
   if (ier /= 0) then
      write(IFLOG,*) '### ERROR ### in calc_vh_ss'
      write(IFLOG,*) '   ier ...',ier ; go to 99
   end if
   call calc_vxc_exc_ss(ier)
   if (ier /= 0) then
      write(IFLOG,*) '### ERROR ### in calc_vxc_exc_ss'
      write(IFLOG,*) '   ier ...',ier ; go to 99
   end if
   do ispin = 1,nspin_ss
      do ir = 1,nmesh
! =============================================== modified by K. T. ========= 4.0
!         vloc_scr_ss(ir,ispin) = vloc_ion_sol(ir) + vh_ss(ir) &
!                               + vx_ss(ir,ispin) + vc_ss(ir,ispin)
         vloc_scr_ss(ir,ispin) = vloc_ion_sol(ir,1) + vh_ss(ir) &
                               + vx_ss(ir,ispin) + vc_ss(ir,ispin)
! ============================================================================ 4.0
      end do
   end do
   call calc_dmat_ss(ier)
   if (ier /= 0) then
      write(IFLOG,*) '### ERROR ### in calc_dmat_ss'
      write(IFLOG,*) '   ier ...',ier ; go to 99
   end if
99 continue
   end subroutine calc_vloc_scr_ss

!=========================================== added by K. T. =========== 4.0
subroutine calc_vloc_scr_ss_kt(ier)
  use parameters
  implicit none

  integer,intent(out) :: ier
  integer :: ispin, ir
  integer :: ispin_ps

  ier = 0

  call calc_vh_ss(ier)
  if (ier /= 0) then
     write(IFLOG,*) '### ERROR ### in calc_vh_ss'
     write(IFLOG,*) '   ier ...',ier ; go to 99
  end if

  call calc_vxc_exc_ss(ier)
  if (ier /= 0) then
     write(IFLOG,*) '### ERROR ### in calc_vxc_exc_ss'
     write(IFLOG,*) '   ier ...',ier ; go to 99
  end if


! -------
!  Do ir=1, nmesh
!     write(500,*) ir, ( vloc_ion_sol(ir,ispin), ispin=1, nspin )
!  End do
!  stop

! ------
  if ( nspin==1 ) then
     do ispin = 1,nspin_ss
        do ir = 1,nmesh
           vloc_scr_ss(ir,ispin) = vloc_ion_sol(ir,1) + vh_ss(ir) &
                + vx_ss(ir,ispin) + vc_ss(ir,ispin)
        end do
     end do
  else if ( nspin == 2 ) then

     do ispin = 1,nspin_ss

        ispin_ps = ispin              ! uncertain

        do ir = 1,nmesh
           vloc_scr_ss(ir,ispin) = vloc_ion_sol(ir,ispin_ps) + vh_ss(ir) &
                + vx_ss(ir,ispin) + vc_ss(ir,ispin)
        end do
     end do
  endif
  
  call calc_dmat_ss_kt(ier)                ! Hen ??

!  call calc_dmat_ss(ier)
  if (ier /= 0) then
     write(IFLOG,*) '### ERROR ### in calc_dmat_ss_kt'
     write(IFLOG,*) '   ier ...',ier ; go to 99
  end if
   
99 continue

end subroutine calc_vloc_scr_ss_kt
! =========================================================================== 4.0

!=====================================================================
   subroutine write_sol(ier)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer :: ips, ishell, ir, nn, ll, kk, jj2, ispin
   character(1) :: fn_label_orbital
   character(2) :: ch_del, ch2
   ier = 0
   ch_del = ','//' '
   open(IFSOL,file=trim(solfile),status='unknown')
   write(IFSOL,*) 'Solved eigen-functions for the present pseudopotential'
   call write_file_header(IFSOL)
   write(IFSOL,*)
   select case (nspin)
   case (1)
      write(IFSOL,*) &
         'rpos, rho_ae, rho_sol, vloc_ion_us, vh_sol, vxc_sol'
      do ir = 1,nmesh
! =============================================== modified by K. T. ============ 4.0
!         write(IFSOL,10) rpos(ir),rho(ir,1),rho_sol(ir), &
!            vloc_ion_us(ir),vh_sol(ir),vx_sol(ir)+vc_sol(ir)
         write(IFSOL,10) rpos(ir),rho(ir,1),rho_sol(ir,1), &
            vloc_ion_us(ir,1),vh_sol(ir),vx_sol(ir,1) +vc_sol(ir,1)
! ============================================================================= 4.0
      end do
   case (2)
      write(IFSOL,*) &
         'rpos, rho1, rho2, rho_sol, vloc_ion_us, vh_sol, vxc_sol'
      do ir = 1,nmesh
! ================================================ modified by K. T. =========== 4.0
!         write(IFSOL,10) rpos(ir),rho(ir,1),rho(ir,2),rho_sol(ir), &
!            vloc_ion_us(ir),vh_sol(ir),vx_sol(ir)+vc_sol(ir)
         write(IFSOL,10) rpos(ir),rho(ir,1),rho(ir,2),rho_sol(ir,1), &
            vloc_ion_us(ir,1),vh_sol(ir),vx_sol(ir,1) +vc_sol(ir,1)
! ============================================================================== 4.0
      end do
   end select
   do ips = 1,nps
      ishell = ishell_ps(ips,1)
      nn = n_qnum(ishell)
      ll = l_qnum(ishell)
      kk = k_qnum(ishell)
      jj2 = j2_qnum(ishell)
      ispin = (1-spin(ishell))/2 + 1
      ch2(1:2) = '_'//fn_label_orbital(ll)
      write(IFSOL,*)
      write(IFSOL,30) nn,ll,jj2,ispin,'(n, l, 2*j, s)'
      write(IFSOL,31) engy_sol(ips),  'elevel'
      write(IFSOL,*)
      write(IFSOL,*) &
         'rpos'//ch2//ch_del//'rphi_sol'//ch2
      do ir = 1,nmesh
         write(IFSOL,10) rpos(ir),rphi_sol(ir,ips)
      end do
   end do
10 format(10(1pe20.10))
30 format(1x,4i5,   5x,':',1x,a14)
31 format(1x,f20.10,5x,':',1x,a6)
   close(IFSOL)
   end subroutine write_sol

!=====================================================================
   subroutine write_ss(ier)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer :: ips, iss, ishell, ir, nn, ll, kk, jj2, ispin
   character(1) :: fn_label_orbital
   character(2) :: ch_del, ch2
   ier = 0
   ch_del = ','//' '
   open(IFSOL,file=trim(solfile),status='unknown')
   write(IFSOL,*) 'Solved eigen-functions for the present pseudopotential'
   call write_file_header(IFSOL)
   write(IFSOL,*)
   select case (is_solve_pp_spin)
   case (NO)
      write(IFSOL,*) &
         'rpos, rho_ae, rho_sol, vloc_ion_us, vh_sol, vxc_sol'
      do ir = 1,nmesh
! ============================================ modified by K. T. ============ 4.0
!         write(IFSOL,10) rpos(ir),rho(ir,1),rho_sol(ir), &
!            vloc_ion_us(ir),vh_sol(ir),vx_sol(ir)+vc_sol(ir)
         write(IFSOL,10) rpos(ir),rho(ir,1),rho_sol(ir,1), &
            vloc_ion_us(ir,1),vh_sol(ir),vx_sol(ir,1)+vc_sol(ir,1)
! =========================================================================== 4.0
      end do
      do ips = 1,nps
         ishell = ishell_ps(ips,1)
         nn = n_qnum(ishell)
         ll = l_qnum(ishell)
         kk = k_qnum(ishell)
         jj2 = j2_qnum(ishell)
         ispin = (1-spin(ishell))/2 + 1
         ch2(1:2) = '_'//fn_label_orbital(ll)
         write(IFSOL,*)
         write(IFSOL,30) nn,ll,jj2,ispin,'(n, l, 2*j, s)'
         write(IFSOL,31) engy_sol(ips),  'elevel'
         write(IFSOL,*)
         write(IFSOL,*) &
            'rpos'//ch2//ch_del//'rphi_sol'//ch2
         do ir = 1,nmesh
            write(IFSOL,10) rpos(ir),rphi_sol(ir,ips)
         end do
      end do
   case (YES)
      select case (nspin_ss)
      case (1)
         write(IFSOL,*) &
            'rpos, rho_ae, rho_ss, vloc_ion_us, vh_ss, vxc_ss'
         do ir = 1,nmesh
            write(IFSOL,10) &
! ================================================ modified by K. T. ======== 4.0
!               rpos(ir),rho(ir,1),rho_ss(ir,1), &
!               vloc_ion_us(ir),vh_ss(ir),vx_ss(ir,1)+vc_ss(ir,1)

               rpos(ir),rho(ir,1),rho_ss(ir,1), &
               vloc_ion_us(ir,1),vh_ss(ir),vx_ss(ir,1)+vc_ss(ir,1)
! ============================================================================= 4.0

         end do
      case (2)
         write(IFSOL,*) &
            'rpos, rho_ae, rho_ss1, rho_ss2, vloc_ion_us, vh_ss, vxc_ss1, vxc_ss2'
         do ir = 1,nmesh
            write(IFSOL,10) &
! ================================================ modified by K. T. ======== 4.0
!               rpos(ir),rho(ir,1),rho_ss(ir,1),rho_ss(ir,2), &
!               vloc_ion_us(ir),vh_ss(ir), &
!               vx_ss(ir,1)+vc_ss(ir,1),vx_ss(ir,2)+vc_ss(ir,2)
!
               rpos(ir),rho(ir,1),rho_ss(ir,1),rho_ss(ir,2), &
               vloc_ion_us(ir,1),vh_ss(ir), &
               vx_ss(ir,1)+vc_ss(ir,1),vx_ss(ir,2)+vc_ss(ir,2)
! ========================================================================== 4.0
         end do
      end select
      do iss = 1,nss
         ishell = ishell_ss(iss)
         nn = n_qnum(ishell)
         ll = l_qnum(ishell)
         kk = k_qnum(ishell)
         jj2 = j2_qnum(ishell)
         ispin = (1-spin_ss(iss))/2 + 1
         ch2(1:2) = '_'//fn_label_orbital(ll)
         write(IFSOL,*)
         write(IFSOL,30) nn,ll,jj2,ispin,'(n, l, 2*j, s)'
         write(IFSOL,31) engy_ss(iss),  'elevel'
         write(IFSOL,*)
         write(IFSOL,*) &
            'rpos'//ch2//ch_del//'rphi_ss'//ch2
         do ir = 1,nmesh
            write(IFSOL,10) rpos(ir),rphi_ss(ir,iss)
         end do
      end do
   end select
10 format(10(1pe20.10))
30 format(1x,4i5,   5x,':',1x,a14)
31 format(1x,f20.10,5x,':',1x,a6)
   close(IFSOL)
   end subroutine write_ss

!
!  Software name : CIAO (Code for Investigating Atomic Orbitals)
!  Subroutine(s) : sizeof_dipole_l_us, sizeof_dipole_l_ps,
!                : calc_dipole_l_us, calc_dipole_l_ps,
!                : write_dipole_l_us, write_dipole_l_ps,
!                : sizeof_dipole_lm_us, sizeof_dipole_lm_ps,
!                : calc_dipole_lm_us, calc_dipole_lm_ps,
!                : write_rdipole_lm_us, write_rdipole_lm_ps,
!                : write_pdipole_lm_us, write_pdipole_lm_ps,
!                : write_cubic_ylm, set_pxyz, set_phase_ylm
!  Author(s)     : Masakuni Okamoto (August 25, 2003)
!
!
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!
!
!  The license of the code and contact address :
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)
!
!=====================================================================
   subroutine sizeof_dipole_l_us(ier)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer :: lt1, lt2, l1, l2, ltlt
   ier = 0
   ltlt = 0
   do lt1 = 1,num_ltx_us
   do lt2 = 1,num_ltx_us
      l1 = l_lt_us(lt1) ; l2 = l_lt_us(lt2)
      if (abs(l1-l2) == 1) then
         ltlt = ltlt + 1
      end if
   end do
   end do
   num_dipole_l_us = ltlt
99 continue
   end subroutine sizeof_dipole_l_us

!======================================= added by K. T. ================= 4.0
subroutine sizeof_dipole_l_us_kt(ier)
  use parameters
  implicit none

  integer,intent(out) :: ier
  integer :: lt1, lt2, l1, l2, ltlt
  integer :: ispin1, ispin2

  ier = 0
  ltlt = 0

  do lt1 = 1,num_ltx_us
     do lt2 = 1,num_ltx_us
        l1 = l_lt_us(lt1) ; l2 = l_lt_us(lt2)

        ispin1 = spin_index_lt_us(lt1)
        ispin2 = spin_index_lt_us(lt2)

        if ( abs(l1-l2) == 1 .and. ispin1 == ispin2 ) then
           ltlt = ltlt + 1
        end if
     end do
  end do

  num_dipole_l_us = ltlt

99 continue

end subroutine sizeof_dipole_l_us_kt
! ============================================================================ 4.0

!=====================================================================
   subroutine sizeof_dipole_l_ps(ier)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer :: l1, l2, ishell1, ishell2, ips1, ips2, isol1, isol2, nlnl
   ier = 0
   nlnl = 0
   do ips1 = 1,nps
   do ips2 = 1,nps
      ishell1 = ishell_ps(ips1,1) ; ishell2 = ishell_ps(ips2,1)
      l1 = l_qnum(ishell1)        ; l2 = l_qnum(ishell2)
      isol1 = is_solve(ishell1)   ; isol2 = is_solve(ishell2)
      if ((abs(l1-l2) == 1).and.(isol1*isol2 /= 0)) then
         nlnl = nlnl + 1
      end if
   end do
   end do
   num_dipole_l_ps = nlnl
99 continue
   end subroutine sizeof_dipole_l_ps

!============================================ added by K. T. =========== 4.0
subroutine sizeof_dipole_l_ps_kt(ier)
  use parameters
  implicit none

  integer,intent(out) :: ier

  integer :: l1, l2, ishell1, ishell2, ips1, ips2, isol1, isol2, nlnl
  integer :: ispin1, ispin2

  ier = 0
  nlnl = 0

  do ips1 = 1,nps
     do ips2 = 1,nps
        ishell1 = ishell_ps(ips1,1) ; ishell2 = ishell_ps(ips2,1)
        l1 = l_qnum(ishell1)        ; l2 = l_qnum(ishell2)

        ispin1 = spin(ishell1)
        ispin2 = spin(ishell2)

        isol1 = is_solve(ishell1)   ; isol2 = is_solve(ishell2)

        if ((abs(l1-l2) == 1).and.(ispin1==ispin2).and.(isol1*isol2 /= 0)) then
           nlnl = nlnl + 1
        end if
     end do
  end do

  num_dipole_l_ps = nlnl

99 continue

end subroutine sizeof_dipole_l_ps_kt
! ============================================================================= 4.0

!=====================================================================
   subroutine calc_dipole_l_us(ier)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer :: lt1, lt2, ir, n1, l1, t1, n2, l2, t2, ltlt, lt, nrc
   real(8) :: sum1, sum2, sum3, r
   ier = 0
   drpsi_us(:,:) = 0.d0 ; drphi_us(:,:) = 0.d0
   do lt = 1,num_ltx_us
      call calc_diff_exp(ier,10,nmesh,rpos(1), &
                         rpsi_us(1,lt),drpsi_us(1,lt))
      call calc_diff_exp(ier,10,nmesh,rpos(1), &
                         rphi_us(1,lt),drphi_us(1,lt))
   end do
   nrc = nrcut_phi_max_us
   call set_weight_exp(ier,1,nrc,rpos,wt)
   dipole_r_us(:)  = 0.d0
   dipole_ri_us(:) = 0.d0
   dipole_pr_us(:) = 0.d0
   ltlt = 0
MAIN1:do lt1 = 1,num_ltx_us
MAIN2:do lt2 = 1,num_ltx_us
      n1 = n_lt_us(lt1) ; n2 = n_lt_us(lt2)
      l1 = l_lt_us(lt1) ; l2 = l_lt_us(lt2)
      t1 = t_lt_us(lt1) ; t2 = t_lt_us(lt2)
      if (abs(l1-l2) == 1) then
         ltlt = ltlt + 1
         lt1_dipole_l_us(ltlt) = lt1 ; lt2_dipole_l_us(ltlt) = lt2
         n1_dipole_l_us (ltlt) = n1  ; n2_dipole_l_us (ltlt) = n2
         l1_dipole_l_us (ltlt) = l1  ; l2_dipole_l_us (ltlt) = l2
         t1_dipole_l_us (ltlt) = t1  ; t2_dipole_l_us (ltlt) = t2
      else
         cycle MAIN2
      end if
      sum1 = 0.d0 ; sum2 = 0.d0 ; sum3 = 0.d0
      do ir = 1,nrc
         r = rpos(ir)
         sum1 = sum1 + wt(ir) * r * ( &
              rpsi_us(ir,lt1) * rpsi_us(ir,lt2) &
            - rphi_us(ir,lt1) * rphi_us(ir,lt2) )
         sum2 = sum2 + wt(ir) / r * ( &
              rpsi_us(ir,lt1) * rpsi_us(ir,lt2) &
            - rphi_us(ir,lt1) * rphi_us(ir,lt2) )
         sum3 = sum3 + wt(ir) * ( &
              rpsi_us(ir,lt1) * drpsi_us(ir,lt2) &
            - rphi_us(ir,lt1) * drphi_us(ir,lt2) )
      end do
      dipole_r_us (ltlt) = sum1
      dipole_ri_us(ltlt) = sum2
      dipole_pr_us(ltlt) = sum3
end do MAIN2
end do MAIN1
   if (ltlt /= num_dipole_l_us) then
      write(IFLOG,*) '### ERROR ### ltlt /= num_dipole_l_us'
      write(IFLOG,*) '   ltlt            ...',ltlt
      write(IFLOG,*) '   num_dipole_l_us ...',num_dipole_l_us
      ier = 1 ; go to 99
   end if
   
99 continue
   end subroutine calc_dipole_l_us

!======================================== added by K. T. ==================== 4.0
subroutine calc_dipole_l_us_kt(ier)
  use parameters
  implicit none

  integer,intent(out) :: ier

  integer :: lt1, lt2, ir, n1, l1, t1, n2, l2, t2, ltlt, lt, nrc
  integer :: ispin1, ispin2

  real(8) :: sum1, sum2, sum3, r

  ier = 0
  drpsi_us(:,:) = 0.d0 ; drphi_us(:,:) = 0.d0

  do lt = 1,num_ltx_us
     call calc_diff_exp(ier,10,nmesh,rpos(1), &
          rpsi_us(1,lt),drpsi_us(1,lt))
     call calc_diff_exp(ier,10,nmesh,rpos(1), &
          rphi_us(1,lt),drphi_us(1,lt))
  end do

  nrc = nrcut_phi_max_us

  call set_weight_exp(ier,1,nrc,rpos,wt)

  dipole_r_us(:)  = 0.d0
  dipole_ri_us(:) = 0.d0
  dipole_pr_us(:) = 0.d0

  ltlt = 0

  MAIN1:do lt1 = 1,num_ltx_us

     MAIN2:do lt2 = 1,num_ltx_us

        n1 = n_lt_us(lt1) ; n2 = n_lt_us(lt2)
        l1 = l_lt_us(lt1) ; l2 = l_lt_us(lt2)
        t1 = t_lt_us(lt1) ; t2 = t_lt_us(lt2)

        ispin1 = spin_index_lt_us(lt1)
        ispin2 = spin_index_lt_us(lt2)

        if (abs(l1-l2) == 1 .and. ispin1==ispin2 ) then
           ltlt = ltlt + 1
           lt1_dipole_l_us(ltlt) = lt1 ; lt2_dipole_l_us(ltlt) = lt2
           n1_dipole_l_us (ltlt) = n1  ; n2_dipole_l_us (ltlt) = n2
           l1_dipole_l_us (ltlt) = l1  ; l2_dipole_l_us (ltlt) = l2
           t1_dipole_l_us (ltlt) = t1  ; t2_dipole_l_us (ltlt) = t2

           spin1_index_dipole_l_us(ltlt) = ispin1

        else
           cycle MAIN2
        end if

        sum1 = 0.d0 ; sum2 = 0.d0 ; sum3 = 0.d0
        do ir = 1,nrc
           r = rpos(ir)
           sum1 = sum1 + wt(ir) * r * ( &
                rpsi_us(ir,lt1) * rpsi_us(ir,lt2) &
                - rphi_us(ir,lt1) * rphi_us(ir,lt2) )
           sum2 = sum2 + wt(ir) / r * ( &
                rpsi_us(ir,lt1) * rpsi_us(ir,lt2) &
                - rphi_us(ir,lt1) * rphi_us(ir,lt2) )
           sum3 = sum3 + wt(ir) * ( &
                rpsi_us(ir,lt1) * drpsi_us(ir,lt2) &
                - rphi_us(ir,lt1) * drphi_us(ir,lt2) )
        end do

        dipole_r_us (ltlt) = sum1
        dipole_ri_us(ltlt) = sum2
        dipole_pr_us(ltlt) = sum3

     end do MAIN2
  end do MAIN1

  if (ltlt /= num_dipole_l_us) then
     write(IFLOG,*) '### ERROR ### ltlt /= num_dipole_l_us'
     write(IFLOG,*) '   ltlt            ...',ltlt
     write(IFLOG,*) '   num_dipole_l_us ...',num_dipole_l_us
     ier = 1 ; go to 99
  end if
   
99 continue

end subroutine calc_dipole_l_us_kt
! ============================================================================ 4.0

!=====================================================================
   subroutine calc_dipole_l_ps(ier)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer :: ips, ishell, ips1, ips2, ishell1, ishell2, ir, &
              n1, l1, n2, l2, isol1, isol2, nlnl, iss
   real(8) :: sum1, sum2, sum3, sum4, sum5, sum6, r
   ier = 0
   rpsi_ps(:,:) = 0.d0 ; rphi_ps(:,:) = 0.d0
   do ips = 1,nps
      ishell = ishell_ps(ips,1)
      rpsi_ps(:,ips) = chi_g(:,ishell)
      if ((is_solve_pp_spin /= NO).and.(is_spin_ss == RESTRICTED)) then
         do iss = 1,nss
            if (ishell_ss(iss) == ishell) then
               rphi_ps(:,ips) = rphi_ss(:,iss) ; exit
            end if
            if (iss == nss) then
               write(IFLOG,*) '### ERROR ### iss was not found'
               ier = 1 ; go to 99
            end if
         end do
      else
         rphi_ps(:,ips) = rphi_sol(:,ips)
      end if
   end do
   drpsi_ps(:,:) = 0.d0 ; drphi_ps(:,:) = 0.d0
   do ips = 1,nps
      call calc_diff_exp(ier,10,nmesh,rpos(1), &
                         rpsi_ps(1,ips),drpsi_ps(1,ips))
      call calc_diff_exp(ier,10,nmesh,rpos(1), &
                         rphi_ps(1,ips),drphi_ps(1,ips))
   end do
   dipole_r_ae (:) = 0.d0 ; dipole_r_pp (:) = 0.d0
   dipole_ri_ae(:) = 0.d0 ; dipole_ri_pp(:) = 0.d0
   dipole_pr_ae(:) = 0.d0 ; dipole_pr_pp(:) = 0.d0
   nlnl = 0
MAIN1:do ips1 = 1,nps
MAIN2:do ips2 = 1,nps
      ishell1 = ishell_ps(ips1,1) ; ishell2 = ishell_ps(ips2,1)
      n1 = n_qnum(ishell1)        ; n2 = n_qnum(ishell2)
      l1 = l_qnum(ishell1)        ; l2 = l_qnum(ishell2)
      isol1 = is_solve(ishell1)   ; isol2 = is_solve(ishell2)
      if ((abs(l1-l2) == 1).and.(isol1*isol2 /= 0)) then
         nlnl = nlnl + 1
         ips1_dipole_l_ps(nlnl) = ips1 ; ips2_dipole_l_ps(nlnl) = ips2
         n1_dipole_l_ps(nlnl) = n1     ; n2_dipole_l_ps(nlnl) = n2
         l1_dipole_l_ps(nlnl) = l1     ; l2_dipole_l_ps(nlnl) = l2
      else
         cycle MAIN2
      end if
      sum1 = 0.d0 ; sum2 = 0.d0 ; sum3 = 0.d0
      sum4 = 0.d0 ; sum5 = 0.d0 ; sum6 = 0.d0
      do ir = 1,nmesh
         r = rpos(ir)
         sum1 = sum1 + wr(ir) * r &
              * rpsi_ps(ir,ips1) * rpsi_ps(ir,ips2)
         sum2 = sum2 + wr(ir) / r &
              * rpsi_ps(ir,ips1) * rpsi_ps(ir,ips2)
         sum3 = sum3 + wr(ir) &
              * rpsi_ps(ir,ips1) * drpsi_ps(ir,ips2)
         sum4 = sum4 + wr(ir) * r &
              * rphi_ps(ir,ips1) * rphi_ps(ir,ips2)
         sum5 = sum5 + wr(ir) / r &
              * rphi_ps(ir,ips1) * rphi_ps(ir,ips2)
         sum6 = sum6 + wr(ir) &
              * rphi_ps(ir,ips1) * drphi_ps(ir,ips2)
      end do
      dipole_r_ae (nlnl) = sum1 ; dipole_r_pp (nlnl) = sum4
      dipole_ri_ae(nlnl) = sum2 ; dipole_ri_pp(nlnl) = sum5
      dipole_pr_ae(nlnl) = sum3 ; dipole_pr_pp(nlnl) = sum6
end do MAIN2
end do MAIN1
99 continue
   end subroutine calc_dipole_l_ps

!================================================== added by K. T. ========== 4.0
subroutine calc_dipole_l_ps_kt(ier)
  use parameters
  implicit none

  integer,intent(out) :: ier

  integer :: ips, ishell, ips1, ips2, ishell1, ishell2, ir, &
       n1, l1, n2, l2, isol1, isol2, nlnl, iss
  integer :: ispin1, ispin2

  real(8) :: sum1, sum2, sum3, sum4, sum5, sum6, r

  ier = 0
  rpsi_ps(:,:) = 0.d0 ; rphi_ps(:,:) = 0.d0

  do ips = 1,nps
     ishell = ishell_ps(ips,1)
     rpsi_ps(:,ips) = chi_g(:,ishell)

     if ( (nspin==1).and.(is_solve_pp_spin /= NO).and.(is_spin_ss == RESTRICTED)) then
        do iss = 1,nss
           if (ishell_ss(iss) == ishell) then
              rphi_ps(:,ips) = rphi_ss(:,iss) ; exit
           end if
           if (iss == nss) then
              write(IFLOG,*) '### ERROR ### iss was not found'
              ier = 1 ; go to 99
           end if
        end do
     else
        rphi_ps(:,ips) = rphi_sol(:,ips)
     end if
  end do

  drpsi_ps(:,:) = 0.d0 ; drphi_ps(:,:) = 0.d0

  do ips = 1,nps
     call calc_diff_exp(ier,10,nmesh,rpos(1), &
          rpsi_ps(1,ips),drpsi_ps(1,ips))
     call calc_diff_exp(ier,10,nmesh,rpos(1), &
          rphi_ps(1,ips),drphi_ps(1,ips))
  end do

  dipole_r_ae (:) = 0.d0 ; dipole_r_pp (:) = 0.d0
  dipole_ri_ae(:) = 0.d0 ; dipole_ri_pp(:) = 0.d0
  dipole_pr_ae(:) = 0.d0 ; dipole_pr_pp(:) = 0.d0

  nlnl = 0

  MAIN1:do ips1 = 1,nps

     MAIN2:do ips2 = 1,nps
     
        ishell1 = ishell_ps(ips1,1) ; ishell2 = ishell_ps(ips2,1)
        n1 = n_qnum(ishell1)        ; n2 = n_qnum(ishell2)
        l1 = l_qnum(ishell1)        ; l2 = l_qnum(ishell2)

        ispin1 = ( 1 -spin(ishell1) )/2 +1
        ispin2 = ( 1- spin(ishell2) )/2 +1

        isol1 = is_solve(ishell1)   ; isol2 = is_solve(ishell2)

        if ((abs(l1-l2) == 1).and.(ispin1==ispin2).and.(isol1*isol2 /= 0)) then
           nlnl = nlnl + 1

           ips1_dipole_l_ps(nlnl) = ips1 ; ips2_dipole_l_ps(nlnl) = ips2
           n1_dipole_l_ps(nlnl) = n1     ; n2_dipole_l_ps(nlnl) = n2
           l1_dipole_l_ps(nlnl) = l1     ; l2_dipole_l_ps(nlnl) = l2

           spin1_index_dipole_l_ps(nlnl) = ispin1

        else
           cycle MAIN2
        end if

        sum1 = 0.d0 ; sum2 = 0.d0 ; sum3 = 0.d0
        sum4 = 0.d0 ; sum5 = 0.d0 ; sum6 = 0.d0

        do ir = 1,nmesh
           r = rpos(ir)
           sum1 = sum1 + wr(ir) * r &
                * rpsi_ps(ir,ips1) * rpsi_ps(ir,ips2)
           sum2 = sum2 + wr(ir) / r &
                * rpsi_ps(ir,ips1) * rpsi_ps(ir,ips2)
           sum3 = sum3 + wr(ir) &
                * rpsi_ps(ir,ips1) * drpsi_ps(ir,ips2)
           sum4 = sum4 + wr(ir) * r &
                * rphi_ps(ir,ips1) * rphi_ps(ir,ips2)
           sum5 = sum5 + wr(ir) / r &
                * rphi_ps(ir,ips1) * rphi_ps(ir,ips2)
           sum6 = sum6 + wr(ir) &
                * rphi_ps(ir,ips1) * drphi_ps(ir,ips2)
        end do

        dipole_r_ae (nlnl) = sum1 ; dipole_r_pp (nlnl) = sum4
        dipole_ri_ae(nlnl) = sum2 ; dipole_ri_pp(nlnl) = sum5
        dipole_pr_ae(nlnl) = sum3 ; dipole_pr_pp(nlnl) = sum6

     end do MAIN2
  end do MAIN1

99 continue

end subroutine calc_dipole_l_ps_kt
! ============================================================================ 4.0

!=====================================================================
   subroutine write_dipole_l_us(ifile)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(in) :: ifile
   integer :: n1, l1, t1, n2, l2, t2, ltlt
   character(3) :: ch1, ch2
   character(1) :: fn_label_orbital
   write(ifile,*)
   write(ifile,*) &
      '[n|r|m]   = <psi[n]|r|psi[m]>   - <phi[n]|r|phi[m]>   =  [m|r|n]'
   write(ifile,*) &
      '[n|1/r|m] = <psi[n]|1/r|psi[m]> - <phi[n]|1/r|phi[m]> =  [m|1/r|n]'
   write(ifile,*) &
      '[n|pr|m]  = <psi[n]|pr|psi[m]>  - <phi[n]|pr|phi[m]>  = -[n|pr|m]'
   write(ifile,*) &
      'where pr = (1/r)*(d/dr)*r'
   write(ifile,*)
   write(ifile,*) &
      '   n = (n1,l1,t1), m = (n2,l2,t2)'
   write(ifile,10) '[n]','[m]','[n|r|m]','[n|1/r|m]','[n|pr|m]'
   do ltlt = 1,num_dipole_l_us
      n1 = n1_dipole_l_us(ltlt) ; n2 = n2_dipole_l_us(ltlt)
      l1 = l1_dipole_l_us(ltlt) ; l2 = l2_dipole_l_us(ltlt)
      t1 = t1_dipole_l_us(ltlt) ; t2 = t2_dipole_l_us(ltlt)
      if (l1 > l2) then
         cycle
      end if
      write(ch1,'(i1,a1,i1)') n1, fn_label_orbital(l1), t1
      write(ch2,'(i1,a1,i1)') n2, fn_label_orbital(l2), t2
      write(ifile,11) ch1,ch2, &
         dipole_r_us(ltlt), dipole_ri_us(ltlt), dipole_pr_us(ltlt)
   end do
10 format(1x,(2x,a3,'-',a3,2x),(10x,a7,3x),(10x,a9,1x),(10x,a8,2x))
11 format(1x,(2x,a3,'-',a3,2x),3f20.10)

   end subroutine write_dipole_l_us

!=========================================== added by K. T. ================ 4.0
subroutine write_dipole_l_us_kt(ifile)
  use parameters
  implicit none

  integer,intent(in) :: ifile

  integer :: n1, l1, t1, n2, l2, t2, ltlt
  integer :: ispin1

  character(3) :: ch1, ch2
  character(1) :: fn_label_orbital

  write(ifile,*)
  write(ifile,*) &
       '[n|r|m]   = <psi[n]|r|psi[m]>   - <phi[n]|r|phi[m]>   =  [m|r|n]'
  write(ifile,*) &
       '[n|1/r|m] = <psi[n]|1/r|psi[m]> - <phi[n]|1/r|phi[m]> =  [m|1/r|n]'
  write(ifile,*) &
       '[n|pr|m]  = <psi[n]|pr|psi[m]>  - <phi[n]|pr|phi[m]>  = -[n|pr|m]'
  write(ifile,*) &
       'where pr = (1/r)*(d/dr)*r'

  write(ifile,*)

  if ( nspin == 1 ) then
     write(ifile,*) &
          '   n = (n1,l1,t1), m = (n2,l2,t2)'
     write(ifile,10) '[n]','[m]','[n|r|m]','[n|1/r|m]','[n|pr|m]'
  else if ( nspin == 2 ) then
     write(ifile,*) &
          '   n = (n1,l1,t1,s1), m = (n2,l2,t2,s2)'
     write(ifile,20) '[n]','[m]','[n|r|m]','[n|1/r|m]','[n|pr|m]'
  endif


  do ltlt = 1,num_dipole_l_us
     n1 = n1_dipole_l_us(ltlt) ; n2 = n2_dipole_l_us(ltlt)
     l1 = l1_dipole_l_us(ltlt) ; l2 = l2_dipole_l_us(ltlt)
     t1 = t1_dipole_l_us(ltlt) ; t2 = t2_dipole_l_us(ltlt)

     ispin1 = spin1_index_dipole_l_us(ltlt)

     if (l1 > l2) then
        cycle
     end if

     write(ch1,'(i1,a1,i1)') n1, fn_label_orbital(l1), t1
     write(ch2,'(i1,a1,i1)') n2, fn_label_orbital(l2), t2
     
     if ( nspin == 1 ) then
        write(ifile,11) ch1,ch2, &
             dipole_r_us(ltlt), dipole_ri_us(ltlt), dipole_pr_us(ltlt)

     else if ( nspin == 2 ) then
        if ( ispin1 == 1 ) then
           write(ifile,21) ch1, '_u' ,ch2, '_u', &
                dipole_r_us(ltlt), dipole_ri_us(ltlt), dipole_pr_us(ltlt)

        else if ( ispin1 == 2 ) then
           write(ifile,21) ch1, '_d' ,ch2, '_d', &
                dipole_r_us(ltlt), dipole_ri_us(ltlt), dipole_pr_us(ltlt)

        endif

     endif

  end do

10 format(1x,(2x,a3,'-',a3,2x),(10x,a7,3x),(10x,a9,1x),(10x,a8,2x))
11 format(1x,(2x,a3,'-',a3,2x),3f20.10)
20 format(1x,(4x,a3,'-',a3,4x),(10x,a7,3x),(10x,a9,1x),(10x,a8,2x))
21 format(1x,(2x,a3,a2,'-',a3,a2,2x),3f20.10)

end subroutine write_dipole_l_us_kt
! ========================================================================= 4.0

!=====================================================================
   subroutine write_dipole_l_ps(ifile)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(in) :: ifile
   integer :: n1, l1, n2, l2, nlnl
   character(3) :: ch1, ch2
   character(1) :: fn_label_orbital
   write(ifile,*)
   write(ifile,*) &
      'AE psi[boundstate]: n = (n1,l1), m = (n2,l2)'
   write(ifile,10) '[n]','[m]','<n|r|m>','<n|1/r|m>','<n|pr|m>'
   do nlnl = 1,num_dipole_l_ps
      n1 = n1_dipole_l_ps(nlnl) ; n2 = n2_dipole_l_ps(nlnl)
      l1 = l1_dipole_l_ps(nlnl) ; l2 = l2_dipole_l_ps(nlnl)
      if (l1 > l2) then
         cycle
      end if
      write(ch1,'(i1,a1)') n1, fn_label_orbital(l1)
      write(ch2,'(i1,a1)') n2, fn_label_orbital(l2)
      write(ifile,11) ch1,ch2, &
         dipole_r_ae(nlnl), dipole_ri_ae(nlnl), dipole_pr_ae(nlnl)
   end do
   write(ifile,*) &
      'where pr = (1/r)*(d/dr)*r'
   write(ifile,*)
   if ((is_solve_pp_spin /= NO).and.(is_spin_ss == RESTRICTED)) then
   write(ifile,*) &
      'PP phi[solved+polarized]: n = (n1,l1), m = (n2,l2)'
   else
   write(ifile,*) &
      'PP phi[solved+restricted]: n = (n1,l1), m = (n2,l2)'
   end if
   write(ifile,10) '[n]','[m]','<n|r|m>','<n|1/r|m>','<n|pr|m>'
   do nlnl = 1,num_dipole_l_ps
      n1 = n1_dipole_l_ps(nlnl) ; n2 = n2_dipole_l_ps(nlnl)
      l1 = l1_dipole_l_ps(nlnl) ; l2 = l2_dipole_l_ps(nlnl)
      if (l1 > l2) then
         cycle
      end if
      write(ch1,'(i1,a1)') n1, fn_label_orbital(l1)
      write(ch2,'(i1,a1)') n2, fn_label_orbital(l2)
      write(ifile,11) ch1,ch2, &
         dipole_r_pp(nlnl), dipole_ri_pp(nlnl), dipole_pr_pp(nlnl)
   end do
   write(ifile,*) &
      'where pr = (1/r)*(d/dr)*r'
10 format(1x,(1x,a3,'-',a3,1x),(10x,a7,3x),(10x,a9,1x),(10x,a8,2x))
11 format(1x,(2x,a2,'-',a2,2x),3f20.10)
   end subroutine write_dipole_l_ps

!=================================================== added by K. T. ======== 4.0
subroutine write_dipole_l_ps_kt(ifile)
  use parameters
  implicit none

  integer,intent(in) :: ifile

  integer :: n1, l1, n2, l2, nlnl
  character(3) :: ch1, ch2
  character(1) :: fn_label_orbital

  integer :: ispin1

  write(ifile,*)
  
  if ( nspin == 1 ) then
     write(ifile,*) &
          'AE psi[boundstate]: n = (n1,l1), m = (n2,l2)'
     write(ifile,10) '[n]','[m]','<n|r|m>','<n|1/r|m>','<n|pr|m>'
  
  else if ( nspin == 2 ) then
     write(ifile,*) &
          'AE psi[boundstate]: n = (n1,l1,s1), m = (n2,l2,s2)'

     write(ifile,20) '[n]','[m]','<n|r|m>','<n|1/r|m>','<n|pr|m>'
  endif


  do nlnl = 1,num_dipole_l_ps
     n1 = n1_dipole_l_ps(nlnl) ; n2 = n2_dipole_l_ps(nlnl)
     l1 = l1_dipole_l_ps(nlnl) ; l2 = l2_dipole_l_ps(nlnl)

     ispin1 = spin1_index_dipole_l_ps(nlnl)

!     write(*,*) 'ispin = ', ispin1

     if (l1 > l2) then
        cycle
     end if

     write(ch1,'(i1,a1)') n1, fn_label_orbital(l1)
     write(ch2,'(i1,a1)') n2, fn_label_orbital(l2)

     if ( nspin == 1 ) then
        write(ifile,11) ch1,ch2, &
             dipole_r_ae(nlnl), dipole_ri_ae(nlnl), dipole_pr_ae(nlnl)
        
     else if ( nspin == 2 ) then
        if ( ispin1 == 1 ) then 
           write(ifile,21) ch1 , '_u', ch2 , '_u', &
                dipole_r_ae(nlnl), dipole_ri_ae(nlnl), dipole_pr_ae(nlnl)
                
        else if ( ispin1 == 2 ) then 
           write(ifile,21) ch1 , '_d', ch2, '_d', &
                dipole_r_ae(nlnl), dipole_ri_ae(nlnl), dipole_pr_ae(nlnl)
        endif
     end if

  end do

  write(ifile,*) &
       'where pr = (1/r)*(d/dr)*r'

  write(ifile,*)

  if ((nspin==1).and.(is_solve_pp_spin /= NO).and.(is_spin_ss == RESTRICTED)) then
     write(ifile,*) &
          'PP phi[solved by solpp]: n = (n1,l1), m = (n2,l2)'
     write(ifile,10) '[n]','[m]','<n|r|m>','<n|1/r|m>','<n|pr|m>'
  else
     write(ifile,*) &
          'PP phi[solved by sol]: n = (n1,l1,s1), m = (n2,l2,s2)'
     write(ifile,20) '[n]','[m]','<n|r|m>','<n|1/r|m>','<n|pr|m>'
  end if


  do nlnl = 1,num_dipole_l_ps
     n1 = n1_dipole_l_ps(nlnl) ; n2 = n2_dipole_l_ps(nlnl)
     l1 = l1_dipole_l_ps(nlnl) ; l2 = l2_dipole_l_ps(nlnl)

     ispin1 = spin1_index_dipole_l_ps(nlnl)

     if (l1 > l2) then
        cycle
     end if
     write(ch1,'(i1,a1)') n1, fn_label_orbital(l1)
     write(ch2,'(i1,a1)') n2, fn_label_orbital(l2)

     if ( nspin == 1 ) then
        write(ifile,11) ch1,ch2, &
             dipole_r_pp(nlnl), dipole_ri_pp(nlnl), dipole_pr_pp(nlnl)

     else if ( nspin == 2 ) then
        if ( ispin1 == 1 ) then
           write(ifile,21) ch1, '_u', ch2, '_u', &
                dipole_r_pp(nlnl), dipole_ri_pp(nlnl), dipole_pr_pp(nlnl)

        else if ( ispin1 == 2 ) then
           write(ifile,21) ch1, '_d', ch2, '_d', &
                dipole_r_pp(nlnl), dipole_ri_pp(nlnl), dipole_pr_pp(nlnl)

        endif
     endif

  end do

  write(ifile,*) &
      'where pr = (1/r)*(d/dr)*r'

10 format(1x,(1x,a3,'-',a3,1x),(10x,a7,3x),(10x,a9,1x),(10x,a8,2x))
11 format(1x,(2x,a2,'-',a2,2x),3f20.10)
20 format(1x,(3x,a3,'-',a3,3x),(10x,a7,3x),(10x,a9,1x),(10x,a8,2x))
21 format(1x,(2x,a2,a2,'-',a2,a2,2x),3f20.10)

end subroutine write_dipole_l_ps_kt
! ============================================================================ 4.0

!=====================================================================
   subroutine sizeof_dipole_lm_us(ier)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer :: l1, l2, m1, m2, ltlt, ltmltm
   ier = 0
   ltmltm = 0
   do ltlt = 1,num_dipole_l_us
      l1 = l1_dipole_l_us(ltlt) ; l2 = l2_dipole_l_us(ltlt)
      do m1 = -l1,l1
      do m2 = -l2,l2
         ltmltm = ltmltm + 1
      end do
      end do
   end do
   num_dipole_lm_us = ltmltm
99 continue
   end subroutine sizeof_dipole_lm_us

!=====================================================================
   subroutine sizeof_dipole_lm_ps(ier)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer :: l1, l2, m1, m2, nlnl, nlmnlm
   ier = 0
   nlmnlm = 0
   do nlnl = 1,num_dipole_l_ps
      l1 = l1_dipole_l_ps(nlnl) ; l2 = l2_dipole_l_ps(nlnl)
      do m1 = -l1,l1
      do m2 = -l2,l2
         nlmnlm = nlmnlm + 1
      end do
      end do
   end do
   num_dipole_lm_ps = nlmnlm
99 continue
   end subroutine sizeof_dipole_lm_ps

!=====================================================================
   subroutine calc_dipole_lm_us(ier)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer :: n1, l1, t1, m1, k1, n2, l2, t2, m2, k2, &
              n1p, l1p, t1p, m1p, n2p, l2p, t2p, m2p, &
              ltlt, ltmltm, ltmltmz, ltmltmp, isum
   real(8) :: sum1, sum2, fac1, fac2
   ier = 0
   dipole_z_us (:) = 0.d0 ; dipole_dz_us(:) = 0.d0
   ltmltm = 0
   do ltlt = 1,num_dipole_l_us
      n1 = n1_dipole_l_us(ltlt) ; n2 = n2_dipole_l_us(ltlt)
      l1 = l1_dipole_l_us(ltlt) ; l2 = l2_dipole_l_us(ltlt)
      t1 = t1_dipole_l_us(ltlt) ; t2 = t2_dipole_l_us(ltlt)
      do m1 = -l1,l1
      do m2 = -l2,l2
         ltmltm = ltmltm + 1
         ltmltm_dipole_us(ltlt,m1,m2) = ltmltm
         ltlt_dipole_lm_us(ltmltm) = ltlt
         n1_dipole_lm_us(ltmltm) = n1 ; n2_dipole_lm_us(ltmltm) = n2
         l1_dipole_lm_us(ltmltm) = l1 ; l2_dipole_lm_us(ltmltm) = l2
         t1_dipole_lm_us(ltmltm) = t1 ; t2_dipole_lm_us(ltmltm) = t2
         m1_dipole_lm_us(ltmltm) = m1 ; m2_dipole_lm_us(ltmltm) = m2
         if (m1 /= m2) then
            cycle
         end if
         if (l1 == l2-1) then
            fac2 = sqrt(dble((l2+m2)*(l2-m2))/dble((2*l2+1)*(2*l2-1)))
            dipole_z_us (ltmltm) = fac2*dipole_r_us(ltlt)
            dipole_dz_us(ltmltm) = fac2*( &
               dipole_pr_us(ltlt) + dble(l2)*dipole_ri_us(ltlt) )
         else if (l1-1 == l2) then
            fac1 = sqrt(dble((l1+m1)*(l1-m1))/dble((2*l1+1)*(2*l1-1)))
            dipole_z_us (ltmltm) = fac1*dipole_r_us(ltlt)
            dipole_dz_us(ltmltm) = fac1*( &
               dipole_pr_us(ltlt) - dble(l1)*dipole_ri_us(ltlt) )
         end if
      end do
      end do
   end do
   if (ltmltm /= num_dipole_lm_us) then
      write(IFLOG,*) '### ERROR ### ltmltm /= num_dipole_lm_us'
      write(IFLOG,*) '   ltmltm           ...',ltmltm
      write(IFLOG,*) '   num_dipole_lm_us ...',num_dipole_lm_us
      ier = 1 ; go to 99
   end if
   dipole_x_us (:) = 0.d0 ; dipole_y_us (:) = 0.d0
   dipole_dx_us(:) = 0.d0 ; dipole_dy_us(:) = 0.d0
   do ltmltm = 1,num_dipole_lm_us
      ltlt = ltlt_dipole_lm_us(ltmltm)
      l1 = l1_dipole_lm_us(ltmltm) ; l2 = l2_dipole_lm_us(ltmltm)
      m1 = m1_dipole_lm_us(ltmltm) ; m2 = m2_dipole_lm_us(ltmltm)
      do k1 = -l1,l1
      do k2 = -l2,l2
         ltmltmz = ltmltm_dipole_us(ltlt,k1,k2)
         fac1 = pxyz(m1,k1,l1) * pxyz(m2,k2,l2)
         fac2 = pxyz(k1,m1,l1) * pxyz(k2,m2,l2)
         dipole_x_us(ltmltm) = dipole_x_us(ltmltm) &
            + dipole_z_us(ltmltmz) * fac1
         dipole_y_us(ltmltm) = dipole_y_us(ltmltm) &
            + dipole_z_us(ltmltmz) * fac2
         dipole_dx_us(ltmltm) = dipole_dx_us(ltmltm) &
            + dipole_dz_us(ltmltmz) * fac1
         dipole_dy_us(ltmltm) = dipole_dy_us(ltmltm) &
            + dipole_dz_us(ltmltmz) * fac2
      end do
      end do
   end do
   do ltmltm = 1,num_dipole_lm_us
      n1 = n1_dipole_lm_us(ltmltm) ; n2 = n2_dipole_lm_us(ltmltm)
      l1 = l1_dipole_lm_us(ltmltm) ; l2 = l2_dipole_lm_us(ltmltm)
      t1 = t1_dipole_lm_us(ltmltm) ; t2 = t2_dipole_lm_us(ltmltm)
      m1 = m1_dipole_lm_us(ltmltm) ; m2 = m2_dipole_lm_us(ltmltm)
      do ltmltmp = 1,num_dipole_lm_us
         n1p = n1_dipole_lm_us(ltmltmp) ; n2p = n2_dipole_lm_us(ltmltmp)
         l1p = l1_dipole_lm_us(ltmltmp) ; l2p = l2_dipole_lm_us(ltmltmp)
         t1p = t1_dipole_lm_us(ltmltmp) ; t2p = t2_dipole_lm_us(ltmltmp)
         m1p = m1_dipole_lm_us(ltmltmp) ; m2p = m2_dipole_lm_us(ltmltmp)
         isum = abs(n1-n2p) + abs(l1-l2p) + abs(t1-t2p) + abs(m1-m2p) &
              + abs(n2-n1p) + abs(l2-l1p) + abs(t2-t1p) + abs(m2-m1p)
         if (isum == 0) then
            sum1 = abs(dipole_x_us (ltmltm) - dipole_x_us (ltmltmp)) &
                 + abs(dipole_y_us (ltmltm) - dipole_y_us (ltmltmp)) &
                 + abs(dipole_z_us (ltmltm) - dipole_z_us (ltmltmp))
            sum2 = abs(dipole_dx_us(ltmltm) + dipole_dx_us(ltmltmp)) &
                 + abs(dipole_dy_us(ltmltm) + dipole_dy_us(ltmltmp)) &
                 + abs(dipole_dz_us(ltmltm) + dipole_dz_us(ltmltmp))
            if (abs(sum1) > 1.d-6) then
               write(IFLOG,*) '### ERROR ### [n|r|m] != [m|r|n]'
               write(IFLOG,*) '   n = (n1,l1,t1,m1) ...',n1,l1,t1,m1
               write(IFLOG,*) '   m = (n2,l2,t2,m2) ...',n2,l2,t2,m2
               write(IFLOG,*) '   [n|x|m]           ...',dipole_x_us(ltmltm)
               write(IFLOG,*) '   [m|x|n]           ...',dipole_x_us(ltmltmp)
               write(IFLOG,*) '   [n|y|m]           ...',dipole_y_us(ltmltm)
               write(IFLOG,*) '   [m|y|n]           ...',dipole_y_us(ltmltmp)
               write(IFLOG,*) '   [n|z|m]           ...',dipole_z_us(ltmltm)
               write(IFLOG,*) '   [m|z|n]           ...',dipole_z_us(ltmltmp)
               ier = 1 ; go to 99
            else if (abs(sum2) > 1.d-6) then
               write(IFLOG,*) '### ERROR ### [n|p|m] != -[m|p|n]'
               write(IFLOG,*) '   n = (n1,l1,t1,m1) ...',n1,l1,t1,m1
               write(IFLOG,*) '   m = (n2,l2,t2,m2) ...',n2,l2,t2,m2
               write(IFLOG,*) '   [n|d/dx|m]        ...',dipole_dx_us(ltmltm)
               write(IFLOG,*) '   [m|d/dx|n]        ...',dipole_dx_us(ltmltmp)
               write(IFLOG,*) '   [n|d/dy|m]        ...',dipole_dy_us(ltmltm)
               write(IFLOG,*) '   [m|d/dy|n]        ...',dipole_dy_us(ltmltmp)
               write(IFLOG,*) '   [n|d/dz|m]        ...',dipole_dz_us(ltmltm)
               write(IFLOG,*) '   [m|d/dz|n]        ...',dipole_dz_us(ltmltmp)
               ier = 2 ; go to 99
            else
               exit
            end if
         end if
         if (ltmltmp == num_dipole_lm_us) then
            write(IFLOG,*) '### ERROR ### ltmltmp was not found.'
            ier = 3 ; go to 99
         end if
      end do
   end do
99 continue
   end subroutine calc_dipole_lm_us

!====================================================== added by K. T. ======== 4.0
subroutine calc_dipole_lm_us_kt(ier)
  use parameters
  implicit none

  integer,intent(out) :: ier

  integer :: n1, l1, t1, m1, k1, n2, l2, t2, m2, k2, &
       n1p, l1p, t1p, m1p, n2p, l2p, t2p, m2p, &
       ltlt, ltmltm, ltmltmz, ltmltmp, isum
  integer :: ispin1, ispin2

  real(8) :: sum1, sum2, fac1, fac2

  ier = 0
  dipole_z_us (:) = 0.d0 ; dipole_dz_us(:) = 0.d0

  ltmltm = 0

  do ltlt = 1,num_dipole_l_us
     n1 = n1_dipole_l_us(ltlt) ; n2 = n2_dipole_l_us(ltlt)
     l1 = l1_dipole_l_us(ltlt) ; l2 = l2_dipole_l_us(ltlt)
     t1 = t1_dipole_l_us(ltlt) ; t2 = t2_dipole_l_us(ltlt)

     ispin1 = spin1_index_dipole_l_us(ltlt)

     do m1 = -l1,l1
        do m2 = -l2,l2
           ltmltm = ltmltm + 1

           ltmltm_dipole_us(ltlt,m1,m2) = ltmltm
           ltlt_dipole_lm_us(ltmltm) = ltlt

           n1_dipole_lm_us(ltmltm) = n1 ; n2_dipole_lm_us(ltmltm) = n2
           l1_dipole_lm_us(ltmltm) = l1 ; l2_dipole_lm_us(ltmltm) = l2
           t1_dipole_lm_us(ltmltm) = t1 ; t2_dipole_lm_us(ltmltm) = t2
           m1_dipole_lm_us(ltmltm) = m1 ; m2_dipole_lm_us(ltmltm) = m2

           spin1_index_dipole_lm_us(ltmltm) = ispin1

           if (m1 /= m2) then
              cycle
           end if

           if (l1 == l2-1) then
              fac2 = sqrt(dble((l2+m2)*(l2-m2))/dble((2*l2+1)*(2*l2-1)))
              dipole_z_us (ltmltm) = fac2*dipole_r_us(ltlt)
              dipole_dz_us(ltmltm) = fac2*( &
                   dipole_pr_us(ltlt) + dble(l2)*dipole_ri_us(ltlt) )
           else if (l1-1 == l2) then
              fac1 = sqrt(dble((l1+m1)*(l1-m1))/dble((2*l1+1)*(2*l1-1)))
              dipole_z_us (ltmltm) = fac1*dipole_r_us(ltlt)
              dipole_dz_us(ltmltm) = fac1*( &
                   dipole_pr_us(ltlt) - dble(l1)*dipole_ri_us(ltlt) )
           end if
        end do
     end do

  end do

  if (ltmltm /= num_dipole_lm_us) then
     write(IFLOG,*) '### ERROR ### ltmltm /= num_dipole_lm_us'
     write(IFLOG,*) '   ltmltm           ...',ltmltm
     write(IFLOG,*) '   num_dipole_lm_us ...',num_dipole_lm_us
     ier = 1 ; go to 99
  end if

  dipole_x_us (:) = 0.d0 ; dipole_y_us (:) = 0.d0
  dipole_dx_us(:) = 0.d0 ; dipole_dy_us(:) = 0.d0

  do ltmltm = 1,num_dipole_lm_us
     ltlt = ltlt_dipole_lm_us(ltmltm)
     l1 = l1_dipole_lm_us(ltmltm) ; l2 = l2_dipole_lm_us(ltmltm)
     m1 = m1_dipole_lm_us(ltmltm) ; m2 = m2_dipole_lm_us(ltmltm)

     do k1 = -l1,l1
        do k2 = -l2,l2
           ltmltmz = ltmltm_dipole_us(ltlt,k1,k2)
           fac1 = pxyz(m1,k1,l1) * pxyz(m2,k2,l2)
           fac2 = pxyz(k1,m1,l1) * pxyz(k2,m2,l2)

           dipole_x_us(ltmltm) = dipole_x_us(ltmltm) &
                + dipole_z_us(ltmltmz) * fac1
           dipole_y_us(ltmltm) = dipole_y_us(ltmltm) &
                + dipole_z_us(ltmltmz) * fac2
           dipole_dx_us(ltmltm) = dipole_dx_us(ltmltm) &
                + dipole_dz_us(ltmltmz) * fac1
           dipole_dy_us(ltmltm) = dipole_dy_us(ltmltm) &
                + dipole_dz_us(ltmltmz) * fac2
        end do
     end do
  end do

  do ltmltm = 1,num_dipole_lm_us
     n1 = n1_dipole_lm_us(ltmltm) ; n2 = n2_dipole_lm_us(ltmltm)
     l1 = l1_dipole_lm_us(ltmltm) ; l2 = l2_dipole_lm_us(ltmltm)
     t1 = t1_dipole_lm_us(ltmltm) ; t2 = t2_dipole_lm_us(ltmltm)
     m1 = m1_dipole_lm_us(ltmltm) ; m2 = m2_dipole_lm_us(ltmltm)

     ispin1 = spin1_index_dipole_lm_us(ltmltm)

     do ltmltmp = 1,num_dipole_lm_us
        n1p = n1_dipole_lm_us(ltmltmp) ; n2p = n2_dipole_lm_us(ltmltmp)
        l1p = l1_dipole_lm_us(ltmltmp) ; l2p = l2_dipole_lm_us(ltmltmp)
        t1p = t1_dipole_lm_us(ltmltmp) ; t2p = t2_dipole_lm_us(ltmltmp)
        m1p = m1_dipole_lm_us(ltmltmp) ; m2p = m2_dipole_lm_us(ltmltmp)

        ispin2 = spin1_index_dipole_lm_us(ltmltmp)

        isum = abs(n1-n2p) + abs(l1-l2p) + abs(t1-t2p) + abs(m1-m2p) &
              + abs(n2-n1p) + abs(l2-l1p) + abs(t2-t1p) + abs(m2-m1p)
        
        if (isum == 0 .and. ispin1==ispin2 ) then
           sum1 = abs(dipole_x_us (ltmltm) - dipole_x_us (ltmltmp)) &
                + abs(dipole_y_us (ltmltm) - dipole_y_us (ltmltmp)) &
                + abs(dipole_z_us (ltmltm) - dipole_z_us (ltmltmp))
           sum2 = abs(dipole_dx_us(ltmltm) + dipole_dx_us(ltmltmp)) &
                + abs(dipole_dy_us(ltmltm) + dipole_dy_us(ltmltmp)) &
                + abs(dipole_dz_us(ltmltm) + dipole_dz_us(ltmltmp))

           if (abs(sum1) > 1.d-6) then
              write(IFLOG,*) '### ERROR ### [n|r|m] != [m|r|n]'
              write(IFLOG,*) '   n = (n1,l1,t1,m1,s1) ...',n1,l1,t1,m1, ispin1
              write(IFLOG,*) '   m = (n2,l2,t2,m2,s2) ...',n2,l2,t2,m2, ispin2
              write(IFLOG,*) '   [n|x|m]           ...',dipole_x_us(ltmltm)
              write(IFLOG,*) '   [m|x|n]           ...',dipole_x_us(ltmltmp)
              write(IFLOG,*) '   [n|y|m]           ...',dipole_y_us(ltmltm)
              write(IFLOG,*) '   [m|y|n]           ...',dipole_y_us(ltmltmp)
              write(IFLOG,*) '   [n|z|m]           ...',dipole_z_us(ltmltm)
              write(IFLOG,*) '   [m|z|n]           ...',dipole_z_us(ltmltmp)
              ier = 1 ; go to 99

           else if (abs(sum2) > 1.d-6) then
              write(IFLOG,*) '### ERROR ### [n|p|m] != -[m|p|n]'
              write(IFLOG,*) '   n = (n1,l1,t1,m1,s1) ...',n1,l1,t1,m1, ispin1
              write(IFLOG,*) '   m = (n2,l2,t2,m2,s2) ...',n2,l2,t2,m2, ispin2
              write(IFLOG,*) '   [n|d/dx|m]        ...',dipole_dx_us(ltmltm)
              write(IFLOG,*) '   [m|d/dx|n]        ...',dipole_dx_us(ltmltmp)
              write(IFLOG,*) '   [n|d/dy|m]        ...',dipole_dy_us(ltmltm)
              write(IFLOG,*) '   [m|d/dy|n]        ...',dipole_dy_us(ltmltmp)
              write(IFLOG,*) '   [n|d/dz|m]        ...',dipole_dz_us(ltmltm)
              write(IFLOG,*) '   [m|d/dz|n]        ...',dipole_dz_us(ltmltmp)
              ier = 2 ; go to 99

           else
              exit
           end if

        end if

        if (ltmltmp == num_dipole_lm_us) then
           write(IFLOG,*) '### ERROR ### ltmltmp was not found.'
           ier = 3 ; go to 99
        end if

     end do
  end do

99 continue

end subroutine calc_dipole_lm_us_kt
! =========================================================================== 4.0
   
!=====================================================================
   subroutine calc_dipole_lm_ps(ier)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer :: n1, l1, m1, k1, n2, l2, m2, k2, &
              n1p, l1p, m1p, n2p, l2p, m2p, &
              nlnl, nlmnlm, nlmnlmz, nlmnlmp, isum
   real(8) :: sum1, sum2, sum3, sum4, fac1, fac2
   ier = 0
   dipole_z_ae (:) = 0.d0 ; dipole_z_pp (:) = 0.d0
   dipole_dz_ae(:) = 0.d0 ; dipole_dz_pp(:) = 0.d0
   nlmnlm = 0
   do nlnl = 1,num_dipole_l_ps
      n1 = n1_dipole_l_ps(nlnl) ; n2 = n2_dipole_l_ps(nlnl)
      l1 = l1_dipole_l_ps(nlnl) ; l2 = l2_dipole_l_ps(nlnl)
      do m1 = -l1,l1
      do m2 = -l2,l2
         nlmnlm = nlmnlm + 1
         nlmnlm_dipole_ps(nlnl,m1,m2) = nlmnlm
         nlnl_dipole_lm_ps(nlmnlm) = nlnl
         n1_dipole_lm_ps(nlmnlm) = n1 ; n2_dipole_lm_ps(nlmnlm) = n2
         l1_dipole_lm_ps(nlmnlm) = l1 ; l2_dipole_lm_ps(nlmnlm) = l2
         m1_dipole_lm_ps(nlmnlm) = m1 ; m2_dipole_lm_ps(nlmnlm) = m2
         if (m1 /= m2) then
            cycle
         end if
         if (l1 == l2-1) then
            fac2 = sqrt(dble((l2+m2)*(l2-m2))/dble((2*l2+1)*(2*l2-1)))
            dipole_z_ae (nlmnlm) = fac2*dipole_r_ae(nlnl)
            dipole_dz_ae(nlmnlm) = fac2*( &
               dipole_pr_ae(nlnl) + dble(l2)*dipole_ri_ae(nlnl) )
            dipole_z_pp (nlmnlm) = fac2*dipole_r_pp(nlnl)
            dipole_dz_pp(nlmnlm) = fac2*( &
               dipole_pr_pp(nlnl) + dble(l2)*dipole_ri_pp(nlnl) )
         else if (l1-1 == l2) then
            fac1 = sqrt(dble((l1+m1)*(l1-m1))/dble((2*l1+1)*(2*l1-1)))
            dipole_z_ae (nlmnlm) = fac1*dipole_r_ae(nlnl)
            dipole_dz_ae(nlmnlm) = fac1*( &
               dipole_pr_ae(nlnl) - dble(l1)*dipole_ri_ae(nlnl) )
            dipole_z_pp (nlmnlm) = fac1*dipole_r_pp(nlnl)
            dipole_dz_pp(nlmnlm) = fac1*( &
               dipole_pr_pp(nlnl) - dble(l1)*dipole_ri_pp(nlnl) )
         end if
      end do
      end do
   end do
   if (nlmnlm /= num_dipole_lm_ps) then
      write(IFLOG,*) '### ERROR ### nlmnlm /= num_dipole_lm_ps'
      write(IFLOG,*) '   nlmnlm           ...',nlmnlm
      write(IFLOG,*) '   num_dipole_lm_ps ...',num_dipole_lm_ps
      ier = 1 ; go to 99
   end if
   dipole_x_ae (:) = 0.d0 ; dipole_y_ae (:) = 0.d0
   dipole_dx_ae(:) = 0.d0 ; dipole_dy_ae(:) = 0.d0
   dipole_x_pp (:) = 0.d0 ; dipole_y_pp (:) = 0.d0
   dipole_dx_pp(:) = 0.d0 ; dipole_dy_pp(:) = 0.d0
   do nlmnlm = 1,num_dipole_lm_ps
      nlnl = nlnl_dipole_lm_ps(nlmnlm)
      l1 = l1_dipole_lm_ps(nlmnlm) ; l2 = l2_dipole_lm_ps(nlmnlm)
      m1 = m1_dipole_lm_ps(nlmnlm) ; m2 = m2_dipole_lm_ps(nlmnlm)
      do k1 = -l1,l1
      do k2 = -l2,l2
         nlmnlmz = nlmnlm_dipole_ps(nlnl,k1,k2)
         fac1 = pxyz(m1,k1,l1) * pxyz(m2,k2,l2)
         fac2 = pxyz(k1,m1,l1) * pxyz(k2,m2,l2)
         dipole_x_ae(nlmnlm) = dipole_x_ae(nlmnlm) &
            + dipole_z_ae(nlmnlmz) * fac1
         dipole_y_ae(nlmnlm) = dipole_y_ae(nlmnlm) &
            + dipole_z_ae(nlmnlmz) * fac2
         dipole_dx_ae(nlmnlm) = dipole_dx_ae(nlmnlm) &
            + dipole_dz_ae(nlmnlmz) * fac1
         dipole_dy_ae(nlmnlm) = dipole_dy_ae(nlmnlm) &
            + dipole_dz_ae(nlmnlmz) * fac2
         dipole_x_pp(nlmnlm) = dipole_x_pp(nlmnlm) &
            + dipole_z_pp(nlmnlmz) * fac1
         dipole_y_pp(nlmnlm) = dipole_y_pp(nlmnlm) &
            + dipole_z_pp(nlmnlmz) * fac2
         dipole_dx_pp(nlmnlm) = dipole_dx_pp(nlmnlm) &
            + dipole_dz_pp(nlmnlmz) * fac1
         dipole_dy_pp(nlmnlm) = dipole_dy_pp(nlmnlm) &
            + dipole_dz_pp(nlmnlmz) * fac2
      end do
      end do
   end do
   do nlmnlm = 1,num_dipole_lm_ps
      n1 = n1_dipole_lm_ps(nlmnlm) ; n2 = n2_dipole_lm_ps(nlmnlm)
      l1 = l1_dipole_lm_ps(nlmnlm) ; l2 = l2_dipole_lm_ps(nlmnlm)
      m1 = m1_dipole_lm_ps(nlmnlm) ; m2 = m2_dipole_lm_ps(nlmnlm)
      do nlmnlmp = 1,num_dipole_lm_ps
         n1p = n1_dipole_lm_ps(nlmnlmp) ; n2p = n2_dipole_lm_ps(nlmnlmp)
         l1p = l1_dipole_lm_ps(nlmnlmp) ; l2p = l2_dipole_lm_ps(nlmnlmp)
         m1p = m1_dipole_lm_ps(nlmnlmp) ; m2p = m2_dipole_lm_ps(nlmnlmp)
         isum = abs(n1-n2p) + abs(l1-l2p) + abs(m1-m2p) &
              + abs(n2-n1p) + abs(l2-l1p) + abs(m2-m1p)
         if (isum == 0) then
            sum1 = abs(dipole_x_ae(nlmnlm) - dipole_x_ae(nlmnlmp)) &
                 + abs(dipole_y_ae(nlmnlm) - dipole_y_ae(nlmnlmp)) &
                 + abs(dipole_z_ae(nlmnlm) - dipole_z_ae(nlmnlmp))
            sum2 = abs(dipole_dx_ae(nlmnlm) + dipole_dx_ae(nlmnlmp)) &
                 + abs(dipole_dy_ae(nlmnlm) + dipole_dy_ae(nlmnlmp)) &
                 + abs(dipole_dz_ae(nlmnlm) + dipole_dz_ae(nlmnlmp))
            sum3 = abs(dipole_x_pp(nlmnlm) - dipole_x_pp(nlmnlmp)) &
                 + abs(dipole_y_pp(nlmnlm) - dipole_y_pp(nlmnlmp)) &
                 + abs(dipole_z_pp(nlmnlm) - dipole_z_pp(nlmnlmp))
            sum4 = abs(dipole_dx_pp(nlmnlm) + dipole_dx_pp(nlmnlmp)) &
                 + abs(dipole_dy_pp(nlmnlm) + dipole_dy_pp(nlmnlmp)) &
                 + abs(dipole_dz_pp(nlmnlm) + dipole_dz_pp(nlmnlmp))
            if (abs(sum1) > 1.d-6) then
               write(IFLOG,*) '### ERROR ### <n|r|m> != <m|r|n>'
               write(IFLOG,*) '   n = (n1,l1,m1) ...',n1,l1,m1
               write(IFLOG,*) '   m = (n2,l2,m2) ...',n2,l2,m2
               write(IFLOG,*) '   <n|x|m>        ...',dipole_x_ae(nlmnlm)
               write(IFLOG,*) '   <m|x|n>        ...',dipole_x_ae(nlmnlmp)
               write(IFLOG,*) '   <n|y|m>        ...',dipole_y_ae(nlmnlm)
               write(IFLOG,*) '   <m|y|n>        ...',dipole_y_ae(nlmnlmp)
               write(IFLOG,*) '   <n|z|m>        ...',dipole_z_ae(nlmnlm)
               write(IFLOG,*) '   <m|z|n>        ...',dipole_z_ae(nlmnlmp)
               ier = 1 ; go to 99
            else if (abs(sum2) > 1.d-6) then
               write(IFLOG,*) '### ERROR ### <n|p|m> != -<m|p|n>'
               write(IFLOG,*) '   n = (n1,l1,m1) ...',n1,l1,m1
               write(IFLOG,*) '   m = (n2,l2,m2) ...',n2,l2,m2
               write(IFLOG,*) '   <n|d/dx|m>     ...',dipole_dx_ae(nlmnlm)
               write(IFLOG,*) '   <m|d/dx|n>     ...',dipole_dx_ae(nlmnlmp)
               write(IFLOG,*) '   <n|d/dy|m>     ...',dipole_dy_ae(nlmnlm)
               write(IFLOG,*) '   <m|d/dy|n>     ...',dipole_dy_ae(nlmnlmp)
               write(IFLOG,*) '   <n|d/dz|m>     ...',dipole_dz_ae(nlmnlm)
               write(IFLOG,*) '   <m|d/dz|n>     ...',dipole_dz_ae(nlmnlmp)
               ier = 2 ; go to 99
            else if (abs(sum3) > 1.d-6) then
               write(IFLOG,*) '### ERROR ### <n|r|m> != <m|r|n>'
               write(IFLOG,*) '   n = (n1,l1,m1) ...',n1,l1,m1
               write(IFLOG,*) '   m = (n2,l2,m2) ...',n2,l2,m2
               write(IFLOG,*) '   <n|x|m>        ...',dipole_x_pp(nlmnlm)
               write(IFLOG,*) '   <m|x|n>        ...',dipole_x_pp(nlmnlmp)
               write(IFLOG,*) '   <n|y|m>        ...',dipole_y_pp(nlmnlm)
               write(IFLOG,*) '   <m|y|n>        ...',dipole_y_pp(nlmnlmp)
               write(IFLOG,*) '   <n|z|m>        ...',dipole_z_pp(nlmnlm)
               write(IFLOG,*) '   <m|z|n>        ...',dipole_z_pp(nlmnlmp)
               ier = 3 ; go to 99
            else if (abs(sum4) > 1.d-6) then
               write(IFLOG,*) '### ERROR ### <n|p|m> != -<m|p|n>'
               write(IFLOG,*) '   n = (n1,l1,m1) ...',n1,l1,m1
               write(IFLOG,*) '   m = (n2,l2,m2) ...',n2,l2,m2
               write(IFLOG,*) '   <n|d/dx|m>     ...',dipole_dx_pp(nlmnlm)
               write(IFLOG,*) '   <m|d/dx|n>     ...',dipole_dx_pp(nlmnlmp)
               write(IFLOG,*) '   <n|d/dy|m>     ...',dipole_dy_pp(nlmnlm)
               write(IFLOG,*) '   <m|d/dy|n>     ...',dipole_dy_pp(nlmnlmp)
               write(IFLOG,*) '   <n|d/dz|m>     ...',dipole_dz_pp(nlmnlm)
               write(IFLOG,*) '   <m|d/dz|n>     ...',dipole_dz_pp(nlmnlmp)
               ier = 4 ; go to 99
            else
               exit
            end if
         end if
         if (nlmnlmp == num_dipole_lm_ps) then
            write(IFLOG,*) '### ERROR ### nlmnlmp was not found.'
            ier = 5 ; go to 99
         end if
      end do
   end do
99 continue
   end subroutine calc_dipole_lm_ps

!======================================================= added by K. T. ======= 4.0
subroutine calc_dipole_lm_ps_kt(ier)
  use parameters
  implicit none

  integer,intent(out) :: ier

  integer :: n1, l1, m1, k1, n2, l2, m2, k2, &
       n1p, l1p, m1p, n2p, l2p, m2p, &
       nlnl, nlmnlm, nlmnlmz, nlmnlmp, isum
  real(8) :: sum1, sum2, sum3, sum4, fac1, fac2

  integer :: ispin1, ispin2

  ier = 0

  dipole_z_ae (:) = 0.d0 ; dipole_z_pp (:) = 0.d0
  dipole_dz_ae(:) = 0.d0 ; dipole_dz_pp(:) = 0.d0

  nlmnlm = 0

  do nlnl = 1,num_dipole_l_ps
     n1 = n1_dipole_l_ps(nlnl) ; n2 = n2_dipole_l_ps(nlnl)
     l1 = l1_dipole_l_ps(nlnl) ; l2 = l2_dipole_l_ps(nlnl)

     ispin1 = spin1_index_dipole_l_ps(nlnl)

     do m1 = -l1,l1
        do m2 = -l2,l2
           nlmnlm = nlmnlm + 1
           nlmnlm_dipole_ps(nlnl,m1,m2) = nlmnlm

           nlnl_dipole_lm_ps(nlmnlm) = nlnl

           n1_dipole_lm_ps(nlmnlm) = n1 ; n2_dipole_lm_ps(nlmnlm) = n2
           l1_dipole_lm_ps(nlmnlm) = l1 ; l2_dipole_lm_ps(nlmnlm) = l2
           m1_dipole_lm_ps(nlmnlm) = m1 ; m2_dipole_lm_ps(nlmnlm) = m2

           spin1_index_dipole_lm_ps(nlmnlm) = ispin1

           if (m1 /= m2) then
              cycle
           end if

           if (l1 == l2-1) then
              fac2 = sqrt(dble((l2+m2)*(l2-m2))/dble((2*l2+1)*(2*l2-1)))

              dipole_z_ae (nlmnlm) = fac2*dipole_r_ae(nlnl)
              dipole_dz_ae(nlmnlm) = fac2*( &
                   dipole_pr_ae(nlnl) + dble(l2)*dipole_ri_ae(nlnl) )
              dipole_z_pp (nlmnlm) = fac2*dipole_r_pp(nlnl)
              dipole_dz_pp(nlmnlm) = fac2*( &
                   dipole_pr_pp(nlnl) + dble(l2)*dipole_ri_pp(nlnl) )

           else if (l1-1 == l2) then
              fac1 = sqrt(dble((l1+m1)*(l1-m1))/dble((2*l1+1)*(2*l1-1)))

              dipole_z_ae (nlmnlm) = fac1*dipole_r_ae(nlnl)
              dipole_dz_ae(nlmnlm) = fac1*( &
                   dipole_pr_ae(nlnl) - dble(l1)*dipole_ri_ae(nlnl) )
              dipole_z_pp (nlmnlm) = fac1*dipole_r_pp(nlnl)
              dipole_dz_pp(nlmnlm) = fac1*( &
                   dipole_pr_pp(nlnl) - dble(l1)*dipole_ri_pp(nlnl) )
           end if

        end do
     end do

  end do

  if (nlmnlm /= num_dipole_lm_ps) then
     write(IFLOG,*) '### ERROR ### nlmnlm /= num_dipole_lm_ps'
     write(IFLOG,*) '   nlmnlm           ...',nlmnlm
     write(IFLOG,*) '   num_dipole_lm_ps ...',num_dipole_lm_ps
     ier = 1 ; go to 99
  end if

  dipole_x_ae (:) = 0.d0 ; dipole_y_ae (:) = 0.d0
  dipole_dx_ae(:) = 0.d0 ; dipole_dy_ae(:) = 0.d0
  dipole_x_pp (:) = 0.d0 ; dipole_y_pp (:) = 0.d0
  dipole_dx_pp(:) = 0.d0 ; dipole_dy_pp(:) = 0.d0

  do nlmnlm = 1,num_dipole_lm_ps
     nlnl = nlnl_dipole_lm_ps(nlmnlm)
     l1 = l1_dipole_lm_ps(nlmnlm) ; l2 = l2_dipole_lm_ps(nlmnlm)
     m1 = m1_dipole_lm_ps(nlmnlm) ; m2 = m2_dipole_lm_ps(nlmnlm)

     do k1 = -l1,l1
        do k2 = -l2,l2
           nlmnlmz = nlmnlm_dipole_ps(nlnl,k1,k2)

           fac1 = pxyz(m1,k1,l1) * pxyz(m2,k2,l2)
           fac2 = pxyz(k1,m1,l1) * pxyz(k2,m2,l2)

           dipole_x_ae(nlmnlm) = dipole_x_ae(nlmnlm) &
                + dipole_z_ae(nlmnlmz) * fac1
           dipole_y_ae(nlmnlm) = dipole_y_ae(nlmnlm) &
                + dipole_z_ae(nlmnlmz) * fac2
           dipole_dx_ae(nlmnlm) = dipole_dx_ae(nlmnlm) &
                + dipole_dz_ae(nlmnlmz) * fac1
           dipole_dy_ae(nlmnlm) = dipole_dy_ae(nlmnlm) &
                + dipole_dz_ae(nlmnlmz) * fac2

           dipole_x_pp(nlmnlm) = dipole_x_pp(nlmnlm) &
                + dipole_z_pp(nlmnlmz) * fac1
           dipole_y_pp(nlmnlm) = dipole_y_pp(nlmnlm) &
                + dipole_z_pp(nlmnlmz) * fac2
           dipole_dx_pp(nlmnlm) = dipole_dx_pp(nlmnlm) &
                + dipole_dz_pp(nlmnlmz) * fac1
           dipole_dy_pp(nlmnlm) = dipole_dy_pp(nlmnlm) &
                + dipole_dz_pp(nlmnlmz) * fac2
        end do
     end do
  end do

  do nlmnlm = 1,num_dipole_lm_ps
     n1 = n1_dipole_lm_ps(nlmnlm) ; n2 = n2_dipole_lm_ps(nlmnlm)
     l1 = l1_dipole_lm_ps(nlmnlm) ; l2 = l2_dipole_lm_ps(nlmnlm)
     m1 = m1_dipole_lm_ps(nlmnlm) ; m2 = m2_dipole_lm_ps(nlmnlm)

     ispin1 = spin1_index_dipole_lm_ps(nlmnlm)

     do nlmnlmp = 1,num_dipole_lm_ps
        n1p = n1_dipole_lm_ps(nlmnlmp) ; n2p = n2_dipole_lm_ps(nlmnlmp)
        l1p = l1_dipole_lm_ps(nlmnlmp) ; l2p = l2_dipole_lm_ps(nlmnlmp)
        m1p = m1_dipole_lm_ps(nlmnlmp) ; m2p = m2_dipole_lm_ps(nlmnlmp)

        ispin2 = spin1_index_dipole_lm_ps(nlmnlmp)

        isum = abs(n1-n2p) + abs(l1-l2p) + abs(m1-m2p) &
             + abs(n2-n1p) + abs(l2-l1p) + abs(m2-m1p)

        if (isum == 0 .and. ispin1==ispin2 ) then
           sum1 = abs(dipole_x_ae(nlmnlm) - dipole_x_ae(nlmnlmp)) &
                + abs(dipole_y_ae(nlmnlm) - dipole_y_ae(nlmnlmp)) &
                + abs(dipole_z_ae(nlmnlm) - dipole_z_ae(nlmnlmp))
           sum2 = abs(dipole_dx_ae(nlmnlm) + dipole_dx_ae(nlmnlmp)) &
                + abs(dipole_dy_ae(nlmnlm) + dipole_dy_ae(nlmnlmp)) &
                + abs(dipole_dz_ae(nlmnlm) + dipole_dz_ae(nlmnlmp))
           sum3 = abs(dipole_x_pp(nlmnlm) - dipole_x_pp(nlmnlmp)) &
                + abs(dipole_y_pp(nlmnlm) - dipole_y_pp(nlmnlmp)) &
                + abs(dipole_z_pp(nlmnlm) - dipole_z_pp(nlmnlmp))
           sum4 = abs(dipole_dx_pp(nlmnlm) + dipole_dx_pp(nlmnlmp)) &
                + abs(dipole_dy_pp(nlmnlm) + dipole_dy_pp(nlmnlmp)) &
                + abs(dipole_dz_pp(nlmnlm) + dipole_dz_pp(nlmnlmp))

           if (abs(sum1) > 1.d-6) then
              write(IFLOG,*) '### ERROR ### <n|r|m> != <m|r|n>'
              write(IFLOG,*) '   n = (n1,l1,m1,s1) ...',n1,l1,m1, ispin1
              write(IFLOG,*) '   m = (n2,l2,m2,s2) ...',n2,l2,m2, ispin2
              write(IFLOG,*) '   <n|x|m>        ...',dipole_x_ae(nlmnlm)
              write(IFLOG,*) '   <m|x|n>        ...',dipole_x_ae(nlmnlmp)
              write(IFLOG,*) '   <n|y|m>        ...',dipole_y_ae(nlmnlm)
              write(IFLOG,*) '   <m|y|n>        ...',dipole_y_ae(nlmnlmp)
              write(IFLOG,*) '   <n|z|m>        ...',dipole_z_ae(nlmnlm)
              write(IFLOG,*) '   <m|z|n>        ...',dipole_z_ae(nlmnlmp)
              ier = 1 ; go to 99

           else if (abs(sum2) > 1.d-6) then
              write(IFLOG,*) '### ERROR ### <n|p|m> != -<m|p|n>'
              write(IFLOG,*) '   n = (n1,l1,m1,s1) ...',n1,l1,m1, ispin1
              write(IFLOG,*) '   m = (n2,l2,m2,s2) ...',n2,l2,m2, ispin2
              write(IFLOG,*) '   <n|d/dx|m>     ...',dipole_dx_ae(nlmnlm)
              write(IFLOG,*) '   <m|d/dx|n>     ...',dipole_dx_ae(nlmnlmp)
              write(IFLOG,*) '   <n|d/dy|m>     ...',dipole_dy_ae(nlmnlm)
              write(IFLOG,*) '   <m|d/dy|n>     ...',dipole_dy_ae(nlmnlmp)
              write(IFLOG,*) '   <n|d/dz|m>     ...',dipole_dz_ae(nlmnlm)
              write(IFLOG,*) '   <m|d/dz|n>     ...',dipole_dz_ae(nlmnlmp)
              ier = 2 ; go to 99

           else if (abs(sum3) > 1.d-6) then
              write(IFLOG,*) '### ERROR ### <n|r|m> != <m|r|n>'
              write(IFLOG,*) '   n = (n1,l1,m1,s1) ...',n1,l1,m1, ispin1
              write(IFLOG,*) '   m = (n2,l2,m2,s2) ...',n2,l2,m2, ispin2
              write(IFLOG,*) '   <n|x|m>        ...',dipole_x_pp(nlmnlm)
              write(IFLOG,*) '   <m|x|n>        ...',dipole_x_pp(nlmnlmp)
              write(IFLOG,*) '   <n|y|m>        ...',dipole_y_pp(nlmnlm)
              write(IFLOG,*) '   <m|y|n>        ...',dipole_y_pp(nlmnlmp)
              write(IFLOG,*) '   <n|z|m>        ...',dipole_z_pp(nlmnlm)
              write(IFLOG,*) '   <m|z|n>        ...',dipole_z_pp(nlmnlmp)
              ier = 3 ; go to 99

           else if (abs(sum4) > 1.d-6) then
              write(IFLOG,*) '### ERROR ### <n|p|m> != -<m|p|n>'
              write(IFLOG,*) '   n = (n1,l1,m1,t1) ...',n1,l1,m1, ispin1
              write(IFLOG,*) '   m = (n2,l2,m2,t2) ...',n2,l2,m2, ispin2
              write(IFLOG,*) '   <n|d/dx|m>     ...',dipole_dx_pp(nlmnlm)
              write(IFLOG,*) '   <m|d/dx|n>     ...',dipole_dx_pp(nlmnlmp)
              write(IFLOG,*) '   <n|d/dy|m>     ...',dipole_dy_pp(nlmnlm)
              write(IFLOG,*) '   <m|d/dy|n>     ...',dipole_dy_pp(nlmnlmp)
              write(IFLOG,*) '   <n|d/dz|m>     ...',dipole_dz_pp(nlmnlm)
              write(IFLOG,*) '   <m|d/dz|n>     ...',dipole_dz_pp(nlmnlmp)
              ier = 4 ; go to 99

           else
              exit
           end if
        end if
        if (nlmnlmp == num_dipole_lm_ps) then
           write(IFLOG,*) '### ERROR ### nlmnlmp was not found.'
           ier = 5 ; go to 99
        end if

     end do
  end do
99 continue

end subroutine calc_dipole_lm_ps_kt
! ========================================================================== 4.0
   
!=====================================================================
subroutine calc_dipole_repaired(ier)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
  use parameters
  implicit none
  integer,intent(out) :: ier
  integer :: l1, m1, ips1, iss1, l2, m2, ips2, iss2, &
       l1p, m1p, lt1, l2p, m2p, lt2, &
       nlnl, nlmnlm, ltlt, ltmltm, iss, isum
  real(8) :: sum1, sum2, sum3, sum4, sum5, sum6, fac
  ier = 0
  dipole_x_ss(:) = 0.d0 ; dipole_dx_ss(:) = 0.d0
  dipole_y_ss(:) = 0.d0 ; dipole_dy_ss(:) = 0.d0
  dipole_z_ss(:) = 0.d0 ; dipole_dz_ss(:) = 0.d0
  do nlmnlm = 1,num_dipole_lm_ps
     l1 = l1_dipole_lm_ps(nlmnlm) ; l2 = l2_dipole_lm_ps(nlmnlm)
     m1 = m1_dipole_lm_ps(nlmnlm) ; m2 = m2_dipole_lm_ps(nlmnlm)
     nlnl = nlnl_dipole_lm_ps(nlmnlm)
     ips1 = ips1_dipole_l_ps(nlnl) ; ips2 = ips2_dipole_l_ps(nlnl)
     do iss = 1,nss
        if (ishell_ss(iss) == ishell_ps(ips1,1)) then
           iss1 = iss ; exit
        end if
        if (iss == nss) then
           write(IFLOG,*) '### ERROR ### iss1 was not found'
           ier = 1 ; go to 99
        end if
     end do
     do iss = 1,nss
        if (ishell_ss(iss) == ishell_ps(ips2,1)) then
           iss2 = iss ; exit
        end if
        if (iss == nss) then
           write(IFLOG,*) '### ERROR ### iss2 was not found'
           ier = 2 ; go to 99
        end if
     end do
     sum1 = 0.d0 ; sum2 = 0.d0 ; sum3 = 0.d0
     sum4 = 0.d0 ; sum5 = 0.d0 ; sum6 = 0.d0
     do ltmltm = 1,num_dipole_lm_us
        l1p = l1_dipole_lm_us(ltmltm) ; l2p = l2_dipole_lm_us(ltmltm)
        m1p = m1_dipole_lm_us(ltmltm) ; m2p = m2_dipole_lm_us(ltmltm)
        ltlt = ltlt_dipole_lm_us(ltmltm)
        lt1 = lt1_dipole_l_us(ltlt) ; lt2 = lt2_dipole_l_us(ltlt)
        fac = beta_phi_ss(lt1,iss1) * beta_phi_ss(lt2,iss2)
        isum = abs(l1-l1p) + abs(l2-l2p) + abs(m1-m1p) + abs(m2-m2p)
        if (isum == 0) then
           sum1 = sum1 + dipole_x_us (ltmltm) * fac
           sum2 = sum2 + dipole_y_us (ltmltm) * fac
           sum3 = sum3 + dipole_z_us (ltmltm) * fac
           sum4 = sum4 + dipole_dx_us(ltmltm) * fac
           sum5 = sum5 + dipole_dy_us(ltmltm) * fac
           sum6 = sum6 + dipole_dz_us(ltmltm) * fac
        end if
     end do
     dipole_x_ss (nlmnlm) = dipole_x_pp (nlmnlm) + sum1
     dipole_y_ss (nlmnlm) = dipole_y_pp (nlmnlm) + sum2
     dipole_z_ss (nlmnlm) = dipole_z_pp (nlmnlm) + sum3
     dipole_dx_ss(nlmnlm) = dipole_dx_pp(nlmnlm) + sum4
     dipole_dy_ss(nlmnlm) = dipole_dy_pp(nlmnlm) + sum5
     dipole_dz_ss(nlmnlm) = dipole_dz_pp(nlmnlm) + sum6
  end do
99 continue
end subroutine calc_dipole_repaired
   
!=====================================================================
subroutine write_rdipole_lm_us(ifile)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
  use parameters
  implicit none
  integer,intent(in) :: ifile
  integer :: n1, l1, t1, m1, n2, l2, t2, m2, ltmltm
  character(3) :: ch1, ch2
  character(1) :: fn_label_orbital
  write(ifile,*)
  write(ifile,*) &
       '[n|x|m] = <psi[n]|x|psi[m]> - <phi[n]|x|phi[m]> = [m|x|n]'
  write(ifile,*) &
       '[n|y|m] = <psi[n]|y|psi[m]> - <phi[n]|y|phi[m]> = [m|y|n]'
  write(ifile,*) &
       '[n|z|m] = <psi[n]|z|psi[m]> - <phi[n]|z|phi[m]> = [m|z|n]'
  write(ifile,*)
  write(ifile,*) &
       '   n = (n1,l1,t1,m1), m = (n2,l2,t2,m2)'
  write(ifile,10) &
       '[n]','[m]','[n|x|m]','[n|y|m]','[n|z|m]'
  do ltmltm = 1,num_dipole_lm_us
     n1 = n1_dipole_lm_us(ltmltm) ; n2 = n2_dipole_lm_us(ltmltm)
     l1 = l1_dipole_lm_us(ltmltm) ; l2 = l2_dipole_lm_us(ltmltm)
     t1 = t1_dipole_lm_us(ltmltm) ; t2 = t2_dipole_lm_us(ltmltm)
     m1 = m1_dipole_lm_us(ltmltm) ; m2 = m2_dipole_lm_us(ltmltm)
     if (l1 > l2) then
        cycle
     end if
     write(ch1,'(i1,a1,i1)') n1, fn_label_orbital(l1), t1
     write(ch2,'(i1,a1,i1)') n2, fn_label_orbital(l2), t2
     write(ifile,11) ch1,m1,ch2,m2,dipole_x_us(ltmltm), &
          dipole_y_us(ltmltm),dipole_z_us(ltmltm)
  end do
10 format(1x,(2x,4x,a3,'-',a3,4x,2x),3(10x,a7,3x))
11 format(1x,(2x,a3,'(',i2,')','-',a3,'(',i2,')',2x),3f20.10)
end subroutine write_rdipole_lm_us

!=================================================== added by K. T. =========== 4.0
subroutine write_rdipole_lm_us_kt(ifile)
  use parameters
  implicit none

  integer,intent(in) :: ifile

  integer :: n1, l1, t1, m1, n2, l2, t2, m2, ltmltm
  character(3) :: ch1, ch2
  character(1) :: fn_label_orbital

  integer :: ispin1

  write(ifile,*)
  write(ifile,*) &
       '[n|x|m] = <psi[n]|x|psi[m]> - <phi[n]|x|phi[m]> = [m|x|n]'
  write(ifile,*) &
       '[n|y|m] = <psi[n]|y|psi[m]> - <phi[n]|y|phi[m]> = [m|y|n]'
  write(ifile,*) &
       '[n|z|m] = <psi[n]|z|psi[m]> - <phi[n]|z|phi[m]> = [m|z|n]'

  write(ifile,*)
  if ( nspin == 1 ) then
     write(ifile,*) &
          '   n = (n1,l1,t1,m1), m = (n2,l2,t2,m2)'
     write(ifile,10) '[n]','[m]','[n|x|m]','[n|y|m]','[n|z|m]'
  else if ( nspin == 2 ) then
     write(ifile,*) &
          '   n = (n1,l1,t1,m1,s1), m = (n2,l2,t2,m2,s2)'
     write(ifile,20) '[n]','[m]','[n|x|m]','[n|y|m]','[n|z|m]'
  end if
  
  
  do ltmltm = 1,num_dipole_lm_us
     n1 = n1_dipole_lm_us(ltmltm) ; n2 = n2_dipole_lm_us(ltmltm)
     l1 = l1_dipole_lm_us(ltmltm) ; l2 = l2_dipole_lm_us(ltmltm)
     t1 = t1_dipole_lm_us(ltmltm) ; t2 = t2_dipole_lm_us(ltmltm)
     m1 = m1_dipole_lm_us(ltmltm) ; m2 = m2_dipole_lm_us(ltmltm)
     
     ispin1 = spin1_index_dipole_lm_us(ltmltm)

     if (l1 > l2) then
        cycle
     end if
     
     write(ch1,'(i1,a1,i1)') n1, fn_label_orbital(l1), t1
     write(ch2,'(i1,a1,i1)') n2, fn_label_orbital(l2), t2

     if ( nspin == 1 ) then
        write(ifile,11) ch1,m1,ch2,m2,dipole_x_us(ltmltm), &
             dipole_y_us(ltmltm),dipole_z_us(ltmltm)

     else if ( nspin == 2 ) then
        if ( ispin1 == 1 ) then
           write(ifile,21) ch1, '_u', m1, ch2,  '_u', m2, &
                &       dipole_x_us(ltmltm), dipole_y_us(ltmltm), dipole_z_us(ltmltm)

        else if ( ispin1 == 2 ) then
           write(ifile,21) ch1, '_d', m1, ch2, '_d', m2, &
                &       dipole_x_us(ltmltm), dipole_y_us(ltmltm), dipole_z_us(ltmltm)

        endif
     endif

  end do
  
10 format(1x,(2x,4x,a3,'-',a3,4x,2x),3(10x,a7,3x))
11 format(1x,(2x,a3,'(',i2,')','-',a3,'(',i2,')',2x),3f20.10)
20 format(1x,(4x,4x,a3,'-',a3,4x,4x),3(10x,a7,3x))
21 format(1x,(2x,a3,a2,'(',i2,')','-',a3,a2,'(',i2,')',2x),3f20.10)

end subroutine write_rdipole_lm_us_kt
! ========================================================================= 4.0

!=====================================================================
subroutine write_rdipole_lm_ps(ifile)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
  use parameters
  implicit none
  integer,intent(in) :: ifile
  integer :: n1, l1, m1, n2, l2, m2, nlmnlm
  character(3) :: ch1, ch2
  character(1) :: fn_label_orbital
  write(ifile,*)
  write(ifile,*) &
       'AE psi[boundstate]: n = (n1,l1,m1), m = (n2,l2,m2)'
  write(ifile,10) &
       '[n]','[m]','<n|x|m>','<n|y|m>','<n|z|m>'
  do nlmnlm = 1,num_dipole_lm_ps
     n1 = n1_dipole_lm_ps(nlmnlm) ; n2 = n2_dipole_lm_ps(nlmnlm)
     l1 = l1_dipole_lm_ps(nlmnlm) ; l2 = l2_dipole_lm_ps(nlmnlm)
     m1 = m1_dipole_lm_ps(nlmnlm) ; m2 = m2_dipole_lm_ps(nlmnlm)
     if (l1 > l2) then
        cycle
     end if
     write(ch1,'(i1,a1)') n1, fn_label_orbital(l1)
     write(ch2,'(i1,a1)') n2, fn_label_orbital(l2)
     write(ifile,11) ch1,m1,ch2,m2,dipole_x_ae(nlmnlm), &
          dipole_y_ae(nlmnlm),dipole_z_ae(nlmnlm)
  end do
  write(ifile,*)
  if ((is_solve_pp_spin /= NO).and.(is_spin_ss == RESTRICTED)) then
     write(ifile,*) &
          'PP phi[solved+polarized]: n = (n1,l1,m1), m = (n2,l2,m2)'
  else
     write(ifile,*) &
          'PP phi[solved+restricted]: n = (n1,l1,m1), m = (n2,l2,m2)'
  end if
  write(ifile,10) &
       '[n]','[m]','<n|x|m>','<n|y|m>','<n|z|m>'
  do nlmnlm = 1,num_dipole_lm_ps
     n1 = n1_dipole_lm_ps(nlmnlm) ; n2 = n2_dipole_lm_ps(nlmnlm)
     l1 = l1_dipole_lm_ps(nlmnlm) ; l2 = l2_dipole_lm_ps(nlmnlm)
     m1 = m1_dipole_lm_ps(nlmnlm) ; m2 = m2_dipole_lm_ps(nlmnlm)
     if (l1 > l2) then
        cycle
     end if
     write(ch1,'(i1,a1)') n1, fn_label_orbital(l1)
     write(ch2,'(i1,a1)') n2, fn_label_orbital(l2)
     write(ifile,11) ch1,m1,ch2,m2,dipole_x_pp(nlmnlm), &
          dipole_y_pp(nlmnlm),dipole_z_pp(nlmnlm)
  end do
  if ((is_solve_pp_spin /= NO).and.(is_spin_ss == RESTRICTED)) then
     write(ifile,*)
     write(ifile,*) &
          'PP phi[repaired]: n = (n1,l1,m1), m = (n2,l2,m2)'
     write(ifile,10) &
          '[n]','[m]','<n|x|m>','<n|y|m>','<n|z|m>'
     do nlmnlm = 1,num_dipole_lm_ps
        n1 = n1_dipole_lm_ps(nlmnlm) ; n2 = n2_dipole_lm_ps(nlmnlm)
        l1 = l1_dipole_lm_ps(nlmnlm) ; l2 = l2_dipole_lm_ps(nlmnlm)
        m1 = m1_dipole_lm_ps(nlmnlm) ; m2 = m2_dipole_lm_ps(nlmnlm)
        if (l1 > l2) then
           cycle
        end if
        write(ch1,'(i1,a1)') n1, fn_label_orbital(l1)
        write(ch2,'(i1,a1)') n2, fn_label_orbital(l2)
        write(ifile,11) ch1,m1,ch2,m2,dipole_x_ss(nlmnlm), &
             dipole_y_ss(nlmnlm),dipole_z_ss(nlmnlm)
     end do
  end if
10 format(1x,(2x,4x,a3,'-',a3,4x,2x),3(10x,a7,3x))
11 format(1x,(3x,a2,'(',i2,')','-',a2,'(',i2,')',3x),3f20.10)
end subroutine write_rdipole_lm_ps

!========================================== added by K. T. ================= 4.0
subroutine write_rdipole_lm_ps_kt(ifile)
  use parameters
  implicit none

  integer,intent(in) :: ifile

  integer :: n1, l1, m1, n2, l2, m2, nlmnlm
  character(3) :: ch1, ch2
  character(1) :: fn_label_orbital

  integer :: ispin1

  write(ifile,*)

  if ( nspin == 1 ) then
     write(ifile,*) &
          'AE psi[boundstate]:  n = (n1,l1,m1), m = (n2,l2,m2)'
     write(ifile,10) '[n]','[m]','<n|x|m>','<n|y|m>','<n|z|m>'

  else if ( nspin == 2 ) then
     write(ifile,*) &
          'AE psi[boundstate]:  n = (n1,l1,m1,s1), m = (n2,l2,m2,s2)'
     write(ifile,20) '[n]','[m]','<n|x|m>','<n|y|m>','<n|z|m>'
  endif
  

  do nlmnlm = 1,num_dipole_lm_ps
     n1 = n1_dipole_lm_ps(nlmnlm) ; n2 = n2_dipole_lm_ps(nlmnlm)
     l1 = l1_dipole_lm_ps(nlmnlm) ; l2 = l2_dipole_lm_ps(nlmnlm)
     m1 = m1_dipole_lm_ps(nlmnlm) ; m2 = m2_dipole_lm_ps(nlmnlm)

     ispin1 = spin1_index_dipole_lm_ps(nlmnlm)

     if (l1 > l2) then
        cycle
     end if
     
     write(ch1,'(i1,a1)') n1, fn_label_orbital(l1)
     write(ch2,'(i1,a1)') n2, fn_label_orbital(l2)

     if ( nspin == 1 ) then
        write(ifile,11) ch1,m1,ch2,m2,dipole_x_ae(nlmnlm), &
             dipole_y_ae(nlmnlm),dipole_z_ae(nlmnlm)

     else if ( nspin == 2 ) then
        if ( ispin1 == 1 ) then
           write(ifile,21) ch1, '_u', m1, ch2, '_u', m2, &
                &   dipole_x_ae(nlmnlm), dipole_y_ae(nlmnlm),dipole_z_ae(nlmnlm)

        else if ( ispin1 == 2 ) then
           write(ifile,21) ch1, '_d', m1, ch2, '_d', m2, &
                &   dipole_x_ae(nlmnlm), dipole_y_ae(nlmnlm),dipole_z_ae(nlmnlm)

        endif
     end if

  end do

  write(ifile,*)
  if ((nspin==1).and.(is_solve_pp_spin /= NO).and.(is_spin_ss == RESTRICTED)) then
     write(ifile,*) &
          'PP phi[solved by solpp]: n = (n1,l1,m1), m = (n2,l2,m2)'
     write(ifile,10) '[n]','[m]','<n|x|m>','<n|y|m>','<n|z|m>'
  else
     write(ifile,*) &
          'PP phi[solved by sol]: n = (n1,l1,m1,s1), m = (n2,l2,m2,s2)'
     write(ifile,20) '[n]','[m]','<n|x|m>','<n|y|m>','<n|z|m>'
  end if


  do nlmnlm = 1,num_dipole_lm_ps
     n1 = n1_dipole_lm_ps(nlmnlm) ; n2 = n2_dipole_lm_ps(nlmnlm)
     l1 = l1_dipole_lm_ps(nlmnlm) ; l2 = l2_dipole_lm_ps(nlmnlm)
     m1 = m1_dipole_lm_ps(nlmnlm) ; m2 = m2_dipole_lm_ps(nlmnlm)

     ispin1 = spin1_index_dipole_lm_ps(nlmnlm)

     if (l1 > l2) then
        cycle
     end if
     write(ch1,'(i1,a1)') n1, fn_label_orbital(l1)
     write(ch2,'(i1,a1)') n2, fn_label_orbital(l2)

     if ( nspin == 1 ) then
        write(ifile,11) ch1,m1,ch2,m2,dipole_x_pp(nlmnlm), &
             dipole_y_pp(nlmnlm),dipole_z_pp(nlmnlm)

     else if ( nspin == 2 ) then
        if ( ispin1 == 1 ) then
           write(ifile,21) ch1, '_u', m1, ch2, '_u', m2, &
                & dipole_x_pp(nlmnlm), dipole_y_pp(nlmnlm),dipole_z_pp(nlmnlm)

        else if ( ispin1 == 2 ) then
           write(ifile,21) ch1, '_d', m1, ch2, '_d', m2, &
                & dipole_x_pp(nlmnlm), dipole_y_pp(nlmnlm),dipole_z_pp(nlmnlm)

        endif
     endif

  end do

  if ( (nspin==1).and.(is_solve_pp_spin /= NO).and.(is_spin_ss == RESTRICTED)) then
     write(ifile,*)
     write(ifile,*) &
          'PP phi[repaired]: n = (n1,l1,m1), m = (n2,l2,m2)'
     write(ifile,10) &
          '[n]','[m]','<n|x|m>','<n|y|m>','<n|z|m>'
     do nlmnlm = 1,num_dipole_lm_ps
        n1 = n1_dipole_lm_ps(nlmnlm) ; n2 = n2_dipole_lm_ps(nlmnlm)
        l1 = l1_dipole_lm_ps(nlmnlm) ; l2 = l2_dipole_lm_ps(nlmnlm)
        m1 = m1_dipole_lm_ps(nlmnlm) ; m2 = m2_dipole_lm_ps(nlmnlm)
        if (l1 > l2) then
           cycle
        end if
        write(ch1,'(i1,a1)') n1, fn_label_orbital(l1)
        write(ch2,'(i1,a1)') n2, fn_label_orbital(l2)
        write(ifile,11) ch1,m1,ch2,m2,dipole_x_ss(nlmnlm), &
             dipole_y_ss(nlmnlm),dipole_z_ss(nlmnlm)
     end do
  end if

10 format(1x,(2x,4x,a3,'-',a3,4x,2x),3(10x,a7,3x))
11 format(1x,(3x,a2,'(',i2,')','-',a2,'(',i2,')',3x),3f20.10)
20 format(1x,(4x,4x,a3,'-',a3,4x,4x),3(10x,a7,3x))
21 format(1x,(3x,a2,a2,'(',i2,')','-',a2,a2,'(',i2,')',3x),3f20.10)

end subroutine write_rdipole_lm_ps_kt

!=====================================================================
subroutine write_pdipole_lm_us(ifile)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(in) :: ifile
   integer :: n1, l1, t1, m1, n2, l2, t2, m2, ltmltm
   character(3) :: ch1, ch2
   character(1) :: fn_label_orbital
   write(ifile,*)
   write(ifile,*) &
      '[n|d/dx|m] = <psi[n]|d/dx|psi[m]> - <phi[n]|d/dx|phi[m]> = -[m|d/dx|n]'
   write(ifile,*) &
      '[n|d/dy|m] = <psi[n]|d/dy|psi[m]> - <phi[n]|d/dy|phi[m]> = -[m|d/dy|n]'
   write(ifile,*) &
      '[n|d/dz|m] = <psi[n]|d/dz|psi[m]> - <phi[n]|d/dz|phi[m]> = -[m|d/dz|n]'
   write(ifile,*)
   write(ifile,*) &
      '   n = (n1,l1,t1,m1), m = (n2,l2,t2,m2)'
   write(ifile,10) &
      '[n]','[m]','[n|d/dx|m]','[n|d/dy|m]','[n|d/dz|m]'
   do ltmltm = 1,num_dipole_lm_us
      n1 = n1_dipole_lm_us(ltmltm) ; n2 = n2_dipole_lm_us(ltmltm)
      l1 = l1_dipole_lm_us(ltmltm) ; l2 = l2_dipole_lm_us(ltmltm)
      t1 = t1_dipole_lm_us(ltmltm) ; t2 = t2_dipole_lm_us(ltmltm)
      m1 = m1_dipole_lm_us(ltmltm) ; m2 = m2_dipole_lm_us(ltmltm)
      if (l1 > l2) then
         cycle
      end if
      write(ch1,'(i1,a1,i1)') n1, fn_label_orbital(l1), t1
      write(ch2,'(i1,a1,i1)') n2, fn_label_orbital(l2), t2
      write(ifile,11) ch1,m1,ch2,m2,dipole_dx_us(ltmltm), &
         dipole_dy_us(ltmltm),dipole_dz_us(ltmltm)
   end do
10 format(1x,(2x,4x,a3,'-',a3,4x,2x),3(10x,a10))
11 format(1x,(2x,a3,'(',i2,')','-',a3,'(',i2,')',2x),3f20.10)
 end subroutine write_pdipole_lm_us

!======================================= added by K. T. =================== 4.0
subroutine write_pdipole_lm_us_kt(ifile)
  use parameters
  implicit none

  integer,intent(in) :: ifile

  integer :: n1, l1, t1, m1, n2, l2, t2, m2, ltmltm
  character(3) :: ch1, ch2
  character(1) :: fn_label_orbital

  integer :: ispin1

  write(ifile,*)
  write(ifile,*) &
       '[n|d/dx|m] = <psi[n]|d/dx|psi[m]> - <phi[n]|d/dx|phi[m]> = -[m|d/dx|n]'
  write(ifile,*) &
       '[n|d/dy|m] = <psi[n]|d/dy|psi[m]> - <phi[n]|d/dy|phi[m]> = -[m|d/dy|n]'
  write(ifile,*) &
       '[n|d/dz|m] = <psi[n]|d/dz|psi[m]> - <phi[n]|d/dz|phi[m]> = -[m|d/dz|n]'

  write(ifile,*)

  if ( nspin == 1 ) then
     write(ifile,*) '   n = (n1,l1,t1,m1), m = (n2,l2,t2,m2)'
     write(ifile,10) '[n]','[m]','[n|d/dx|m]','[n|d/dy|m]','[n|d/dz|m]'
  else if ( nspin == 2 ) then
     write(ifile,*) '   n = (n1,l1,t1,m1,s1), m = (n2,l2,t2,m2,s2)'
     write(ifile,20) '[n]','[m]','[n|d/dx|m]','[n|d/dy|m]','[n|d/dz|m]'
  endif


  do ltmltm = 1,num_dipole_lm_us
     n1 = n1_dipole_lm_us(ltmltm) ; n2 = n2_dipole_lm_us(ltmltm)
     l1 = l1_dipole_lm_us(ltmltm) ; l2 = l2_dipole_lm_us(ltmltm)
     t1 = t1_dipole_lm_us(ltmltm) ; t2 = t2_dipole_lm_us(ltmltm)
     m1 = m1_dipole_lm_us(ltmltm) ; m2 = m2_dipole_lm_us(ltmltm)

     ispin1 = spin1_index_dipole_lm_us(ltmltm)

     if (l1 > l2) then
        cycle
     end if

     write(ch1,'(i1,a1,i1)') n1, fn_label_orbital(l1), t1
     write(ch2,'(i1,a1,i1)') n2, fn_label_orbital(l2), t2

     if ( nspin == 1 ) then
        write(ifile,11) ch1,m1,ch2,m2,dipole_dx_us(ltmltm), &
             dipole_dy_us(ltmltm),dipole_dz_us(ltmltm)

     else if ( nspin == 2 ) then
        if ( ispin1 == 1 ) then
           write(ifile,21) ch1, '_u',  m1, ch2,  '_u', m2, &
                &  dipole_dx_us(ltmltm), dipole_dy_us(ltmltm),dipole_dz_us(ltmltm)

        else if ( ispin1 == 2 ) then
           write(ifile,21) ch1,  '_d',  m1, ch2, '_d', m2, &
                &  dipole_dx_us(ltmltm), dipole_dy_us(ltmltm),dipole_dz_us(ltmltm)
        endif

     endif

  end do

10 format(1x,(2x,4x,a3,'-',a3,4x,2x),3(10x,a10))
11 format(1x,(2x,a3,'(',i2,')','-',a3,'(',i2,')',2x),3f20.10)
20 format(1x,(4x,4x,a3,'-',a3,4x,4x),3(10x,a10))
21 format(1x,(2x,a3,a2,'(',i2,')','-',a3,a2,'(',i2,')',2x),3f20.10)

end subroutine write_pdipole_lm_us_kt

!=====================================================================
   subroutine write_pdipole_lm_ps(ifile)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(in) :: ifile
   integer :: n1, l1, m1, n2, l2, m2, nlmnlm
   character(3) :: ch1, ch2
   character(1) :: fn_label_orbital
   write(ifile,*)
   write(ifile,*) &
      'AE psi[boundstate]: n = (n1,l1,m1), m = (n2,l2,m2)'
   write(ifile,10) &
      '[n]','[m]','<n|d/dx|m>','<n|d/dy|m>','<n|d/dz|m>'
   do nlmnlm = 1,num_dipole_lm_ps
      n1 = n1_dipole_lm_ps(nlmnlm) ; n2 = n2_dipole_lm_ps(nlmnlm)
      l1 = l1_dipole_lm_ps(nlmnlm) ; l2 = l2_dipole_lm_ps(nlmnlm)
      m1 = m1_dipole_lm_ps(nlmnlm) ; m2 = m2_dipole_lm_ps(nlmnlm)
      if (l1 > l2) then
         cycle
      end if
      write(ch1,'(i1,a1)') n1, fn_label_orbital(l1)
      write(ch2,'(i1,a1)') n2, fn_label_orbital(l2)
      write(ifile,11) ch1,m1,ch2,m2,dipole_dx_ae(nlmnlm), &
         dipole_dy_ae(nlmnlm),dipole_dz_ae(nlmnlm)
   end do
   write(ifile,*)
   if ((is_solve_pp_spin /= NO).and.(is_spin_ss == RESTRICTED)) then
   write(ifile,*) &
      'PP phi[solved+polarized]: n = (n1,l1,m1), m = (n2,l2,m2)'
   else
   write(ifile,*) &
      'PP phi[solved+restricted]: n = (n1,l1,m1), m = (n2,l2,m2)'
   end if
   write(ifile,10) &
      '[n]','[m]','<n|d/dx|m>','<n|d/dy|m>','<n|d/dz|m>'
   do nlmnlm = 1,num_dipole_lm_ps
      n1 = n1_dipole_lm_ps(nlmnlm) ; n2 = n2_dipole_lm_ps(nlmnlm)
      l1 = l1_dipole_lm_ps(nlmnlm) ; l2 = l2_dipole_lm_ps(nlmnlm)
      m1 = m1_dipole_lm_ps(nlmnlm) ; m2 = m2_dipole_lm_ps(nlmnlm)
      if (l1 > l2) then
         cycle
      end if
      write(ch1,'(i1,a1)') n1, fn_label_orbital(l1)
      write(ch2,'(i1,a1)') n2, fn_label_orbital(l2)
      write(ifile,11) ch1,m1,ch2,m2,dipole_dx_pp(nlmnlm), &
         dipole_dy_pp(nlmnlm),dipole_dz_pp(nlmnlm)
   end do
   if ((is_solve_pp_spin /= NO).and.(is_spin_ss == RESTRICTED)) then
   write(ifile,*)
   write(ifile,*) &
      'PP phi[repaired]: n = (n1,l1,m1), m = (n2,l2,m2)'
   write(ifile,10) &
      '[n]','[m]','<n|d/dx|m>','<n|d/dy|m>','<n|d/dz|m>'
   do nlmnlm = 1,num_dipole_lm_ps
      n1 = n1_dipole_lm_ps(nlmnlm) ; n2 = n2_dipole_lm_ps(nlmnlm)
      l1 = l1_dipole_lm_ps(nlmnlm) ; l2 = l2_dipole_lm_ps(nlmnlm)
      m1 = m1_dipole_lm_ps(nlmnlm) ; m2 = m2_dipole_lm_ps(nlmnlm)
      if (l1 > l2) then
         cycle
      end if
      write(ch1,'(i1,a1)') n1, fn_label_orbital(l1)
      write(ch2,'(i1,a1)') n2, fn_label_orbital(l2)
      write(ifile,11) ch1,m1,ch2,m2,dipole_dx_ss(nlmnlm), &
         dipole_dy_ss(nlmnlm),dipole_dz_ss(nlmnlm)
   end do
   end if
10 format(1x,(2x,4x,a3,'-',a3,4x,2x),3(10x,a10))
11 format(1x,(3x,a2,'(',i2,')','-',a2,'(',i2,')',3x),3f20.10)
   end subroutine write_pdipole_lm_ps

!================================================== added by K. T. ============= 4.0
subroutine write_pdipole_lm_ps_kt(ifile)
  use parameters
  implicit none

  integer,intent(in) :: ifile

  integer :: n1, l1, m1, n2, l2, m2, nlmnlm
  character(3) :: ch1, ch2
  character(1) :: fn_label_orbital

  integer :: ispin1

  write(ifile,*)

  if ( nspin == 1 ) then
     write(ifile,*) &
          'AE psi[boundstate]:   n = (n1,l1,m1), m = (n2,l2,m2)'
     write(ifile,10) '[n]','[m]','<n|d/dx|m>','<n|d/dy|m>','<n|d/dz|m>'
  else if ( nspin == 2 ) then
     write(ifile,*) &
          'AE psi[boundstate]:   n = (n1,l1,m1,s1), m = (n2,l2,m2,s2)'
     write(ifile,20) '[n]','[m]','<n|d/dx|m>','<n|d/dy|m>','<n|d/dz|m>'
  endif


  do nlmnlm = 1,num_dipole_lm_ps
     n1 = n1_dipole_lm_ps(nlmnlm) ; n2 = n2_dipole_lm_ps(nlmnlm)
     l1 = l1_dipole_lm_ps(nlmnlm) ; l2 = l2_dipole_lm_ps(nlmnlm)
     m1 = m1_dipole_lm_ps(nlmnlm) ; m2 = m2_dipole_lm_ps(nlmnlm)

     ispin1 = spin1_index_dipole_lm_ps(nlmnlm)

     if (l1 > l2) then
        cycle
     end if

     write(ch1,'(i1,a1)') n1, fn_label_orbital(l1)
     write(ch2,'(i1,a1)') n2, fn_label_orbital(l2)

     if ( nspin == 1 ) then
        write(ifile,11) ch1,m1,ch2,m2,dipole_dx_ae(nlmnlm), &
             dipole_dy_ae(nlmnlm),dipole_dz_ae(nlmnlm)
        
     else if ( nspin == 2 ) then

        if ( ispin1 == 1 ) then
           write(ifile,21) ch1, '_u', m1,ch2, '_u',m2, &
                & dipole_dx_ae(nlmnlm), dipole_dy_ae(nlmnlm),dipole_dz_ae(nlmnlm)

        else if ( ispin1 == 2 ) then
           write(ifile,21) ch1,  '_d', m1,ch2, '_d',m2, &
                & dipole_dx_ae(nlmnlm), dipole_dy_ae(nlmnlm),dipole_dz_ae(nlmnlm)
        endif
     endif

  end do
  
  write(ifile,*)
  if ((nspin==1).and.(is_solve_pp_spin /= NO).and.(is_spin_ss == RESTRICTED)) then
     write(ifile,*) &
          'PP phi[solved by solpp]: n = (n1,l1,m1), m = (n2,l2,m2)'
     write(ifile,10) '[n]','[m]','<n|d/dx|m>','<n|d/dy|m>','<n|d/dz|m>'
  else
     write(ifile,*) &
          'PP phi[solved by sol]: n = (n1,l1,m1,s1), m = (n2,l2,m2,s2)'
     write(ifile,20) '[n]','[m]','<n|d/dx|m>','<n|d/dy|m>','<n|d/dz|m>'
  end if


  do nlmnlm = 1,num_dipole_lm_ps
     n1 = n1_dipole_lm_ps(nlmnlm) ; n2 = n2_dipole_lm_ps(nlmnlm)
     l1 = l1_dipole_lm_ps(nlmnlm) ; l2 = l2_dipole_lm_ps(nlmnlm)
     m1 = m1_dipole_lm_ps(nlmnlm) ; m2 = m2_dipole_lm_ps(nlmnlm)

     ispin1 = spin1_index_dipole_lm_ps(nlmnlm)

     if (l1 > l2) then
        cycle
     end if
     write(ch1,'(i1,a1)') n1, fn_label_orbital(l1)
     write(ch2,'(i1,a1)') n2, fn_label_orbital(l2)

     if ( nspin == 1 ) then
        write(ifile,11) ch1,m1,ch2,m2,dipole_dx_pp(nlmnlm), &
             dipole_dy_pp(nlmnlm),dipole_dz_pp(nlmnlm)

     else if ( nspin == 2 ) then
        if ( ispin1 == 1 ) then
           write(ifile,21) ch1, '_u', m1,ch2, '_u', m2, &
                & dipole_dx_pp(nlmnlm), dipole_dy_pp(nlmnlm),dipole_dz_pp(nlmnlm)

        else if ( ispin1 == 2 ) then
           write(ifile,21) ch1, '_d', m1,ch2, '_d', m2, &
                & dipole_dx_pp(nlmnlm), dipole_dy_pp(nlmnlm),dipole_dz_pp(nlmnlm)
        endif
     endif

  end do

  if ((nspin==1).and.(is_solve_pp_spin /= NO).and.(is_spin_ss == RESTRICTED)) then
     write(ifile,*)
     write(ifile,*) &
          'PP phi[repaired]: n = (n1,l1,m1), m = (n2,l2,m2)'
     write(ifile,10) &
          '[n]','[m]','<n|d/dx|m>','<n|d/dy|m>','<n|d/dz|m>'

     do nlmnlm = 1,num_dipole_lm_ps
        n1 = n1_dipole_lm_ps(nlmnlm) ; n2 = n2_dipole_lm_ps(nlmnlm)
        l1 = l1_dipole_lm_ps(nlmnlm) ; l2 = l2_dipole_lm_ps(nlmnlm)
        m1 = m1_dipole_lm_ps(nlmnlm) ; m2 = m2_dipole_lm_ps(nlmnlm)
        if (l1 > l2) then
           cycle
        end if
        write(ch1,'(i1,a1)') n1, fn_label_orbital(l1)
        write(ch2,'(i1,a1)') n2, fn_label_orbital(l2)
        write(ifile,11) ch1,m1,ch2,m2,dipole_dx_ss(nlmnlm), &
             dipole_dy_ss(nlmnlm),dipole_dz_ss(nlmnlm)
     end do
  end if

10 format(1x,(2x,4x,a3,'-',a3,4x,2x),3(10x,a10))
11 format(1x,(3x,a2,'(',i2,')','-',a2,'(',i2,')',3x),3f20.10)
20 format(1x,(4x,4x,a3,'-',a3,4x,4x),3(10x,a10))
21 format(1x,(3x,a2,a2,'(',i2,')','-',a2,a2,'(',i2,')',3x),3f20.10)

end subroutine write_pdipole_lm_ps_kt
! ============================================================================= 4.0

!=====================================================================
   subroutine write_cubic_ylm(ifile,lmax)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   implicit none
   integer,intent(in)  :: ifile,lmax
   write(ifile,*)
   write(ifile,*) &
   'Definition of cubic harmonics : Yc[l,m] = Z[l,m]/{sqrt(4*pi)*r^l}'
   write(ifile,*) &
   'where r = sqrt(x*x+y*y+z*z), and Z[l,m] is defined by'
   write(ifile,*)
   if (lmax >= 0) then
      write(ifile,*) 'Z[0, 0] = 1'
   end if
   if (lmax >= 1) then
      write(ifile,*) 'Z[1, 1] = sqrt(3) * x'
      write(ifile,*) 'Z[1, 0] = sqrt(3) * z'
      write(ifile,*) 'Z[1,-1] = sqrt(3) * y'
   end if
   if (lmax >= 2) then
      write(ifile,*) 'Z[2, 2] = sqrt(15)/2 * (x*x-y*y)'
      write(ifile,*) 'Z[2, 1] = sqrt(15)   * x*z'
      write(ifile,*) 'Z[2, 0] = sqrt(5)/2  * (3*z*z-r*r)'
      write(ifile,*) 'Z[2,-1] = sqrt(15)   * y*z'
      write(ifile,*) 'Z[2,-2] = sqrt(15)   * x*y'
   end if
   if (lmax >= 3) then
      write(ifile,*) 'Z[3, 3] = sqrt(70)/4  * x*(x*x-3*y*y)'
      write(ifile,*) 'Z[3, 2] = sqrt(105)/2 * z*(x*x-y*y)'
      write(ifile,*) 'Z[3, 1] = sqrt(42)/4  * x*(5*z*z-r*r)'
      write(ifile,*) 'Z[3, 0] = sqrt(7)/2   * z*(5*z*z-3*r*r)'
      write(ifile,*) 'Z[3,-1] = sqrt(42)/4  * y*(5*z*z-r*r)'
      write(ifile,*) 'Z[3,-2] = sqrt(105)   * x*y*z'
      write(ifile,*) 'Z[3,-3] = sqrt(70)/4  * y*(3*x*x-y*y)'
   end if
   if (lmax >= 4) then
      write(ifile,*) 'Z[4, 4] = 3*sqrt(35)/8 * (x^4-6*x^2*y^2+y^4)'
      write(ifile,*) 'Z[4, 3] = 3*sqrt(70)/4 * x*z*(x*x-3*y*y)'
      write(ifile,*) 'Z[4, 2] = 3*sqrt(5)/4  * (x*x-y*y)*(7*z*z-r*r)'
      write(ifile,*) 'Z[4, 1] = 3*sqrt(10)/4 * x*z*(7*z*z-3*r*r)'
      write(ifile,*) 'Z[4, 0] = 3/8          * (3*r^4-30*r^2*z^2+35*z^4)'
      write(ifile,*) 'Z[4,-1] = 3*sqrt(10)/4 * y*z*(7*z*z-3*r*r)'
      write(ifile,*) 'Z[4,-2] = 3*sqrt(5)/2  * x*y*(7*z*z-r*r)'
      write(ifile,*) 'Z[4,-3] = 3*sqrt(70)/4 * y*z*(3*x*x-y*y)'
      write(ifile,*) 'Z[4,-4] = 3*sqrt(35)/2 * x*y*(x*x-y*y)'
   end if
   if (lmax >= 5) then
      write(ifile,*) 'Z[5, 5] = 3*sqrt(154)/16 * x*(x^4-10*x^2*y^2+5*y^4)'
      write(ifile,*) 'Z[5, 4] = 3*sqrt(385)/8  * z*(x^4-6*x^2*y^2+y^4)'
      write(ifile,*) 'Z[5, 3] = sqrt(770)/16   * x*(x*x-3*y*y)*(9*z*z-r*r)'
      write(ifile,*) 'Z[5, 2] = sqrt(1155)/4   * (x*x-y*y)*z*(3*z*z-r*r)'
      write(ifile,*) 'Z[5, 1] = sqrt(165)/8    * x*(21*z^4-14*z^2*r^2+r^4)'
      write(ifile,*) 'Z[5, 0] = sqrt(11)/8     * z*(63*z^4-70*z^2*r^2+15*r^4)'
      write(ifile,*) 'Z[5,-1] = sqrt(165)/8    * y*(21*z^4-14*z^2*r^2+r^4)'
      write(ifile,*) 'Z[5,-2] = sqrt(1155)/2   * x*y*z*(3*z*z-r*r)'
      write(ifile,*) 'Z[5,-3] = sqrt(770)/16   * y*(3*x*x-y*y)*(9*z*z-r*r)'
      write(ifile,*) 'Z[5,-4] = 3*sqrt(385)/2  * x*y*z*(x*x-y*y)'
      write(ifile,*) 'Z[5,-5] = 3*sqrt(154)/16 * y*(5*x^4-10*x^2*y^2+y^4)'
   end if
   if (lmax >= 6) then
      write(ifile,*) 'Z[6, 6] = sqrt(6006)/32   * (x*x-y*y)*(x^4-14*x^2*y^2+y^4)'
      write(ifile,*) 'Z[6, 5] = 3*sqrt(2002)/16 * x*z*(x^4-10*x^2*y^2+5*y^4)'
      write(ifile,*) 'Z[6, 4] = 3*sqrt(91)/16   * (11*z*z-r*r)*(x^4-6*x^2*y^2+y^4)'
      write(ifile,*) 'Z[6, 3] = sqrt(2730)/16   * x*z*(x*x-3*y*y)*(11*z*z-r*r)'
      write(ifile,*) 'Z[6, 2] = sqrt(2730)/32   * (x*x-y*y)*(33*z^4-18*z^2*r^2+r^4)'
      write(ifile,*) 'Z[6, 1] = sqrt(273)/8     * x*z*(33*z^4-30*z^2*r^2+5*r^4)'
      write(ifile,*) 'Z[6, 0] = sqrt(13)/16     * (231*z^6-315*z^4*r^2+105*z^2*r^4-5*r^6)'
      write(ifile,*) 'Z[6,-1] = sqrt(273)/8     * y*z*(33*z^4-30*z^2*r^2+5*r^4)'
      write(ifile,*) 'Z[6,-2] = sqrt(2730)/16   * x*y*(33*z^4-18*z^2*r^2+r^4)'
      write(ifile,*) 'Z[6,-3] = sqrt(2730)/16   * y*z*(3*x*x-y*y)*(11*z*z-3*r*r)'
      write(ifile,*) 'Z[6,-4] = 3*sqrt(91)/4    * x*y*(x*x-y*y)*(11*z*z-r*r)'
      write(ifile,*) 'Z[6,-5] = 3*sqrt(2002)/16 * y*z*(5*x^4-10*x^2*y^2+y^4)'
      write(ifile,*) 'Z[6,-6] = sqrt(6006)/16   * x*y*(x*x-3*y*y)*(3*x*x-y*y)'
   end if
   end subroutine write_cubic_ylm

!=====================================================================
   subroutine set_pxyz(ier,ifile,lmax,pxyz)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   implicit none
   integer,intent(in)  :: ifile,lmax
   real(8),intent(out) :: pxyz(-lmax:lmax,-lmax:lmax,0:lmax)
   integer,intent(out) :: ier
   integer :: ll, m1, m2
   real(8) :: tmp
   real(8),allocatable :: cmat(:,:)
   ier = 0
   pxyz(:,:,:) = 0.d0
   if (lmax >= 0) then
      pxyz( 0, 0, 0) =  1.000000000000000d0
   end if
   if (lmax >= 1) then
      pxyz(-1, 1, 1) =  1.000000000000000d0
      pxyz( 1, 0, 1) =  1.000000000000000d0
      pxyz( 0,-1, 1) =  1.000000000000000d0
   end if
   if (lmax >= 2) then
      pxyz( 2, 2, 2) = -0.500000000000000d0
      pxyz( 2, 0, 2) =  0.866025403784439d0
      pxyz( 1,-1, 2) =  1.000000000000000d0
      pxyz( 0, 2, 2) = -0.866025403784439d0
      pxyz( 0, 0, 2) = -0.500000000000000d0
      pxyz(-1,-2, 2) =  1.000000000000000d0
      pxyz(-2, 1, 2) =  1.000000000000000d0
   end if
   if (lmax >= 3) then
      pxyz( 3, 2, 3) = -0.612372435695794d0
      pxyz( 3, 0, 3) =  0.790569415042095d0
      pxyz( 2,-1, 3) =  0.790569415042095d0
      pxyz( 2,-3, 3) = -0.612372435695794d0
      pxyz( 1, 2, 3) = -0.790569415042095d0
      pxyz( 1, 0, 3) = -0.612372435695794d0
      pxyz( 0,-1, 3) = -0.612372435695794d0
      pxyz( 0,-3, 3) = -0.790569415042095d0
      pxyz(-1, 3, 3) = -0.968245836551854d0
      pxyz(-1, 1, 3) = -0.250000000000000d0
      pxyz(-2,-2, 3) =  1.000000000000000d0
      pxyz(-3, 3, 3) = -0.250000000000000d0
      pxyz(-3, 1, 3) =  0.968245836551854d0
   end if
   if (lmax >= 4) then
      pxyz( 4, 4, 4) =  0.125000000000000d0
      pxyz( 4, 2, 4) = -0.661437827766148d0
      pxyz( 4, 0, 4) =  0.739509972887452d0
      pxyz( 3,-1, 4) =  0.661437827766148d0
      pxyz( 3,-3, 4) = -0.750000000000000d0
      pxyz( 2, 4, 4) =  0.661437827766148d0
      pxyz( 2, 2, 4) = -0.500000000000000d0
      pxyz( 2, 0, 4) = -0.559016994374947d0
      pxyz( 1,-1, 4) = -0.750000000000000d0
      pxyz( 1,-3, 4) = -0.661437827766148d0
      pxyz( 0, 4, 4) =  0.739509972887452d0
      pxyz( 0, 2, 4) =  0.559016994374947d0
      pxyz( 0, 0, 4) =  0.375000000000000d0
      pxyz(-1,-2, 4) = -0.353553390593274d0
      pxyz(-1,-4, 4) = -0.935414346693485d0
      pxyz(-2, 3, 4) = -0.935414346693485d0
      pxyz(-2, 1, 4) = -0.353553390593274d0
      pxyz(-3,-2, 4) =  0.935414346693485d0
      pxyz(-3,-4, 4) = -0.353553390593274d0
      pxyz(-4, 3, 4) = -0.353553390593274d0
      pxyz(-4, 1, 4) =  0.935414346693485d0
   end if
   if (lmax >= 5) then
      pxyz( 5, 4, 5) =  0.197642353760524d0
      pxyz( 5, 2, 5) = -0.684653196881458d0
      pxyz( 5, 0, 5) =  0.701560760020114d0
      pxyz( 4,-1, 5) =  0.572821961869480d0
      pxyz( 4,-3, 5) = -0.795495128834866d0
      pxyz( 4,-5, 5) =  0.197642353760524d0
      pxyz( 3, 4, 5) =  0.795495128834866d0
      pxyz( 3, 2, 5) = -0.306186217847897d0
      pxyz( 3, 0, 5) = -0.522912516583797d0
      pxyz( 2,-1, 5) = -0.661437827766148d0
      pxyz( 2,-3, 5) = -0.306186217847897d0
      pxyz( 2,-5, 5) =  0.684653196881458d0
      pxyz( 1, 4, 5) =  0.572821961869480d0
      pxyz( 1, 2, 5) =  0.661437827766148d0
      pxyz( 1, 0, 5) =  0.484122918275927d0
      pxyz( 0,-1, 5) =  0.484122918275927d0
      pxyz( 0,-3, 5) =  0.522912516583797d0
      pxyz( 0,-5, 5) =  0.701560760020114d0
      pxyz(-1, 5, 5) =  0.905711046636840d0
      pxyz(-1, 3, 5) =  0.405046293650491d0
      pxyz(-1, 1, 5) =  0.125000000000000d0
      pxyz(-2,-2, 5) = -0.500000000000000d0
      pxyz(-2,-4, 5) = -0.866025403784439d0
      pxyz(-3, 5, 5) =  0.419262745781211d0
      pxyz(-3, 3, 5) = -0.812500000000000d0
      pxyz(-3, 1, 5) = -0.405046293650491d0
      pxyz(-4,-2, 5) =  0.866025403784439d0
      pxyz(-4,-4, 5) = -0.500000000000000d0
      pxyz(-5, 5, 5) =  0.062500000000000d0
      pxyz(-5, 3, 5) = -0.419262745781211d0
      pxyz(-5, 1, 5) =  0.905711046636840d0
   end if
   if (lmax >= 6) then
      pxyz( 6, 6, 6) = -0.031250000000000d0
      pxyz( 6, 4, 6) =  0.253876200144874d0
      pxyz( 6, 2, 6) = -0.695268608165218d0
      pxyz( 6, 0, 6) =  0.671693289381396d0
      pxyz( 5,-1, 6) =  0.507752400289748d0
      pxyz( 5,-3, 6) = -0.802827036166571d0
      pxyz( 5,-5, 6) =  0.312500000000000d0
      pxyz( 4, 6, 6) = -0.253876200144874d0
      pxyz( 4, 4, 6) =  0.812500000000000d0
      pxyz( 4, 2, 6) = -0.171163299220364d0
      pxyz( 4, 0, 6) = -0.496078370824611d0
      pxyz( 3,-1, 6) = -0.592927061281571d0
      pxyz( 3,-3, 6) = -0.062500000000000d0
      pxyz( 3,-5, 6) =  0.802827036166571d0
      pxyz( 2, 6, 6) = -0.695268608165218d0
      pxyz( 2, 4, 6) =  0.171163299220364d0
      pxyz( 2, 2, 6) =  0.531250000000000d0
      pxyz( 2, 0, 6) =  0.452855523318420d0
      pxyz( 1,-1, 6) =  0.625000000000000d0
      pxyz( 1,-3, 6) =  0.592927061281571d0
      pxyz( 1,-5, 6) =  0.507752400289748d0
      pxyz( 0, 6, 6) = -0.671693289381396d0
      pxyz( 0, 4, 6) = -0.496078370824611d0
      pxyz( 0, 2, 6) = -0.452855523318420d0
      pxyz( 0, 0, 6) = -0.312500000000000d0
      pxyz(-1,-2, 6) =  0.197642353760524d0
      pxyz(-1,-4, 6) =  0.433012701892219d0
      pxyz(-1,-6, 6) =  0.879452954966893d0
      pxyz(-2, 5, 6) =  0.802827036166571d0
      pxyz(-2, 3, 6) =  0.562500000000000d0
      pxyz(-2, 1, 6) =  0.197642353760524d0
      pxyz(-3,-2, 6) = -0.562500000000000d0
      pxyz(-3,-4, 6) = -0.684653196881458d0
      pxyz(-3,-6, 6) =  0.463512405443479d0
      pxyz(-4, 5, 6) =  0.586301969977929d0
      pxyz(-4, 3, 6) = -0.684653196881458d0
      pxyz(-4, 1, 6) = -0.433012701892219d0
      pxyz(-5,-2, 6) =  0.802827036166571d0
      pxyz(-5,-4, 6) = -0.586301969977929d0
      pxyz(-5,-6, 6) =  0.108253175473055d0
      pxyz(-6, 5, 6) =  0.108253175473055d0
      pxyz(-6, 3, 6) = -0.463512405443479d0
      pxyz(-6, 1, 6) =  0.879452954966893d0
   end if
  !++++++++++++++++++++++++++++++++++++++++++++++++++++
   allocate(cmat(-lmax:lmax,-lmax:lmax)) ; cmat = 0.d0
  !++++++++++++++++++++++++++++++++++++++++++++++++++++
   do ll = 0,lmax
      cmat(:,:) = matmul(matmul(pxyz(:,:,ll),pxyz(:,:,ll)),pxyz(:,:,ll))
      do m1 = -ll,ll
      do m2 = -ll,ll
         if (m1 == m2) then
            tmp = abs(cmat(m1,m2) - 1.d0)
         else
            tmp = abs(cmat(m1,m2))
         end if
         if (tmp > 1.d-6) then
            write(ifile,*) '### ERROR ### sigma**3 != 1'
            write(ifile,*) '   m1,m2,ll ...',m1,m2,ll
            write(ifile,*) '   pxyz**3  ...',cmat(m1,m2)
            ier = 1 ; go to 99
         end if
      end do
      end do
   end do
  !+++++++++++++++++
   deallocate(cmat)
  !+++++++++++++++++
99 continue
   end subroutine set_pxyz

!=====================================================================
subroutine set_phase_ylm(ier,lmax,phase_ylm)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
  implicit none
  integer,intent(in)  :: lmax
  integer,intent(out) :: phase_ylm(0:lmax,-lmax:lmax)
  integer,intent(out) :: ier
  ier = 0
  if (lmax >= 0) then
     phase_ylm(0, 0) =  1
  end if
  if (lmax >= 1) then
     phase_ylm(1, 1) =  2
     phase_ylm(1, 0) =  4
     phase_ylm(1,-1) =  3
  end if
  if (lmax >= 2) then
     phase_ylm(2, 2) =  6
     phase_ylm(2, 1) =  9
     phase_ylm(2, 0) =  5
     phase_ylm(2,-1) =  8
     phase_ylm(2,-2) =  7
  end if
  if (lmax >= 3) then
     phase_ylm(3, 3) = 15
     phase_ylm(3, 2) = 13
     phase_ylm(3, 1) = 11
     phase_ylm(3, 0) = 10
     phase_ylm(3,-1) = 12
     phase_ylm(3,-2) = 14
     phase_ylm(3,-3) = 16
  end if
  if (lmax >= 4) then
     phase_ylm(4, 4) = 24
     phase_ylm(4, 3) = 22
     phase_ylm(4, 2) = 20
     phase_ylm(4, 1) = 18
     phase_ylm(4, 0) = 17
     phase_ylm(4,-1) = 19
     phase_ylm(4,-2) = 21
     phase_ylm(4,-3) = 23
     phase_ylm(4,-4) = 25
  end if
99 continue
end subroutine set_phase_ylm

! ========== KT_add ======================================= 4.1
subroutine check_if_corestates
  use parameters
  implicit none
  
  integer :: l1, ishell
  real(8) :: emin
  
  emin = 1.0D10
  Do ishell=1, nshell
     if ( is_valence(ishell) /= 0 ) then
        emin = min( emin, engy(ishell) )
     endif
!     write(*,*) ishell, is_valence(ishell), n_qnum(ishell), l_qnum(ishell)
  End Do
!  stop

  allocate( is_core_states(nshell) );  is_core_states = 0
  num_core_states = 0

  lmax_core_states = 0
  
  Do ishell=1, nshell
     if ( is_valence(ishell) /= 0 )  cycle

!!     if ( engy(ishell) < emin ) then
     if ( engy(ishell) < emin .or. &
          & focc(ishell) > 0 ) then
        is_core_states( ishell ) = 1
        num_core_states = num_core_states +1
        
        l1 = l_qnum(ishell)
        lmax_core_states = max( lmax_core_states, l1 )
     endif
  End Do
  
end subroutine check_if_corestates

subroutine count_felec_core
  use parameters
  implicit none
  
  integer :: ishell

  felec_core = 0.0d0
  Do ishell=1, nshell
     if ( is_core_states(ishell) == 1 ) then
        felec_core = felec_core + focc( ishell )
     endif
  End do
!  write(IFLOG,*) 'Felec core = ', felec_core

end subroutine count_felec_core

subroutine calc_ekin_core_zora_asymm( ekin_core ) ! asymm +zora
  use parameters
  implicit none
  real(8), intent(out) :: ekin_core

  real(8), parameter :: c_vel = 137.035999679D0

  integer :: ishell, ir, ll, ier, ispin
  real(8) :: r, coeff1, c1, c2, c3, c4, c5, term1, term2, vv
  real(8), allocatable :: psi_i(:), dpsi_i(:), ddpsi_i(:), d_veff(:,:)
  real(8), allocatable :: psi_j(:), dpsi_j(:), ddpsi_j(:)

  allocate( d_veff(nmesh,nspin) );  d_veff = 0.0d0
  allocate(   psi_i(nmesh) );         psi_i = 0.0d0;  
  allocate(  dpsi_i(nmesh) );        dpsi_i = 0.0d0;  
  allocate( ddpsi_i(nmesh) );       ddpsi_i = 0.0d0
  if ( is_calc == REL ) then
     allocate(   psi_j(nmesh) );         psi_j = 0.0d0;  
     allocate(  dpsi_j(nmesh) );        dpsi_j = 0.0d0;  
     allocate( ddpsi_j(nmesh) );       ddpsi_j = 0.0d0
  endif

  Do ispin=1, nspin
     call calc_diff_exp( ier,iord_diff, nmesh, rpos(1), veff(1,ispin,lmax_core), &
          &              d_veff(1,ispin) )
  End Do

  ekin_core = 0.0d0

  do ishell = 1,nshell
     if ( is_core_states(ishell) == 0 ) cycle

     ispin = (1-spin(ishell))/2 + 1

     if ( is_calc /= REL ) then     ! SREL 
        ll = l_qnum(ishell)
        coeff1 = dble( ll )*dble( ll +1 )

        psi_i(:) = chi_g(:,ishell)
        call calc_ddiff_exp( ier, iord_diff, nmesh, rpos, psi_i, dpsi_i, ddpsi_i )

        do ir = 1,nmesh
           vv = veff(ir, ispin, lmax_core)
           c1 = 1.0d0 /( 2.0d0 -vv /c_vel**2 )
           c2 = psi_i(ir) *( dpsi_i(ir) -psi_i(ir)/rpos(ir) ) 
           c3 = psi_i(ir) *ddpsi_i(ir) -coeff1 *psi_i(ir) *psi_i(ir) /rpos(ir)**2

           term1 = -d_veff(ir,ispin) /c_vel**2 *c1**2 *c2
           term2 = -c1 *c3

           ekin_core = ekin_core +focc(ishell) *wr(ir) *( term1 +term2 )
        end do
     else
        ll = l_qnum(ishell)
        coeff1 = dble( ll )*dble( ll +1 )

        psi_i(:) = chi_g(:,ishell)
        psi_j(:) = chi_f(:,ishell)
        call calc_ddiff_exp( ier, iord_diff, nmesh, rpos, psi_i, dpsi_i, ddpsi_i )
        call calc_ddiff_exp( ier, iord_diff, nmesh, rpos, psi_j, dpsi_j, ddpsi_j )

        do ir = 1,nmesh
           vv = veff(ir, ispin, lmax_core)
           c1 = 1.0d0 /( 2.0d0 -vv /c_vel**2 )
           c2 = psi_i(ir) *( dpsi_i(ir) -psi_i(ir)/rpos(ir) ) 
           c3 = psi_i(ir) *ddpsi_i(ir) -coeff1 *psi_i(ir) *psi_i(ir) /rpos(ir)**2

           c4 = psi_j(ir) *( dpsi_j(ir) -psi_j(ir)/rpos(ir) ) 
           c5 = psi_j(ir) *ddpsi_j(ir) -coeff1 *psi_j(ir) *psi_j(ir) /rpos(ir)**2

           term1 = -d_veff(ir,ispin) /c_vel**2 *c1**2 *( c2 +c4 )
           term2 = -c1 *( c3 +c5)

           ekin_core = ekin_core +focc(ishell) *wr(ir) *( term1 +term2 )
        end do
     endif
  end do

  deallocate( d_veff )
  deallocate( psi_i );  deallocate( dpsi_i );  deallocate( ddpsi_i )
  if ( is_calc == REL ) then
     deallocate( psi_j );  deallocate( dpsi_j );  deallocate( ddpsi_j )
  endif
end subroutine calc_ekin_core_zora_asymm

subroutine calc_ekin_core_dirac_asymm( ekin_core ) ! asymm +dirac ????
  use parameters
  implicit none
  real(8), intent(out) :: ekin_core

  real(8), parameter :: c_vel = 137.035999679D0

  integer :: ishell, ir, ll, ier, ispin
  real(8) :: r, coeff1, c1, c2, c3, c4, c5, term1, term2, vv
  real(8), allocatable :: psi_i(:), dpsi_i(:), ddpsi_i(:), d_veff(:,:)
  real(8), allocatable :: psi_j(:), dpsi_j(:), ddpsi_j(:)

  allocate( d_veff(nmesh,nspin) );  d_veff = 0.0d0
  allocate(   psi_i(nmesh) );         psi_i = 0.0d0;  
  allocate(  dpsi_i(nmesh) );        dpsi_i = 0.0d0;  
  allocate( ddpsi_i(nmesh) );       ddpsi_i = 0.0d0
  if ( is_calc == REL ) then
     allocate(   psi_j(nmesh) );         psi_j = 0.0d0;  
     allocate(  dpsi_j(nmesh) );        dpsi_j = 0.0d0;  
     allocate( ddpsi_j(nmesh) );       ddpsi_j = 0.0d0
  endif

  Do ispin=1, nspin
     call calc_diff_exp( ier,iord_diff, nmesh, rpos(1), veff(1,ispin,lmax_core), &
          &              d_veff(1,ispin) )
  End Do

  ekin_core = 0.0d0

  do ishell = 1,nshell
     if ( is_core_states(ishell) == 0 ) cycle

     ispin = (1-spin(ishell))/2 + 1

     if ( is_calc /= REL ) then     ! SREL 
        ll = l_qnum(ishell)
        coeff1 = dble( ll )*dble( ll +1 )

        psi_i(:) = chi_g(:,ishell)
        call calc_ddiff_exp( ier, iord_diff, nmesh, rpos, psi_i, dpsi_i, ddpsi_i )

        do ir = 1,nmesh
           vv = veff(ir, ispin, lmax_core) -engy(ishell)
           c1 = 1.0d0 /( 2.0d0 -vv /c_vel**2 )
           c2 = psi_i(ir) *( dpsi_i(ir) -psi_i(ir)/rpos(ir) ) 
           c3 = psi_i(ir) *ddpsi_i(ir) -coeff1 *psi_i(ir) *psi_i(ir) /rpos(ir)**2

           term1 = -d_veff(ir,ispin) /c_vel**2 *c1**2 *c2
           term2 = -c1 *c3

           ekin_core = ekin_core +focc(ishell) *wr(ir) *( term1 +term2 )
        end do
     else
        ll = l_qnum(ishell)
        coeff1 = dble( ll )*dble( ll +1 )

        psi_i(:) = chi_g(:,ishell)
        psi_j(:) = chi_f(:,ishell)
        call calc_ddiff_exp( ier, iord_diff, nmesh, rpos, psi_i, dpsi_i, ddpsi_i )
        call calc_ddiff_exp( ier, iord_diff, nmesh, rpos, psi_j, dpsi_j, ddpsi_j )

        do ir = 1,nmesh
           vv = veff(ir, ispin, lmax_core) -engy(ishell)
           c1 = 1.0d0 /( 2.0d0 -vv /c_vel**2 )
           c2 = psi_i(ir) *( dpsi_i(ir) -psi_i(ir)/rpos(ir) ) 
           c3 = psi_i(ir) *ddpsi_i(ir) -coeff1 *psi_i(ir) *psi_i(ir) /rpos(ir)**2

           c4 = psi_j(ir) *( dpsi_j(ir) -psi_j(ir)/rpos(ir) ) 
           c5 = psi_j(ir) *ddpsi_j(ir) -coeff1 *psi_j(ir) *psi_j(ir) /rpos(ir)**2

           term1 = -d_veff(ir,ispin) /c_vel**2 *c1**2 *( c2 +c4 )
           term2 = -c1 *( c3 +c5)

           ekin_core = ekin_core +focc(ishell) *wr(ir) *( term1 +term2 )
        end do
     endif
  end do

  deallocate( d_veff )
  deallocate( psi_i );  deallocate( dpsi_i );  deallocate( ddpsi_i )
  if ( is_calc == REL ) then
     deallocate( psi_j );  deallocate( dpsi_j );  deallocate( ddpsi_j )
  endif
end subroutine calc_ekin_core_dirac_asymm

subroutine calc_ekin_val_asymm( ekin_val )       ! asymm.
  use parameters
  implicit none

  real(8), intent(out) :: ekin_val
  integer :: ishell, ir, ll, ier, coeff1
  real(8) :: r, c3, c4
  real(8), allocatable :: psi_i(:), dpsi_i(:), ddpsi_i(:)
  real(8), allocatable :: psi_j(:), dpsi_j(:), ddpsi_j(:)

  allocate(   psi_i(nmesh) );         psi_i = 0.0d0;  
  allocate(  dpsi_i(nmesh) );        dpsi_i = 0.0d0;  
  allocate( ddpsi_i(nmesh) );       ddpsi_i = 0.0d0

  if ( is_calc == REL ) then
     allocate(   psi_j(nmesh) );         psi_j = 0.0d0;  
     allocate(  dpsi_j(nmesh) );        dpsi_j = 0.0d0;  
     allocate( ddpsi_j(nmesh) );       ddpsi_j = 0.0d0
  endif
  ekin_val = 0.d0

  do ishell = 1,nshell
     if ( is_core_states(ishell) == 1 ) cycle

     if ( is_calc /= REL ) then
        ll = l_qnum(ishell)
        coeff1 = dble( ll )*dble( ll +1 )

        psi_i(:) = chi_g(:,ishell)
        call calc_ddiff_exp( ier, iord_diff, nmesh, rpos, psi_i, dpsi_i, ddpsi_i )
        do ir = 1,nmesh
           c3 = psi_i(ir) *ddpsi_i(ir) -coeff1 *psi_i(ir) *psi_i(ir) /rpos(ir)**2
           ekin_val = ekin_val -focc(ishell) *0.5d0 *wr(ir) *c3
        end do
     else
        ll = l_qnum(ishell)
        coeff1 = dble( ll )*dble( ll +1 )

        psi_i(:) = chi_g(:,ishell)
        psi_j(:) = chi_f(:,ishell)
        call calc_ddiff_exp( ier, iord_diff, nmesh, rpos, psi_i, dpsi_i, ddpsi_i )
        call calc_ddiff_exp( ier, iord_diff, nmesh, rpos, psi_j, dpsi_j, ddpsi_j )

        do ir = 1,nmesh
           c3 = psi_i(ir) *ddpsi_i(ir) -coeff1 *psi_i(ir) *psi_i(ir) /rpos(ir)**2
           c4 = psi_j(ir) *ddpsi_j(ir) -coeff1 *psi_j(ir) *psi_j(ir) /rpos(ir)**2
           ekin_val = ekin_val -focc(ishell) *0.5d0 *wr(ir) *( c3 +c4 )
        end do
     endif
  end do

  deallocate( psi_i );  deallocate( dpsi_i );  deallocate( ddpsi_i )
  if ( is_calc == REL ) then
     deallocate( psi_j );  deallocate( dpsi_j );  deallocate( ddpsi_j )
  endif
end subroutine calc_ekin_val_asymm

subroutine calc_ekin_val_symm1( ekin_val )         ! symm. ????
  use parameters
  implicit none

  real(8), intent(out) :: ekin_val
  integer :: ishell, ir, ll
  real(8) :: r

  ekin_val = 0.d0
  do ishell = 1,nshell
     if ( is_core_states(ishell) == 1 ) cycle
     if ( is_calc /= REL ) then
        do ir = 1,nmesh
           ll = l_qnum(ishell)
           r  = rpos(ir)
           ekin_val = ekin_val + focc(ishell) &
                * 0.5d0*wr(ir) &
                *( (dxchi_g(ir,ishell)/r)**2 &
                + dble(ll*(ll+1))*(chi_g(ir,ishell)/r)**2 )
        end do
     else
        do ir = 1,nmesh
           ll = l_qnum(ishell)
           r  = rpos(ir)
           ekin_val = ekin_val + focc(ishell) &
                * 0.5d0*wr(ir) &
                *( (dxchi_g(ir,ishell)/r)**2 &
                + dble(ll*(ll+1))*(chi_g(ir,ishell)/r)**2 &
                + (dxchi_f(ir,ishell)/r)**2 &
                + dble(ll*(ll+1))*(chi_f(ir,ishell)/r)**2 )
        end do
     endif
  end do
end subroutine calc_ekin_val_symm1

subroutine calc_ekin_core0( ekin_core )
  use parameters
  implicit none

  real(8), intent(out) :: ekin_core
  integer :: ishell, ir, ll
  real(8) :: r

  ekin_core = 0.d0
  do ishell = 1,nshell
     if ( is_core_states(ishell) == 0) cycle

     do ir = 1,nmesh
        ll = l_qnum(ishell)
        r  = rpos(ir)
        ekin_core = ekin_core + focc(ishell) &
             * 0.5d0*wr(ir) &
             *( (dxchi_g(ir,ishell)/r)**2 &
             + dble(ll*(ll+1))*(chi_g(ir,ishell)/r)**2 )
     end do
  end do
end subroutine calc_ekin_core0

subroutine calc_rho_core_kt(ier)
  use parameters
  implicit none

  integer,intent(out) :: ier
  integer :: ir, ishell
  real(8) :: sum, pi4
  real(8),parameter :: RHOMIN = 1.d-99

  ier = 0
  pi4 = 4.d0 * PI
  rho_core(:) = 0.d0

  do ishell = 1,nshell
     if ( is_core_states(ishell) == 0 ) cycle

     select case (is_calc)
     case (NONREL,SREL)
        do ir = 1,nmesh
           rho_core(ir) = rho_core(ir) &
                + focc(ishell) * (chi_g(ir,ishell)/rpos(ir))**2 / pi4
        end do
     case (REL)
        do ir = 1,nmesh
           rho_core(ir) = rho_core(ir) &
                + focc(ishell) * ( (chi_g(ir,ishell)/rpos(ir))**2 &
                +(chi_f(ir,ishell)/rpos(ir))**2 )/ pi4
        end do
     end select
  end do

  do ir = 1,nmesh
     if (rho_core(ir) < RHOMIN) then
        rho_core(ir) = 0.d0
     end if
  end do
end subroutine calc_rho_core_kt

subroutine calc_vh_core( vh_core, ier )
  use parameters
  implicit none

  real(8), intent(out) :: vh_core( nmesh )
  integer,intent(out) :: ier

  integer :: ir, ii, i0, is, j, jr, ispin
  real(8) :: sum1, sum2

  ier = 0;  vh_core = 0.0d0

  do ir = 1,nmesh
     sum1 = 0.d0;  sum2 = 0.d0
     if (ir == 1) then
        sum1 = 0.d0
     else if ((ir >= 2).and.(ir <= 5)) then
        do ii = 2,ir
           i0 = ii-1; is = 1
           call set_open_weight_exp(ier,i0,is,rpos,wt)
           do j = 1,4
              sum1 = sum1 &
                   + rpos(i0+j*is)**2*rho_core(i0+j*is)*wt(i0+j*is)
           end do
        end do
     else
        call set_weight_exp(ier,1,ir,rpos,wt)
        do jr = 1,ir
           sum1 = sum1 + rpos(jr)**2*rho_core(jr)*wt(jr)
        end do
     end if
     sum1 = sum1*(4.d0*PI/rpos(ir))
     if (ir == nmesh) then
        sum2 = 0.d0
     else if ((ir <= nmesh-1).and.(ir >= nmesh-4)) then
        do ii = ir,nmesh-1
           i0 = ii+1; is = -1
           call set_open_weight_exp(ier,i0,is,rpos,wt)
           do j = 1,4
              sum2 = sum2 &
                   - rpos(i0+j*is)**2*rho_core(i0+j*is)*wt(i0+j*is)
           end do
        end do
     else
        call set_weight_exp(ier,ir,nmesh,rpos,wt)
        do jr = ir,nmesh
           sum2 = sum2 + rpos(jr)*rho_core(jr)*wt(jr)
        end do
     end if
     sum2 = sum2*(4.d0*PI)
     vh_core(ir) = sum1 + sum2
  end do
99 continue
end subroutine calc_vh_core

subroutine calc_eion_core( eion_core )
  use parameters
  implicit none

  real(8), intent(out) :: eion_core

  integer :: ir, ishell, ll, ll_core

  eion_core = 0.d0
  
  do ishell = 1,nshell
     if ( is_core_states(ishell) == 0 ) cycle
     
     ll = l_qnum(ishell)
     if (is_core == PATOM) then
        ll_core = ll
     else
        ll_core = lmax_core
     end if
     
     select case (is_calc)
     case (NONREL,SREL)
        do ir = 1,nmesh
           eion_core = eion_core &
                + wr(ir) * focc(ishell) &
                * chi_g(ir,ishell)**2 * vion(ir,ll_core)
        end do
     case (REL)
        do ir = 1,nmesh
           eion_core = eion_core &
                + wr(ir) * focc(ishell) * vion(ir,ll_core) &
                * (chi_g(ir,ishell)**2 + chi_f(ir,ishell)**2)
        end do
     end select
  end do
end subroutine calc_eion_core

subroutine calc_eh_core( eh_core )
  use parameters
  implicit none

  real(8), intent(out) :: eh_core

  integer :: ir, ier
  real(8) :: r
  real(8), allocatable :: vh_core(:)

  allocate( vh_core(nmesh) );  vh_core = 0.0d0
  call calc_rho_core_kt( ier )
  call calc_vh_core( vh_core, ier )

  eh_core = 0.0d0
  do ir = 1,nmesh
     r = rpos(ir)
     eh_core = eh_core &
          + 2.d0*PI*r*r*wr(ir)*rho_core(ir)*vh_core(ir)
  end do
  deallocate( vh_core )

end subroutine calc_eh_core

subroutine sizeof_dipole_cor2val_l_us(ier)
  use parameters
  implicit none
  
  integer,intent(out) :: ier
  
  integer :: ishell, n1, n2
  integer :: lt1, lt2, l1, l2, ltlt
  integer :: ispin1, ispin2
  
  ier = 0;   ltlt = 0
  
  do ishell=1, nshell
     n1 = n_qnum(ishell); l1 = l_qnum(ishell)
     ispin1 = (1-spin(ishell))/2 +1

!        write(*,*) 'n1 l1 valence ', n1, l1, is_valence(ishell)

     lt1 = ishell
     
     if ( is_core_states(ishell) == 0 ) cycle
     
     do lt2 = 1,num_ltx_us
        n2 = n_lt_us(lt2)
        l2 = l_lt_us(lt2)
        ispin2 = spin_index_lt_us(lt2)

        if ( abs(l1-l2) == 1 .and. ispin1 == ispin2 ) then
!              write(*,*) 'XX', n1, l1, n2, l2, ispin2

           ltlt = ltlt + 1
        end if
     end do
  end do
  
  num_dipole_cor2val_l_us = ltlt
  
99 continue
  
end subroutine sizeof_dipole_cor2val_l_us

subroutine sizeof_dipole_cor2val_lm_us(ier)
  use parameters
  implicit none
  
  integer,intent(out) :: ier
  
  integer :: l1, l2, m1, m2, ltlt, ltmltm
  
  ier = 0
  ltmltm = 0
  do ltlt = 1,num_dipole_cor2val_l_us
     l1 = l1_dipole_cor2val_l_us(ltlt) ; l2 = l2_dipole_cor2val_l_us(ltlt)
     
     !        write(*,*) 'YY ', l1, l2
     
     do m1 = -l1,l1
        do m2 = -l2,l2
           ltmltm = ltmltm + 1
        end do
     end do
  end do
  
  num_dipole_cor2val_lm_us = ltmltm
99 continue
  
end subroutine sizeof_dipole_cor2val_lm_us

subroutine calc_dipole_cor2val_l_us(ier)
  use parameters
  implicit none
  
  integer,intent(out) :: ier
  
  integer :: ishell, ispin1, ispin2
  integer :: lt1, lt2, ir, n1, l1, t1, n2, l2, t2, ltlt, lt, nrc
  real(8) :: sum1, sum2, sum3, r
  
  ier = 0
  if ( is_calc == REL ) return
  
  drpsi_us(:,:) = 0.d0 ; drphi_us(:,:) = 0.d0
  do lt = 1,num_ltx_us
     call calc_diff_exp(ier,10,nmesh,rpos(1),rpsi_us(1,lt),drpsi_us(1,lt))
     call calc_diff_exp(ier,10,nmesh,rpos(1),rphi_us(1,lt),drphi_us(1,lt))
  end do
  
  nrc = nrcut_phi_max_us
  call set_weight_exp(ier,1,nrc,rpos,wt)
  
  dipole_cor2val_r_us(:) = 0.d0; 
  dipole_cor2val_ri_us(:) = 0.d0
  dipole_cor2val_pr_us(:) = 0.d0
  
  lt1 = 0; ltlt = 0

! -----
!     MAIN1: do icor2val = 1,num_cor2val_hole
!        n1 = n_val_label_cor2val_hole(icor2val)
!        l1 = l_val_label_cor2val_hole(icor2val)
!        t1 = 1
!        ishell = ishell_cor2val_hole(icor2val)
!        ispin1 = (1-spin(ishell))/2 + 1

!        lt1 = icor2val
! -----
     
  MAIN1: do ishell=1, nshell
     n1 = n_qnum(ishell); l1 = l_qnum(ishell); t1 = 1
     ispin1 = (1-spin(ishell))/2 +1
     
     if ( is_core_states( ishell ) == 0 ) cycle
     
     lt1 = lt1 +1
     
     MAIN2:do lt2 = 1,num_ltx_us
        n2 = n_lt_us(lt2)
        l2 = l_lt_us(lt2)
        t2 = t_lt_us(lt2)
        ispin2 = spin_index_lt_us(lt2)
        
        if ( abs(l1-l2) == 1 .and. ispin1==ispin2 ) then
           ltlt = ltlt + 1
           lt1_dipole_cor2val_l_us(ltlt) = lt1; lt2_dipole_cor2val_l_us(ltlt) = lt2
           n1_dipole_cor2val_l_us (ltlt) = n1 ; n2_dipole_cor2val_l_us (ltlt) = n2
           l1_dipole_cor2val_l_us (ltlt) = l1 ; l2_dipole_cor2val_l_us (ltlt) = l2
           t1_dipole_cor2val_l_us (ltlt) = t1 ; t2_dipole_cor2val_l_us (ltlt) = t2
           
           spin1_indx_dipole_cor2val_l_us(ltlt) = ispin1
           
        else
           cycle MAIN2
        end if
        
        sum1 = 0.d0 ; sum2 = 0.d0 ; sum3 = 0.d0
        
        do ir = 1,nrc
           r = rpos(ir)
           sum1 = sum1 + wt(ir) * r * ( &
                &               chi_g(ir,ishell) *rpsi_us(ir,lt2) &
                &             - chi_g(ir,ishell) *rphi_us(ir,lt2) )
           sum2 = sum2 + wt(ir) / r * ( &
                &               chi_g(ir,ishell) *rpsi_us(ir,lt2) &
                &             - chi_g(ir,ishell) *rphi_us(ir,lt2) )
           sum3 = sum3 + wt(ir) * ( &
                &               chi_g(ir,ishell) *drpsi_us(ir,lt2) &
                &              -chi_g(ir,ishell) *drphi_us(ir,lt2) )
        end do
        dipole_cor2val_r_us(ltlt) = sum1
        dipole_cor2val_ri_us(ltlt) = sum2
        dipole_cor2val_pr_us(ltlt) = sum3
        
     end do MAIN2
  end do MAIN1

  if (ltlt /= num_dipole_cor2val_l_us) then
     write(IFLOG,*) '### ERROR ### ltlt /= num_dipole_cor2val_l_us'
     write(IFLOG,*) '   ltlt            ...',ltlt
     write(IFLOG,*) '   num_dipole_cor2val_l_us ...',num_dipole_cor2val_l_us
     ier = 1 ; go to 99
  end if

99 continue

end subroutine calc_dipole_cor2val_l_us

subroutine calc_dipole_cor2val_lm_us(ier)
  use parameters
  implicit none
  
  integer,intent(out) :: ier
  
  integer :: n1, l1, t1, m1, k1, n2, l2, t2, m2, k2, &
       &     n1p, l1p, t1p, m1p, n2p, l2p, t2p, m2p, &
       &     ltlt, ltmltm, ltmltmz, ltmltmp, isum
  integer :: ispin1, ispin2
  
  real(8) :: sum1, sum2, fac1, fac2
  
  ier = 0
  dipole_cor2val_z_us (:) = 0.d0 ; dipole_cor2val_dz_us(:) = 0.d0
  
  ltmltm = 0
  
  do ltlt = 1,num_dipole_cor2val_l_us
     n1 = n1_dipole_cor2val_l_us(ltlt) ; n2 = n2_dipole_cor2val_l_us(ltlt)
     l1 = l1_dipole_cor2val_l_us(ltlt) ; l2 = l2_dipole_cor2val_l_us(ltlt)
     t1 = t1_dipole_cor2val_l_us(ltlt) ; t2 = t2_dipole_cor2val_l_us(ltlt)
     
     ispin1 = spin1_indx_dipole_cor2val_l_us(ltlt)
     
!        write(*,*) 'ZZ', ltlt, l1, l2

     do m1 = -l1,l1
        do m2 = -l2,l2
           ltmltm = ltmltm + 1
           
           ltmltm_dipole_cor2val_us(ltlt,m1,m2) = ltmltm
           
!              write(500,*) 'GGG ', ltlt, m1, m2, ltmltm,  ltmltm_dipole_cor2val_us(ltlt,m1,m2)

           ltlt_dipole_cor2val_lm_us(ltmltm) = ltlt
           
           n1_dipole_cor2val_lm_us(ltmltm)=n1; n2_dipole_cor2val_lm_us(ltmltm)=n2
           l1_dipole_cor2val_lm_us(ltmltm)=l1; l2_dipole_cor2val_lm_us(ltmltm)=l2
           t1_dipole_cor2val_lm_us(ltmltm)=t1; t2_dipole_cor2val_lm_us(ltmltm)=t2
           m1_dipole_cor2val_lm_us(ltmltm)=m1; m2_dipole_cor2val_lm_us(ltmltm)=m2
           
           spin1_indx_dipole_cor2val_lm_us(ltmltm) = ispin1
           
           if (m1 /= m2) then
              cycle
           end if
           
           if (l1 == l2-1) then
              fac2 = sqrt(dble((l2+m2)*(l2-m2))/dble((2*l2+1)*(2*l2-1)))
              dipole_cor2val_z_us (ltmltm) = fac2*dipole_cor2val_r_us(ltlt)
              dipole_cor2val_dz_us(ltmltm) = fac2*( &
                   dipole_cor2val_pr_us(ltlt) + dble(l2)*dipole_cor2val_ri_us(ltlt) )
              
           else if (l1-1 == l2) then
              fac1 = sqrt(dble((l1+m1)*(l1-m1))/dble((2*l1+1)*(2*l1-1)))
              
              dipole_cor2val_z_us (ltmltm) = fac1*dipole_cor2val_r_us(ltlt)
              dipole_cor2val_dz_us(ltmltm) = fac1*( &
                   dipole_cor2val_pr_us(ltlt) - dble(l1)*dipole_cor2val_ri_us(ltlt) )
           end if
        end do
     end do
     
  end do

!     stop
  
  if (ltmltm /= num_dipole_cor2val_lm_us) then
     write(IFLOG,*) '### ERROR ### ltmltm /= num_dipole_cor2val_lm_us'
     write(IFLOG,*) '   ltmltm           ...',ltmltm
     write(IFLOG,*) '   num_dipole_cor2val_lm_us ...',num_dipole_cor2val_lm_us
     ier = 1 ; go to 99
  end if
  
  dipole_cor2val_x_us (:) = 0.d0 ; dipole_cor2val_y_us (:) = 0.d0
  dipole_cor2val_dx_us(:) = 0.d0 ; dipole_cor2val_dy_us(:) = 0.d0
  
  do ltmltm = 1,num_dipole_cor2val_lm_us
     ltlt = ltlt_dipole_cor2val_lm_us(ltmltm)
     l1 = l1_dipole_cor2val_lm_us(ltmltm); l2 = l2_dipole_cor2val_lm_us(ltmltm)
     m1 = m1_dipole_cor2val_lm_us(ltmltm); m2 = m2_dipole_cor2val_lm_us(ltmltm)
     
     do k1 = -l1,l1
        do k2 = -l2,l2
           ltmltmz = ltmltm_dipole_cor2val_us(ltlt,k1,k2)

!              write(600,*) 'aaaa ', ltlt, k1, k2, m1, m2, ltmltmz
           
           fac1 = pxyz(m1,k1,l1) * pxyz(m2,k2,l2)
           fac2 = pxyz(k1,m1,l1) * pxyz(k2,m2,l2)
           
           dipole_cor2val_x_us(ltmltm) = dipole_cor2val_x_us(ltmltm) &
                + dipole_cor2val_z_us(ltmltmz) * fac1
           dipole_cor2val_y_us(ltmltm) = dipole_cor2val_y_us(ltmltm) &
                + dipole_cor2val_z_us(ltmltmz) * fac2
           dipole_cor2val_dx_us(ltmltm) = dipole_cor2val_dx_us(ltmltm) &
                + dipole_cor2val_dz_us(ltmltmz) * fac1
           dipole_cor2val_dy_us(ltmltm) = dipole_cor2val_dy_us(ltmltm) &
                + dipole_cor2val_dz_us(ltmltmz) * fac2
        end do
           
!           write(*,*) 'ltmltm = ', ltmltm, num_dipole_cor2val_lm_us
     end do
  end do

!     stop 'aaaaaaap'

  return
  
  do ltmltm = 1,num_dipole_cor2val_lm_us
     n1 = n1_dipole_cor2val_lm_us(ltmltm); n2 = n2_dipole_cor2val_lm_us(ltmltm)
     l1 = l1_dipole_cor2val_lm_us(ltmltm); l2 = l2_dipole_cor2val_lm_us(ltmltm)
     t1 = t1_dipole_cor2val_lm_us(ltmltm); t2 = t2_dipole_cor2val_lm_us(ltmltm)
     m1 = m1_dipole_cor2val_lm_us(ltmltm); m2 = m2_dipole_cor2val_lm_us(ltmltm)
     
     ispin1 = spin1_indx_dipole_cor2val_lm_us(ltmltm)
     
     do ltmltmp = 1,num_dipole_cor2val_lm_us
        n1p = n1_dipole_cor2val_lm_us(ltmltmp); n2p = n2_dipole_cor2val_lm_us(ltmltmp)
        l1p = l1_dipole_cor2val_lm_us(ltmltmp); l2p = l2_dipole_cor2val_lm_us(ltmltmp)
        t1p = t1_dipole_cor2val_lm_us(ltmltmp); t2p = t2_dipole_cor2val_lm_us(ltmltmp)
        m1p = m1_dipole_cor2val_lm_us(ltmltmp); m2p = m2_dipole_cor2val_lm_us(ltmltmp)
        
        ispin2 = spin1_indx_dipole_cor2val_lm_us(ltmltmp)
        
        isum = abs(n1-n2p) + abs(l1-l2p) + abs(t1-t2p) + abs(m1-m2p) &
             + abs(n2-n1p) + abs(l2-l1p) + abs(t2-t1p) + abs(m2-m1p)
        
        if (isum == 0 .and. ispin1==ispin2 ) then
           sum1 = abs(dipole_cor2val_x_us (ltmltm) -dipole_cor2val_x_us (ltmltmp)) &
                + abs(dipole_cor2val_y_us (ltmltm) -dipole_cor2val_y_us (ltmltmp)) &
                + abs(dipole_cor2val_z_us (ltmltm) -dipole_cor2val_z_us (ltmltmp))
           sum2 = abs(dipole_cor2val_dx_us(ltmltm) +dipole_cor2val_dx_us(ltmltmp)) &
                + abs(dipole_cor2val_dy_us(ltmltm) +dipole_cor2val_dy_us(ltmltmp)) &
                + abs(dipole_cor2val_dz_us(ltmltm) +dipole_cor2val_dz_us(ltmltmp))
           
           if (abs(sum1) > 1.d-6) then
              write(IFLOG,*) '### ERROR ### [n|r|m] != [m|r|n]'
              write(IFLOG,*) '   n = (n1,l1,t1,m1,s1) ...',n1,l1,t1,m1, ispin1
              write(IFLOG,*) '   m = (n2,l2,t2,m2,s2) ...',n2,l2,t2,m2, ispin2
              write(IFLOG,*) '   [n|x|m]           ...',dipole_cor2val_x_us(ltmltm)
              write(IFLOG,*) '   [m|x|n]           ...',dipole_cor2val_x_us(ltmltmp)
              write(IFLOG,*) '   [n|y|m]           ...',dipole_cor2val_y_us(ltmltm)
              write(IFLOG,*) '   [m|y|n]           ...',dipole_cor2val_y_us(ltmltmp)
              write(IFLOG,*) '   [n|z|m]           ...',dipole_cor2val_z_us(ltmltm)
              write(IFLOG,*) '   [m|z|n]           ...',dipole_cor2val_z_us(ltmltmp)
              ier = 1 ; go to 99
              
           else if (abs(sum2) > 1.d-6) then
              write(IFLOG,*) '### ERROR ### [n|p|m] != -[m|p|n]'
              write(IFLOG,*) '   n = (n1,l1,t1,m1,s1) ...',n1,l1,t1,m1, ispin1
              write(IFLOG,*) '   m = (n2,l2,t2,m2,s2) ...',n2,l2,t2,m2, ispin2
              write(IFLOG,*) '   [n|d/dx|m]        ...',dipole_cor2val_dx_us(ltmltm)
              write(IFLOG,*) '   [m|d/dx|n]        ...',dipole_cor2val_dx_us(ltmltmp)
              write(IFLOG,*) '   [n|d/dy|m]        ...',dipole_cor2val_dy_us(ltmltm)
              write(IFLOG,*) '   [m|d/dy|n]        ...',dipole_cor2val_dy_us(ltmltmp)
              write(IFLOG,*) '   [n|d/dz|m]        ...',dipole_cor2val_dz_us(ltmltm)
              write(IFLOG,*) '   [m|d/dz|n]        ...',dipole_cor2val_dz_us(ltmltmp)
              ier = 2 ; go to 99
              
           else
              exit
           end if
           
        end if
        
        if (ltmltmp == num_dipole_cor2val_lm_us) then
           write(IFLOG,*) '### ERROR ### ltmltmp was not found.'
           ier = 3 ; go to 99
        end if
        
     end do
  end do
  
99 continue

end subroutine calc_dipole_cor2val_lm_us

subroutine write_cor2val_file(ier)
  use parameters 
  implicit none
  
  integer, intent(out) :: ier
  
  integer :: ltmltm, ishell, ir, ispin
  integer :: n1, n2, l1, l2, m1, m2, t1, t2, j2
!
  character(10) :: xc_name
  real(8), allocatable :: array_tmp(:)
  
  if ( is_with_dipole_cor2val == 0) return

  open( IFCOR2VAL, file=trim(file_cor2val), status='unknown' )

  call date_time(day_now);  call write_title(IFCOR2VAL,day_now)
  
  write(IFCOR2VAL,*)
  write(IFCOR2VAL,'(a)') '### Atomic label'
  write(IFCOR2VAL,'((a12,8x),a2,7x,a20)') &
       'atomic_label', atom_label(zatom), atom_name(zatom)
    
  write(IFCOR2VAL,*)
  write(IFCOR2VAL,'(a)') '### Atomic charge : Z, Za, Zc, Zv, (Ne, Nc, Nv)'
  write(IFCOR2VAL,'((a13,6x),(i3,4x),3f11.5)') &
       'atomic_charge', zatom, fatom, fcore, fval
  write(IFCOR2VAL,'((13x,6x),(3x,4x),3f11.5)') felec, felec_core, felec_val
  
  write(IFCOR2VAL,*)
  write(IFCOR2VAL,'(a)') '### Exchange-correlation potential'
  select case (is_xc)
  case (LDAPZ81)
     xc_name = 'ldapz81'
  case (LDAPW92_MOMO, LDAPW92_MOMO2, LDAPW92_GNCPP)
     xc_name = 'ldapw92'
  case (GGAPW91_MOMO, GGAPW91_MOMO2, GGAPW91_F90, GGAPW91_F77)
     xc_name = 'ggapw91'
  case (GGAPBE96_MOMO, GGAPBE96_MOMO2, GGAPBE96_GNCPP, GGAPBE96_KATO)
     xc_name = 'ggapbe'
  case default
     write(IFLOG,*) '### ERROR ### xc_type'
     write(IFLOG,*) '   is_xc ...', is_xc
     ier = 1 ; return
  end select
  
  write(IFCOR2VAL,'((a12,8x),a7,5x,a5)') &
       'xc_potential', xc_name, xc_approx
  write(IFCOR2VAL,*)
  write(IFCOR2VAL,'(a)') '### r-Mesh : Nmesh, rmin, rmax'
  write(IFCOR2VAL,'(a5,5x,a11)') 'rmesh','logarithmic'
  write(IFCOR2VAL,'(i10,2(1pe25.15))') nmesh, rmin, rmax
  write(IFCOR2VAL,*)
  
  write(IFCOR2VAL,'(A)') '### All-electron energy Levels of core states'
  write(IFCOR2VAL,'(A,I4)') 'Num of core states : ', num_core_states
  write(IFCOR2VAL,'(A)') 
  
  write(IFCOR2VAL,'(A)') '  n  l  2j s      Energy (Ha)   nocc   focc'
  
  Do ishell=1, nshell
     if ( is_core_states( ishell ) == 0 ) cycle
     
     n1 = n_qnum(ishell); l1 = l_qnum(ishell); j2 = j2_qnum(ishell)
     ispin = (1-spin(ishell))/2 + 1
     
     write(IFCOR2VAL,'(4I3,F20.12,I3,F10.5)') n1, l1, j2, ispin, engy(ishell), &
          &                          nocc(ishell),focc(ishell)
  End do
  write(IFCOR2VAL,*)

! -----
  write(IFCOR2VAL,'(A)') "### All-electron SCF wavefunctions : r*psi[n](r)"
  write(IFCOR2VAL,'(A)') "ae_wave_function_rpsi"
  
  allocate( array_tmp( nmesh) ) 
  
  Do ishell=1, nshell
     if ( is_core_states( ishell ) == 0 ) cycle
     
     n1 = n_qnum(ishell); l1 = l_qnum(ishell); j2 = j2_qnum(ishell)
     ispin = (1-spin(ishell))/2 + 1
     
     write(IFCOR2VAL,*)
     write(IFCOR2VAL,'(1x,a31,4i3)') &
          'r*psi[n](r): n = (n,l,2j,s) -->',n1, l1, j2, ispin
     do ir = 1,nmesh
        if (abs(chi_g(ir,ishell)) < 1.d-99) then
           array_tmp(ir) = 0.d0
        else
           array_tmp(ir) = chi_g(ir,ishell)
        end if
     end do
     
     write(IFCOR2VAL,15) ( array_tmp(ir),ir=1,nmesh)
  End Do
  
  deallocate( array_tmp ) 

  write(IFCOR2VAL,*)
! -----

  write(IFCOR2VAL,'(a)') &
       '### Dipole moment : [n|d/dx|m], [n|d/dy|m], [n|d/dz|m]'
  write(IFCOR2VAL,'(a)') &
       '#  [n|d/dx|m] = <psi[n]|d/dx|psi[m]> - <phi[n]|d/dx|phi[m]>'
  write(IFCOR2VAL,'(a)') &
       '#  [n|d/dy|m] = <psi[n]|d/dy|psi[m]> - <phi[n]|d/dy|phi[m]>'
  write(IFCOR2VAL,'(a)') &
       '#  [n|d/dz|m] = <psi[n]|d/dz|psi[m]> - <phi[n]|d/dz|phi[m]>'
  write(IFCOR2VAL,'(a)') &
       '#     n = (n1,l1,t1,m1), m = (n2,l2,t2,m2)'
  write(IFCOR2VAL,'(a)') "#               ( n: core orbitals, m: valence orbitals )"
  
  write(IFCOR2VAL,'(A)') 'dipole'
  write(IFCOR2VAL,*) num_dipole_cor2val_lm_us
  
  write(IFCOR2VAL,'(8(1x,a2),3(4x,a10,4x),2(1x,a2))') &
       'n1','l1','t1','m1','n2','l2','t2','m2', &
       '[n|d/dx|m]','[n|d/dy|m]','[n|d/dz|m]','y1','y2'
  
  do ltmltm = 1,num_dipole_cor2val_lm_us
     n1 = n1_dipole_cor2val_lm_us(ltmltm); n2 = n2_dipole_cor2val_lm_us(ltmltm)
     l1 = l1_dipole_cor2val_lm_us(ltmltm); l2 = l2_dipole_cor2val_lm_us(ltmltm)
     t1 = t1_dipole_cor2val_lm_us(ltmltm); t2 = t2_dipole_cor2val_lm_us(ltmltm)
     m1 = m1_dipole_cor2val_lm_us(ltmltm); m2 = m2_dipole_cor2val_lm_us(ltmltm)
     
!        if (l1 > l2) then
!           cycle
!        end if

     write(IFCOR2VAL,53) n1,l1,t1,m1,n2,l2,t2,m2, &
          &            dipole_cor2val_dx_us(ltmltm),&
          &            dipole_cor2val_dy_us(ltmltm), &
          &            dipole_cor2val_dz_us(ltmltm), &
          &            phase_ylm(l1,m1),phase_ylm(l2,m2)
  end do
    
15 format(4e20.12)
53 format(8i3,3e18.10,2i3)

  close(IFCOR2VAL)
     
end subroutine write_cor2val_file

subroutine write_cor2val_to_gncpp2(ier)
  use parameters 
  implicit none
  
  integer, intent(out) :: ier
  
  integer :: ltmltm, ishell, ir, ispin
  integer :: n1, n2, l1, l2, m1, m2, t1, t2, j2
!
  character(10) :: xc_name
  real(8) :: ekin_core, eion_core, eh_core, ekin_val
  real(8), allocatable :: array_tmp(:)
  
  if ( is_with_dipole_cor2val == 0) return

  write(IFGNCPP2,'(A)') 'CORE STATES'
  write(IFGNCPP2,'(I4)') num_core_states

  allocate( array_tmp( nmesh) ) 
    
  Do ishell=1, nshell
     if ( is_core_states( ishell ) == 0 ) cycle
     
     n1 = n_qnum(ishell); l1 = l_qnum(ishell); j2 = j2_qnum(ishell)
     ispin = (1-spin(ishell))/2 + 1
     
     write(IFGNCPP2,'(2I4,F28.15,F12.5,A)') n1, l1, engy(ishell), focc(ishell), &
          &                                 "    n  l  engy  focc"
     do ir = 1,nmesh
        if (abs(chi_g(ir,ishell)) < 1.d-99) then
           array_tmp(ir) = 0.d0
        else
           array_tmp(ir) = chi_g(ir,ishell)
        end if
     end do
     
     write(IFGNCPP2,15) ( array_tmp(ir),ir=1,nmesh)
  End Do
  
  deallocate( array_tmp ) 
  
! ------------
  select case( method_ekin_core )
  case (0)
     call calc_ekin_core0( ekin_core )            ! same as before
  case (-1)
     call calc_ekin_val_symm1( ekin_val )            ! symm. 
     if (is_calc == NONREL) then
        ekin_core = ekin_sum1 -ekin_val
     else
        ekin_core = ekin_sum -ekin_val
     endif
  case (-2)
     call calc_ekin_val_asymm( ekin_val )            ! asymm. 
     if (is_calc == NONREL) then
        ekin_core = ekin_sum1 -ekin_val
     else
        ekin_core = ekin_sum -ekin_val
     endif
  case (1)
     call calc_ekin_core_dirac_asymm( ekin_core )          ! asymm., dirac ???
  case (2)
     call calc_ekin_core_zora_asymm( ekin_core )            ! asymm., zora
  end select

  call calc_eion_core( eion_core )
  call calc_eh_core( eh_core )

  write(IFGNCPP2,'(A)') 'CORE ENERGY CONTRIB'
  write(IFGNCPP2,'(E20.12,A10)') ekin_core, " kin  "
  write(IFGNCPP2,'(E20.12,A10)') eion_core, " ion  "
  write(IFGNCPP2,'(E20.12,A10)') eh_core,   " hartr"
! -----------

! ================== KT_add =================== 4.2
   if ( is_write_soc_core /= 0 ) then
      call calc_soc_core_kt
   endif
! ============================================= 4.2

  write(IFGNCPP2,'(A)') 'DIPOLE-CORE-TO-VALENCE'
  write(IFGNCPP2,'(I6)') num_dipole_cor2val_lm_us
  
  do ltmltm = 1,num_dipole_cor2val_lm_us
     n1 = n1_dipole_cor2val_lm_us(ltmltm); n2 = n2_dipole_cor2val_lm_us(ltmltm)
     l1 = l1_dipole_cor2val_lm_us(ltmltm); l2 = l2_dipole_cor2val_lm_us(ltmltm)
     t1 = t1_dipole_cor2val_lm_us(ltmltm); t2 = t2_dipole_cor2val_lm_us(ltmltm)
     m1 = m1_dipole_cor2val_lm_us(ltmltm); m2 = m2_dipole_cor2val_lm_us(ltmltm)
       
!        if (l1 > l2) then
!           cycle
!        end if

     write(IFGNCPP2,53) n1,l1,t1,m1,n2,l2,t2,m2, &
          &            dipole_cor2val_dx_us(ltmltm),&
          &            dipole_cor2val_dy_us(ltmltm), &
          &            dipole_cor2val_dz_us(ltmltm), &
          &            phase_ylm(l1,m1),phase_ylm(l2,m2)
  end do
  
15 format(4e20.12)
53 format(8i3,3e18.10,2i3)

end subroutine write_cor2val_to_gncpp2

subroutine write_cor2val_to_ciaopp
  use parameters 
  implicit none
  
  integer :: ltmltm, ishell, ir, ispin1
  integer :: n1, n2, l1, l2, m1, m2, t1, t2, j2
!
  character(10) :: xc_name
  real(8) :: ekin_core, eion_core, eh_core, ekin_val
  real(8), allocatable :: array_tmp(:)
  
  if ( is_with_dipole_cor2val == 0) return

  write(IFCIAOPP,*)
  write(IFCIAOPP,'(A)') 'CORE STATES'
  write(IFCIAOPP,'(I4)') num_core_states

  allocate( array_tmp( nmesh) ) 
    
  Do ishell=1, nshell
     if ( is_core_states( ishell ) == 0 ) cycle
     
     n1 = n_qnum(ishell); l1 = l_qnum(ishell); j2 = j2_qnum(ishell)
     ispin1 = (1-spin(ishell))/2 + 1
     
     if ( nspin == 1 ) then
        write(IFCIAOPP,'(2I4,F28.15,F12.5,A)') n1, l1, engy(ishell), focc(ishell), &
             &                                 "    n  l  engy  focc"
     else if ( nspin == 2 ) then
        write(IFCIAOPP,'(3I4,F28.15,F12.5,A)') n1, l1, ispin1, &
             &                                 engy(ishell), focc(ishell), &
             &                                 "    n  l  spin  engy  focc"
     endif
     do ir = 1,nmesh
        if (abs(chi_g(ir,ishell)) < 1.d-99) then
           array_tmp(ir) = 0.d0
        else
           array_tmp(ir) = chi_g(ir,ishell)
        end if
     end do
     
     write(IFCIAOPP,15) ( array_tmp(ir),ir=1,nmesh)
  End Do
  
  deallocate( array_tmp ) 
  
! ------------
  select case( method_ekin_core )
  case (0)
     call calc_ekin_core0( ekin_core )            ! same as before
  case (-1)
     call calc_ekin_val_symm1( ekin_val )            ! symm. 
     if (is_calc == NONREL) then
        ekin_core = ekin_sum1 -ekin_val
     else
        ekin_core = ekin_sum -ekin_val
     endif
  case (-2)
     call calc_ekin_val_asymm( ekin_val )            ! asymm. 
     if (is_calc == NONREL) then
        ekin_core = ekin_sum1 -ekin_val
     else
        ekin_core = ekin_sum -ekin_val
     endif
  case (1)
     call calc_ekin_core_dirac_asymm( ekin_core )          ! asymm., dirac ???
  case (2)
     call calc_ekin_core_zora_asymm( ekin_core )            ! asymm., zora
  end select

  call calc_eion_core( eion_core )
  call calc_eh_core( eh_core )

  write(IFCIAOPP,*)
  write(IFCIAOPP,'(A)') 'CORE ENERGY CONTRIB'
  write(IFCIAOPP,'(E20.12,A10)') ekin_core, " kin  "
  write(IFCIAOPP,'(E20.12,A10)') eion_core, " ion  "
  write(IFCIAOPP,'(E20.12,A10)') eh_core,   " hartr"
! -----------

  write(IFCIAOPP,*)
  write(IFCIAOPP,'(a)') &
       '### Dipole moment core to valence : [n|d/dx|m], [n|d/dy|m], [n|d/dz|m]'

  if ( nspin == 1 ) then
     write(IFCIAOPP,'(a)') &
          '#     n = (n1,l1,t1,m1), m = (n2,l2,t2,m2)'
  else if ( nspin == 2 ) then
     write(IFCIAOPP,'(a)') &
          '#     n = (n1,l1,t1,m1,s1), m = (n2,l2,t2,m2,s2)'
  endif
  
  write(IFCIAOPP,'(A)') 'DIPOLE-CORE-TO-VALENCE'
  write(IFCIAOPP,'(I6)') num_dipole_cor2val_lm_us
   
   do ltmltm = 1,num_dipole_cor2val_lm_us
      n1 = n1_dipole_cor2val_lm_us(ltmltm); n2 = n2_dipole_cor2val_lm_us(ltmltm)
      l1 = l1_dipole_cor2val_lm_us(ltmltm); l2 = l2_dipole_cor2val_lm_us(ltmltm)
      t1 = t1_dipole_cor2val_lm_us(ltmltm); t2 = t2_dipole_cor2val_lm_us(ltmltm)
      m1 = m1_dipole_cor2val_lm_us(ltmltm); m2 = m2_dipole_cor2val_lm_us(ltmltm)

      ispin1 = spin1_indx_dipole_cor2val_lm_us(ltmltm)
       
!        if (l1 > l2) then
!           cycle
!        end if

      if ( nspin == 1 ) then
          write(IFCIAOPP,'(8i3,3(1pe18.10),2i3)') &
               &       n1,l1,t1,m1,n2,l2,t2,m2, &
               &       dipole_cor2val_dx_us(ltmltm),&
               &       dipole_cor2val_dy_us(ltmltm), &
               &       dipole_cor2val_dz_us(ltmltm), &
               &       phase_ylm(l1,m1),phase_ylm(l2,m2)
       else if ( nspin == 2 ) then
          write(IFCIAOPP,'(10i3,3(1pe18.10),2i3)') &
               &       n1,l1,t1,m1, ispin1, n2,l2,t2,m2, ispin1, &
               &       dipole_cor2val_dx_us(ltmltm),&
               &       dipole_cor2val_dy_us(ltmltm), &
               &       dipole_cor2val_dz_us(ltmltm), &
               &       phase_ylm(l1,m1),phase_ylm(l2,m2)
       endif
   end do
   
15 format(4e20.12)

end subroutine write_cor2val_to_ciaopp
! ========================================================= 4.1

!
!  Software name : CIAO (Code for Investigating Atomic Orbitals)
!  Subroutine(s) : iswap
!  Author(s)     : Masakuni Okamoto (August 25, 2003)
!
!
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!
!
!  The license of the code and contact address :
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)
!
!=====================================================================
   subroutine iswap(a,b)
!=====================================================================
!
!  Swaps integers a and b
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   implicit none
   integer,intent(inout) :: a, b
   integer :: itmp
   itmp = a ; a = b ; b = itmp
   end subroutine iswap

!
!  Software name : CIAO (Code for Investigating Atomic Orbitals)
!  Subroutine(s) : calc_dvxc_ddvxc, calc_de_srel, write_de_srel
!                : write_ee_srel
!  Author(s)     : Masakuni Okamoto (August 25, 2003)
!
!
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!
!
!  The license of the code and contact address :
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)
!
!=====================================================================
   subroutine calc_dvxc_ddvxc(ier)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer :: ispin, ll, ll_core
   ier = 0
   do ispin = 1,nspin
      call calc_ddiff_exp(ier,iord_diff,nmesh,rpos(1),vx(1,ispin), &
                          dvx(1,ispin),ddvx(1,ispin))
      call calc_ddiff_exp(ier,iord_diff,nmesh,rpos(1),vc(1,ispin), &
                          dvc(1,ispin),ddvc(1,ispin))
      do ll = 0,lmax
         if (is_core == PATOM) then
            ll_core = ll
         else
            ll_core = lmax_core
         end if
         call calc_ddiff_exp(ier,iord_diff,nmesh,rpos(1), &
                             veff(1,ispin,ll_core), &
                             dveff(1,ispin,ll_core), &
                             ddveff(1,ispin,ll_core))
      end do
   end do
99 continue
   end subroutine calc_dvxc_ddvxc

!=====================================================================
   subroutine calc_de_srel(ier)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer :: ir, ispin, ishell, jshell, n1, l1, ll_core, n2, l2, &
              is_order_perturbation, is_order_alpha, ir_min
   real(8) :: sum, aa, a4, de_core, de_h, de_xc, de_e2, de_a4, &
              de_o2, tmp, sum_m
   ier = 0
   is_order_perturbation = 1 ; is_order_alpha = 2
   ir_min = 10
   aa = ALPHA * ALPHA ; a4 = aa * aa
   de_srel(:) = 0.d0
   write(IFLOG,*)
   write(IFLOG,*) 'Energy shifts (in eV) by 1st and 2nd order perturbation'
   write(IFLOG,10) 'n','l','core','h','xc','e2','a4','o2','dE[SREL]'
   do ishell = 1,nshell
      ispin = (1-spin(ishell))/2 + 1
      n1 = n_qnum(ishell) ; l1 = l_qnum(ishell)
      if (is_core == PATOM) then
         ll_core = l1
      else
         ll_core = lmax_core
      end if
      if ((is_order_perturbation >= 1).and.(is_order_alpha >= 2)) then
         de_core = aa*dble(zatom)/8.d0 &
                   * (chi_g(ir_min,ishell)/rpos(ir_min))**2
         sum = 0.d0
         do ir = 1,nmesh
            sum = sum + wr(ir) * chi_g(ir,ishell)**2 * rho(ir,ispin)
         end do
         de_h = -aa*PI/2.d0*sum
         sum = 0.d0
         do ir = 1,nmesh
            sum = sum + wr(ir) * chi_g(ir,ishell)**2 &
               * (ddvx(ir,ispin) + 2.d0/rpos(ir)*dvx(ir,ispin) &
                + ddvc(ir,ispin) + 2.d0/rpos(ir)*dvc(ir,ispin))
         end do
         de_xc = aa*sum/8.d0
         sum = 0.d0
         do ir = 1,nmesh
            sum = sum + wr(ir) * chi_g(ir,ishell)**2 &
               * (engy(ishell) - veff(ir,ispin,ll_core))**2
         end do
         de_e2 = -aa*sum/2.d0
      else
         de_core = 0.d0 ; de_h = 0.d0 ; de_xc = 0.d0 ; de_e2 = 0.d0
      end if
      if ((is_order_perturbation >= 1).and.(is_order_alpha >= 4)) then
         de_a4 = 0.d0
         sum = 0.d0
         do ir = 1,nmesh
            sum = sum + wr(ir) * chi_g(ir,ishell)**2 &
               * dveff(ir,ispin,ll_core)**2
         end do
         tmp = a4*sum*3.d0/32.d0
         de_a4 = de_a4 + tmp
         tmp = -a4*dble(zatom)/16.d0 &
            * (chi_g(ir_min,ishell)/rpos(ir_min))**2 &
            * (engy(ishell) - veff(ir_min,ispin,ll_core))
         de_a4 = de_a4 + tmp
         sum = 0.d0
         do ir = 1,nmesh
            sum = sum + wr(ir) * chi_g(ir,ishell)**2 * rho(ir,ispin) &
               * (engy(ishell) - veff(ir,ispin,ll_core))
         end do
         tmp = a4*PI/4.d0*sum
         de_a4 = de_a4 + tmp
         sum = 0.d0
         do ir = 1,nmesh
            sum = sum + wr(ir) * chi_g(ir,ishell)**2 &
               * (ddvx(ir,ispin) + 2.d0/rpos(ir)*dvx(ir,ispin) &
                + ddvc(ir,ispin) + 2.d0/rpos(ir)*dvc(ir,ispin)) &
               * (engy(ishell) - veff(ir,ispin,ll_core))
         end do
         tmp = -a4*sum/16.d0
         de_a4 = de_a4 + tmp
      else
         de_a4 = 0.d0
      end if
      if ((is_order_perturbation >= 2).and.(is_order_alpha >= 4)) then
         de_o2 = 0.d0
         do jshell = 1,nshell
            n2 = n_qnum(jshell) ; l2 = l_qnum(jshell)
            if ((n1 /= n2).and.(l1 == l2)) then
               sum_m = 0.d0
               tmp = aa*dble(zatom)/8.d0 &
                  * (chi_g(ir_min,jshell)/rpos(ir_min)) &
                  * (chi_g(ir_min,ishell)/rpos(ir_min))
               sum_m = sum_m + tmp
               sum = 0.d0
               do ir = 1,nmesh
                  sum = sum + wr(ir) * rho(ir,ispin) &
                            * chi_g(ir,jshell) * chi_g(ir,ishell)
               end do
               tmp = -aa*PI/2.d0*sum
               sum_m = sum_m + tmp
               sum = 0.d0
               do ir = 1,nmesh
                  sum = sum + wr(ir) &
                     * chi_g(ir,jshell) * chi_g(ir,ishell) &
                     * (ddvx(ir,ispin) + 2.d0/rpos(ir)*dvx(ir,ispin) &
                      + ddvc(ir,ispin) + 2.d0/rpos(ir)*dvc(ir,ispin))
               end do
               tmp = aa*sum/8.d0
               sum_m = sum_m + tmp
               sum = 0.d0
               do ir = 1,nmesh
                  sum = sum + wr(ir) &
                     * chi_g(ir,jshell) * chi_g(ir,ishell) &
                     * (engy(ishell) - veff(ir,ispin,ll_core))**2
               end do
               tmp = -aa*sum/2.d0
               sum_m = sum_m + tmp
               de_o2 = de_o2 + sum_m**2/(engy(ishell) - engy(jshell))
            end if
         end do
      else
         de_o2 = 0.d0
      end if
      de_srel(ishell) = de_core + de_h + de_xc + de_e2 + de_a4 + de_o2
      write(IFLOG,11) &
         n1, l1, de_core*HARTREE, de_h*HARTREE, de_xc*HARTREE, &
         de_e2*HARTREE, de_a4*HARTREE, de_o2*HARTREE, &
         de_srel(ishell)*HARTREE
   end do
   ee_srel(:) = engy(:) + de_srel(:)
10 format(2(2x,a1),(10x,a4,1x),(10x,a1,4x),4(10x,a2,3x),(7x,a8))
11 format(2i3,7f15.5)
99 continue
   end subroutine calc_de_srel

!=====================================================================
   subroutine write_de_srel(ifile)
!=====================================================================  
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(in) :: ifile
   integer        :: i, nn, ll, ishell, lshell
   character(100) :: line, buffer
   do i = 1,100
      line(i:i)='-'
   end do
   write(ifile,*)
   write(ifile,*) 'eng  SREL correction dE [All-electron]'
      read(atom_label(zatom),*) buffer
   write(ifile,*) 'eng  Element ---> ',buffer(1:3)
   select case (is_spin)
   case (RESTRICTED)
   write(ifile,10) line(1:100)
   write(ifile,11) 'symm', &
                   'dE (Ha)','dE (eV)','nocc','focc'
   write(ifile,10) line(1:100)
   do ishell = 1,nshell
      lshell = list_shell(ishell)
      if (is_solve(lshell) == 0) then
         cycle
      end if
      nn = n_qnum(lshell)
      ll = l_qnum(lshell)
      write(ifile,12) state(lshell)(1:2), &
         de_srel(lshell),de_srel(lshell)*HARTREE,nocc(lshell),focc(lshell)
   end do
   write(ifile,10) line(1:100)
   write(ifile,13) 'Total number of electrons',felec
   write(ifile,10) line(1:100)
10 format(1x,'eng',a65)
11 format(1x,'eng',(3x,a4),2(13x,a7),(2x,a4),(6x,a4))
12 format(1x,'eng',(4x,a2,1x),2(f20.10),i6,f10.5)
13 format(1x,'eng',2x,a25,26x,f10.5)
   end select
   end subroutine write_de_srel

!=====================================================================
   subroutine write_ee_srel(ifile)
!=====================================================================  
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(in) :: ifile
   integer        :: i, nn, ll, ishell, lshell
   character(100) :: line, buffer
   do i = 1,100
      line(i:i)='-'
   end do
   write(ifile,*)
   write(ifile,*) 'eng  SREL corrected energy levels [All-electron]'
      read(atom_label(zatom),*) buffer
   write(ifile,*) 'eng  Element ---> ',buffer(1:3)
   select case (is_spin)
   case (RESTRICTED)
   write(ifile,10) line(1:100)
   write(ifile,11) 'symm', &
                   'Energy (Ha)','Energy (eV)','nocc','focc'
   write(ifile,10) line(1:100)
   do ishell = 1,nshell
      lshell = list_shell(ishell)
      if (is_solve(lshell) == 0) then
         cycle
      end if
      nn = n_qnum(lshell)
      ll = l_qnum(lshell)
      write(ifile,12) state(lshell)(1:2), &
         ee_srel(lshell),ee_srel(lshell)*HARTREE,nocc(lshell),focc(lshell)
   end do
   write(ifile,10) line(1:100)
   write(ifile,13) 'Total number of electrons',felec
   write(ifile,10) line(1:100)
10 format(1x,'eng',a65)
11 format(1x,'eng',(3x,a4),2(9x,a11),(2x,a4),(6x,a4))
12 format(1x,'eng',(4x,a2,1x),2(f20.10),i6,f10.5)
13 format(1x,'eng',2x,a25,26x,f10.5)
   end select
   end subroutine write_ee_srel

!
!  Software name : CIAO (Code for Investigating Atomic Orbitals)
!  Subroutine(s) : calc_scf
!  Author(s)     : Masakuni Okamoto (August 25, 2003)
!
!
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!
!
!  The license of the code and contact address :
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)
!
!=====================================================================
   subroutine calc_scf(ier)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------  
   use parameters   
   implicit none
   integer,intent(out) :: ier
   integer :: loop_scf, is_conv
   ier = 0
   loop_scf = 0
   istart_anderson = loop_scf
SCF: do
   loop_scf = loop_scf + 1
   engy_old(:)     = engy(:)
   rho_old(:,:)    = rho(:,:)
   veff_old(:,:,:) = veff(:,:,:)
   etot_old        = etot_sum
   felec1_old      = felec1
   felec2_old      = felec2
   felec_old       = felec
   if (is_xc_class == GGA) then
   select case (is_xc)
   case (GGAPBE96_MOMO)
      call calc_drho_ddrho(ier)
      if (ier /= 0) then
         write(IFLOG,*) '### ERROR ### in calc_drho_ddrho' ; go to 99
      end if
   case default
      call calc_drho(ier)
      if (ier /= 0) then
         write(IFLOG,*) '### ERROR ### in calc_drho' ; go to 99
      end if
   end select
   end if
   call calc_veff(ier)
   if (ier /= 0) then
      write(IFLOG,*) '### ERROR ### in calc_veff(1)' ; go to 99
   end if
   call calc_bound_state(ier)
   if (ier /= 0) then
      write(IFLOG,*) '### ERROR ### in calc_bound_state' ; go to 99
   end if
   call sort_engy(ier)
   if (ier /= 0) then
      write(IFLOG,*) '### ERROR ### in sort_engy' ; go to 99
   end if
   call set_focc(ier)
   if (ier /= 0) then
      write(IFLOG,*) '### ERROR ### in set_focc' ; go to 99
   end if
   call calc_efermi(ier)
   if (ier /= 0) then
      write(IFLOG,*) '### ERROR ### in calc_efermi' ; go to 99
   end if
   call calc_rho(ier)
   if (ier /= 0) then
      write(IFLOG,*) '### ERROR ### in calc_rho' ; go to 99
   end if
   call calc_etot(ier)
   if (ier /= 0) then
      write(IFLOG,*) '### ERROR ### in calc_etot' ; go to 99
   end if
   call check_conv(ier,is_conv,loop_scf)
   if (ier /= 0) then
      write(IFLOG,*) '### ERROR ### in check_conv' ; go to 99
   end if
   if (is_conv == YES) then
      exit SCF
   end if
   call mix_rho(ier,loop_scf)
   if (ier /= 0) then
      write(IFLOG,*) '### ERROR ### in mix_rho' ; go to 99
   end if
end do SCF
   if (is_xc_class == GGA) then
   select case (is_xc)
   case (GGAPBE96_MOMO)
      call calc_drho_ddrho(ier)
      if (ier /= 0) then
         write(IFLOG,*) '### ERROR ### in calc_drho_ddrho' ; go to 99
      end if
   case default
      call calc_drho(ier)
      if (ier /= 0) then
         write(IFLOG,*) '### ERROR ### in calc_drho' ; go to 99
      end if
   end select
   end if
   call calc_veff(ier)
   if (ier /= 0) then
      write(IFLOG,*) '### ERROR ### in calc_veff(2)' ; go to 99
   end if
99 continue
   end subroutine calc_scf

!
!  Software name : CIAO (Code for Investigating Atomic Orbitals)
!  Subroutine(s) : adjust_rho, calc_rho, calc_rho_core
!                : calc_ddiff_rho_origin, calc_drho_ddrho, 
!                : calc_drho_ddrho_core, calc_drho_ddrho_pcore
!                : calc_drho, calc_drho_core, calc_drho_pcore
!                : write_rho
!  Author(s)     : Masakuni Okamoto (August 25, 2003)
!
!
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!
!
!  The license of the code and contact address :
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)
!
!=====================================================================
   subroutine adjust_rho(ier,ifile,nmesh,rpos,wr,rho,felec,eps)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   implicit none
   integer,intent(in)    :: ifile, nmesh
   real(8),intent(in)    :: rpos(nmesh), wr(nmesh), felec, eps
   real(8),intent(inout) :: rho(nmesh)
   integer,intent(out)   :: ier
   integer :: ir
   real(8) :: sum, pi4
   ier = 0
   pi4 = 16.d0 * atan(1.d0)
   sum = 0.d0
   do ir = 1,nmesh
      sum = sum + rho(ir) * rpos(ir)**2 * wr(ir)
   end do
   sum = sum * pi4
   if (abs(sum-felec) > eps) then
      write(ifile,*) '### CAUTION ### sum of rho != felec'
      write(ifile,*) '   sum of rho ...',sum
      write(ifile,*) '   felec      ...',felec
      rho(:) = rho(:) * felec/sum
      write(ifile,*) 'rho was adjusted to felec.'
   end if
99 continue
   end subroutine adjust_rho

!=====================================================================
   subroutine calc_rho(ier)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer :: ir, ishell, ispin
   real(8) :: sum, pi4, fe1, fe2
   real(8),parameter :: RHOMIN = 1.d-99
   ier = 0
   pi4 = 4.d0 * PI
   rho(:,:) = 0.d0
   do ishell = 1,nshell
      ispin = (1-spin(ishell))/2 + 1
      select case (is_calc)
      case (NONREL,SREL)
         do ir = 1,nmesh
            rho(ir,ispin) = rho(ir,ispin) &
             + focc(ishell) * (chi_g(ir,ishell)/rpos(ir))**2 / pi4
         end do
      case (REL)
         do ir = 1,nmesh
            rho(ir,ispin) = rho(ir,ispin) &
             + focc(ishell) * ( (chi_g(ir,ishell)/rpos(ir))**2 &
                               +(chi_f(ir,ishell)/rpos(ir))**2 )/ pi4
         end do
      end select
   end do
   ispin = 1
   fe1 = 0.d0
   do ir = 1,nmesh
      if (rho(ir,ispin) < RHOMIN) then
         rho(ir,ispin) = 0.d0
      end if
      fe1 = fe1 + rho(ir,ispin) * pi4 * rpos(ir)**2 * wr(ir)
   end do
   sum = fe1
   if (is_spin == POLARIZED) then
      ispin = 2
      fe2 = 0.d0
      do ir = 1,nmesh
         if (rho(ir,ispin) < RHOMIN) then
            rho(ir,ispin) = 0.d0
         end if
         fe2 = fe2 + rho(ir,ispin) * pi4 * rpos(ir)**2 * wr(ir)
      end do
      sum = sum + fe2
   else
      fe2 = 0.d0
   end if
   if (is_spin_state == AUTOMATIC) then
      felec1 = fe1
      felec2 = fe2
   end if
   write(IFLOG,'(1x,a25,3f15.10)') &
        '??? charge (f1,f2,rho)...',felec1,felec2,sum
   if (abs(sum-felec) > eps_check) then
      write(IFLOG,*) '### ERROR ### sum of rho != felec'
      write(IFLOG,*) '   sum of rho ...',sum
      write(IFLOG,*) '   felec      ...',felec
      ier = 1 ; go to 99
   end if
99 continue
   end subroutine calc_rho

!=====================================================================
   subroutine calc_rho_core(ier)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer :: ir, ishell
   real(8) :: sum, pi4
   real(8),parameter :: RHOMIN = 1.d-99
   ier = 0
   pi4 = 4.d0 * PI
   rho_core(:) = 0.d0
   felec_core = 0.d0
   do ishell = 1,nshell
      if ((is_solve(ishell) /= 0).and.(is_valence(ishell) == 0)) then
      select case (is_calc)
      case (NONREL,SREL)
         do ir = 1,nmesh
            rho_core(ir) = rho_core(ir) &
             + focc(ishell) * (chi_g(ir,ishell)/rpos(ir))**2 / pi4
         end do
      case (REL)
         do ir = 1,nmesh
            rho_core(ir) = rho_core(ir) &
             + focc(ishell) * ( (chi_g(ir,ishell)/rpos(ir))**2 &
                               +(chi_f(ir,ishell)/rpos(ir))**2 )/ pi4
         end do
      end select
      felec_core = felec_core + focc(ishell)
      end if
   end do
   sum = 0.d0
   do ir = 1,nmesh
      if (rho_core(ir) < RHOMIN) then
         rho_core(ir) = 0.d0
      end if
      sum = sum + rho_core(ir) * pi4 * rpos(ir)**2 * wr(ir)
   end do
   write(IFLOG,'(1x,a25,3f15.10)') &
        '??? charge (felec_core,rho_core)...',felec_core,sum
   if (abs(sum - felec_core) > eps_check) then
      write(IFLOG,*) '### ERROR ### sum of rho_core != felec_core'
      write(IFLOG,*) '   sum of rho_core ...',sum
      write(IFLOG,*) '   felec_core      ...',felec_core
      ier = 1 ; go to 99
   end if
99 continue
   end subroutine calc_rho_core

!=====================================================================
   subroutine calc_ddiff_rho_origin(ier,np,nmesh,rpos,rho,drho,ddrho)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   implicit none
   integer,intent(out) :: ier
   integer :: np, nmesh, ip, np_lsq
   real(8) :: rpos(nmesh), rho(nmesh), drho(nmesh), ddrho(nmesh), &
              det, sum_x, sum_y, sum_xx, sum_xy, &
              ave_x, ave_y, ave_xx, ave_xy, a, b, c, &
              xi, yi
   ier    = 0
   np_lsq = 10
   sum_x  = 0.d0 ; sum_y  = 0.d0
   sum_xx = 0.d0 ; sum_xy = 0.d0
   do ip = 1,np_lsq
      xi = log(rpos(ip)) ; yi = log( max(rho(ip),1.d-30) )
      sum_x  = sum_x  + xi
      sum_y  = sum_y  + yi
      sum_xx = sum_xx + xi*xi
      sum_xy = sum_xy + xi*yi
   end do
   ave_x  = sum_x  / dble(np_lsq) ; ave_y  = sum_y  / dble(np_lsq)
   ave_xx = sum_xx / dble(np_lsq) ; ave_xy = sum_xy / dble(np_lsq)
   det = ave_xx - ave_x*ave_x
   a = (ave_xy       - ave_x*ave_y ) / det
   b = (ave_xx*ave_y - ave_x*ave_xy) / det
   c = exp(b)
   do ip = 1,np
       drho(ip) =         a/rpos(ip) *  rho(ip)
      ddrho(ip) = -(1.d0-a)/rpos(ip) * drho(ip)
   end do
99 continue
   end subroutine calc_ddiff_rho_origin

!=====================================================================
   subroutine calc_diff_rho_origin(ier,np,nmesh,rpos,rho,drho)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   implicit none
   integer,intent(in)  :: np, nmesh
   real(8),intent(in)  :: rpos(nmesh), rho(nmesh)
   integer,intent(out) :: ier
   real(8),intent(out) :: drho(nmesh)
   integer :: ip, np_lsq
   real(8) :: det, sum_x, sum_y, sum_xx, sum_xy, &
              ave_x, ave_y, ave_xx, ave_xy, a, b, c, &
              xi, yi
   ier    = 0
   np_lsq = 10
   sum_x  = 0.d0 ; sum_y  = 0.d0
   sum_xx = 0.d0 ; sum_xy = 0.d0
   do ip = 1,np_lsq
      xi = log(rpos(ip)) ; yi = log( max(rho(ip),1.d-30) )
      sum_x  = sum_x  + xi
      sum_y  = sum_y  + yi
      sum_xx = sum_xx + xi*xi
      sum_xy = sum_xy + xi*yi
   end do
   ave_x  = sum_x  / dble(np_lsq) ; ave_y  = sum_y  / dble(np_lsq)
   ave_xx = sum_xx / dble(np_lsq) ; ave_xy = sum_xy / dble(np_lsq)
   det = ave_xx - ave_x*ave_x
   a = (ave_xy       - ave_x*ave_y ) / det
   b = (ave_xx*ave_y - ave_x*ave_xy) / det
   c = exp(b)
   do ip = 1,np
      drho(ip) = a/rpos(ip) * rho(ip)
   end do
99 continue
   end subroutine calc_diff_rho_origin

!=====================================================================
   subroutine calc_drho_ddrho(ier)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer :: ir, ispin
   ier = 0
   do ispin = 1,nspin
      call calc_ddiff_exp(ier,iord_diff,nmesh,rpos(1),rho(1,ispin), &
                          drho(1,ispin),ddrho(1,ispin))
      call calc_ddiff_rho_origin(ier,iord_diff,nmesh, &
               rpos(1),rho(1,ispin),drho(1,ispin),ddrho(1,ispin))
      do ir = nmesh-iord_diff*2-1,nmesh
           rho(ir,ispin) =   rho(nmesh-iord_diff*2-2,ispin)
          drho(ir,ispin) =  drho(nmesh-iord_diff*2-2,ispin)
         ddrho(ir,ispin) = ddrho(nmesh-iord_diff*2-2,ispin)
      end do
   end do
99 continue
   end subroutine calc_drho_ddrho

!=====================================================================
   subroutine calc_drho_ddrho_core(ier)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer :: ir
   ier = 0
   call calc_ddiff_exp(ier,iord_diff,nmesh,rpos, &
                       rho_core,drho_core,ddrho_core)
   call calc_ddiff_rho_origin(ier,iord_diff,nmesh, &
                              rpos,rho_core,drho_core,ddrho_core)
   do ir = nmesh-iord_diff*2-1,nmesh
        rho_core(ir) =   rho_core(nmesh-iord_diff*2-2)
       drho_core(ir) =  drho_core(nmesh-iord_diff*2-2)
      ddrho_core(ir) = ddrho_core(nmesh-iord_diff*2-2)
   end do
99 continue
   end subroutine calc_drho_ddrho_core

!=====================================================================
   subroutine calc_drho_ddrho_pcore(ier)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer :: ir
   ier = 0
   call calc_ddiff_exp(ier,iord_diff,nmesh,rpos, &
                       rho_pcore,drho_pcore,ddrho_pcore)
   call calc_ddiff_rho_origin(ier,iord_diff,nmesh, &
                              rpos,rho_pcore,drho_pcore,ddrho_pcore)
   do ir = nmesh-iord_diff*2-1,nmesh
        rho_pcore(ir) =   rho_pcore(nmesh-iord_diff*2-2)
       drho_pcore(ir) =  drho_pcore(nmesh-iord_diff*2-2)
      ddrho_pcore(ir) = ddrho_pcore(nmesh-iord_diff*2-2)
   end do
99 continue
   end subroutine calc_drho_ddrho_pcore

!=====================================================================
   subroutine calc_drho(ier)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer :: ir, ispin
   ier = 0
   do ispin = 1,nspin
      call calc_diff_exp(ier,iord_diff,nmesh,rpos(1),rho(1,ispin), &
                          drho(1,ispin))
      call calc_diff_rho_origin(ier,iord_diff,nmesh, &
               rpos(1),rho(1,ispin),drho(1,ispin))
      do ir = nmesh-iord_diff*2-1,nmesh
           rho(ir,ispin) =   rho(nmesh-iord_diff*2-2,ispin)
          drho(ir,ispin) =  drho(nmesh-iord_diff*2-2,ispin)
      end do
   end do
99 continue
   end subroutine calc_drho

!=====================================================================
   subroutine calc_drho_core(ier)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer :: ir
   ier = 0
   call calc_diff_exp(ier,iord_diff,nmesh,rpos, &
                       rho_core,drho_core)
   call calc_diff_rho_origin(ier,iord_diff,nmesh, &
                              rpos,rho_core,drho_core)
   do ir = nmesh-iord_diff*2-1,nmesh
        rho_core(ir) =   rho_core(nmesh-iord_diff*2-2)
       drho_core(ir) =  drho_core(nmesh-iord_diff*2-2)
   end do
99 continue
   end subroutine calc_drho_core

!=====================================================================
   subroutine calc_drho_pcore(ier)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer :: ir
   ier = 0
   call calc_diff_exp(ier,iord_diff,nmesh,rpos, &
                       rho_pcore,drho_pcore)
   call calc_diff_rho_origin(ier,iord_diff,nmesh, &
                              rpos,rho_pcore,drho_pcore)
   do ir = nmesh-iord_diff*2-1,nmesh
        rho_pcore(ir) =   rho_pcore(nmesh-iord_diff*2-2)
       drho_pcore(ir) =  drho_pcore(nmesh-iord_diff*2-2)
   end do
99 continue
   end subroutine calc_drho_pcore

!=====================================================================
   subroutine write_rho(ier)
!=====================================================================
!
!  M. Okamoto
!     
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer :: ir, ll_core
   real(8) :: zeta
   ier = 0
   open(IFRHO,file=trim(rhofile),status='unknown')
   write(IFRHO,*) 'All-electron density and potentials'
   call write_file_header(IFRHO)
   write(IFRHO,*)
   if (is_core == PATOM) then
      ll_core = 0
   else
      ll_core = lmax_core
   end if
   select case (nspin)
   case (1)
      write(IFRHO,*) 'rpos, rho, vion, vh, vx, vc'
      do ir = 1,nmesh
         write(IFRHO,10) rpos(ir),rho(ir,1), &
            vion(ir,ll_core),vh(ir),vx(ir,1),vc(ir,1)
      end do
   case (2)
      write(IFRHO,*) &
         'rpos, rho, vion, vh, <vx>, <vc>'
      do ir = 1,nmesh
         write(IFRHO,10) rpos(ir),rho(ir,1)+rho(ir,2), &               
            vion(ir,ll_core),vh(ir),(vx(ir,1)+vx(ir,2))*0.5d0, &
            (vc(ir,1)+vc(ir,2))*0.5d0                          
      end do
      write(IFRHO,*)
      write(IFRHO,*) 'rpos, rho1, rho2, zeta'
      do ir = 1,nmesh
         zeta = (rho(ir,1)-rho(ir,2))/(rho(ir,1)+rho(ir,2))
         write(IFRHO,10) rpos(ir),rho(ir,1),rho(ir,2),zeta
      end do
      write(IFRHO,*)
      write(IFRHO,*) 'rpos, vx1, vx2, vc1, vc2'
      do ir = 1,nmesh
         write(IFRHO,10) rpos(ir),vx(ir,1),vx(ir,2), &
                         vc(ir,1),vc(ir,2)
      end do
   end select
10 format(10(1pe20.10))
   close(IFRHO)
   end subroutine write_rho

!
!  Software name : CIAO (Code for Investigating Atomic Orbitals)
!  Module(s)     : parameters
!  Author(s)     : Masakuni Okamoto (August 25, 2003)
!
!
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!
!
!  The license of the code and contact address :
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)
!
!=====================================================================
   module parameters
!=====================================================================
!
!  Parameters and variables
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   implicit none
   integer,parameter :: NATOM = 120
   integer,parameter :: &
      NO = 0, YES = 1, NONE = 0, NONREL = 1, SREL = 2, REL = 3, &
      RESTRICTED = 1, POLARIZED = 2, AUTOMATIC = 1, MANUAL = 2, &
      UD_SPECIFIED = MANUAL, SPIN_SPECIFIED = 3, NREL = NONREL, &
      NORMAL = 1, PATOM = 2, OZAKI_KINO = 3, &
      LDAPZ81 = 1, LDAPW92_MOMO = 2, LDAPW92_MOMO2 = 3,           &
      LDAPW92_GNCPP = 4, GGAPW91_MOMO = 5, GGAPW91_MOMO2 = 6,     &
      GGAPW91_F90 = 7, GGAPW91_F77 = 8, GGAPBE96_MOMO = 9,        &
      GGAPBE96_MOMO2 = 10, GGAPBE96_GNCPP = 11,                   &
      GGAPBE96_KATO = 12, REVPBE = 13, XLDA = 14, XGGA = 15,      &
      LDA = 1, GGA = 2,                                           &
      BHS82 = 1, TM91 = 2, US90 = 3, GENERAL_PP = 4, PAW = 5,     &
      TM91SO = 6,                                                 &
      NC = 100, US = 101, SEMILOCAL = 100, SEPARABLE = 101,       &
      PCC = 1, FCC = 2, POLYNOMIAL = 1, SBESSEL = 2, BHSPCC = 3,  &
      ANGULAR = 3, NOOPT = 4,                                     &
      PCC_RATIO = 1, PCC_RC = 2, ITERATIVE = 1, FREDHOLM = 2,     &
      CORE_POTENTIAL_CONFINEMENT = 1, OZAKI_KINO_CONFINEMENT = 2, &
      JRCAT = 3, EXTENDED = 1

   character(4)  :: version
   character(11) :: vdate
   integer :: narg, have_args, have_infile
   character(50) :: argv(15)

   real(8),parameter :: ARGMAX = 150.d0

   character(50) :: &
      calc_type, spin_type, spin_state_type, xc_type, xc_approx,   &
      mesh_type, weight_type, core_type, calc_type_explained,      &
      spin_type_explained, spin_state_type_explained,              &
      xc_type_explained, xc_approx_explained, mesh_type_explained, &
      weight_type_explained, core_type_explained

   character(50),allocatable :: &
      state(:), spin_label(:), state_in(:)

   integer :: &
      zatom, nshell, nspin, nmesh, ng_mesh, loop_conv, lmax_core,     &
      iord_pc, iord_diff, iord_nec, iord_coeff, is_calc, is_spin,     &
      is_spin_state, is_xc, is_mesh, is_weight, is_core, is_xc_class, &
      is_write_rho, is_write_rm, is_debug, nshell_in, nsave_dee,      &
      nrcut_ok, is_write_orbital

   integer,allocatable :: & 
      is_solve(:), is_valence(:), list_shell(:), n_qnum(:), &
      l_qnum(:), k_qnum(:), j2_qnum(:), spin(:), nocc(:),   &
      nrm_pos(:), nrt_pos(:), nmm_pos(:), is_solve_in(:),   &
      is_valence_in(:), n_qnum_in(:), l_qnum_in(:)

! ======================================== added by K. T. =============== 4.0
   integer, allocatable :: spin_index_ps(:)
! ======================================================================= 4.0

   real(8) :: &
      rmin, rmax, xmin, xmax, dx, xh, gmin, gmax, fatom, felec, &
      felec1, felec2, fspin, felec_old, felec1_old, felec2_old, &
      mix1, mix2, foccnl(10,0:4,2), foccnl_tmp(10,0:4,2),       &
      foccnls(10,0:4,2), foccnls_tmp(10,0:4,2),                 &
      dee_conv, efermi, ekin_sum, ekin_sum1, ekin_sum2, &
      eloc_ion_sum, enl_ion_sum, eion_sum, vlocqps_sum, eh_sum, &
      ex_sum, ec_sum, exc_sum, etot_sum1, etot_sum2, etot_sum,  &
      etot_old, vx_sum, vc_sum, vxc_sum, eband_sum, veff_sum,   &
      expc_sum, ecpc_sum, excpc_sum,    &
      vxpc_sum, vcpc_sum, vxcpc_sum,   &
      eps_check, eps_de, h_ok, drcl_ok, rcut_ok, rl_ok

   real(8),allocatable :: &
      focc(:), rcut_tm(:), rcut_core(:), vcut_core(:), rpos(:),      &
      xpos(:), wr(:), wt(:), gpos(:), wg(:), vion(:,:), vh(:),       &
      ex(:), ec(:), vx(:,:), vc(:,:), vcoeff(:,:,:), veff(:,:,:),    &
      veff_old(:,:,:), rho(:,:), rho_old(:,:), rho_zeta(:), engy(:), &
      engy_old(:), chi_g(:,:), chi_gl(:), chi_gr(:), chi_f(:,:),     &
      chi_fl(:), chi_fr(:), dxchi_g(:,:), dxchi_gl(:), dxchi_gr(:),  &
      dxchi_f(:,:), dxchi_fl(:), dxchi_fr(:), focc_in(:,:),          &
      dee_save(:)

   real(8),allocatable :: &
      rho1_rad(:), rho2_rad(:), drho1_rad(:), drho2_rad(:), &
      drho_rad(:),                                          &
      fx_rad(:), fc_rad(:), dfx_rad(:,:), dfc_rad(:,:),     &
      dfxda_rad(:,:), dfcda_rad(:), vx_rad(:,:), vc_rad(:,:)

   real(8),allocatable :: &
      dvx(:,:), dvc(:,:), ddvx(:,:), ddvc(:,:), &
      dveff(:,:,:), ddveff(:,:,:), de_srel(:), ee_srel(:)

   character(50),allocatable :: &
      state_so(:), spin_label_so(:)

   integer :: nshell_so

   integer,allocatable :: & 
      is_solve_so(:), is_valence_so(:), list_shell_so(:),      &
      n_qnum_so(:), l_qnum_so(:), k_qnum_so(:), j2_qnum_so(:), &
      spin_so(:), nocc_so(:), nrm_pos_so(:), nrt_pos_so(:),    &
      nmm_pos_so(:)

   real(8) :: &
      felec_so, ekin_sum_so, eion_sum_so, eh_sum_so, exc_sum_so, &
      ex_sum_so, ec_sum_so, vx_sum_so, vc_sum_so, vxc_sum_so,    &
      eband_sum_so, etot_sum_so

   real(8),allocatable :: &
      focc_so(:), engy_so(:)

   character(50) :: pp_type, pp_type_explained

   integer :: &
      is_pp, is_pp_calc_class, is_pp_out_class, is_write_gncpp, &
      is_write_psvpp, is_write_gncpp2, is_write_ciaopp,         &
      is_with_core, is_with_ae, is_with_so, is_write_pp,        &
      is_pp_generated, is_semilocal_mode, is_paw,               &
      nps, lloc, lmax, ips_loc, ncoeff_phi_tm

! ================= KT_add ================= 4.1
   logical :: is_paw_is_read
! ========================================== 4.1

   integer,allocatable :: &
      ishell_ps(:,:), num_so_ps(:), is_gen_ps(:,:)

   real(8) :: &
      felec_core, felec_val, r_core, rmax_ps, rcut_loc_bhs,      &
      vcut_loc_bhs, lambda_loc_bhs, rcut_loc_poly, vcut_loc_poly

   real(8),allocatable :: &
      vscr_bhs(:,:), vion_bhs(:,:), vso_bhs(:,:),                   &
      vscr_tmso(:,:), vion_tmso(:,:), vso_tmso(:,:),                &
! ================================================ modified by K. T. ======= 4.0
!      rho_ps(:), &
      rho_ps(:,:), &
! ========================================================================== 4.0
      chi_ps(:,:,:), veff_ps(:,:,:), veff_ps_old(:,:,:), &
      vion_ps(:,:,:), vh_ps(:), &
! =============================================== modified by K. T. ======= 4.0
!      vloc_ps(:), vx_ps(:), vc_ps(:),     &
      vloc_ps(:,:), vx_ps(:,:), vc_ps(:,:),     &
! ========================================================================== 4.0
      ex_ps(:), ec_ps(:), &
      coeff_tm(:,:,:), vcoeff_ps(:,:,:),        &
      rho_core(:), vxpc_ps(:), vcpc_ps(:), expc_ps(:), ecpc_ps(:),  &
      coeff_phi_tm(:,:,:)

   character(50) :: local_type_us, local_name_us
   character(50),allocatable :: val_label_ps(:), val_type_ps(:)

   integer :: &
      is_write_us, is_write_qps, num_ltlt_us, num_ltltx_us,          &
      num_ltt_us, num_lttx_us, num_lt_us, num_lt_loc_us, num_ltx_us, &
      nref_max_ps, nref_max_us, l3_max_us, nrcut_max_us,             &
      nrcut_maxx_us, nrcut_phi_max_us, nrcut_loc_us, ng_phi_us,      &
      ng_qps_us, ncoeff_max_us, ncoeff_phi_us, ncoeff_qps_us,        &
      is_deficit_type, is_projector_type

   integer,allocatable :: &
      l_val_label_ps(:), n_val_label_ps(:), is_val_type_ps(:),       &
      is_val_type_us(:), nref_ps(:), nref_us(:), lt_n_us(:,:),       &
      ips_lt_us(:), n_lt_us(:), l_lt_us(:), t_lt_us(:), ln_lt_us(:), &
      tn_lt_us(:), nrcut_phi_us(:), nodes_phi_us(:), is_bound_us(:), &
      is_bound_ps(:), ltt_nm_us(:,:,:), ips1_ltt_us(:),              &
      ips2_ltt_us(:), n1_ltt_us(:), n2_ltt_us(:), l_ltt_us(:),       &
      t1_ltt_us(:), t2_ltt_us(:), tn_ltt_us(:), tm_ltt_us(:),        &
      ltlt_nm_us(:,:,:,:), ips1_ltlt_us(:), n1_ltlt_us(:),           &
      l1_ltlt_us(:), t1_ltlt_us(:), ln_ltlt_us(:), tn_ltlt_us(:),    &
      ips2_ltlt_us(:), n2_ltlt_us(:), l2_ltlt_us(:), t2_ltlt_us(:),  &
      lm_ltlt_us(:), tm_ltlt_us(:), nrcut_qps_us(:,:)

! ============================ added by K. T. ====================== 4.0
   integer, allocatable :: spin_index_lt_us(:)
   integer, allocatable :: spin1_index_ltt_us(:)
   integer, allocatable :: spin2_index_ltt_us(:)
   integer, allocatable :: spin1_index_ltlt_us(:)
   integer, allocatable :: spin2_index_ltlt_us(:)
! ================================================================== 4.0

   real(8) :: &
      deref_max_ps, gmin_phi_us, gmax_phi_us, gmin_qps_us,         &
      gmax_qps_us, gmin_pcc_us, gmax_pcc_us, rcut_max_us,          &
      rcut_loc_us, rcut_phi_max_us, eband_sum_us, eloc_ion_sum_us, &
      eloc_scr_sum_us, ex_sum_us, ec_sum_us, exc_sum_us,           &
      vx_sum_us, vc_sum_us, vxc_sum_us, eh_sum_us, etot_sum_us

   real(8),allocatable :: &
      deref_ps(:,:), rcut_phi_ps(:,:), rin_qps_ps(:,:),              &

! ========================================= modiifed by K. T. ============= 4.0
!      vloc_scr_us(:), vloc_ion_us(:), &
      vloc_scr_us(:,:), vloc_ion_us(:,:), &
! ========================================================================= 4.0
      norm_psi_ps(:),                &
      norm_psi_us(:), norm_phi_us(:), eref_us(:), veff_us(:,:),      &
      rpsi_us(:,:), rphi_us(:,:), drpsi_us(:,:), drphi_us(:,:),      &
      ddrphi_us(:,:), rchi_us(:,:), rbeta_us(:,:),                   &
      coeff_phi_us(:,:), q_sum_us(:), qps_sum_us(:), vlocqps_us(:),  &
      bmat_us(:), dmat_us(:), dion_us(:), q_us(:,:), qps_us(:,:,:),  &
      coeff_qps_us(:,:,:), rcut_qps_us(:,:), psi_g_us(:,:),          &
      phi_g_us(:,:), chi_g_us(:,:), beta_g_us(:,:), qps_g_us(:,:,:), &
      q_g_us(:,:)

   integer :: is_write_sol
   integer,allocatable :: list_sol(:)

   real(8) :: felec_sol, etot_sol, &
      ekin_sum1_sol, ekin_sum2_sol, ekin_sum_sol, eloc_ion_sum_sol, &
      enl_ion_sum_sol, vlocqps_sum_sol, eion_sum_sol, eh_sum_sol,   &
      ex_sum_sol, ec_sum_sol, exc_sum_sol, etot_sum1_sol,           &
      etot_sum2_sol, etot_sum_sol, vx_sum_sol, vc_sum_sol,          &
      vxc_sum_sol, eband_sum_sol, veff_sum_sol,                     &
      expc_sum_sol, ecpc_sum_sol, excpc_sum_sol,                    &
      vxpc_sum_sol, vcpc_sum_sol, vxcpc_sum_sol

! ==================================== modified by K. T. =================== 4.0
!   real(8),allocatable :: &
!      focc_sol(:), engy_sol(:), rphi_sol(:,:), rho_sol(:),           &
!      beta_phi_sol(:,:), vh_sol(:), ex_sol(:), ec_sol(:), vx_sol(:), &
!      vc_sol(:), vloc_scr_sol(:), vloc_ion_sol(:), drho_sol(:),      &
!      ddrho_sol(:), expc_sol(:), ecpc_sol(:), vxpc_sol(:), vcpc_sol(:)

   real(8),allocatable :: &
      focc_sol(:), engy_sol(:), rphi_sol(:,:), rho_sol(:,:),           &
      beta_phi_sol(:,:), vh_sol(:), ex_sol(:), ec_sol(:), vx_sol(:,:), &
      vc_sol(:,:), vloc_scr_sol(:,:), vloc_ion_sol(:,:), drho_sol(:,:),      &
      ddrho_sol(:,:), expc_sol(:), ecpc_sol(:), vxpc_sol(:), vcpc_sol(:)
! ============================================================================ 4.0

   character(50) :: &
      solve_pp_spin_type, solve_pp_spin_type_explained,         &
      spin_type_ss, spin_type_ss_explained, spin_state_type_ss, &
      spin_state_type_ss_explained

   character(50),allocatable :: val_label_ss(:)
   character(1),allocatable :: spin_label_ss(:)

   integer :: &
      is_spin_ss, is_spin_state_ss, is_solve_pp_spin, nspin_ss, nss

   integer,allocatable :: &
      n_val_label_ss(:), l_val_label_ss(:), spin_ss(:),        &
      ishell_ss(:), is_solve_ss(:), nrm_pos_ss(:), nocc_ss(:), &
      list_ss(:)             

   real(8) :: &
      felec1_ss, felec2_ss, felec_ss, fspin_ss, mix_ss, efermi_ss, &
      etot_ss, etot_ss_old, felec1_ss_old, felec2_ss_old, felec_ss_old, &
      ekin_sum1_ss, ekin_sum2_ss, ekin_sum_ss, eloc_ion_sum_ss,     &
      enl_ion_sum_ss, vlocqps_sum_ss, eion_sum_ss, eh_sum_ss,       &
      ex_sum_ss, ec_sum_ss, exc_sum_ss, etot_sum1_ss, etot_sum2_ss, &
      etot_sum_ss, vx_sum_ss, vc_sum_ss, vxc_sum_ss, eband_sum_ss,  &
      veff_sum_ss, expc_sum_ss, ecpc_sum_ss, excpc_sum_ss,          &
      vxpc_sum_ss, vcpc_sum_ss, vxcpc_sum_ss           

   real(8),allocatable :: &
      focc_ss(:), vloc_scr_ss(:,:), engy_ss(:), rphi_ss(:,:),       &
      beta_phi_ss(:,:), rho_ss(:,:), drho_ss(:,:), ddrho_ss(:,:),   &
      vh_ss(:), dmat_ss(:,:), vlocqps_ss(:,:), ex_ss(:), ec_ss(:),  &
      vx_ss(:,:), vc_ss(:,:), expc_ss(:), ecpc_ss(:), vxpc_ss(:,:), &
      vcpc_ss(:,:), engy_ss_old(:), rho_ss_old(:,:),                &
      vloc_scr_ss_old(:,:)

   character(50) :: &
      pao_type, pao_type_explained
   character(12) :: pao_formula

   integer :: is_calc_pao, is_pao_type, num_l_pao, num_pao
   integer,allocatable :: &
      lnum_pao(:), nnum_pao(:), l_pao(:), n_pao(:)

   real(8),allocatable :: &
      engy_pao(:), rphi_pao(:,:), drphi_pao(:,:), beta_phi_pao(:,:), &
      vloc_pao(:)

   character(50) :: &
      core_state_type, core_state_type_explained

   integer :: zcore, zval, num_core
   real(8) :: fcore, fval
   integer :: is_core_hole_unscreened, num_core_hole

   real(8) :: ftot_core_hole
   character(50),allocatable :: label_core_hole(:)

   integer,allocatable :: &
      n_val_label_core_hole(:), l_val_label_core_hole(:), &
      ishell_core_hole(:)
   real(8),allocatable :: &
      focc_core_hole(:)

   character(50) :: &
      qps_type, qps_type_explained, &
      projector_type, projector_type_explained

   integer :: is_qps_type, lmax_qps, nrcut_beta
   real(8) :: rcut_beta, kappa_beta

   real(8),allocatable :: rcl_qps(:)

   character(50) :: &
      pcc_type, pcc_type_explained, pcc_method, &
      pcc_method_explained, pcc_rad, pcc_rad_explained

   integer :: &
      is_pcc, is_pcc_method, is_write_pcc, is_pcc_rad, nr0_pcc, &
      ng_pcc, ncoeff_pcc, nk_pcc

   real(8) :: r0_pcc, a_pcc, b_pcc, gmin_pcc, gmax_pcc, &
      a_bhspcc, b_bhspcc

   real(8),allocatable :: &
      rho_pcore(:), coeff_pcc(:), rho_core0_pcc(:), gg_rho_core(:), &
      gg_rho_pcore(:), gg_rho_val(:)

   real(8),allocatable :: &
      drho(:,:), ddrho(:,:), &
! ========================================== modified by K. T. =========== 4.0
!      drho_ps(:), ddrho_ps(:), &
      drho_ps(:,:), ddrho_ps(:,:), &
! ========================================================================= 4.0
      drho_core(:), &
      ddrho_core(:), drho_pcore(:), ddrho_pcore(:)                 

   integer :: n_anderson, istart_anderson

   real(8),allocatable :: &
      rho_p(:,:,:), rho_old_p(:,:,:), mat_p(:,:), vec_p(:,:), &
      coeff_p(:)    

   integer :: is_calc_hubbard
   real(8) :: hubbard_b(0:3,-3:3,0:6)
   real(8),allocatable :: hubbard_i(:,:,:), hubbard_u(:,:,:,:)

   integer :: &
      is_with_dipole, num_dipole_l_us, num_dipole_lm_us, &
      num_dipole_l_ps, num_dipole_lm_ps

   integer,allocatable :: phase_ylm(:,:), &
      n1_dipole_l_us(:), l1_dipole_l_us(:), t1_dipole_l_us(:),       &
      lt1_dipole_l_us(:), n2_dipole_l_us(:), l2_dipole_l_us(:),      &
      t2_dipole_l_us(:), lt2_dipole_l_us(:), n1_dipole_lm_us(:),     &
      l1_dipole_lm_us(:), t1_dipole_lm_us(:), m1_dipole_lm_us(:),    &
      n2_dipole_lm_us(:), l2_dipole_lm_us(:), t2_dipole_lm_us(:),    &
      m2_dipole_lm_us(:), ltlt_dipole_lm_us(:),                      &
      ltmltm_dipole_us(:,:,:), n1_dipole_l_ps(:), l1_dipole_l_ps(:), &
      ips1_dipole_l_ps(:), n2_dipole_l_ps(:), l2_dipole_l_ps(:),     &
      ips2_dipole_l_ps(:), n1_dipole_lm_ps(:), l1_dipole_lm_ps(:),   &
      m1_dipole_lm_ps(:), n2_dipole_lm_ps(:), l2_dipole_lm_ps(:),    &
      m2_dipole_lm_ps(:), nlnl_dipole_lm_ps(:),                      &
      nlmnlm_dipole_ps(:,:,:)

! =============================== added by K. T. ========================= 4.0
   integer,allocatable :: spin1_index_dipole_l_ps(:), &
        &                 spin1_index_dipole_lm_ps(:), &
        &                 spin1_index_dipole_l_us(:), &
        &                 spin1_index_dipole_lm_us(:)
! ========================================================================= 4.0

   real(8),allocatable :: pxyz(:,:,:), &
      dipole_r_us(:), dipole_ri_us(:), dipole_pr_us(:),  &
      dipole_x_us(:), dipole_y_us(:), dipole_z_us(:),    &
      dipole_dx_us(:), dipole_dy_us(:), dipole_dz_us(:), &
      dipole_r_ae(:), dipole_ri_ae(:), dipole_pr_ae(:),  &
      dipole_x_ae(:), dipole_y_ae(:), dipole_z_ae(:),    &
      dipole_dx_ae(:), dipole_dy_ae(:), dipole_dz_ae(:), &
      dipole_r_pp(:), dipole_ri_pp(:), dipole_pr_pp(:),  &
      dipole_x_pp(:), dipole_y_pp(:), dipole_z_pp(:),    &
      dipole_dx_pp(:), dipole_dy_pp(:), dipole_dz_pp(:), &
      dipole_x_ss(:), dipole_y_ss(:), dipole_z_ss(:),    &
      dipole_dx_ss(:), dipole_dy_ss(:), dipole_dz_ss(:), &
      rpsi_ps(:,:), drpsi_ps(:,:), rphi_ps(:,:), drphi_ps(:,:)

! ============ KT_add =========================================== 4.1
   integer :: is_with_dipole_cor2val, num_core_states, lmax_core_states, &
        &     num_dipole_cor2val_l_us, num_dipole_cor2val_lm_us

   integer, allocatable :: &
        &     n1_dipole_cor2val_l_us(:), n2_dipole_cor2val_l_us(:), &
        &     l1_dipole_cor2val_l_us(:), l2_dipole_cor2val_l_us(:), &
        &     t1_dipole_cor2val_l_us(:), t2_dipole_cor2val_l_us(:), &
        &     lt1_dipole_cor2val_l_us(:), lt2_dipole_cor2val_l_us(:), &
!
        &     n1_dipole_cor2val_lm_us(:), n2_dipole_cor2val_lm_us(:), &
        &     l1_dipole_cor2val_lm_us(:), l2_dipole_cor2val_lm_us(:), &
        &     t1_dipole_cor2val_lm_us(:), t2_dipole_cor2val_lm_us(:), &
        &     m1_dipole_cor2val_lm_us(:), m2_dipole_cor2val_lm_us(:), &
!
        &     ltlt_dipole_cor2val_lm_us(:), ltmltm_dipole_cor2val_us(:,:,:)

   integer,allocatable :: spin1_indx_dipole_cor2val_l_us(:), &
        &                 spin1_indx_dipole_cor2val_lm_us(:), &
        &                 is_core_states(:)

   real(8),allocatable :: &
        &  dipole_cor2val_r_us(:),  dipole_cor2val_ri_us(:), dipole_cor2val_pr_us(:),  &
        &  dipole_cor2val_x_us(:),  dipole_cor2val_y_us(:),  dipole_cor2val_z_us(:),  &
        &  dipole_cor2val_dx_us(:), dipole_cor2val_dy_us(:), dipole_cor2val_dz_us(:)
! =============================================================== 4.1

! ===== KT_add === 4.2
   integer :: is_write_orbital_index
   integer :: is_write_soc_valence
   integer :: is_write_soc_core
! ================ 4.2
   integer :: is_write_core_full
   integer :: method_ekin_core

   integer :: ne_kb, have_ghost_kb
   integer,allocatable :: is_solved_kb(:,:), is_ghost_kb(:)
   real(8),allocatable :: &
      engy_kb(:,:), vrms_kb(:,:), cos_kb(:,:), ee_local_kb(:,:)

   character(50) :: &
      logderi_type, logderi_type_explained, logderi_method, &
      logderi_method_explained, logderi_nonlocal,           &
      logderi_nonlocal_explained

   integer :: &
      is_logderi, ne_logderi, is_write_logderi, nrcut_logderi, &
      is_logderi_method, is_logderi_nonlocal
   real(8) :: emax_logderi, emin_logderi, rcut_logderi

   real(8),allocatable :: &
      logderi(:,:), logderi_ps(:,:), ee_logderi(:), &
! ================================================ modified by K. T. =========== 4.0
!      logderi_ae(:,:), logderi_us(:,:)
      logderi_ae(:,:,:), logderi_us(:,:,:)
! ============================================================================== 4.0

   character(50) :: fourier_type, fourier_type_explained
   integer :: is_fourier, ng_fourier, is_write_fourier
   real(8) :: gmin_fourier, gmax_fourier

   real(8),allocatable :: &
      gpos_ft(:), gg_vion_ft(:,:), gg_vion_ps_ft(:,:), &

! ================================================ modified by K. T. ========== 4.0
!      gg_vloc_ion_ft(:)
      gg_vloc_ion_ft(:,:)
! ============================================================================= 4.0

   real(8),allocatable :: &
      gr_wk(:), js_wk(:)
  !--- MO-100526
   integer :: ntkc
   real(8),allocatable :: tkc(:), dekin_tkc(:,:)
  !---
   character(50) :: &
      jobname, infile, logfile, sumfile, rhofile, pccfile, usfile, &
      qpsfile, ldrfile, ftfile, ppfile, gncppfile, gncpp2file,     &
      psvppfile, solfile, ciaoppfile, paofile, bhsppfile, tmsoppfile, &
      orbfile, infofile
   integer,parameter :: &
      IFIN    = 21, IFLOG   = 22, IFSUM    = 23, &
      IFRHO   = 24, IFPCC   = 25, IFUS     = 26, &
      IFQPS   = 27, IFLDR   = 28, IFFT     = 29, &
      IFPP    = 30, IFGNCPP = 31, IFGNCPP2 = 32, &
      IFPSVPP = 33, IFSOL   = 34, IFCIAOPP = 35, &
      IFPAO   = 36, IFBHSPP = 37, IFTMSOPP = 38, &
      IFORB   = 39

! ===================== KT_add ===================== 4.1
   character(50) :: file_cor2val
   integer :: IFCOR2VAL = 50
! ================================================== 4.1

   character(3) :: ch_loop,ch_dr,ch_drr,ch_de,ch_dee

   character(2),allocatable  :: atom_label(:)
   character(30),allocatable :: atom_name(:) 
   real(8),allocatable :: &
      cc_param(:,:), cc_a1(:), cc_a2(:), cc_c1(:), dist_nn(:)

   character(20) :: day_start, day_end, day_now
   integer       :: icount0

   real          :: time, total_time

   real(8),parameter :: &
      PI = 3.1415926535897932384626433832795028d0, &
      CLIGHT   =   2.99792458d8,         &
      C_AU     = 137.03599911d0,         &
      MU0      =   4.d-7 * PI,           &
      EPS0     =   1.d0/(MU0*CLIGHT**2), &
      GNEWTON  =   6.6742d-11,           &
      HBAR     =   1.05457168d-34,       &
      HPLANCK  =   6.6260693d-34,        &
      ELEC     =   1.60217653d-19,       &
      PHIMAG0  =   2.06783372d-15,       &
      GCOND0   =   7.748091733d-5,       &
      MASSE    =   9.1093826d-31,        &
      MASSP    =   1.67262171d-27,       &
      MASSR    =   1836.15267261d0,      &
      ALPHA    =   1.d0/C_AU,            &
      RINF     =   10973731.568525d0,    &
      AVOGADRO =   6.0221415d23,         &
      FARADAY  =   96485.3383d0,         &
      RGAS     =   8.314472d0,           &
      KBOLTZ   =   1.3806505d-23          
   real(8),parameter :: &
      RYDBERG  =  13.6056923d0,          &
      HARTREE  =  27.2113845d0,          &
      BOHR     =   0.5291772108d0         
   end module parameters

!
!  Software name : CIAO (Code for Investigating Atomic Orbitals)
!  Subroutine(s) : find_ishell_core_hole, reset_felec_ss
!  Author(s)     : Masakuni Okamoto (January 20, 2005)
!
!
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!
!
!  The license of the code and contact address :
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)
!
!=====================================================================
   subroutine find_ishell_core_hole(ier)
!=====================================================================
!
!  Find ishell_core_hole(:) for unscreened core holes.
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer :: ishell, n1, l1, n2, l2, icore, &
              is_found, ishell_found
   ier = 0
   ftot_core_hole = 0.d0
if (num_core_hole > 0) then
   do icore = 1,num_core_hole
      n1 = n_val_label_core_hole(icore)
      l1 = l_val_label_core_hole(icore)
      is_found = 0
      do ishell = 1,nshell
         n2 = n_qnum(ishell)
         l2 = l_qnum(ishell)
         if ((n1 == n2).and.(l1 == l2)) then
            ishell_found = ishell
            ishell_core_hole(icore) = ishell_found
            is_found = 1
            exit
         end if
      end do
      if (is_found == 0) then
         write(IFLOG,*) '### ERROR ### ishell was not found'
         write(IFLOG,*) &
            'Core hole state specified by PP input was not found.'
         write(IFLOG,*) '   (n,l) ...',n1,l1
         ier = 1 ; go to 99
      end if
      if (focc_core_hole(icore) > focc(ishell_found)) then
         write(IFLOG,*) '### ERROR ### number of core holes was wrong.'
         write(IFLOG,*) &
            'Number of core holes exceeds the occupation number.'
         write(IFLOG,*) '   (n,l)                ...',n1,l1
         write(IFLOG,*) '   number of core holes ...', &
            focc_core_hole(icore)
         write(IFLOG,*) '   occupation number    ...', &
            focc(ishell_found)
         ier = 1 ; go to 99
      end if
      ftot_core_hole = ftot_core_hole + focc_core_hole(icore)
   end do
else
   write(IFLOG,*) &
      'find_ishell_core_hole was not done, because num_core_hole = 0.'
   write(IFLOG,*) &
      'therefore, unscreened core holes are not considered.'
end if
99 continue
   end subroutine find_ishell_core_hole

!=====================================================================
   subroutine reset_felec_ss(ier)
!=====================================================================
!
!  Reset felec_ss
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   character(256) :: &
      buffer, keyword
   integer :: &
      loop, ishell, nn, ll, ips, iss
   real(8) :: &
      res, res1, res2, ftot
   ier = 0
   felec_ss = felec_val
   call open_infile
   rewind(IFIN)
   loop = 0
INPUT: do while (loop < 10000)
   loop = loop + 1
      read(IFIN,'(a)',end=98) buffer
      if (buffer == '') cycle INPUT
      read(buffer,*) keyword
      select case (keyword(1:1))
      case ('#', '!')
         cycle INPUT
      end select
      select case (keyword)
      case ('#', '!')
         cycle INPUT
      case ('end', 'END', 'End')
         write(IFLOG,*) '### ERROR ### solve_pp_spin was not found.'
         ier = 1
         exit INPUT
      case ('solve_pp_spin', 'solve_spin_pp', 'solve_pp')
         read(IFIN,'(a)',end=98) buffer
            focc_ss     = 0.d0
            n_val_label_ss = 0 ; l_val_label_ss = 0
            spin_ss        = 0 ; nocc_ss        = 0
            ishell_ss      = 0
         focc_ss(:) = 0.d0
         select case (is_spin_state_ss)
         case (AUTOMATIC)
            felec_ss = felec_val
            iss = 0
            felec1_ss = 0.d0
            felec2_ss = 0.d0
            res = felec_ss
            do ips = 1,nps
               iss = iss + 1
               ishell = ishell_ps(ips,1)
               nn = n_qnum(ishell)
               ll = l_qnum(ishell)
               spin_ss(iss) = +1
               ishell_ss(iss) = ishell
               n_val_label_ss(iss) = nn
               l_val_label_ss(iss) = ll
               select case (is_spin_ss)
               case (RESTRICTED)
                  nocc_ss(iss) = 2*(2*ll+1)
               case (POLARIZED)
                  nocc_ss(iss)   = 2*ll+1
                  nocc_ss(iss+1) = 2*ll+1
               end select
               ftot = dble(nocc_ss(iss))
               if (ftot >= res) then
                  focc_ss(iss) = res
                  res = 0.d0
               else
                  focc_ss(iss) = ftot
                  res = res - ftot
               end if
               felec1_ss = felec1_ss + focc_ss(iss)
               if (is_spin_ss == POLARIZED) then
                  iss = iss + 1
                  spin_ss(iss) = -1
                  ishell_ss(iss) = ishell
                  n_val_label_ss(iss) = nn
                  l_val_label_ss(iss) = ll
                  ftot = dble(nocc_ss(iss))
                  if (ftot >= res) then
                     focc_ss(iss) = res
                     res = 0.d0
                  else
                     focc_ss(iss) = ftot
                     res = res - ftot
                  end if
                  felec2_ss = felec2_ss + focc_ss(iss)
               end if
            end do
            select case (is_spin_ss)
            case (POLARIZED)
               fspin_ss = felec1_ss - felec2_ss
            case (RESTRICTED)
               fspin_ss = 0.d0
            end select
         case (UD_SPECIFIED)
            iss = 0
            felec1_ss = 0.d0
            felec2_ss = 0.d0
            do ips = 1,nps
               iss = iss + 1
               select case (is_spin_ss)
               case (RESTRICTED)
                  read(IFIN,*) val_label_ss(iss),focc_ss(iss)
                  spin_ss(iss) = +1
                  felec1_ss = felec1_ss + focc_ss(iss)
               case (POLARIZED)
                  read(IFIN,*) val_label_ss(iss),focc_ss(iss), &
                                                 focc_ss(iss+1)
                  if (focc_ss(iss) < focc_ss(iss+1)) then
                     call swap(focc_ss(iss),focc_ss(iss+1))
                  end if
                  spin_ss(iss) = +1
                  felec1_ss = felec1_ss + focc_ss(iss)
                  spin_ss(iss+1) = -1
                  felec2_ss = felec2_ss + focc_ss(iss+1)
                  val_label_ss(iss+1) = val_label_ss(iss)
               end select
               read(val_label_ss(iss)(1:1),*) n_val_label_ss(iss)
               select case (val_label_ss(iss)(2:2))
               case ('s', 'S')
                  l_val_label_ss(iss) = 0
               case ('p', 'P')
                  l_val_label_ss(iss) = 1
               case ('d', 'D')
                  l_val_label_ss(iss) = 2
               case ('f', 'F')
                  l_val_label_ss(iss) = 3
               case default
                  write(IFLOG,*) '### ERROR ### val_label_ss'
                  write(IFLOG,*) '   iss          ...',iss
                  write(IFLOG,*) '   val_label_ss ... ', &
                                     val_label_ss(iss)
                  ier = 1 ; go to 99
               end select
               nn = n_val_label_ss(iss)
               ll = l_val_label_ss(iss)
               call find_ishell_ss(nshell,n_qnum,l_qnum,nn,ll, &
                                   ishell)
               if (ishell == 0) then
                  write(IFLOG,*) '### ERROR ### ishell_ss was not found'
                  write(IFLOG,*) &
                    'Valence state specified by PP input was not found.'
                  write(IFLOG,*) '   (n,l) ...',nn,ll
                  ier = 1 ; go to 99
               end if
               ishell_ss(iss) = ishell
               select case (is_spin_ss)
               case (RESTRICTED)
                  nocc_ss(iss) = 2*(2*ll+1)
               case (POLARIZED)
                  nocc_ss(iss)   = 2*ll+1
                  nocc_ss(iss+1) = 2*ll+1
                  n_val_label_ss(iss+1) = n_val_label_ss(iss)
                  l_val_label_ss(iss+1) = l_val_label_ss(iss)
                  ishell_ss(iss+1) = ishell_ss(iss)
                  iss = iss + 1
               end select
            end do
            felec_ss = felec1_ss + felec2_ss
            select case (is_spin_ss)
            case (POLARIZED)
               fspin_ss = felec1_ss - felec2_ss
            case (RESTRICTED)
               fspin_ss = 0.d0
            end select
            if (iss /= nss) then
               write(IFLOG,*) '### ERROR ### iss != nss'
               write(IFLOG,*) '   iss ...',iss
               write(IFLOG,*) '   nss ...',nss
               ier = 1 ; go to 99
            end if
         case (SPIN_SPECIFIED)
            felec_ss = felec_val
            select case (is_spin_ss)
            case (POLARIZED)
               if (fspin_ss < 0.d0) then
                  fspin_ss = -fspin_ss
               end if
               felec1_ss = 0.5d0 * (felec_ss + fspin_ss)
               felec2_ss = 0.5d0 * (felec_ss - fspin_ss)
               res1 = felec1_ss
               res2 = felec2_ss
               iss = 0
               do ips = 1,nps
                  iss = iss + 1
                  spin_ss(iss) = +1
                  ishell = ishell_ps(ips,1)
                  nn = n_qnum(ishell)
                  ll = l_qnum(ishell)
                  ishell_ss(iss) = ishell
                  n_val_label_ss(iss) = nn
                  l_val_label_ss(iss) = ll
                  nocc_ss(iss) = 2*ll+1
                  ftot = dble(nocc_ss(iss))
                  if (ftot >= res1) then
                     focc_ss(iss) = res1
                     res1 = 0.d0
                  else
                     focc_ss(iss) = ftot
                     res1 = res1 - ftot
                  end if
                  iss = iss + 1
                  spin_ss(iss) = -1
                  ishell_ss(iss) = ishell
                  n_val_label_ss(iss) = nn
                  l_val_label_ss(iss) = ll
                  nocc_ss(iss) = 2*ll+1
                  ftot = dble(nocc_ss(iss))
                  if (ftot >= res2) then
                     focc_ss(iss) = res2
                     res2 = 0.d0
                  else
                     focc_ss(iss) = ftot
                     res2 = res2 - ftot
                  end if
               end do
            case (RESTRICTED)
               felec1_ss = felec_ss ; felec2_ss = 0.d0
               fspin_ss = 0.d0
               res1 = felec1_ss
               iss = 0
               do ips = 1,nps
                  iss = iss + 1
                  spin_ss(iss) = +1
                  ishell = ishell_ps(ips,1)
                  nn = n_qnum(ishell)
                  ll = l_qnum(ishell)
                  ishell_ss(iss) = ishell
                  n_val_label_ss(iss) = nn
                  l_val_label_ss(iss) = ll
                  nocc_ss(iss) = 2*(2*ll+1)
                  ftot = dble(nocc_ss(iss))
                  if (ftot >= res1) then
                     focc_ss(iss) = res1
                     res1 = 0.d0
                  else
                     focc_ss(iss) = ftot
                     res1 = res1 - ftot
                  end if
               end do
            end select
         end select
         exit INPUT
      case default
         cycle INPUT
      end select
end do INPUT
   close(IFIN)
   go to 99
98 continue
   ier = 100
99 continue
   end subroutine reset_felec_ss

!
!  Software name : CIAO (Code for Investigating Atomic Orbitals)
!  Subroutine(s) : calc_logderi_sol, write_logderi_sol, calc_lt_nn_nnn
!                : calc_bsum_sol, set_initpoints_left_ae
!                : int_from_left_ae, pc_adams_5_ae
!  Author(s)     : Masakuni Okamoto (August 25, 2003)
!
!
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!
!
!  The license of the code and contact address :
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)
!
!=====================================================================
   subroutine calc_logderi_sol(ier)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer :: ll, ispin, id, ir, tt, t1, t2, lt, lt1, nref, ltt, &
              node_sum, nrc, nrt, isdiff, ie_logderi, loop
   real(8) :: ee, de, rcut, gcut0, gcut1, dummy2, sum, &
              logderi0, logderi1
   real(8),allocatable :: &
      bsum(:), amat(:,:), bvec(:), coeff(:), fmat(:,:), hmat(:,:), &
      h0vec(:), rphi_tmp(:,:)
   integer,parameter :: loop_max = 200
   real(8),parameter :: eps_logderi = 1.d-5
   ier = 0
  !++++++++++++++++++++++++++++++++++++
   allocate(bsum(nmesh)) ; bsum = 0.d0
  !++++++++++++++++++++++++++++++++++++
   call calc_vcoeff(ier)
   if (ier /= 0) then
      write(IFLOG,*) '### ERROR ### in calc_vcoeff' ; go to 99
   end if
   de = (emax_logderi - emin_logderi) / dble(ne_logderi-1)
   do ie_logderi = 1,ne_logderi
      ee_logderi(ie_logderi) = emin_logderi &
                             + dble(ie_logderi-1) * de
   end do
   if (rcut_logderi < 1.d-12) then
      nrcut_logderi = 0
   else if (rcut_logderi >= rmax) then
      write(IFLOG,*) '### ERROR ### rcut_logderi >= rmax'
      write(IFLOG,*) '   rcut_logderi ...',rcut_logderi
      write(IFLOG,*) '   rmax         ...',rmax
      ier = 1 ; go to 99
   else
      do ir = nmesh,5,-1
         if (rpos(ir) < rcut_logderi) then
            nrcut_logderi = ir ; exit
         end if
      end do
   end if
   if (nrcut_logderi == 0) then
      nrc = nrcut_max_us
   else
      nrc = max(nrcut_logderi,nrcut_max_us)
   end if
   nrt = nrc + 1 + max(iord_diff,iord_pc)
   rcut = rpos(nrc)
   ispin = 1
MAIN1:do ll = 0,lmax
L_EE1:do ie_logderi = 1,ne_logderi
      ee = ee_logderi(ie_logderi)
      id = +1
      call set_initpoints_left_ae(ier,ll,ispin,ee)
      if (ier /= 0) then
         write(IFLOG,*) '### ERROR ### in set_initpoints_left'
         go to 99
      end if
      call int_from_left_ae(ier,node_sum,nrt,id,ll,ee,ispin)
      if (ier /= 0) then
         write(IFLOG,*) '### ERROR ### in int_from_left' ; go to 99
      end if
      isdiff = 1
      call diff_exp(ier,isdiff,nrc-iord_diff,nrc+iord_diff, &
                    rpos,chi_gl,rcut,gcut0,gcut1,dummy2)

! ============================================= modified by K. T. =========== 4.0
!      logderi_ae(ie_logderi,ll) = gcut1 / gcut0
      logderi_ae(ie_logderi,ll,1) = gcut1 / gcut0
! =========================================================================== 4.0

end do L_EE1
end do MAIN1
MAIN2:do ll = 0,lmax
   select case (is_logderi_method)
   case (FREDHOLM)
      nref = nref_us(ll)
     !++++++++++++++++++++++++++++++++++++++++++++++++++++++++
      allocate(amat(nref,nref),bvec(nref),coeff(nref), &
               fmat(nref,nref),hmat(nref,nref),h0vec(nref), &
               rphi_tmp(nmesh,0:nref))
         amat = 0.d0 ; bvec = 0.d0 ; coeff = 0.d0
         fmat = 0.d0 ; hmat = 0.d0 ; h0vec = 0.d0
         rphi_tmp = 0.d0
     !++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   end select
L_EE2:do ie_logderi = 1,ne_logderi
      ee = ee_logderi(ie_logderi)
   select case (is_logderi_method)
   case (ITERATIVE)
      lt1 = lt_n_us(ll,1)
      chi_gl(:) = rphi_us(:,lt1)
      isdiff = 1
      call diff_exp(ier,isdiff,nrc-iord_diff,nrc+iord_diff, &
                    rpos,chi_gl,rcut,gcut0,gcut1,dummy2)
      logderi0 = gcut1 / gcut0
L_US:do loop = 1,loop_max
      call calc_bsum_sol(ier,nrc,ll,ee,bsum)
      call set_initpoints_left_sol(ier,nmesh,ll,ee,rpos, &
              chi_gl,chi_fl,dxchi_gl,dxchi_fl,vloc_scr_us,bsum)
      call int_from_left_sol(ier,nmesh,node_sum,nrt, &
              ll,ee,iord_nec,dx,rpos, &
              chi_gl,chi_fl,dxchi_gl,dxchi_fl,vloc_scr_us,bsum)
      if (ier /= 0) then
         write(IFLOG,*) '### ERROR ### in int_from_left_ps' ; go to 99
      end if
      isdiff = 1
      call diff_exp(ier,isdiff,nrc-iord_diff,nrc+iord_diff, &
                    rpos,chi_gl,rcut,gcut0,gcut1,dummy2)
      logderi1 = gcut1 / gcut0
      if (abs(logderi0-logderi1) < eps_logderi) then
         exit L_US
      else if (loop == loop_max) then
         if (abs(logderi0-logderi1) < 50.d0) then 
            write(IFLOG,'(a40,2i5,f10.5,f12.7)') &
               '### CAUTION ### [logderi] ll,ie,ee,diff:', &
                ll,ie_logderi,ee,abs(logderi0-logderi1)
            logderi0 = logderi1
         else
            write(IFLOG,*) '### ERROR ### loop == loop_max'
            write(IFLOG,*) '   loop ...',loop
            write(IFLOG,*) '   diff ...',abs(logderi0-logderi1)
            write(IFLOG,*) '   ll   ...',ll
            write(IFLOG,*) '   ie   ...',ie_logderi
            write(IFLOG,*) '   ee   ...',ee
            ier = 1 ; go to 99
         end if
      else
         logderi0 = logderi1
      end if
end do L_US

! ========================================= modified by K. T. ================ 4.0
!      logderi_us(ie_logderi,ll) = logderi1
      logderi_us(ie_logderi,ll,1) = logderi1
! ============================================================================ 4.0

   case (FREDHOLM)
      bsum = 0.d0
      call set_initpoints_left_sol(ier,nmesh,ll,ee,rpos, &
              chi_gl,chi_fl,dxchi_gl,dxchi_fl,vloc_scr_us,bsum)
      call int_from_left_sol(ier,nmesh,node_sum,nrt, &
              ll,ee,iord_nec,dx,rpos, &
              chi_gl,chi_fl,dxchi_gl,dxchi_fl,vloc_scr_us,bsum)
      if (ier /= 0) then
         write(IFLOG,*) '### ERROR ### in int_from_left_ps' ; go to 99
      end if
      rphi_tmp(:,0) = chi_gl(:)
      do tt = 1,nref
         lt = lt_n_us(ll,tt)
         bsum(:) = -rbeta_us(:,lt)
         call set_initpoints_left_sol(ier,nmesh,ll,ee,rpos, &
                 chi_gl,chi_fl,dxchi_gl,dxchi_fl,vloc_scr_us,bsum)
         call int_from_left_sol(ier,nmesh,node_sum,nrt, &
                 ll,ee,iord_nec,dx,rpos, &
                 chi_gl,chi_fl,dxchi_gl,dxchi_fl,vloc_scr_us,bsum)
         if (ier /= 0) then
            write(IFLOG,*) '### ERROR ### in int_from_left_ps'
            go to 99
         end if
         rphi_tmp(:,tt) = chi_gl(:)
      end do
      fmat(:,:) = 0.d0
      do t1 = 1,nref
      do t2 = 1,nref
         ltt = ltt_nm_us(ll,t1,t2)
         fmat(t1,t2) = dmat_us(ltt) - ee*q_sum_us(ltt)
      end do
      end do
      do t1 = 1,nref
         lt1 = lt_n_us(ll,t1)
         do t2 = 1,nref
            sum = 0.d0
            do ir = 1,nmesh
               sum = sum + rbeta_us(ir,lt1)*rphi_tmp(ir,t2)*wr(ir)
            end do
            hmat(t1,t2) = sum
         end do
      end do
      amat = matmul(fmat,hmat)
      do tt = 1,nref
         amat(tt,tt) = amat(tt,tt) + 1.d0
      end do
      do tt = 1,nref
         lt = lt_n_us(ll,tt)
         sum = 0.d0
         do ir = 1,nmesh
            sum = sum + rbeta_us(ir,lt)*rphi_tmp(ir,0)*wr(ir)
         end do
         h0vec(tt) = sum
      end do      
      bvec = -matmul(fmat,h0vec)
      call axb_real_matrix(ier,nref,1,amat,coeff,bvec)
      chi_gl(:) = rphi_tmp(:,0)
      do tt = 1,nref
         chi_gl(:) = chi_gl(:) + coeff(tt)*rphi_tmp(:,tt)
      end do
      isdiff = 1
      call diff_exp(ier,isdiff,nrc-iord_diff,nrc+iord_diff, &
                    rpos,chi_gl,rcut,gcut0,gcut1,dummy2)
      logderi1 = gcut1 / gcut0
! ================================================ modified by K. T. ======== 4.0
!      logderi_us(ie_logderi,ll) = logderi1
      logderi_us(ie_logderi,ll,1) = logderi1
! =========================================================================== 4.0
   end select
end do L_EE2
   select case (is_logderi_method)
   case (FREDHOLM)
     !+++++++++++++++++++++++++++++++++++++++++++++++++++++
      deallocate(amat,bvec,coeff,fmat,hmat,h0vec,rphi_tmp)
     !+++++++++++++++++++++++++++++++++++++++++++++++++++++
  end select
end do MAIN2
99 continue
  !+++++++++++++++++
   deallocate(bsum)
  !+++++++++++++++++
   end subroutine calc_logderi_sol

! ==================================== added by K. T. ======================== 4.0
subroutine calc_logderi_sol_kt(ier)
  use parameters
  implicit none

  integer,intent(out) :: ier
  integer :: ll, ispin, id, ir, tt, t1, t2, lt, lt1, nref, ltt, &
       node_sum, nrc, nrt, isdiff, ie_logderi, loop
  integer :: itmp1, itmp2

  real(8) :: ee, de, rcut, gcut0, gcut1, dummy2, sum, &
       logderi0, logderi1

  real(8),allocatable :: &
       bsum(:), amat(:,:), bvec(:), coeff(:), fmat(:,:), hmat(:,:), &
       h0vec(:), rphi_tmp(:,:)

  integer,parameter :: loop_max = 200
  real(8),parameter :: eps_logderi = 1.d-5

  ier = 0

  !++++++++++++++++++++++++++++++++++++
  allocate(bsum(nmesh)) ; bsum = 0.d0
  !++++++++++++++++++++++++++++++++++++

  call calc_vcoeff(ier)
  if (ier /= 0) then
     write(IFLOG,*) '### ERROR ### in calc_vcoeff' ; go to 99
  end if

  de = (emax_logderi - emin_logderi) / dble(ne_logderi-1)

  do ie_logderi = 1,ne_logderi
     ee_logderi(ie_logderi) = emin_logderi &
          + dble(ie_logderi-1) * de
  end do

  if (rcut_logderi < 1.d-12) then
     nrcut_logderi = 0

  else if (rcut_logderi >= rmax) then

     write(IFLOG,*) '### ERROR ### rcut_logderi >= rmax'
     write(IFLOG,*) '   rcut_logderi ...',rcut_logderi
     write(IFLOG,*) '   rmax         ...',rmax
     ier = 1 ; go to 99

  else

     do ir = nmesh,5,-1
        if (rpos(ir) < rcut_logderi) then
           nrcut_logderi = ir ; exit
        end if
     end do

  end if

  if (nrcut_logderi == 0) then
     nrc = nrcut_max_us
  else
     nrc = max(nrcut_logderi,nrcut_max_us)
  end if

  nrt = nrc + 1 + max(iord_diff,iord_pc)
  rcut = rpos(nrc)


  Do ispin=1, nspin
     
     MAIN1:do ll = 0,lmax

        L_EE1:do ie_logderi = 1,ne_logderi
           
           ee = ee_logderi(ie_logderi)
           id = +1
           
           call set_initpoints_left_ae(ier,ll,ispin,ee)
           if (ier /= 0) then
              write(IFLOG,*) '### ERROR ### in set_initpoints_left'
              go to 99
           end if
           
           call int_from_left_ae(ier,node_sum,nrt,id,ll,ee,ispin)
           if (ier /= 0) then
              write(IFLOG,*) '### ERROR ### in int_from_left' ; go to 99
           end if
           
           isdiff = 1

           call diff_exp(ier,isdiff,nrc-iord_diff,nrc+iord_diff, &
                rpos,chi_gl,rcut,gcut0,gcut1,dummy2)

           logderi_ae(ie_logderi,ll,ispin) = gcut1 / gcut0

        end do L_EE1
     end do MAIN1
     

     MAIN2:do ll = 0,lmax

        select case (is_logderi_method)
           
        case (FREDHOLM)
           nref = nref_us(ll)

           !++++++++++++++++++++++++++++++++++++++++++++++++++++++++
           allocate(amat(nref,nref),bvec(nref),coeff(nref), &
                fmat(nref,nref),hmat(nref,nref),h0vec(nref), &
                rphi_tmp(nmesh,0:nref))
           amat = 0.d0 ; bvec = 0.d0 ; coeff = 0.d0
           fmat = 0.d0 ; hmat = 0.d0 ; h0vec = 0.d0
           rphi_tmp = 0.d0
           !++++++++++++++++++++++++++++++++++++++++++++++++++++++++
        end select

        L_EE2:do ie_logderi = 1,ne_logderi
           ee = ee_logderi(ie_logderi)
           
           select case (is_logderi_method)

           case (ITERATIVE)
              
              lt1 = lt_n_us(ll, 1 +nref_max_us *(ispin-1) )
              chi_gl(:) = rphi_us(:,lt1)
              
              isdiff = 1
              
              call diff_exp(ier,isdiff,nrc-iord_diff,nrc+iord_diff, &
                   rpos,chi_gl,rcut,gcut0,gcut1,dummy2)
              logderi0 = gcut1 / gcut0
              
              L_US:do loop = 1,loop_max
                 
                 call calc_bsum_sol_kt( ier, nrc, ll, ee, ispin, bsum )
                 
                 call set_initpoints_left_sol(ier,nmesh,ll,ee,rpos, &
                      &     chi_gl,chi_fl,dxchi_gl,dxchi_fl, &
                      &     vloc_scr_us(:,ispin), bsum )
                 
                 call int_from_left_sol(ier,nmesh,node_sum,nrt, &
                      & ll,ee,iord_nec,dx,rpos, &
                      & chi_gl,chi_fl,dxchi_gl,dxchi_fl, &
                      & vloc_scr_us(:,ispin), bsum )
                 
                 if (ier /= 0) then
                    write(IFLOG,*) '### ERROR ### in int_from_left_ps' ; go to 99
                 end if
                 
                 isdiff = 1
                 
                 call diff_exp(ier,isdiff,nrc-iord_diff,nrc+iord_diff, &
                      rpos,chi_gl,rcut,gcut0,gcut1,dummy2)
                 
                 logderi1 = gcut1 / gcut0

                 if (abs(logderi0-logderi1) < eps_logderi) then
                    exit L_US
                    
                 else if (loop == loop_max) then
                    if (abs(logderi0-logderi1) < 50.d0) then 
                       write(IFLOG,'(a40,2i5,f10.5,f12.7)') &
                            '### CAUTION ### [logderi] ll,ie,ee,diff:', &
                            ll,ie_logderi,ee,abs(logderi0-logderi1)
                       logderi0 = logderi1
                    else
                       write(IFLOG,*) '### ERROR ### loop == loop_max'
                       write(IFLOG,*) '   loop ...',loop
                       write(IFLOG,*) '   diff ...',abs(logderi0-logderi1)
                       write(IFLOG,*) '   ll   ...',ll
                       write(IFLOG,*) '   ispin   ...', ispin
                       write(IFLOG,*) '   ie   ...',ie_logderi
                       write(IFLOG,*) '   ee   ...',ee
                       ier = 1 ; go to 99
                    end if

                 else
                    logderi0 = logderi1
                 end if
                 
              end do L_US

              logderi_us(ie_logderi,ll,ispin) = logderi1


           case (FREDHOLM)
           
              bsum = 0.d0

              call set_initpoints_left_sol(ier,nmesh,ll,ee,rpos, &
                   &    chi_gl,chi_fl,dxchi_gl,dxchi_fl, &
                   &    vloc_scr_us(:,ispin) ,bsum )

              call int_from_left_sol(ier,nmesh,node_sum,nrt, &
                   & ll,ee,iord_nec,dx,rpos, &
                   & chi_gl,chi_fl,dxchi_gl,dxchi_fl, &
                   & vloc_scr_us(:,ispin), bsum )
              
              if (ier /= 0) then
                 write(IFLOG,*) '### ERROR ### in int_from_left_ps' ; go to 99
              end if
              
              rphi_tmp(:,0) = chi_gl(:)

              do tt = 1,nref
                 itmp1 = tt + nref_max_us *(ispin -1)

                 lt = lt_n_us(ll,itmp1)
                 bsum(:) = -rbeta_us(:,lt)
                 
                 call set_initpoints_left_sol(ier,nmesh,ll,ee,rpos, &
                      &  chi_gl,chi_fl,dxchi_gl,dxchi_fl, &
                      &  vloc_scr_us(:,ispin), bsum )

                 call int_from_left_sol(ier,nmesh,node_sum,nrt, &
                      & ll,ee,iord_nec,dx,rpos, &
                      & chi_gl,chi_fl,dxchi_gl,dxchi_fl, &
                      & vloc_scr_us(:,ispin), bsum )
                 
                 if (ier /= 0) then
                    write(IFLOG,*) '### ERROR ### in int_from_left_ps'
                    go to 99
                 end if
                 
                 rphi_tmp(:,tt) = chi_gl(:)
              end do
              
              fmat(:,:) = 0.d0
              
              do t1 = 1,nref
                 do t2 = 1,nref
                    itmp1 = t1 + nref_max_us * (ispin -1)
                    itmp2 = t2 + nref_max_us * (ispin -1)

                    ltt = ltt_nm_us(ll,itmp1,itmp2)
                    fmat(t1,t2) = dmat_us(ltt) - ee*q_sum_us(ltt)
                 end do
              end do
              
              do t1 = 1,nref
                 itmp1 = t1 + nref_max_us * (ispin -1)
                 lt1 = lt_n_us(ll,itmp1)

                 do t2 = 1,nref
                    sum = 0.d0
                    do ir = 1,nmesh
                       sum = sum + rbeta_us(ir,lt1)*rphi_tmp(ir,t2)*wr(ir)
                    end do
                    hmat(t1,t2) = sum
                 end do
              end do
              
              amat = matmul(fmat,hmat)
              do tt = 1,nref
                 amat(tt,tt) = amat(tt,tt) + 1.d0
              end do
              
              do tt = 1,nref
                 itmp1 = tt + nref_max_us * (ispin -1)
                 lt = lt_n_us(ll,itmp1)

                 sum = 0.d0
                 do ir = 1,nmesh
                    sum = sum + rbeta_us(ir,lt)*rphi_tmp(ir,0)*wr(ir)
                 end do
                 h0vec(tt) = sum
              end do
              
              bvec = -matmul(fmat,h0vec)
              
              call axb_real_matrix(ier,nref,1,amat,coeff,bvec)
              
              chi_gl(:) = rphi_tmp(:,0)
              do tt = 1,nref
                 chi_gl(:) = chi_gl(:) + coeff(tt)*rphi_tmp(:,tt)
              end do
              
              isdiff = 1
              call diff_exp(ier,isdiff,nrc-iord_diff,nrc+iord_diff, &
                   rpos,chi_gl,rcut,gcut0,gcut1,dummy2)
              
              logderi1 = gcut1 / gcut0
              logderi_us(ie_logderi,ll,ispin) = logderi1

           end select
     
        end do L_EE2


        select case (is_logderi_method)
        case (FREDHOLM)
           !+++++++++++++++++++++++++++++++++++++++++++++++++++++
           deallocate(amat,bvec,coeff,fmat,hmat,h0vec,rphi_tmp)
           !+++++++++++++++++++++++++++++++++++++++++++++++++++++
        end select
        
     end do MAIN2
     
  End do

99 continue

  !+++++++++++++++++
  deallocate(bsum)
  !+++++++++++++++++

end subroutine calc_logderi_sol_kt
! =========================================================================== 4.0

!=====================================================================
   subroutine write_logderi_sol(ier)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer :: ll, tt, lt, nref, ispin, ie_logderi, nrc
   real(8) :: ee
   character(1) :: ch_ln, fn_label_orbital
   character(2) :: ch_del, ch2
   ier = 0
   if (nrcut_logderi == 0) then
      nrc = nrcut_max_us
   else
      nrc = max(nrcut_logderi,nrcut_max_us)
   end if
   ch_del = ','//' '
   open(IFLDR,file=trim(ldrfile),status='unknown')
   write(IFLDR,*) 'Logarithmic derivatives [Separable]'
   call write_file_header(IFLDR)
   write(IFLDR,23) ne_logderi,'ne_mesh'
   do ll = 0,lmax
      ch_ln = fn_label_orbital(ll)
      ch2(1:2) = '_'//ch_ln(1:1)
      nref = nref_us(ll)
      if (nref == 0) then
         cycle
      end if

      ispin = 1
      write(IFLDR,*)
      write(IFLDR,30) ll,nref,ispin,'(l, nref, s)'
      do tt = 1,nref
      lt = lt_n_us(ll,tt)
      write(IFLDR,31) eref_us(lt),'elevel'
      end do
      write(IFLDR,31) rpos(nrc)  ,'rcut  '
      write(IFLDR,*)
      write(IFLDR,*) 'ee'//ch2//ch_del//'ldr_ae'//ch2//ch_del &
                     //'ldr_us'//ch2
      do ie_logderi = 1,ne_logderi
         ee = ee_logderi(ie_logderi)
! ============================================ modified by K. T. =========== 4.0
!         write(IFLDR,10) ee,logderi_ae(ie_logderi,ll), &
!                            logderi_us(ie_logderi,ll)
         write(IFLDR,10) ee,logderi_ae(ie_logderi,ll,1), &
                            logderi_us(ie_logderi,ll,1)
! ========================================================================== 4.0
      end do
   end do
10 format(3(1pe20.10))
23 format(1x,i10,10x,5x,':',1x,a7)
30 format(1x,3i5, 5x,5x,':',1x,a12)
31 format(1x,f20.10, 5x,':',1x,a6)
   close(IFLDR)
   end subroutine write_logderi_sol

!=============================== added by K. T. ======================== 4.0
subroutine write_logderi_sol_kt(ier)
  use parameters
  implicit none

  integer,intent(out) :: ier
  integer :: ll, tt, lt, nref, ispin, ie_logderi, nrc
  real(8) :: ee
  character(1) :: ch_ln, fn_label_orbital
  character(2) :: ch_del, ch2

  integer :: itmp1

  ier = 0
  if (nrcut_logderi == 0) then
     nrc = nrcut_max_us
  else
     nrc = max(nrcut_logderi,nrcut_max_us)
  end if

  ch_del = ','//' '

  open(IFLDR,file=trim(ldrfile),status='unknown')
  write(IFLDR,*) 'Logarithmic derivatives [Separable]'

  call write_file_header(IFLDR)
  write(IFLDR,23) ne_logderi,'ne_mesh'

  do ll = 0,lmax
     ch_ln = fn_label_orbital(ll)
     ch2(1:2) = '_'//ch_ln(1:1)

     nref = nref_us(ll)
     if (nref == 0) then
        cycle
     end if
     
     Do ispin=1, nspin
        write(IFLDR,*)
        write(IFLDR,30) ll,nref,ispin,'(l, nref, s)'

        do tt = 1,nref
           itmp1 = tt + nref_max_us * (ispin -1)
           lt = lt_n_us(ll,itmp1)

           write(IFLDR,31) eref_us(lt),'elevel'
        end do

        write(IFLDR,31) rpos(nrc)  ,'rcut  '
        write(IFLDR,*)
        write(IFLDR,*) 'ee'//ch2//ch_del//'ldr_ae'//ch2//ch_del &
             //'ldr_us'//ch2

        do ie_logderi = 1,ne_logderi
           ee = ee_logderi(ie_logderi)
           write(IFLDR,10) ee, logderi_ae(ie_logderi,ll,ispin), &
                &              logderi_us(ie_logderi,ll,ispin)
        end do
     end do
     
  End do

10 format(3(1pe20.10))
23 format(1x,i10,10x,5x,':',1x,a7)
30 format(1x,3i5, 5x,5x,':',1x,a12)
31 format(1x,f20.10, 5x,':',1x,a6)

  close(IFLDR)

end subroutine write_logderi_sol_kt
! ======================================================================= 4.0

!=====================================================================
   subroutine calc_lt_nn_nnn(ll,ee,lt1,lt2)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(in)  :: ll
   real(8),intent(in)  :: ee
   integer,intent(out) :: lt1, lt2
   real(8),allocatable :: dee(:)
   integer,allocatable :: tee(:)
   integer :: nref, i, j, tn, lt
   nref = nref_us(ll)
  !+++++++++++++++++++++++++++++++++++++++++++++++++++++
   allocate(dee(nref),tee(nref)) ; dee = 0.d0 ; tee = 0
  !+++++++++++++++++++++++++++++++++++++++++++++++++++++
   do tn = 1,nref
      lt = lt_n_us(ll,tn)
      dee(tn) = abs(ee - eref_us(lt))
      tee(tn) = tn
   end do
   if (nref == 1) then
      lt1 = lt_n_us(ll,1)
      lt2 = lt_n_us(ll,1)
   else
      do i = 1,nref-1
         do j = i+1,nref
            if (dee(tee(i)) > dee(tee(j))) then
               call iswap(tee(i),tee(j))
            end if
         end do
      end do
      lt1 = lt_n_us(ll,tee(1))
      lt2 = lt_n_us(ll,tee(2))
   end if   
  !++++++++++++++++++++
   deallocate(dee,tee)
  !++++++++++++++++++++
   end subroutine calc_lt_nn_nnn

!=====================================================================
   subroutine calc_bsum_sol(ier,nrc,ll,ee,bsum)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   integer,intent(in)  :: nrc, ll
   real(8),intent(in)  :: ee
   integer,intent(out) :: ier
   real(8),intent(out) :: bsum(nmesh)
   integer :: ir, nref, tn, tm, ltn, ltm, ltt
   real(8) :: sum
   ier = 0
   nref = nref_us(ll)
   bsum(:) = 0.d0
   do tm = 1,nref
      ltm = lt_n_us(ll,tm)
      sum = 0.d0
      do ir = 1,nmesh
         sum = sum + wr(ir)*rbeta_us(ir,ltm)*chi_gl(ir)
      end do
      do tn = 1,nref
         ltn = lt_n_us(ll,tn)
         ltt = ltt_nm_us(ll,tn,tm)
         do ir = 1,nrc
         bsum(:) = bsum(:) &
            + rbeta_us(:,ltn)*(dmat_us(ltt)-ee*q_sum_us(ltt))*sum
         end do
      end do
   end do
   end subroutine calc_bsum_sol

!===================================== added by K. T. ======================= 4.0
subroutine calc_bsum_sol_kt( ier, nrc, ll, ee, ispin, bsum )
  use parameters
  implicit none

  integer,intent(in)  :: nrc, ll, ispin
  real(8),intent(in)  :: ee
  integer,intent(out) :: ier
  real(8),intent(out) :: bsum(nmesh)
  
  integer :: ir, nref, tn, tm, ltn, ltm, ltt
  integer :: itmp1, itmp2
  real(8) :: sum

  ier = 0
  nref = nref_us(ll)

  bsum(:) = 0.d0

  do tm = 1,nref
     itmp1 = tm + nref_max_us *(ispin -1)
     ltm = lt_n_us(ll,itmp1)

     sum = 0.d0
     do ir = 1,nmesh
        sum = sum + wr(ir)*rbeta_us(ir,ltm)*chi_gl(ir)
     end do

     do tn = 1,nref
        itmp2 = tn + nref_max_us *(ispin -1)

        ltn = lt_n_us(ll,itmp2)
        ltt = ltt_nm_us(ll,itmp2,itmp1)

        do ir = 1,nrc
           bsum(:) = bsum(:) &
                + rbeta_us(:,ltn)*(dmat_us(ltt)-ee*q_sum_us(ltt))*sum
        end do
     end do
  end do

end subroutine calc_bsum_sol_kt
! ============================================================================= 4.0

!=====================================================================
   subroutine set_initpoints_left_ae(ier,ll,ispin,ee)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(in)  :: ll, ispin
   real(8),intent(in)  :: ee
   integer,intent(out) :: ier
   integer :: ncoeff, icoeff, j, ir, ll_core
   real(8) :: sum, r, mass, power
   real(8),allocatable :: gcoeff(:), fcoeff(:)
   ier = 0
   ncoeff =  iord_coeff
  !++++++++++++++++++++++++++++++++++++++++++++
   allocate(gcoeff(0:ncoeff),fcoeff(0:ncoeff))
      gcoeff = 0.d0 ; fcoeff = 0.d0
  !++++++++++++++++++++++++++++++++++++++++++++
   if (is_core == PATOM) then
      ll_core = ll
   else
      ll_core = lmax_core
   end if
   select case (is_calc)
   case (NONREL)
      gcoeff(0) = 1.d0
      fcoeff(0) = vcoeff(-1,ispin,ll_core) / dble(ll+1) * gcoeff(0)
      if (ncoeff >= 2) then
         do icoeff = 1,ncoeff-1
            gcoeff(icoeff) =  fcoeff(icoeff-1) / dble(icoeff)
            sum = 0.d0
            do j = -1,icoeff-1
               sum = sum + vcoeff(j,ispin,ll_core)*gcoeff(icoeff-1-j)
            end do
            fcoeff(icoeff) = (-2.d0*ee*gcoeff(icoeff-1)+2.d0*sum) &
                           / dble(icoeff+2*ll+2)
         end do
      end if
      do ir = 1,10
         r = rpos(ir)
         chi_gl(ir) = 0.d0
         chi_fl(ir) = 0.d0
         do icoeff = 0,ncoeff-1
            chi_gl(ir) = chi_gl(ir) &
              + gcoeff(icoeff) * r**(icoeff+ll+1)
            chi_fl(ir) = chi_fl(ir) &
              + fcoeff(icoeff) * r**(icoeff+ll+1)
         end do
         call dgdx_dfdx_nonrel(r,chi_gl(ir),chi_fl(ir), &
              dxchi_gl(ir),dxchi_fl(ir),ll,ee,veff(ir,ispin,ll_core))
      end do
   case (SREL)
      mass = 1.d0 + 0.5d0*ALPHA*ALPHA*(ee-veff(1,ispin,ll_core))
      select case (ll)
      case (0)
         gcoeff(0) = 1.d0 ; power = 1.d0
         do icoeff = 1,ncoeff
            sum = 0.d0
            do j = -1,icoeff-2
               sum = sum + vcoeff(j,ispin,ll_core)*gcoeff(icoeff-j-2)
            end do
            if (icoeff >= 2) then
               sum = sum - ee*gcoeff(icoeff-2)
            end if
            gcoeff(icoeff) = sum * 2.d0*mass &
                                 / dble(icoeff*(icoeff+1))
            fcoeff(icoeff-1) = dble(icoeff) / (2.d0*mass) &
                             * gcoeff(icoeff)
         end do
      case (1:)
         gcoeff(0) = 0.d0 ; gcoeff(1) = 1.d0 ; power = dble(ll)
         fcoeff(0) = dble(ll)/(2.d0*mass) * gcoeff(1)
         if (ncoeff >= 2) then
            do icoeff = 2,ncoeff
               sum = 0.d0
               do j = -1,icoeff-2
                  sum = sum + vcoeff(j,ispin,ll_core) &
                              * gcoeff(icoeff-j-2)
               end do
               sum = sum - ee*gcoeff(icoeff-2)
               gcoeff(icoeff) = sum * 2.d0*mass &
                              / dble((icoeff-1)*(icoeff+2*ll))
               fcoeff(icoeff-1) = dble(icoeff+ll-1) &
                                / (2.d0*mass) * gcoeff(icoeff)
            end do
         end if
      end select
      do ir = 1,10
         r = rpos(ir)
         chi_gl(ir) = 0.d0
         chi_fl(ir) = 0.d0
         do icoeff = 0,ncoeff-1
            chi_gl(ir) = chi_gl(ir) &
              + gcoeff(icoeff) * r**(dble(icoeff)+power)
            chi_fl(ir) = chi_fl(ir) &
              + fcoeff(icoeff) * r**(dble(icoeff)+power)
         end do
         call dgdx_dfdx_srel(r,chi_gl(ir),chi_fl(ir), &
              dxchi_gl(ir),dxchi_fl(ir),ll,ee,veff(ir,ispin,ll_core))
      end do
   end select
99 continue
  !++++++++++++++++++++++++++
   deallocate(gcoeff,fcoeff)
  !++++++++++++++++++++++++++
   end subroutine set_initpoints_left_ae

!=====================================================================
   subroutine int_from_left_ae(ier,node_sum,nrt,id,ll,ee,ispin)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(in)  :: nrt, id, ll, ispin
   real(8),intent(in)  :: ee
   integer,intent(out) :: ier, node_sum
   integer :: nec, ir
   ier = 0
   nec = iord_nec
   node_sum = 0
      do ir = 4,nrt+1
         call pc_adams_5_ae(ier,ir,id,ll,ee,nec,ispin)
         if (chi_gl(ir)*chi_gl(ir-1) < 0.d0) then
            node_sum = node_sum + 1
         end if
      end do
99 continue
   end subroutine int_from_left_ae

!=====================================================================
   subroutine pc_adams_5_ae(ier,ir,id,ll,ee,nec,ispin)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters   
   implicit none
   integer,intent(in)    :: ir, ll, nec, ispin
   real(8),intent(in)    :: ee
   integer,intent(inout) :: id
   integer,intent(out)   :: ier
   integer :: iec, ll_core
   real(8) :: dx24, &
              g0, g1, g2, g3, dg0, dg1, dg2, dg3, g9, dg9, &
              f0, f1, f2, f3, df0, df1, df2, df3, f9, df9
   ier = 0
   if (is_core == PATOM) then
      ll_core = ll
   else
      ll_core = lmax_core
   end if
   id   = sign(1, id)
   dx24 = dx / 24.d0 * dble(id)
   select case (id)
   case(+1)
      g0  =   chi_gl(ir     ) ; f0  =   chi_fl(ir     )
      g1  =   chi_gl(ir-1*id) ; f1  =   chi_fl(ir-1*id)
      g2  =   chi_gl(ir-2*id) ; f2  =   chi_fl(ir-2*id)
      g3  =   chi_gl(ir-3*id) ; f3  =   chi_fl(ir-3*id)
      dg0 = dxchi_gl(ir     ) ; df0 = dxchi_fl(ir     )
      dg1 = dxchi_gl(ir-1*id) ; df1 = dxchi_fl(ir-1*id)
      dg2 = dxchi_gl(ir-2*id) ; df2 = dxchi_fl(ir-2*id)
      dg3 = dxchi_gl(ir-3*id) ; df3 = dxchi_fl(ir-3*id)
   case(-1)
      g0  =   chi_gr(ir     ) ; f0  =   chi_fr(ir     )
      g1  =   chi_gr(ir-1*id) ; f1  =   chi_fr(ir-1*id)
      g2  =   chi_gr(ir-2*id) ; f2  =   chi_fr(ir-2*id)
      g3  =   chi_gr(ir-3*id) ; f3  =   chi_fr(ir-3*id)
      dg0 = dxchi_gr(ir     ) ; df0 = dxchi_fr(ir     )
      dg1 = dxchi_gr(ir-1*id) ; df1 = dxchi_fr(ir-1*id)
      dg2 = dxchi_gr(ir-2*id) ; df2 = dxchi_fr(ir-2*id)
      dg3 = dxchi_gr(ir-3*id) ; df3 = dxchi_fr(ir-3*id)
   end select
   g9 = g0 + dx24 * (55.d0*dg0 - 59.d0*dg1 + 37.d0*dg2 - 9.d0*dg3)
   f9 = f0 + dx24 * (55.d0*df0 - 59.d0*df1 + 37.d0*df2 - 9.d0*df3)
   do iec = 1,nec
      select case (is_calc)
      case (NONREL)
         call dgdx_dfdx_nonrel(rpos(ir+id),g9,f9,dg9,df9, &
                               ll,ee,veff(ir+id,ispin,ll_core))
      case (SREL)
         call dgdx_dfdx_srel(rpos(ir+id),g9,f9,dg9,df9, &
                             ll,ee,veff(ir+id,ispin,ll_core))
      end select
      g9 = g0 + dx24 * (9.d0*dg9 + 19.d0*dg0 - 5.d0*dg1 + dg2)
      f9 = f0 + dx24 * (9.d0*df9 + 19.d0*df0 - 5.d0*df1 + df2)
   end do
   select case (is_calc)
   case (NONREL)
      call dgdx_dfdx_nonrel(rpos(ir+id),g9,f9,dg9,df9, &
                            ll,ee,veff(ir+id,ispin,ll_core))
   case (SREL)
      call dgdx_dfdx_srel(rpos(ir+id),g9,f9,dg9,df9, &
                          ll,ee,veff(ir+id,ispin,ll_core))
   end select
   select case (id)
   case(+1)
        chi_gl(ir+id) =  g9 ;   chi_fl(ir+id) =  f9
      dxchi_gl(ir+id) = dg9 ; dxchi_fl(ir+id) = df9
   case(-1)
        chi_gr(ir+id) =  g9 ;   chi_fr(ir+id) =  f9
      dxchi_gr(ir+id) = dg9 ; dxchi_fr(ir+id) = df9
   end select
   end subroutine pc_adams_5_ae

!
!  Software name : CIAO (Code for Investigating Atomic Orbitals)
!  Subroutine(s) : sort_engy_sol, sort_engy_ss, set_focc_sol
!                : set_focc_ss, calc_efermi_ss
!  Author(s)     : Masakuni Okamoto (August 25, 2003)
!
!
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!
!
!  The license of the code and contact address :
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)
!
!=====================================================================
   subroutine sort_engy_sol(ier)
!=====================================================================
!
!  Sorts energy levels
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer :: ips, jps, imin
   ier = 0
   do ips = 1,nps
      list_sol(ips) = ips
   end do
   do ips = 1,nps-1
      imin = ips
      do jps = ips+1,nps
         if (engy_sol(list_sol(jps)) < engy_sol(list_sol(imin))) then
            imin = jps
         end if
      end do
      call iswap(list_sol(ips),list_sol(imin))
   end do
99 continue
   end subroutine sort_engy_sol

!=====================================================================
   subroutine sort_engy_ss(ier)
!=====================================================================
!
!  Sorts energy levels
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer :: iss, jss, imin
   ier = 0
   do iss = 1,nss
      list_ss(iss) = iss
   end do
   do iss = 1,nss-1
      imin = iss
      do jss = iss+1,nss
         if (engy_ss(list_ss(jss)) < engy_ss(list_ss(imin))) then
            imin = jss
         end if
      end do
      call iswap(list_ss(iss),list_ss(imin))
   end do
99 continue
   end subroutine sort_engy_ss

!=====================================================================
   subroutine set_focc_sol(ier)
!=====================================================================
!
!  Sets focc_sol(:)
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer :: ishell, ips
   ier = 0
   focc_sol(:) = 0.d0
   do ips = 1,nps
      ishell = ishell_ps(ips,1)
      focc_sol(ips) = focc(ishell)
   end do
99 continue
   end subroutine set_focc_sol

!=====================================================================
   subroutine set_focc_ss(ier)
!=====================================================================
!
!  Sets focc_ss(:)
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer :: ishell, iss, lspin, lss, nn, ll
   real(8) :: ftot, sum, res1, res2
   ier = 0
   select case (is_spin_state_ss)
   case (AUTOMATIC, SPIN_SPECIFIED)
      select case (is_spin_ss)
      case (POLARIZED)
         focc_ss(:) = 0.d0
         res1 = felec1_ss
         res2 = felec2_ss
         do iss = 1,nss
            lss = list_ss(iss)
            ftot = dble(nocc_ss(lss))
            lspin  = (1-spin_ss(lss))/2 + 1
            select case (lspin)
            case (1)
               if (ftot >= res1) then
                  focc_ss(lss) = res1
                  res1 = 0.d0
               else
                  focc_ss(lss) = ftot
                  res1 = res1 - ftot
               end if
            case (2)
               if (ftot >= res2) then
                  focc_ss(lss) = res2
                  res2 = 0.d0
               else
                  focc_ss(lss) = ftot
                  res2 = res2 - ftot
               end if
            end select
            nn = n_qnum(ishell_ss(lss))
            ll = l_qnum(ishell_ss(lss))
            write(IFLOG,*) 'iss,lss,lspin,n,l,isol,focc,e ...', &
               iss,lss,lspin,nn,ll,is_solve_ss(lss),focc_ss(lss),engy_ss(lss)
         end do
      case (RESTRICTED)
         focc_ss(:) = 0.d0
         res1 = felec_ss
         do iss = 1,nss
            lss = list_ss(iss)
            ftot = dble(nocc_ss(lss))
            if (ftot >= res1) then
               focc_ss(lss) = res1
            else
               focc_ss(lss) = ftot
               res1 = res1 - ftot
            end if
         end do
      end select
   case (UD_SPECIFIED)
   case default
      write(IFLOG,*) '### ERROR ### is_spin_state_ss is wrong'
      write(IFLOG,*) '   is_spin_state_ss ...',is_spin_state_ss
      ier = 1 ; go to 99
   end select
   do iss = 1,nss
      if ((focc_ss(iss) > 1.d-10).and.(is_solve_ss(iss) == 0)) then
         ishell = ishell_ss(iss)
         nn = n_qnum(ishell)
         ll = l_qnum(ishell)
         write(IFLOG,*) '### ERROR ### focc_ss != 0 for is_solve_ss = 0'
         write(IFLOG,*) '   iss         ...', iss
         write(IFLOG,*) '   (n,l)       ...', nn,ll
         write(IFLOG,*) '   focc_ss     ...', focc_ss(iss)
         write(IFLOG,*) '   is_solve_ss ...', is_solve_ss(iss)
         ier =1 ; go to 99
      end if
   end do
   sum = 0.d0
   do iss = 1,nss
      if (is_solve_ss(iss) /= 0) then
         sum = sum + focc_ss(iss)
      end if
   end do
   if (abs(sum-felec_ss) > 1.d-6) then
      write(IFLOG,*) '### ERROR ### sum of focc_ss != felec_ss'
      write(IFLOG,*) '   sum of focc_ss ...',sum
      write(IFLOG,*) '   felec_ss       ...',felec_ss
      ier = 1 ; go to 99
   end if
99 continue
   end subroutine set_focc_ss

!=====================================================================
   subroutine calc_efermi_ss(ier)
!=====================================================================
!
!  Calculates Fermi level
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   use parameters
   implicit none
   integer,intent(out) :: ier
   integer :: iss, lss
   ier = 0
   efermi_ss = 0.d0
   do iss = 1,nss
      lss = list_ss(iss)
      if (abs(focc_ss(lss)) > 1.d-10) then
         efermi_ss = engy_ss(lss)
      else
         exit
      end if
   end do
99 continue
   end subroutine calc_efermi_ss

!
!  Software name : CIAO (Code for Investigating Atomic Orbitals)
!  Subroutine(s) : opt_poly_fn, calc_poly_fn, calc_dpoly_fn
!                : calc_ddpoly_fn, calc_dddpoly_fn, calc_ddddpoly_fn
!                : calc_poly_rchi, opt_poly_qps, opt_ub_to_bound
!                : set_vloc_poly10
!  Function(s)   : fn_rexp, fn_hfact, fn_patom_poly12
!  Author(s)     : Masakuni Okamoto (August 25, 2003)
!
!
!  Contact address :  Phase System Consortium
!                     E-mail: phase_system@nims.go.jp URL https://azuma.nims.go.jp
!
!
!  The license of the code and contact address :
!  See the files, COPYRIGHT and LICENSE (or LICENSE_J.pdf)
!
!=====================================================================
   subroutine opt_poly_fn(ier,ifile,ll,ss, &
                 nr_mesh,rpos,f,nk,nrc,fc,ng_mesh,gmin,gmax,np,cp)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   implicit none
   integer,intent(in)  :: ifile, ll, ss, nr_mesh, nk, nrc, ng_mesh, np
   real(8),intent(in)  :: rpos(nr_mesh), f(nr_mesh), fc(0:nk), &
                          gmin, gmax
   integer,intent(out) :: ier
   real(8),intent(out) :: cp(0:np)
   integer :: ir, ig, ip, jp, ik, jk, ifac, itmp, is_debug
   real(8) :: g, r, sum, eps_invmat, det
   real(8),allocatable :: &
      amat(:,:), bvec(:), cmat(:,:), ainv(:,:), &
      a(:,:), b(:), lambda(:), &
      achk(:,:), bchk(:), gr(:), js(:), &
      gpos(:), wg(:), wt1(:), wt2(:), f_in(:,:), f_out(:)
   is_debug = 1
   eps_invmat = 1.d-3
  !++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   allocate(wt1(nr_mesh),wt2(nr_mesh),gr(nr_mesh),js(nr_mesh), &
            amat(0:np,0:np),bvec(0:np),cmat(0:np,0:nk))
   allocate(gpos(ng_mesh),wg(ng_mesh), &
            f_in(0:np,ng_mesh),f_out(ng_mesh))
  !++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   if (is_debug /= 0) then
   write(ifile,*)
   write(ifile,*) 'nk ...',nk
   do ik = 0,nk
      write(ifile,*) 'k,fc ...',ik,fc(ik)
   end do
   end if
   do ig = 1,ng_mesh
      gpos(ig) = gmin + dble(ig-1)/dble(ng_mesh-1)*(gmax-gmin)
   end do
   call set_weight_unif(ier,1,ng_mesh,gpos,wg)
   call set_weight_exp(ier,1,nrc,rpos,wt1)
   call set_weight_exp(ier,nrc,nr_mesh,rpos,wt2)
   f_in(:,:) = 0.d0 ; f_out(:) = 0.d0
   do ig = 1,ng_mesh
      gr(:) = gpos(ig)*rpos(:)
      call bessel_js(ll,nr_mesh,gr,js)
      do ip = 0,np
      do ir = 1,nrc
         r = rpos(ir)
         f_in(ip,ig) = f_in(ip,ig) &
            + r*r * wt1(ir) * r**(2*ip+ll) * js(ir)
      end do
      end do
      do ir = nrc,nr_mesh
         r = rpos(ir)
         f_out(ig) = f_out(ig) &
            + r*r * wt2(ir) * f(ir) * js(ir)
      end do
   end do
   amat(:,:) = 0.d0
   do ip = 0,np
   do jp = ip,np
      do ig = 1,ng_mesh
         g = gpos(ig)
         amat(ip,jp) = amat(ip,jp) &
            + 2.d0 * g*g*(g**ss) * wg(ig) * f_in(ip,ig) * f_in(jp,ig)
      end do
      amat(jp,ip) = amat(ip,jp)
   end do
   end do
   bvec(:) = 0.d0
   do ip = 0,np
      do ig = 1,ng_mesh
         g = gpos(ig)
         bvec(ip) = bvec(ip) &
            + 2.d0 * g*g*(g**ss) * wg(ig) * f_in(ip,ig) * f_out(ig)
      end do
   end do
   do ip = 0,np
      do ik = 0,nk
         if (2*ip+ll < ik) then
            ifac = 0
         else
            ifac = 1
            if (ik > 0) then
               do itmp = 1,ik
                  ifac = ifac * (2*ip+ll-itmp+1)
               end do
            end if
         end if
         cmat(ip,ik) = rpos(nrc)**(2*ip+ll-ik) * dble(ifac)
      end do
   end do
  !+++++++++++++++++++++++++++++++
   deallocate(gpos,wg,f_in,f_out)
   allocate(ainv(0:np,0:np))
   allocate(achk(0:np,0:np))
  !+++++++++++++++++++++++++++++++
   call det_real_matrix(ier,np+1,amat(0,0),det)
   call inv_real_matrix(ier,np+1,amat(0,0),ainv(0,0))
   write(ifile,*) '### CHECK ### det(Aij) ...',det
   achk = matmul(amat,ainv)
   do ip = 0,np
   do jp = 0,np
      if (ip == jp) then
         if (abs(achk(ip,jp) - 1.d0) > eps_invmat) then
            write(ifile,*) '### ERROR ### A * inv(A) != 1'
            write(ifile,*) '   ip          ...',ip
            write(ifile,*) '   jp          ...',jp
            write(ifile,*) '   achk(ip,jp) ...',achk(ip,jp)
            write(ifile,*) '   eps_invmat  ...',eps_invmat
            ier = 1 ; go to 99
         end if
      else
         if (abs(achk(ip,jp)) > eps_invmat) then
            write(ifile,*) '### ERROR ### A * inv(A) != 1'
            write(ifile,*) '   ip          ...',ip
            write(ifile,*) '   jp          ...',jp
            write(ifile,*) '   achk(ip,jp) ...',achk(ip,jp)
            write(ifile,*) '   eps_invmat  ...',eps_invmat
            ier = 2 ; go to 99
         end if
      end if
   end do
   end do
  !++++++++++++++++++++++++++++++++++++++++++++
   deallocate(achk)
   allocate(a(0:nk,0:nk),b(0:nk),lambda(0:nk))
  !++++++++++++++++++++++++++++++++++++++++++++
   a(:,:) = 0.d0
   do ik = 0,nk
   do jk = ik,nk
      do ip = 0,np
      do jp = 0,np
         a(ik,jk) = a(ik,jk) &
            - ainv(ip,jp) * cmat(ip,ik) * cmat(jp,jk)
      end do
      end do
      a(jk,ik) = a(ik,jk)
   end do
   end do
   b(:) = 0.d0
   do ik = 0,nk
      do ip = 0,np
      do jp = 0,np
         b(ik) = b(ik) &
            + ainv(ip,jp) * cmat(ip,ik) * bvec(jp)
      end do
      end do
      b(ik) = b(ik) + fc(ik)
   end do
  !+++++++++++++++++++++
   allocate(bchk(0:nk))
  !+++++++++++++++++++++
   call det_real_matrix(ier,nk+1,a(0,0),det)
   write(ifile,*) '### CHECK ### det(a) ...',det
   call axb_real_matrix(ier,nk+1,1,a(0,0),lambda(0),b(0))
   if (ier /= 0) then
      write(ifile,*) '### ERROR ### in axb_real_matrix'
      write(ifile,*) '### ERROR ###    det(a) ...',det
      go to 99
   end if
   bchk(:) = 0.d0
   do ik = 0,nk
      do jk = 0,nk
         bchk(ik) = bchk(ik) + a(ik,jk) * lambda(jk)
      end do
   end do
   do ik = 0,nk
      if (abs(bchk(ik) - b(ik))/(abs(b(ik))+1.d-15) > 1.d-6) then
         write(ifile,*) '### ERROR ### a * lambda != b'
         write(ifile,*) '   ik         ...',ik
         write(ifile,*) '   a * lambda ...',bchk(ik)
         write(ifile,*) '   b          ...',b(ik)
         ier = 3 ; go to 99
      end if
   end do
  
   if (is_debug /= 0) then
   write(ifile,*)
   write(ifile,*) 'nk ...',nk
   do ik = 0,nk
      write(ifile,*) 'k,lambda ...',ik,lambda(ik)
   end do
   end if
  !+++++++++++++++++
   deallocate(bchk)
  !+++++++++++++++++
   cp(:) = 0.d0
   do ip = 0,np
      do jp = 0,np
         sum = 0.d0
         do ik = 0,nk
            sum = sum + cmat(jp,ik) * lambda(ik)
         end do
         cp(ip) = cp(ip) - ainv(ip,jp) * (bvec(jp) + sum)
      end do
   end do
   
   if (is_debug /= 0) then
   write(ifile,*)
   write(ifile,*) 'np ...',np
   do ip = 0,np
      write(ifile,*) 'ip,cp ...',ip,cp(ip)
   end do
   end if
  !++++++++++++++++++++++++++++++++++++++++++++++
   deallocate(a,b,lambda)
   deallocate(wt1,wt2,gr,js,amat,bvec,cmat,ainv)
  !++++++++++++++++++++++++++++++++++++++++++++++
99 continue
   end subroutine opt_poly_fn

!=====================================================================
   subroutine calc_poly_fn( &
      ir1,ir2,rpos,ll,ncoeff,coeff,poly_fn)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   implicit none
   integer,intent(in)  :: ir1, ir2, ll, ncoeff
   real(8),intent(in)  :: rpos(*), coeff(0:*)
   real(8),intent(out) :: poly_fn(*)
   integer :: ir, icoeff
   real(8) :: r
   do ir = ir1,ir2
      poly_fn(ir) = coeff(ncoeff)
   end do
   do icoeff = ncoeff-1,0,-1
      do ir = ir1,ir2
         r = rpos(ir)
         poly_fn(ir) = poly_fn(ir)*r*r + coeff(icoeff)
      end do
   end do
   do ir = ir1,ir2
      poly_fn(ir) = poly_fn(ir) * rpos(ir)**(ll)
   end do
   end subroutine calc_poly_fn

!=====================================================================
   subroutine calc_dpoly_fn( &
      ir1,ir2,rpos,ll,ncoeff,coeff,dpoly_fn)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   implicit none
   integer,intent(in)  :: ir1, ir2, ll, ncoeff
   real(8),intent(in)  :: rpos(*), coeff(0:*)
   real(8),intent(out) :: dpoly_fn(*)
   integer :: ir, icoeff
   real(8) :: r
   do ir = ir1,ir2
      dpoly_fn(ir) = coeff(ncoeff) * dble(2*ncoeff+ll)
   end do
   do icoeff = ncoeff-1,0,-1
      do ir = ir1,ir2
         r = rpos(ir)
         dpoly_fn(ir) = dpoly_fn(ir)*r*r &
                      + coeff(icoeff) * dble(2*icoeff+ll)
      end do
   end do
   do ir = ir1,ir2
      dpoly_fn(ir) = dpoly_fn(ir) * rpos(ir)**(ll-1)
   end do
   end subroutine calc_dpoly_fn

!=====================================================================
   subroutine calc_ddpoly_fn( &
      ir1,ir2,rpos,ll,ncoeff,coeff,ddpoly_fn)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   implicit none
   integer,intent(in)  :: ir1, ir2, ll, ncoeff
   real(8),intent(in)  :: rpos(*), coeff(0:*)
   real(8),intent(out) :: ddpoly_fn(*)
   integer :: ir, icoeff
   real(8) :: r
   do ir = ir1,ir2
      ddpoly_fn(ir) = coeff(ncoeff) &
                    * dble((2*ncoeff+ll)*(2*ncoeff+ll-1))
   end do
   do icoeff = ncoeff-1,0,-1
      do ir = ir1,ir2
         r = rpos(ir)
         ddpoly_fn(ir) = ddpoly_fn(ir)*r*r &
            + coeff(icoeff) * dble((2*icoeff+ll)*(2*icoeff+ll-1))
      end do
   end do
   do ir = ir1,ir2
      ddpoly_fn(ir) = ddpoly_fn(ir) * rpos(ir)**(ll-2)
   end do
   end subroutine calc_ddpoly_fn

!=====================================================================
   subroutine calc_dddpoly_fn( &
      ir1,ir2,rpos,ll,ncoeff,coeff,dddpoly_fn)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   implicit none
   integer,intent(in)  :: ir1, ir2, ll, ncoeff
   real(8),intent(in)  :: rpos(*), coeff(0:*)
   real(8),intent(out) :: dddpoly_fn(*)
   integer :: ir, icoeff
   real(8) :: r
   do ir = ir1,ir2
      dddpoly_fn(ir) = coeff(ncoeff) &
         * dble((2*ncoeff+ll)*(2*ncoeff+ll-1)*(2*ncoeff+ll-2))
   end do
   
   do icoeff = ncoeff-1,0,-1
      do ir = ir1,ir2
         r = rpos(ir)
         dddpoly_fn(ir) = dddpoly_fn(ir)*r*r &
            + coeff(icoeff) &
               * dble((2*icoeff+ll)*(2*icoeff+ll-1)*(2*icoeff+ll-2))
      end do
   end do
   do ir = ir1,ir2
      dddpoly_fn(ir) = dddpoly_fn(ir) * rpos(ir)**(ll-3)
   end do
   end subroutine calc_dddpoly_fn

!=====================================================================
   subroutine calc_ddddpoly_fn( &
      ir1,ir2,rpos,ll,ncoeff,coeff,ddddpoly_fn)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   implicit none
   integer,intent(in)  :: ir1, ir2, ll, ncoeff
   real(8),intent(in)  :: rpos(*), coeff(0:*)
   real(8),intent(out) :: ddddpoly_fn(*)
   integer :: ir, icoeff
   real(8) :: r
   do ir = ir1,ir2
      ddddpoly_fn(ir) = coeff(ncoeff) &
         * dble((2*ncoeff+ll)*(2*ncoeff+ll-1) &
               *(2*ncoeff+ll-2)*(2*ncoeff+ll-3))
   end do
   do icoeff = ncoeff-1,0,-1
      do ir = ir1,ir2
         r = rpos(ir)
         ddddpoly_fn(ir) = ddddpoly_fn(ir)*r*r &
            + coeff(icoeff) &
               * dble((2*icoeff+ll)*(2*icoeff+ll-1) &
                     *(2*icoeff+ll-2)*(2*icoeff+ll-3))
      end do
   end do
   do ir = ir1,ir2
      ddddpoly_fn(ir) = ddddpoly_fn(ir) * rpos(ir)**(ll-4)
   end do
   end subroutine calc_ddddpoly_fn

!=====================================================================
   subroutine calc_poly_rchi( &
      ir1,ir2,rpos,ll,ncoeff,coeff,engy,rphi,vloc,poly_rchi)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   implicit none
   integer,intent(in)  :: ir1, ir2, ll, ncoeff
   real(8),intent(in)  :: rpos(*), coeff(0:*), engy, rphi(*), vloc(*)
   real(8),intent(out) :: poly_rchi(*)
   integer :: ir, icoeff
   real(8) :: fac
   fac = dble((2*ncoeff+2*ll+1)*ncoeff)
   do ir = ir1,ir2
      poly_rchi(ir) = coeff(ncoeff) * fac
   end do
   do icoeff = ncoeff-1,1,-1
      fac = dble((2*icoeff+2*ll+1)*icoeff)
      do ir = ir1,ir2
         poly_rchi(ir) = poly_rchi(ir)*rpos(ir)**2 &
                       + coeff(icoeff) * fac
      end do
   end do
   do ir = ir1,ir2
      poly_rchi(ir) = poly_rchi(ir) * rpos(ir)**(ll+1) &
                    + (engy - vloc(ir)) * rphi(ir)
   end do
   end subroutine calc_poly_rchi

!=====================================================================
   subroutine opt_poly_qps(ier,ifile,ll,ss, &
                 nr_mesh,rpos,f,nk,nrc,fc,fint,ng_mesh,gmin,gmax, &
                 np,cp)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   implicit none
   integer,intent(in)  :: ifile, ll, ss, nr_mesh, nk, nrc, ng_mesh, np
   real(8),intent(in)  :: rpos(nr_mesh), f(nr_mesh), fc(0:nk), fint, &
                          gmin, gmax
   integer,intent(out) :: ier
   real(8),intent(out) :: cp(0:np)
   integer :: ir, ig, ip, jp, ik, jk, ifac, itmp, is_debug
   real(8) :: g, r, sum, eps_invmat, det
   real(8),allocatable :: &
      amat(:,:), bvec(:), cmat(:,:), ainv(:,:), &
      a(:,:), b(:), lambda(:), &
      achk(:,:), bchk(:), gr(:), js(:), &
      gpos(:), wg(:), wt1(:), wt2(:), f_in(:,:), f_out(:)
   is_debug = 1

! ================================== modified by K. T. ================= 4.0
!   eps_invmat = 1.d-3
!
#ifdef mode_v300
   eps_invmat = 1.d-3
#else
   eps_invmat = 2.0d-3
#endif
! ====================================================================== 4.0

  !++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   allocate(wt1(nr_mesh),wt2(nr_mesh),gr(nr_mesh),js(nr_mesh), &
            amat(0:np,0:np),bvec(0:np),cmat(0:np,0:nk+1))
   allocate(gpos(ng_mesh),wg(ng_mesh), &
            f_in(0:np,ng_mesh),f_out(ng_mesh))
  !++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   if (is_debug /= 0) then
   write(ifile,*)
   write(ifile,*) 'nk+1 ...',nk+1
   do ik = 0,nk
      write(ifile,*) 'k,fc   ...',ik,fc(ik)
   end do
      write(ifile,*) 'k,fint ...',nk+1,fint
   end if
   do ig = 1,ng_mesh
      gpos(ig) = gmin + dble(ig-1)/dble(ng_mesh-1)*(gmax-gmin)
   end do
   call set_weight_unif(ier,1,ng_mesh,gpos,wg)
   call set_weight_exp(ier,1,nrc,rpos,wt1)
   call set_weight_exp(ier,nrc,nr_mesh,rpos,wt2)
   f_in(:,:) = 0.d0 ; f_out(:) = 0.d0
   do ig = 1,ng_mesh
      gr(:) = gpos(ig) * rpos(:)
      call bessel_js(ll,nr_mesh,gr,js)
      do ip = 0,np
      do ir = 1,nrc
         r = rpos(ir)
         f_in(ip,ig) = f_in(ip,ig) &
            + r*r * wt1(ir) * r**(2*ip+ll) * js(ir)
      end do
      end do
      do ir = nrc,nr_mesh
         r = rpos(ir)
         f_out(ig) = f_out(ig) &
            + r*r * wt2(ir) * f(ir) * js(ir)
      end do
   end do
   amat(:,:) = 0.d0
   do ip = 0,np
   do jp = ip,np
      do ig = 1,ng_mesh
         g = gpos(ig)
         amat(ip,jp) = amat(ip,jp) &
            + 2.d0 * g**(ss+2) * wg(ig) * f_in(ip,ig) * f_in(jp,ig)
      end do
      amat(jp,ip) = amat(ip,jp)
   end do
   end do
   bvec(:) = 0.d0
   do ip = 0,np
      do ig = 1,ng_mesh
         g = gpos(ig)
         bvec(ip) = bvec(ip) &
            + 2.d0 * g**(ss+2) * wg(ig) * f_in(ip,ig) * f_out(ig)
      end do
   end do
   do ip = 0,np
      do ik = 0,nk
         if (2*ip+ll < ik) then
            ifac = 0
         else
            ifac = 1
            if (ik > 0) then
               do itmp = 1,ik
                  ifac = ifac * (2*ip+ll-itmp+1)
               end do
            end if
         end if
         cmat(ip,ik) = rpos(nrc)**(2*ip+ll-ik) * dble(ifac)
      end do
      cmat(ip,nk+1) = rpos(nrc)**(2*ip+2*ll+3) / dble(2*ip+2*ll+3)
   end do
  !+++++++++++++++++++++++++++++++
   deallocate(gpos,wg,f_in,f_out)
   allocate(ainv(0:np,0:np))
   allocate(achk(0:np,0:np))
  !+++++++++++++++++++++++++++++++
   call det_real_matrix(ier,np+1,amat(0,0),det)
   call inv_real_matrix(ier,np+1,amat(0,0),ainv(0,0))
   write(ifile,*) '### CHECK ### det(Aij) ...',det
   achk = matmul(amat,ainv)
   do ip = 0,np
   do jp = 0,np
      if (ip == jp) then
         if (abs(achk(ip,jp) - 1.d0) > eps_invmat) then
            write(ifile,*) '### ERROR ### A * inv(A) != 1'
            write(ifile,*) '   ip          ...',ip
            write(ifile,*) '   jp          ...',jp
            write(ifile,*) '   achk(ip,jp) ...',achk(ip,jp)
            write(ifile,*) '   eps_invmat  ...',eps_invmat
            ier = 1 ; go to 99
         end if
      else
         if (abs(achk(ip,jp)) > eps_invmat) then
            write(ifile,*) '### ERROR ### A * inv(A) != 1'
            write(ifile,*) '   ip          ...',ip
            write(ifile,*) '   jp          ...',jp
            write(ifile,*) '   achk(ip,jp) ...',achk(ip,jp)
            write(ifile,*) '   eps_invmat  ...',eps_invmat
            ier = 2 ; go to 99
         end if
      end if
   end do
   end do
  !++++++++++++++++++++++++++++++++++++++++++++++++++++
   deallocate(achk)
   allocate(a(0:nk+1,0:nk+1),b(0:nk+1),lambda(0:nk+1))
  !++++++++++++++++++++++++++++++++++++++++++++++++++++
   a(:,:) = 0.d0
   do ik = 0,nk+1
   do jk = ik,nk+1
      do ip = 0,np
      do jp = 0,np
         a(ik,jk) = a(ik,jk) &
            - ainv(ip,jp) * cmat(ip,ik) * cmat(jp,jk)
      end do
      end do
      a(jk,ik) = a(ik,jk)
   end do
   end do
   b(:) = 0.d0
   do ik = 0,nk
      do ip = 0,np
      do jp = 0,np
         b(ik) = b(ik) &
            + ainv(ip,jp) * cmat(ip,ik) * bvec(jp)
      end do
      end do
      b(ik) = b(ik) + fc(ik)
   end do
   ik = nk+1
      do ip = 0,np
      do jp = 0,np
         b(ik) = b(ik) &
            + ainv(ip,jp) * cmat(ip,ik) * bvec(jp)
      end do
      end do
      b(ik) = b(ik) + fint
  !+++++++++++++++++++++++
   allocate(bchk(0:nk+1))
  !+++++++++++++++++++++++
   call det_real_matrix(ier,nk+2,a(0,0),det)
   write(ifile,*) '### CHECK ### det(a) ...',det
   call axb_real_matrix(ier,nk+2,1,a(0,0),lambda(0),b(0))
   if (ier /= 0) then
      write(ifile,*) '### ERROR ### in axb_real_matrix'
      write(ifile,*) '### ERROR ###    det(a) ...',det
      go to 99
   end if
   bchk(:) = 0.d0
   do ik = 0,nk+1
      do jk = 0,nk+1
         bchk(ik) = bchk(ik) + a(ik,jk) * lambda(jk)
      end do
   end do
   do ik = 0,nk+1
      if (abs(bchk(ik) - b(ik))/(abs(b(ik))+1.d-15) > 1.d-6) then
         write(ifile,*) '### ERROR ### a * lambda != b'
         write(ifile,*) '   ik         ...',ik
         write(ifile,*) '   a * lambda ...',bchk(ik)
         write(ifile,*) '   b          ...',b(ik)
         ier = 3 ; go to 99
      end if
   end do
  !+++++++++++++++++
   deallocate(bchk)
  !+++++++++++++++++
   if (is_debug /= 0) then
   write(ifile,*)
   write(ifile,*) 'nk+1 ...',nk+1
   do ik = 0,nk+1
      write(ifile,*) 'k,lambda ...',ik,lambda(ik)
   end do
   end if
   cp(:) = 0.d0
   do ip = 0,np
      do jp = 0,np
         sum = 0.d0
         do ik = 0,nk+1
            sum = sum + cmat(jp,ik) * lambda(ik)
         end do
         cp(ip) = cp(ip) - ainv(ip,jp) * (bvec(jp) + sum)
      end do
   end do
   if (is_debug /= 0) then
   write(ifile,*)
   write(ifile,*) 'np ...',np
   do ip = 0,np
      write(ifile,*) 'ip,cp ...',ip,cp(ip)
   end do
   end if
  !++++++++++++++++++++++++++++++++++++++++++++++
   deallocate(a,b,lambda)
   deallocate(wt1,wt2,gr,js,amat,bvec,cmat,ainv)
  !++++++++++++++++++++++++++++++++++++++++++++++
99 continue
   end subroutine opt_poly_qps

!=====================================================================
   subroutine opt_ub_to_bound(ier,iflog,ifsum, &
      nn,ll,tt,eref,deref,nmesh,rpos,nrc,rpsi_ub,rpsi_b)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   implicit none
   integer,intent(in)  :: iflog, ifsum, nn, ll, tt, nmesh, nrc
   real(8),intent(in)  :: eref, deref, rpos(nmesh), rpsi_ub(nmesh)
   integer,intent(out) :: ier
   real(8),intent(out) :: rpsi_b(nmesh)
   integer :: nk, isdiff, ir, n1, n2, ik, jk, n_mat, n_vec
   real(8) :: kl, rcut, fn_rexp, sum, r
   real(8),allocatable :: &
      f0_num(:), f1_num(:), mat_a(:,:), vec_c(:), vec_ub(:), coeff(:)
   rcut = rpos(nrc)
   kl = dble(ll+2)/2.d0
   nk = 4
  !+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   allocate(f0_num(0:nk),f1_num(0:nk),mat_a(nk+1,nk+1),vec_c(nk+1), &
            vec_ub(nk+1),coeff(0:nk))
  !+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
   f0_num(:)  = 0.d0
   isdiff = nk
   n1 = nrc - 10
   n2 = nrc + 10
   rcut = rpos(nrc)
   call diff4_exp(ier,isdiff,n1,n2,rpos,rpsi_ub,rcut, &
                  f0_num(0),f0_num(1),f0_num(2),f0_num(3),f0_num(4))
   f0_num(0) = rpsi_ub(nrc)
   do ik = 0,nk
      vec_ub(ik+1) = f0_num(ik)
   end do
   do ik = 0,nk
      do jk = 0,nk
         mat_a(ik+1,jk+1) = fn_rexp(ik,2*jk+ll+1,-kl,rcut)
      end do
   end do
   n_mat = nk+1
   n_vec = 1
   call axb_real_matrix(ier,n_mat,n_vec,mat_a,vec_c,vec_ub)
   do ik = 0,nk
      coeff(ik) = vec_c(ik+1)
   end do
   do ir = nrc+1,nmesh
      r = rpos(ir)
      sum = 0.d0
      do jk = 0,nk
         sum = sum + coeff(jk)*fn_rexp(0,2*jk+ll+1,-kl,r)
      end do
      rpsi_b(ir) = sum
   end do
   f1_num(:)  = 0.d0
   call diff4_exp(ier,isdiff,n1,n2,rpos,rpsi_b,rcut, &
                  f1_num(0),f1_num(1),f1_num(2),f1_num(3),f1_num(4))
   f1_num(0) = rpsi_b(nrc)
10 format(1x,a10,f20.10,i20)
11 format(1x,a10,2(i20))
12 format(1x,(a6,i2,a2),f20.10)
13 format(1x,10x,(8x,a8,4x),(8x,a9,3x),(8x,a9,3x))
14 format(1x,a10,5(f20.10))
15 format(1x,a10,(10x,(i2,2x,i2,2x,i2)),(18x,a2))
16 format(1x,10x,2(8x,a10,2x))
   write(iflog,*)
   write(iflog,*)  &
      'Unbound r*psi[n](r) was modified to bound at large r.'
   write(iflog,15) ' (n,l,t) :', nn,ll,tt,'US'
   write(iflog,10) ' rc, nrc :', rcut, nrc
   write(iflog,14) 'eref, de :', eref, deref
   write(iflog,13) 'rpsi(rc)','rpsi''(rc)','rpsi"(rc)'
   write(iflog,14) 'Exact    :',(f0_num(ik),ik=0,2)
   write(iflog,14) 'Numerical:',(f1_num  (ik),ik=0,2)
   write(iflog,16) 'rpsi"''(rc)','rpsi""(rc)'
   write(iflog,14) 'Exact    :',(f0_num(ik),ik=3,nk)
   write(iflog,14) 'Numerical:',(f1_num  (ik),ik=3,nk)
   write(ifsum,*)
   write(ifsum,*)  &
      'Unbound r*psi[n](r) was modified to bound at large r.'
   write(ifsum,15) ' (n,l,t) :', nn,ll,tt,'US'
   write(ifsum,10) ' rc, nrc :', rcut, nrc
   write(ifsum,14) 'eref, de :', eref, deref
   write(ifsum,13) 'rpsi(rc)','rpsi''(rc)','rpsi"(rc)'
   write(ifsum,14) 'Exact    :',(f0_num(ik),ik=0,2)
   write(ifsum,14) 'Numerical:',(f1_num  (ik),ik=0,2)
   write(ifsum,16) 'rpsi"''(rc)','rpsi""(rc)'
   write(ifsum,14) 'Exact    :',(f0_num(ik),ik=3,nk)
   write(ifsum,14) 'Numerical:',(f1_num  (ik),ik=3,nk)
  !+++++++++++++++++++++++++++++++++++++++++++++++++++
   deallocate(f0_num,f1_num,mat_a,vec_c,vec_ub,coeff)
  !+++++++++++++++++++++++++++++++++++++++++++++++++++
   end subroutine opt_ub_to_bound

!=====================================================================
   function fn_rexp(n,a,b,r)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   implicit none
   real(8) :: fn_rexp
   integer,intent(in) :: n, a
   real(8),intent(in) :: b, r
   integer :: m, fn_hfact
   real(8) :: sum
   if (n >= 0) then
      sum = 0.d0
      do m = 0,n
         if (a-m >= 0) then
            sum = sum &
                + dble(fn_hfact(a,n,m)) &
                   * b**(n-m) * r**(a-m) * exp(b*r)
         end if
      end do
   else
      sum = 0.d0
   end if
   fn_rexp = sum
   end function fn_rexp

!=====================================================================
   function fn_hfact(a,n,m)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   implicit none
   integer(8) :: fn_factorial
   integer :: n, a, m, fn_hfact
   fn_hfact = (fn_factorial(a) / fn_factorial(a-m)) &
            * (fn_factorial(n) / fn_factorial(n-m)) &
            /  fn_factorial(m)
   end function fn_hfact

!=====================================================================
   function fn_patom_poly12(r,fatom,rcut,vcut)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   implicit none
   real(8) :: fn_patom_poly12
   real(8),intent(in) :: r, fatom, rcut, vcut
   integer :: i
   real(8) :: f(0:12), zcut, rr
   zcut  = -fatom/rcut
   rr    = (r/rcut)**2
   f( 0) =        vcut
   f( 2) = - 6.d0*vcut + (3003.d0/256.d0)*zcut
   f( 4) =  15.d0*vcut - (9009.d0/256.d0)*zcut
   f( 6) = -20.d0*vcut + (6435.d0/128.d0)*zcut
   f( 8) =  15.d0*vcut - (5005.d0/128.d0)*zcut
   f(10) = - 6.d0*vcut + (4095.d0/256.d0)*zcut
   f(12) =        vcut - ( 693.d0/256.d0)*zcut
   fn_patom_poly12 = 0.d0
   do i = 0,6
      fn_patom_poly12 = fn_patom_poly12 + f(2*i) * rr**(i)
   end do
   end function fn_patom_poly12

!=====================================================================
   subroutine set_vloc_poly10(nmesh,rpos,veff,rcut,vcut,vloc)
!=====================================================================
!
!  M. Okamoto
!
!---------------------------------------------------------------------
   implicit none
   integer,intent(in)    :: nmesh
   real(8),intent(in)    :: vcut, rpos(nmesh), veff(nmesh)
   real(8),intent(inout) :: rcut
   real(8),intent(out)   :: vloc(nmesh)
   integer :: i, ir, nrc, isdiff, n1, n2, ier
   real(8) :: rr, gcut(0:4)
   real(8) :: coeff(0:5), amat(5,5), bvec(5), xvec(5), rc(10)
   do ir = nmesh,1,-1
      if (rpos(ir) < rcut) then
         nrc = ir ; exit
      end if
      if (ir == 1) then
         write(*,*) '### ERROR ### nrc not found in set_vloc_poly10'
         stop
      end if
   end do
   rcut = rpos(nrc)
   n1 = nrc - 10 ; n2 = nrc + 10
   isdiff = 4
   call diff4_exp(ier,isdiff,n1,n2,rpos,veff,rcut, &
              gcut(0),gcut(1),gcut(2),gcut(3),gcut(4))
   rc(1) = rcut
   do i = 2,10
      rc(i) = rc(i-1) * rcut
   end do
   amat(1,1) =      rc(2)     ; amat(1,2) =       rc(4)
   amat(2,1) = 2.d0*rc(1)     ; amat(2,2) =  4.d0*rc(3)
   amat(3,1) = 2.d0           ; amat(3,2) = 12.d0*rc(2)
   amat(4,1) = 0.d0           ; amat(4,2) = 24.d0*rc(1)
   amat(5,1) = 0.d0           ; amat(5,2) = 24.d0
   amat(1,3) =        rc(6)   ; amat(1,4) =         rc(8)
   amat(2,3) =   6.d0*rc(5)   ; amat(2,4) =    8.d0*rc(7)
   amat(3,3) =  30.d0*rc(4)   ; amat(3,4) =   56.d0*rc(6)
   amat(4,3) = 120.d0*rc(3)   ; amat(4,4) =  336.d0*rc(5)
   amat(5,3) = 360.d0*rc(2)   ; amat(5,4) = 1680.d0*rc(4)
   amat(1,5) =         rc(10) ; bvec(1) = gcut(0) - vcut
   amat(2,5) =   10.d0*rc(9)  ; bvec(2) = gcut(1)
   amat(3,5) =   90.d0*rc(8)  ; bvec(3) = gcut(2)
   amat(4,5) =  720.d0*rc(7)  ; bvec(4) = gcut(3)
   amat(5,5) = 5040.d0*rc(6)  ; bvec(5) = gcut(4)
   call axb_real_matrix(ier,5,1,amat,xvec,bvec)
   coeff(0) = vcut
   do i = 1,5
      coeff(i) = xvec(i)
   end do
   vloc(:) = 0.d0
   do ir = 1,nrc
      rr = rpos(ir)*rpos(ir)
      do i = 0,5
         vloc(ir) = vloc(ir) + coeff(i) * rr**(i)
      end do
   end do
   do ir = nrc+1,nmesh
      vloc(ir) = veff(ir)
   end do
   end subroutine set_vloc_poly10

!=====================================================================
   subroutine calc_coeff_ok_poly3(z,rc,dr,h,b)
!=====================================================================
   implicit none
   real(8),intent(in)  :: z, rc, dr, h
   real(8),intent(out) :: b(0:3)
   real(8) :: amat(4,4), bvec(4), xvec(4), rl
   integer :: ier
   rl = rc - dr
   amat(1,1) = 1.d0 ; amat(1,2) = rl ; amat(1,3) = rl*rl ; amat(1,4) = rl*rl*rl
   amat(2,1) = 0.d0 ; amat(2,2) = 1.d0 ; amat(2,3) = 2.d0*rl ; amat(2,4) = 3.d0*rl*rl
   amat(3,1) = 1.d0 ; amat(3,2) = rc ; amat(3,3) = rc*rc ; amat(3,4) = rc*rc*rc
   amat(4,1) = 0.d0 ; amat(4,2) = 1.d0 ; amat(4,3) = 2.d0*rc ; amat(4,4) = 3.d0*rc*rc
   bvec(1) = -z/rl ; bvec(2) = z/rl/rl ; bvec(3) = h ; bvec(4) = 0.d0
   call axb_real_matrix(ier,4,1,amat,xvec,bvec)
   if (ier /= 0) then
      write(*,*) '### ERROR ### ier != 0 in axb_real_matrix'
      write(*,*) '   ier ...',ier
      stop
   end if
   b(0:3) = xvec(1:4)
   end subroutine calc_coeff_ok_poly3
